class sdapp_customized_form_client{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        const row = __constructorOptions.blockrow;
        const __row = row;
        const dataRow = __constructorOptions.datarow;
        const themeId = row.themeid;
        const lang = allVariables.lang;
        this.init = __methodOptions =>{
            let form = $(gen.createEl("div")).html(text["form-type-not-found"][lang]);
            const type = __methodOptions.type;
            switch(type){
                case "default": form = __constructorOptions.defaultform;break;
                case "cartform": form = this.cartform(__methodOptions).init();break;
                case "bookingform": form = this.bookingform(__methodOptions).init();break;
            }
            return form;
        };
        this.block = __functionOptions =>{
            let attr = {};
            if(__functionOptions.hasOwnProperty("attr")){attr = __functionOptions.attr;}
            return {
                element:"div",
                attr:attr,
                css:{
                    border:`1px ${__functionOptions.color} solid`,
                    borderRadius:"5px",
                    margin:"5px",
                    float:"left",
                    width:"100%",
                    padding:"0"
                },
                children:[
                    {
                        element:"div",
                        css:{
                            backgroundColor:`${__functionOptions.color}`,
                            color:__functionOptions.textcolor,
                            padding:"5px",
                            fontWeight:"bold",
                            width:"100%"
                        },
                        children:[
                            {
                                element:"i",
                                attr:{
                                    class:__functionOptions.icon
                                },
                                css:{
                                    marginRight:"5px",
                                    fontSize:"20px"
                                }
                            },
                            {
                                element:"text",
                                html:__functionOptions.title
                            },
                            {
                                element:"div",
                                css:{
                                    float:"right",
                                    textAlign:"right",
                                    display:"block",
                                    backgroundColor:`${__functionOptions.color}`,
                                    paddingLeft:"5px"
                                },
                                html:__functionOptions.rightcontent
                            }
                        ]
                    },
                    {
                        element:"div",
                        attr:{
                            class:"col-lg-12"
                        },
                        css:{
                            padding:"5px"
                        },
                        html:__functionOptions.content
                    }
                ]
            };
        }
        this.dataCaller = __functionOptions =>{
            const blockId = __functionOptions.blockid;
            const ref = `WHERE blockid ='${blockId}' AND datastatus > 0`;
            const columns = __functionOptions.columns;
            const data = gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {key:"returnjson",fields:["sdappdataid","blockid","data"],table:"sdappdata",datatype:"json",ref: ref,getter: true}, false, 1));
            const getData = function(__annonymFunctionOptions){
                let row = new Object();
                const ID = __annonymFunctionOptions.id;
                const data = __annonymFunctionOptions.data;
                const columns = __annonymFunctionOptions.columns;
                row["id"] = ID; 
                if(columns!==undefined && columns!==null){
                    if(Array.isArray(columns)){
                        columns.forEach(item=>{
                            row[item] =data[item];
                        });
                    }
                    else{
                        row[columns] = data[columns];

                    }
                }
                return row;
            };
            if(Array.isArray(data) && data.length > 0){
                let __data = [];
                for(let i = 0; i < data.length; i++){
                    __data.push(getData({
                        columns:columns,
                        data:gen.getObjectFromJSON(data[i].data),
                        id:data[i][0]
                    }));
                }
                return {
                    status:"success",
                    statuscode:200,
                    data:__data,
                    message:"data found"  
                };
            }
            else{
                return {
                    status:"failure",
                    statuscode:404,
                    message:"data not found"
                };
            }
            
        }
        this.cartform = __methodOptions =>{
            allVariables.cartinformation = {};
            const methodOptions = __methodOptions;
            const anchorAddProduct = $(gen.createEl("a"));
            const __objects = {
                clientblock:__functionOptions=>{
                     const clientObject = __functionOptions.customizedsettings.client;
                     const photoColumn = clientObject.clientphotocolumn;
                     const fullnameColumns = clientObject.clientfullnamecolumn
                     const columns = [photoColumn].concat(fullnameColumns);
                     const callData = me.dataCaller({
                        blockid:clientObject.blockid,
                        columns:columns
                    });
                    const editedValue = function(){
                        if(__objects.dataEdit()!==null && editedValue && __objects.dataEdit()!==undefined){
                            return __objects.dataEdit()[__functionOptions.customizedsettings.row.clientcolumn].fkid;
                        }
                        return null;
                    }
                    const dataArray = callData.data;
                    const resultFound = $(gen.createEl("div"));
                    if(editedValue()!== null && editedValue()!== undefined){
                        resultFound.html(__objects.searchClientResultRow({
                            item:{},
                            editedclientfullname:__objects.dataEdit().cartinformation.client.clientfullname,
                            editedclientphoto:__objects.dataEdit().cartinformation.client.clientphoto,
                            editedclientid:__objects.dataEdit().cartinformation.client.clientid
                        }));
                    }
                    const searchInput = $(gen.createEl("input"));
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    children:[
                                        {
                                            element:"div",
                                            attr:{
                                                class:"row"
                                            },
                                            children:[
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-8"
                                                    },
                                                    children:[
                                                        {
                                                            element:searchInput,
                                                            attr:{
                                                                class:"form-control",
                                                                placeholder:text["search-client-name-or-phone-number"][lang],
                                                                cartform:text["cart-form-search-client-input"]
                                                            },
                                                            on:{
                                                                type:"keypress",
                                                                data:{
                                                                    data:dataArray,
                                                                    columns:columns,
                                                                    photocolumn:photoColumn,
                                                                    resultsection:resultFound,
                                                                    input:searchInput,
                                                                    fullnamecolumns:fullnameColumns
                                                                },
                                                                callback:e=>{
                                                                    if(e.keyCode === 13 || e.which === 13){
                                                                        __objects.searchClient(e);
                                                                    }
                                                                }
                                                            },
                                                            css:{
                                                                marginBottom:"5px",
                                                                width:"100%"
                                                            }
                                                        }
                                                    ]
                                                },
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-4"
                                                    },
                                                    children:[
                                                        {
                                                            element:"button",
                                                            type:"button",
                                                            attr:{
                                                                class:"btn"
                                                            },
                                                            css:{
                                                                marginBottom:"5px",
                                                                width:"100%"
                                                            },
                                                            on:{
                                                                type:"click",
                                                                data:{
                                                                    data:dataArray,
                                                                    columns:columns,
                                                                    photocolumn:photoColumn,
                                                                    resultsection:resultFound,
                                                                    input:searchInput,
                                                                    fullnamecolumns:fullnameColumns
                                                                },
                                                                callback:e=>{
                                                                    __objects.searchClient(e);
                                                                }
                                                            },
                                                            children:[
                                                                {
                                                                    element:"i",
                                                                    css:{
                                                                        fontSize:"15px"
                                                                    },
                                                                    attr:{
                                                                        class:"icon-magnifier"
                                                                    }
                                                                },
                                                                {
                                                                    element:"text",
                                                                    css:{
                                                                        marginLeft:"5px"
                                                                    },
                                                                    html:text["search"][lang]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    html:resultFound

                                }
                            ]
                        }
                    ]).init();
                },
                productblock:__functionOptions=>{
                    allVariables.cartinformation = __functionOptions;
                    const rowUI = function(__annonymFunctionOptions){
                        const item = __annonymFunctionOptions.item;
                        const rateSymbol = __annonymFunctionOptions.ratesymbol;
                        const counter = __annonymFunctionOptions.n;
                        const css = {
                            display:"flex",
                            justifyContent:"center",
                            alignItems:"center"
                        };
                        const quantitySection = $(gen.createEl("div"));
                        const totalAmountSection = $(gen.createEl("div"));
                        const parent = $(gen.createEl("div")).css({
                            border:"1px solid #f8f9fa",
                            margin:counter > 1 ? "2px 2px 5px 2px" : "15px 2px 5px 2px",
                            padding:"2px",
                            borderRadius:"3px"
                        });
                        const inputQuantity = $(gen.textBox("id","name","form-control",item.qty,"numeric"));
                        inputQuantity.css({
                            width:"50px",
                            textAlign:"center",
                            border:"1px #ccc solid"
                        })
                        .attr({
                            type:"number"
                        })
                        .on("input",{
                            quatitysection:quantitySection,
                            totalamountsection:totalAmountSection,
                            item:item,
                            row:parent,
                            input:inputQuantity
                        },e =>{
                            adderOrDidacter({
                                e:e,
                                type:"setter"
                            });
                        });
                        const adderOrDidacter = function(__annonymFunctionOptions){
                            let incrementer = -1;
                            if(__annonymFunctionOptions.type ==="adder"){
                                incrementer = 1;
                            }

                            if(allVariables.hasOwnProperty("cartinformation") && allVariables.cartinformation !== null && allVariables.cartinformation.hasOwnProperty("rows")
                            && Array.isArray(allVariables.cartinformation.rows) && allVariables.cartinformation.rows.length > 0){
                                const rateSymbol = allVariables.cartinformation.ratesymbol;
                                const item = __annonymFunctionOptions.e.data.item;
                                const input = __annonymFunctionOptions.e.data.input;
                                const quantitySection = __annonymFunctionOptions.e.data.quatitysection;
                                const totalAmountSection = __annonymFunctionOptions.e.data.totalamountsection;
                                const parent = __annonymFunctionOptions.e.data.row;
                                let qty = parseInt(item.qty) +   incrementer;
                                if(__annonymFunctionOptions.type ==="setter"){
                                    qty = input.val();
                                }
                                const total = qty * parseInt(item.price);
                                input.val(qty);
                                let updateRows = [];
                                allVariables.cartinformation.rows.forEach(value =>{
                                    if(parseInt(value.id) === parseInt(item.id)){
                                        value.qty = qty;
                                        value.total = total;
                                    }
                                    updateRows.push(value);
                                });
                                allVariables.cartinformation.rows = updateRows;
                                totalAmountSection.html(`${rateSymbol} ${total}`);
                                let totalAmount = 0;
                                for(let y = 0; y < allVariables.cartinformation.rows.length; y++){
                                    const row = allVariables.cartinformation.rows[y];
                                    totalAmount += parseFloat(row.total);
                                }
                                $(`div[cartform="${text["cart-form-tota-amount-section"]}"]`).html(`${rateSymbol} ${totalAmount}`);
                                if(qty < 1){
                                    const __action = function(){
                                        parent.remove();
                                        $(`div[cartformserviceid="${item.id}"]`).remove();
                                        allVariables.cartinformation.rows = allVariables.cartinformation.rows.filter(__item =>{return parseInt(__item.id)!== parseInt(item.id)});
                                        allVariables.cartinformation.agentservicerows = allVariables.cartinformation.agentservicerows.filter(__item =>{return parseInt(__item.serviceid)!== parseInt(item.id)});
                                    };
                                    gen.sweetWarningMsgBox(
                                        __action,
                                        text["alert"][allVariables.lang],
                                        text["cart-form-remove-item-warning"][allVariables.lang],
                                        text["cart-form-remove-item-success"][allVariables.lang],
                                        text["sdapp-no-action-done"][allVariables.lang]
                                    );
                                }

                            }

                        };
                        return parent.html(gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-1"
                                        },
                                        css:css,
                                        html:() =>{
                                            return gen.anchor({
                                                icon:"icon-minus icons",
                                                css:{
                                                    cursor:"pointer",
                                                    fontWeight:"bolder",
                                                    color:"#000"
                                                },
                                                data:{
                                                    quatitysection:quantitySection,
                                                    totalamountsection:totalAmountSection,
                                                    item:item,
                                                    row:parent,
                                                    input:inputQuantity
                                                },
                                                callback:e =>{
                                                    e.preventDefault();
                                                    adderOrDidacter({
                                                        e:e,
                                                        type:"didacter"
                                                    });
                                                }

                                            });
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-2"
                                        },
                                        css:css,
                                        html:()=>{
                                            return $(gen.createEl("img"))
                                            .css({
                                                width:"50px",
                                                height:"50px"
                                            })
                                            .attr({
                                                src:`../${gen.jsonCharReplacer(item.productphoto,-1)}`
                                            })
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-2"
                                        },
                                        css:css,
                                        html:item.productname
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-2"
                                        },
                                        css:css,
                                        html:quantitySection.html(inputQuantity)
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-2"
                                        },
                                        css:css,
                                        html:`${rateSymbol} ${item.price}`
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-2"
                                        },
                                        css:css,
                                        html:totalAmountSection.html(`${rateSymbol} ${item.total}`)
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-1"
                                        },
                                        css:css,
                                        html:()=>{
                                            return gen.anchor({
                                                icon:"icon-plus icons",
                                                css:{
                                                    cursor:"pointer",
                                                    fontWeight:"bolder",
                                                    color:"#000"
                                                },
                                                data:{
                                                    quatitysection:quantitySection,
                                                    totalamountsection:totalAmountSection,
                                                    item:item,
                                                    row:parent,
                                                    input:inputQuantity
                                                },
                                                callback:e =>{
                                                    e.preventDefault();
                                                    adderOrDidacter({
                                                        e:e,
                                                        type:"adder"
                                                    });
                                                }
                                            });
                                        }
                                    },
                                ]
                            },
                        ]).init());
                    };
                    const rowTotal = function(__annonymFunctionOptions){
                        const totalAmount = __annonymFunctionOptions.totalamount;
                        const rateSymbol = __annonymFunctionOptions.ratesymbol;
                        const parentDiv = $(gen.createEl("div")).css({
                            border:"1px solid #f8f9fa",
                            margin:"2px 2px 5px 2px",
                            padding:"5px",
                            borderRadius:"3px"
                        });
                        return parentDiv.html(gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            textTransform:"uppercase",
                                            fontWeight:"bolder"
                                        },
                                        html:text["total"][lang]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6",
                                            cartform:text["cart-form-tota-amount-section"]
                                        },
                                        css:{
                                            textTransform:"uppercase",
                                            fontWeight:"bolder",
                                            textAlign:"right"
                                        },
                                        html:`${rateSymbol} ${totalAmount}`
                                    }
                                ]
                            }
                        ]).init());
                    };
                    const baseUI = $(gen.createEl("div")).html(function(){
                        let rows = []
                        if(allVariables.cartinformation !== null && allVariables.cartinformation!== undefined && allVariables.cartinformation.hasOwnProperty("rows")){
                            if(Array.isArray(allVariables.cartinformation.rows) && allVariables.cartinformation.rows.length > 0){
                                let counter = 0;
                                let totalAmount = 0;
                                const rateSymbol = allVariables.cartinformation.ratesymbol;
                                for(let i = 0; i < allVariables.cartinformation.rows.length; i++){
                                    counter++;
                                    const item = allVariables.cartinformation.rows[i];
                                    const rowDiv = $(gen.createEl("div"));
                                    totalAmount += parseFloat(item.total);
                                    rows.push(rowUI({
                                        item:item,
                                        ratesymbol:allVariables.cartinformation.ratesymbol,
                                        n:counter
                                    }));
                                }
                                rows.push(rowTotal({
                                    totalamount:totalAmount,
                                    ratesymbol:rateSymbol
                                }));
                            }
                        }
                        return rows;
                    });
                    return baseUI;
                },
                agentblock:__functionOptions=>{
                    const rowUI = function(__annonymFunctionOptions){
                        const item = __annonymFunctionOptions.item;
                        let agentEditedValue = null;
                        if(__functionOptions.hasOwnProperty("agentservicerows") && Array.isArray(__functionOptions.agentservicerows) && __functionOptions.agentservicerows.length > 0){
                            const service = __functionOptions.agentservicerows.filter(el=>{return parseInt(el.serviceid) === parseInt(item.id)});
                            if(service[0].hasOwnProperty("agentid")){
                                agentEditedValue = service[0].agentid;
                            }
                        }
                        const parent = $(gen.createEl("div"));
                        parent.css({
                            padding:"5px",
                            border:"1px #f8f9fa solid",
                            margin:"5px 2px 5px 2px",
                            borderRadius:"3px"
                        }).attr({
                            cartformserviceid:item.id
                        });
                        parent.html(gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        html:item.productname
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        html:() =>{
                                                    const agentObject = methodOptions.customizedsettings.agent;
                                                    const photoColumn = agentObject.agentphotocolumn;
                                                    const fullnameColumns = agentObject.agentfullnamecolumn
                                                    const columns = [photoColumn].concat(fullnameColumns);
                                                    const callData = me.dataCaller({
                                                    blockid:agentObject.blockid,
                                                    columns:columns
                                                     });
                                                    const dataArray = callData.data;
                                                    return gen.dropDownFromArray({
                                                        attr:{
                                                            class:"form-control single-select",
                                                            cartform:text["product-or-service-agent"]
                                                        },
                                                        editedvalue:agentEditedValue,
                                                        legend:text["select-agent"][lang],
                                                        array:dataArray,
                                                        id:"id",
                                                        output:(arr) =>{
                                                            if(Array.isArray(fullnameColumns) && fullnameColumns.length >0){
                                                                const output = [];
                                                                fullnameColumns.forEach(item =>{
                                                                    if(arr[item]!==undefined){
                                                                        output.push(arr[item]);
                                                                    }
                                                                });
                                                                return output.join(" ");
                                                            }
                                                        },
                                                        onchange:e=>{
                                                            const value = parseInt(e.target.value);
                                                                    if(Array.isArray(allVariables.cartinformation.agentservicerows) && allVariables.cartinformation.agentservicerows.length > 0){
                                                                   
                                                                        for(let i = 0; i < allVariables.cartinformation.agentservicerows.length; i++){
                                                                            const agentservicerow = allVariables.cartinformation.agentservicerows[i];
                                                                            if(parseInt(item.id) === parseInt(agentservicerow.serviceid)){
                                                                                if(value > 0){
                                                                                    allVariables.cartinformation.agentservicerows[i].agentid = parseInt(value);
                                                                                    allVariables.cartinformation.agentservicerows[i].agentfullname = $(e.target).children("option:selected").html();
                                                                                }else{
                                                                                    if(allVariables.cartinformation.agentservicerows[i].hasOwnProperty("agentid") && allVariables.cartinformation.agentservicerows[i].hasOwnProperty("agentfullname")){
                                                                                        delete allVariables.cartinformation.agentservicerows[i].agentid;
                                                                                        delete allVariables.cartinformation.agentservicerows[i].agentfullname;
                                                                                    }
                                                                                }
                                                                               
                                                                            }
                                                                        }
                                                                   
                                                                    
                                                                    }
                                                           
                                                            
                                                           
                                                        }
                                                    });
                                        }
                                    }
                                ]
                            }
                        ]).init());
                        return parent;
                    };
                    
                    if(__functionOptions!==null && __functionOptions!==undefined && __functionOptions.hasOwnProperty("rows") && Array.isArray(__functionOptions.rows) && __functionOptions.rows.length > 0){
                        let rows = [];
                        const baseUI = $(gen.createEl("div"));
                        for(let i = 0; i < __functionOptions.rows.length; i++){
                            const item = __functionOptions.rows[i];
                            rows.push(rowUI({
                                item:item
                            }));
                        }
                         baseUI.html(rows);
                         return baseUI;
                    }
                },
                dataEdit:__functionOptions=>{
                    if(dataRow!== undefined){
                        return gen.getObjectFromJSON(dataRow.data);
                    }
                },
                paymentmethod:__functionOptions=>{
                    const paymentMethodObject = __functionOptions.customizedsettings.paymentmethod;
                    const columns = paymentMethodObject.paymentmethodcolumname;
                    const callData = me.dataCaller({
                        blockid:paymentMethodObject.blockid,
                        columns:columns
                    });
                    const editedValue = function(){
                        if(__objects.dataEdit()!==null && editedValue && __objects.dataEdit()!==undefined){
                            return __objects.dataEdit()[__functionOptions.customizedsettings.row.paymentmethodcolumn].fkid;
                        }
                        return null;
                    }
                    if(callData.statuscode === 200){
                        return gen.dropDownFromArray({
                            array:callData.data,
                            id:"id",
                            output:columns,
                            attr:{
                                class:"form-control",
                                cartform:text["payment-method-dropdown"]
                            },
                            legend:text["select-payment-method"][lang],
                            editedvalue:editedValue()
                        })
                    }
                },
                searchClientResultRow : function(__annonymFunctionOptions){
                    const item = __annonymFunctionOptions.item;
                    const photoColumn = __annonymFunctionOptions.photocolumn;
                    const photoPath = gen.jsonCharReplacer(`../${__annonymFunctionOptions.editedclientphoto!==undefined?__annonymFunctionOptions.editedclientphoto:item[photoColumn]}`,-1);
                    const fullnameColumns = __annonymFunctionOptions.fullnamecolumns;
                    let fullname = []; if(Array.isArray(fullnameColumns)){fullnameColumns.forEach(val =>{fullname.push(item[val]);});} fullname = fullname.join(" "); if(__annonymFunctionOptions.editedclientfullname !== undefined){fullname = __annonymFunctionOptions.editedclientfullname;}
                    let icon = $(gen.createEl("i")).addClass("icon-question icons").css({fontSize:"18px"});
                    let onclick = function(){
                        return {
                            type:"click",
                            data:{
                                fullname:fullname,
                                client:item,
                                searchsection:__annonymFunctionOptions.searchsection,
                                input:__annonymFunctionOptions.input
                            },
                            callback: e =>{
                                const me = $(e.target).parent(`div[cartform="${text["client-search-result"]}"]`);
                                $(me).find(`div[cartform="${text["search-result-icon-validation"]}"]`).html($(gen.createEl("i")).addClass("icon-check icons").css({color:"#28a745"}))
                                e.data.searchsection.html(me);
                                $(e.data.input).val("");
                                allVariables.cartinformation.client = {
                                    clientfullname:gen.getLetterFromString(e.data.fullname),
                                    clientid:e.data.client.id,
                                    clientphoto:e.data.client[photoColumn]
                                };
                            }
                        };
                    };
                    if(__annonymFunctionOptions.editedclientfullname){
                        icon.removeAttr("class");
                        icon.addClass("icon-check icons").css({color:"#28a745"});
                        allVariables.cartinformation.client = {
                            clientfullname:__annonymFunctionOptions.editedclientfullname,
                            clientid:__annonymFunctionOptions.editedclientid,
                            clientphoto:__annonymFunctionOptions.editedclientphoto
                        };
                        onclick = ()=>{return undefined;}
                    }
                    const objUI = gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row",
                                cartform:text["client-search-result"]
                            },
                            css:{
                                cursor:"pointer"
                            },
                            on:onclick(),
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-2"
                                    },
                                    css:{
                                        display:"flex",
                                        justifyContent:"center",
                                        alignItems:"center"
                                    },
                                    children:[
                                        {
                                            element:"img",
                                            attr:{
                                                src:photoPath
                                            },
                                            css:{
                                                height:"50px",
                                                width:"50px",
                                                borderRadius:"100px"
                                            }
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-8"
                                    },
                                    css:{
                                        display:"flex",
                                        justifyContent:"center",
                                        alignItems:"center",
                                        fontWeight:"500"
                                    },
                                    html:gen.getLetterFromString(fullname)
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-2",
                                        cartform:text["search-result-icon-validation"]
                                    },
                                    css:{
                                        display:"flex",
                                        justifyContent:"center",
                                        alignItems:"center",
                                        fontWeight:"500"
                                    },
                                    html:icon
                                }
                            ]
                        }
                    ]).init();
                    return $(gen.createEl("div"))
                     .css({
                         margin:"5px",
                         backgroundColor:"rgb(239, 239, 239)",
                         border:"1px #f8f9fa solid",
                         padding:"5px"
                     })
                    .html(objUI);
                },
                searchClient:e=>{
                    const input = e.data.input;
                    const data = e.data.data;
                    const columns = e.data.columns;
                    const keyword = $(input).val().toLowerCase();
                    const searchSection  = e.data.resultsection;
                    const photoColumn = e.data.photocolumn;
                    const fullnameColumns = e.data.fullnamecolumns;
                    let foundClients = [];
                    const dataMatchesAtLeastOneOccurency = function(columns,row,keyword){
                        let n = 0;
                        if(Array.isArray(columns) && columns.length > 0){
                            for(let i = 0; i < columns.length; i++){
                                if(row[columns[i]].toLowerCase().indexOf(keyword) > -1){
                                    n++;
                                }
                            }
                            return n;
                        }
                        else{
                            if(row[columns].toLowerCase().indexOf(keyword) > -1){
                                return 1;
                            }
                            return 0;
                        }
                    };
                    if(input.val().length < 1){
                        swal(text["alert"][lang],text["add-keyword"][lang],"warning");
                        input.focus();
                        return false;
                    }
                    if(Array.isArray(data) && data.length > 0){
                        for(let i = 0; i < data.length; i++){
                            if(dataMatchesAtLeastOneOccurency(columns,data[i],keyword) > 0){
                                foundClients.push(data[i]);
                            }
                        }
                    }
                    let clientList = [];
                    if(foundClients.length > 0){
                        foundClients.forEach(item =>{
                            clientList.push(__objects.searchClientResultRow({
                                item:item,
                                photocolumn:photoColumn,
                                fullnamecolumns:fullnameColumns,
                                searchsection:searchSection,
                                input:input 
                            }));
                        }); 
                    }
                    else{
                        clientList =[
                            $(gen.createEl("i")).addClass("icon-exclamation icons").css({color:"rgb(255, 193, 7)"}),
                            $(gen.createEl("span")).html(gen.superReplacer(text["no-client-found"][lang],"@keyword",keyword.bold())).css({marginLeft:"5px"})
                        ]
                    }
                    $(searchSection)
                    .css({
                        backgroundColor:"#f7f7ff",
                        padding:"5px",
                        margin:"10px 0px 10px 0px",
                        borderRadius:"3px"
                    })
                    .html(clientList);
                },
                addProductToCartAnchor:__functionOptions =>{
                    return gen.anchor({
                        element:anchorAddProduct,
                        icon:"fa fa-plus",
                        title:text["cart-form-add-product-or-service"][lang],
                        css:{
                            cursor:"pointer"
                        },
                        data:{
                            object:__functionOptions
                        },
                        attr:{
                            cartform:text["cart-form-trigger-product-modal-box"]
                        },
                        callback:e=>{
                            e.preventDefault();
                            __objects.addProductToCartModalBox(e.data.object);
                        }
                    })
                },
                addProductToCartModalBox : __functionOptions =>{
                    gen.modalBoxUI({
                        bg:"bg-light",
                        textcolor:"text-dark",
                        modalid: "sdapp-default-size-modal",
                        size: "modal-lg",
                        title: text["products-or-services"][lang],
                        content: (me) => {
                            __functionOptions.modalboxsection = me;
                           __objects.productsTableUI(__functionOptions);
                           $('[data-toggle="tooltip"]').tooltip();
                            $(me).css({
                               height:"500px",
                               overflow:"auto" 
                            })
                        },
                        footer: text["sdapp-copyright"][lang].replace("@date", gen.currentDate())
                    });
                    $('[data-toggle="tooltip"]').tooltip();
                },
                productsTableUI : (__functionOptions)=>{
                    const productObject = __functionOptions.customizedsettings.product;
                    const productNameColumn = productObject.productnamecolumn;
                    const productPhotoColumn = productObject.productphotocolumn;
                    const productPriceColumn = productObject.productpricecolumn;
                    const columns = [productNameColumn,productPhotoColumn,productPriceColumn];
                    const rateSymbol = __functionOptions.customizedsettings.rate.ratesymbol;
                    const callData = me.dataCaller({
                       blockid:productObject .blockid,
                       columns:columns
                   });
                   const dataArray = callData.data;
                    if(Array.isArray(dataArray) && dataArray.length > 0){
                        const tableSection = $(gen.createEl("div"));
                        const UISection = $(gen.createEl("div"));
                        const searchSection = $(gen.createEl("div"));
                        const productSelector = $(gen.createEl("div")).attr({class:"col-lg-3"});
                        const selectorButton = $(gen.createEl("button"))
                        .on("click",e =>{
                            e.preventDefault();
                            let productServices = [];
                            let agentServices = [];
                            $(`tbody[cartform="${text["cartform-product-service-tbody"]}"]`).find(`tr`).each(function(trIndex,trElement){
                                const input = $(trElement).children(`td:eq(0)`).find(`input[type="checkbox"]:checked`)
                                const inputVal = parseInt(input.val());
                                if(input.length > 0){
                                    const rowObject = dataArray.filter(item=>{return parseInt(item.id) === inputVal;})[0];
                                    rowObject.productname = rowObject[productNameColumn];
                                    rowObject.productphoto = rowObject[productPhotoColumn];
                                    rowObject.append = true;
                                    rowObject.qty = 1;
                                    rowObject.total = rowObject.qty * parseInt(rowObject[productPriceColumn]);
                                    rowObject.price = parseInt(rowObject[productPriceColumn]);
                                    productServices.push(rowObject);
                                    agentServices.push({
                                        serviceid:rowObject.id,
                                        servicename:rowObject[productNameColumn]
                                    });
                                } 
                            });
                            __objects.productRowAdder({
                                ratesymbol:rateSymbol,
                                productservices:productServices,
                                productpricecolumn:productPriceColumn,
                                agentservices:agentServices
                            }); 

                            __functionOptions.productsection.html(__objects.productblock(allVariables.cartinformation));
                            __functionOptions.agentsection.html(__objects.agentblock(allVariables.cartinformation));
                            sdapp.activateSelect2();
                            gen.closeModal();
                        })
                        .html([
                            `<i class="fa fa-plus" style="margin-right:3px;"></i>`,
                            text["add-products-or-services"][lang]
                        ])
                        .css({
                            marginBottom:"10px",
                            width:"100%"
                        })
                        .attr({
                            class:"btn",
                            cartform:text["cart-form-select-all-items-button"]
                        });
                        const __table = __annonymFunctionOptions =>{
                            const table = $(gen.createEl("table"));
                            const tbody = $(gen.createEl("tbody")).attr({cartform:text["cartform-product-service-tbody"]});
                            const thead = $(gen.createEl("thead"));
                            let rows = [];
                            thead.html(gen.tableRow([
                                {
                                    html:() =>{
                                        return $(gen.createEl("input")).attr({
                                            type:"checkbox"
                                        })
                                        .on("click", e =>{
                                            let html = "";
                                            let checked = false
                                            if(e.target.checked === true){
                                                html = selectorButton;
                                                checked = true;
                                            }
                                            if(gen.isElementExistsInDOM($(`button[cartform="${text["cart-form-select-all-items-button"]}"]`)) === false){
                                                productSelector.html(html);
                                            }
                                            tbody.find(`tr`).each(function(trIndex,trElement){
                                                $(trElement).children(`td:eq(0)`).find(`input[type="checkbox"]`).prop("checked",checked);
                                            })
                                        });
                                    }
                                },
                                {
                                    html:text["photo"][lang]
                                },
                                {
                                    html:text["product-or-service"][lang]
                                },
                                {
                                    html:text["price"][lang]
                                },
                                {
                                    html:text["action"][lang],
                                    css:{
                                        textAlign:"right"
                                    }
                                }
                            ],{
                             td:"th"   
                            }));
                            __annonymFunctionOptions.array.forEach(item=>{
                                rows.push(gen.tableRow([
                                    {
                                        html:() =>{
                                            return $(gen.createEl("input"))
                                            .attr({type:"checkbox",value:item.id,cartfom:text["available-product"]})
                                            .on("click",e=>{
                                                if(e.target.checked === true){
                                                    const html = selectorButton;
                                                    if(gen.isElementExistsInDOM($(`button[cartform="${text["cart-form-select-all-items-button"]}"]`)) === false){
                                                        productSelector.html(html)
                                                    }
                                                }
                                                
                                            });
                                        }
                                    },
                                    {
                                        html:() =>{
                                            return $(gen.createEl("img")).attr({
                                                src:`../${gen.jsonCharReplacer(item[productPhotoColumn],-1)}`
                                            }).css({
                                                width:"50px",
                                                height:"50px"
                                            })
                                        }
                                    },
                                    {
                                        html:gen.jsonCharReplacer(item[productNameColumn],-1)
                                    },
                                    {
                                        html:`${rateSymbol} ${gen.jsonCharReplacer(item[productPriceColumn],-1)}`
                                    },
                                    {
                                        html:()=>{
                                            return gen.anchor({
                                                icon:"fa fa-plus",
                                                css:{
                                                    cursor:"pointer"
                                                },
                                                attr:{
                                                    title:text["add"][lang],
                                                    "data-toggle":"tooltip",
                                                    "data-placement":"top"
                                                },
                                                callback:e =>{
                                                    e.preventDefault();
                                                    item.productname = item[productNameColumn];
                                                    item.productphoto = item[productPhotoColumn];
                                                    item.qty = 1;
                                                    item.total = 1 * parseInt(item[productPriceColumn]);
                                                    item.price = parseInt(item[productPriceColumn]);
                                                    const service = {
                                                        servicename:item[productNameColumn],
                                                        serviceid:item.id
                                                    };
                                                    __objects.productRowAdder({
                                                        ratesymbol:rateSymbol,
                                                        productservices:[item],
                                                        agentservices:[service],
                                                        productpricecolumn:productPriceColumn
                                                    });
                                                    __functionOptions.productsection.html(__objects.productblock(allVariables.cartinformation));
                                                    __functionOptions.agentsection.html(__objects.agentblock(allVariables.cartinformation));
                                                    sdapp.activateSelect2();
                                                    gen.closeModal();
                                                
                                                }
                                            })
                                        },
                                        css:{
                                            textAlign:"right"
                                        }
                                    }
                                ]));
                            });
                            table.attr({class:"table table-striped",width:"100%"});
                            tbody.html(rows);
                            table.html([thead,tbody]);
                            return table;
                        };
                        const __searchProduct = __annonymFunctionOptions =>{
                            const keyword = __annonymFunctionOptions.value.toLowerCase();
                            let  array = __annonymFunctionOptions.array;
                            const productnamecolumn = __annonymFunctionOptions.productnamecolumn;
                            array = array.filter(item =>{ return item[productnamecolumn].toLowerCase().indexOf(keyword) > -1;});
                            __annonymFunctionOptions.section.html(__table({
                                array:array
                            }))
                        };
                        const searchRow = gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:productSelector
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        children:[
                                            {
                                                element:"input",
                                                attr:{
                                                    type:"text",
                                                    placeholder:text["search-product-or-service"][allVariables.lang],
                                                    class:"form-control",
                                                    name:text["search-product-service-input"]
                                                },
                                                css:{
                                                    marginBottom:"10px"
                                                },
                                                on:{
                                                    type:"keypress",
                                                    callback:e=>{
                                                        const value = e.target.value;
                                                        if(e.which === 13 || e.keyCode === 13){
                                                            __searchProduct({
                                                                value:value,
                                                                section:tableSection,
                                                                array:dataArray,
                                                                productnamecolumn:productNameColumn
                                                            });
                                                        }
                                                    }
                                                }
                                            }
                                        ]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        children:[
                                            {
                                                element:"button",
                                                attr:{
                                                    type:"button",
                                                    class:"btn"
                                                },
                                                css:{
                                                        width:"100%"
                                                    },
                                                on:{
                                                    type:"click",
                                                    callback:e=>{
                                                        const value = $(`input[type="text"][name="${text["search-product-service-input"]}"]`).val();
                                                        __searchProduct({
                                                            value:value,
                                                            section:tableSection,
                                                            array:dataArray,
                                                            productnamecolumn:productNameColumn
                                                        });
                                                       
                                                    }
                                                },
                                                children:[
                                                    {
                                                        element:"i",
                                                        attr:{
                                                            class:"icon-magnifier icons"
                                                        }
                                                    },
                                                    {
                                                        element:"text",
                                                        html:text["search"][lang]
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ]
                            }
                        ]).init();
                        const table = __table({array:dataArray});
                        gen.removeBorderFromTable({
                            table:table,
                            type:"all"
                        });
                        tableSection.html(table);
                        searchSection.html(searchRow); 
                        $(__functionOptions.modalboxsection).html(UISection.html([searchSection,tableSection]));
                    }
                    else{
                        return text["no-product-or-service-avaiable"][lang]
                    }
                },
                productRowAdder:(__functionOptions)=>{
                    const productPriceColumn = __functionOptions.productpricecolumn;
                    const productServices = __functionOptions.productservices;
                    const rateSymbol = __functionOptions.ratesymbol;
                    const agentServices = __functionOptions.agentservices;
                    if(allVariables.cartinformation.hasOwnProperty("rows")){
                        for(let i = 0; i < productServices.length; i++){
                            const newRow = productServices[i];
                            const agentServiceRow = {
                                serviceid:newRow.id,
                                servicename:newRow.productname
                            };
                            newRow.append = true;
                            let approveAddNewProduct = 1;
                            for(let x = 0; x < allVariables.cartinformation.rows.length; x++){
                                const existingRow = allVariables.cartinformation.rows[x];
                                if(parseInt(newRow.id) === parseInt(existingRow.id)){
                                    approveAddNewProduct = 0;
                                    existingRow.qty = existingRow.qty + 1;
                                    existingRow.total = parseInt(existingRow.qty) * parseInt(existingRow[productPriceColumn]);
                                    existingRow.append = undefined;
                                }
                            }
                            if(approveAddNewProduct > 0){
                               allVariables.cartinformation.rows.push(newRow);
                               allVariables.cartinformation.agentservicerows.push(agentServiceRow);
                            }
                            
                        }

                    }
                    else{
                        allVariables.cartinformation.rows = productServices;
                        allVariables.cartinformation.agentservicerows = agentServices;
                        allVariables.cartinformation.ratesymbol = rateSymbol;
                    }
                },
                dataSaving:(__functionOptions)=>{
                    let buttonText = text["cart-form-save-payment"][lang];
                    let buttonIcon = "fa fa-save";
                    let buttonAction = "save";
                    if(__objects.dataEdit() !== null && __objects.dataEdit() !== undefined){
                        buttonText = text["cart-form-update-payment"][lang];
                        buttonIcon = "fa fa-pencil",
                        buttonAction = "edit";
                    }
                    return $(gen.button(
                        "cart-form-save-button-id",
                        "cart-form-save-button-name",
                        "btn",
                        buttonText,
                        e =>{
                            e.preventDefault();
                            const paymentMethod = $(`select[cartform="${text["payment-method-dropdown"]}"]`);
                            if(paymentMethod.val().length < 1){
                                swal(text["alert"][lang],text["payment-method-warning"][lang],"warning");
                                paymentMethod.focus();
                                return false;
                            }
                            if(allVariables.cartinformation.hasOwnProperty("client") === false){
                                swal(text["alert"][lang],text["cart-form-client-warning"][lang],"warning");
                                $(`input[cartform="${text["cart-form-search-client-input"]}"]`).focus();
                                return false;
                            }
                            if(allVariables.cartinformation.hasOwnProperty("rows") === false){
                                anchorAddProduct.trigger("click");
                                return false;
                            }
                            const agentservicerows = allVariables.cartinformation.agentservicerows;
                            for(let i = 0; i < agentservicerows.length; i++){
                                if(agentservicerows[i].hasOwnProperty("agentid") === false){
                                    swal(text["alert"][lang],gen.superReplacer(text["select-agent-on-service"][lang],"@serviceorproduct",agentservicerows[i].servicename),"warning");
                                    return false;
                                }
                            }
                            const action = function(){
                                return {
                                    callback:()=>{
                                        const data = {};
                                        const operationNumber = `op-${gen.random(8)}-${allVariables.cartinformation.client.clientid}`;
                                        const paymentMethodTitle = paymentMethod.find(`option:selected`).html();
                                        allVariables.cartinformation.operationnumber = operationNumber;
                                        allVariables.cartinformation.paymentmethod = paymentMethodTitle; 
                                        data["cartinformation"] = allVariables.cartinformation;
                                            data[methodOptions.customizedsettings.row.operationnumbercolumn]= operationNumber;
                                            data[methodOptions.customizedsettings.row.clientcolumn]={
                                                fkid: allVariables.cartinformation.client.clientid,
                                                blockid: methodOptions.customizedsettings.client.blockid,
                                                columns: [methodOptions.customizedsettings.client.clientfullnamecolumnoutput],
                                                themeid:themeId
                                            };
                                            data[methodOptions.customizedsettings.row.paymentmethodcolumn]={
                                                fkid: parseInt(paymentMethod.val()),
                                                blockid: methodOptions.customizedsettings.paymentmethod.blockid,
                                                columns: [methodOptions.customizedsettings.paymentmethod.paymentmethodcolumname],
                                                themeid:themeId
                                            };
                                            data[methodOptions.customizedsettings.row.amoutpaidcolumn]=(rows =>{
                                                let total = 0;
                                                if(Array.isArray(rows)){
                                                    rows.forEach(item=>{
                                                        total+= parseFloat(item.total);
                                                    });
                                                }
                                                return `${allVariables.cartinformation.ratesymbol} ${total}`;
                                            })(allVariables.cartinformation.rows);

                                        if(buttonAction ==="save"){
                                            gen.url(false, gen.serverSideUrl, {
                                                key: "sqlwrite",
                                                table:"sdappdata",
                                                fieldandvalues: {
                                                    sdappdataid: "NULL",
                                                    themeid:themeId,
                                                    blockid:__row[0],
                                                    data:data,
                                                    createdby: allVariables.userid
                                                }
                                            }, false, 1);  
                                        }
                                        else{
                                            gen.url(false, gen.serverSideUrl, {
                                                key: "sqledit",
                                                table:"sdappdata",
                                                fieldandvalues: {
                                                    themeid:themeId,
                                                    blockid:__row[0],
                                                    data:data,
                                                    createdby: allVariables.userid
                                                },
                                                referencefield: "sdappdataid",
                                                referenceid: dataRow[0]
                                            }, false, 1);
                                        }
                                        sdapp.sdapp_Access_Menu({
                                         key: `view-record-form-token-${sdapp.editSmartUrl({ id:__row[0], encription: text["url-encription-page-id"] }).id}`
                                        });
                                        __objects.print({
                                            cartinformation:allVariables.cartinformation
                                        });
                                       
                                    },
                                    warning:() =>{
                                        if(buttonAction ==="save"){
                                            return text["cart-form-save-warning"][lang];
                                        }
                                        return text["cart-form-edit-warning"][lang];
                                    },
                                    success:() =>{
                                        if(buttonAction ==="save"){
                                            return text["cart-form-save-success"][lang];
                                        }
                                        return text["cart-form-edit-success"][lang];
                                    }
                                };
                            };
                            gen.sweetWarningMsgBox(
                                action().callback,
                                text["alert"][allVariables.lang],
                                action().warning(),
                                action().success(),
                                text["sdapp-no-action-done"][allVariables.lang]
                            );
                            
                        },
                        buttonIcon
                        )).css({
                            width:"100%"
                        });
                },
                print: __functionOptions =>{
                    if(allVariables.cartinformation === undefined){
                        allVariables.cartinformation = __functionOptions.cartinformation;
                    }
                    const table = function(){
                            const rateSymbol = allVariables.cartinformation.ratesymbol;
                            let total =  0;
                            const table = $(gen.createEl("table")).attr({width:"100%"});
                            let rows = [];
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["payment-method"][lang]
                                },
                                {
                                    html:__functionOptions.cartinformation.paymentmethod
                                }
                            ]);
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["operation-number"][lang]
                                },
                                {
                                    html:__functionOptions.cartinformation.operationnumber
                                }
                            ]);
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["client"][lang]
                                },
                                {
                                    html:__functionOptions.cartinformation.client.clientfullname,
                                    attr:{
                                        colspan:4
                                    }
                                }
                            ]);
            
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["services-or-products"][lang],
                                    css:{
                                        textTransform:"uppercase",
                                        textAlign:"left"
                                    },
                                    attr:{
                                        colspan:5
                                    }
                                }
                            ]);
                            if(Array.isArray(allVariables.cartinformation.rows) && allVariables.cartinformation.rows.length > 0){
                                let n = 0;
                                rows[rows.length] = gen.tableRow([
                                    {
                                        html:text["num"][lang],
                                        css:{
                                            textTransform:"uppercase"
                                        }
                                    },
                                    {
                                        html:text["item"][lang],
                                        css:{
                                            textTransform:"uppercase"
                                        }
                                    },
                                    {
                                        html:text["qty"][lang],
                                        css:{
                                            textTransform:"uppercase",
                                            textAlign:"right"
                                        }
                                    },
                                    {
                                        html:text["pu"][lang],
                                        css:{
                                            textAlign:"right",
                                            textTransform:"uppercase"
                                        }
                                    },
                                    {
                                        html:text["pt"][lang],
                                        css:{
                                            textAlign:"right",
                                            textTransform:"uppercase"
                                        }
                                    }
                                ]);
                                allVariables.cartinformation.rows.forEach(item=>{
                                    n++;
                                    total+=parseFloat(item.total);
                                    rows.push(gen.tableRow([
                                        {
                                            html:n
                                        },
                                        {
                                            html:item.productname
                                        },
                                        {
                                            html:item.qty,
                                            css:{
                                                textAlign:"right"
                                            }
                                        },
                                        {
                                            html:`${rateSymbol}${item.price}`,
                                            css:{
                                                textAlign:"right"
                                            }
                                        },
                                        {
                                            html:`${rateSymbol}${item.total}`,
                                            css:{
                                                textAlign:"right"
                                            }
                                        }
                                    ]));
                                });
                                
                            }
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["total"][lang],
                                    css:{
                                       textTransform:"uppercase",
                                       fontWeight:"bold" 
                                    },
                                    attr:{
                                        colspan:4
                                    }
                                },
                                {
                                    html:`${rateSymbol}${total}`,
                                    css:{
                                        textTransform:"uppercase",
                                        fontWeight:"bold",
                                        textAlign:"right"
                                    }
                                }
                            ]);
                            table.html(rows);
                            return table;
                    };
                    const printingSection = $(gen.createEl("div"));
                    printingSection
                    .html(table())
                    .attr({id:text["cart-form-printing-section"]})
                    .css({
                        display:"none"
                    });
                    if(__functionOptions.hasOwnProperty("returncontent") && __functionOptions.returncontent === true){
                        return table();
                    }
                    if(gen.isElementExistsInDOM($(`div#${text["cart-form-printing-section"]}`)) === false){
                        $(`body`).append(printingSection);
                    }
                    else{
                        $(`div#${text["cart-form-printing-section"]}`).replaceWith(printingSection);
                    }
                    gen.print({
                        divid:text["cart-form-printing-section"],
                        type:2,
                        pagetitle:__functionOptions.cartinformation.operationnumber
                    });
                    
                },
                init:(__functionOptions) =>{
                    let children = [];
                    //payment method block starts
                    children[children.length] = me.block({
                        icon:"fa fa-money",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["payment-method"][lang],
                        content:__objects.paymentmethod(__methodOptions)
                    }); 
                    //payment method block end
                    //client search block starts
                    children[children.length] = me.block({
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        icon:"fa fa-users",
                        title:text["client-search"][lang],
                        content:__objects.clientblock(__methodOptions)
                    }); 
                    //client search block ends
                    //product search block starts
                    const productSection = $(gen.createEl("div"));
                    if(__objects.dataEdit()!== null && __objects.dataEdit()!== undefined){
                        productSection.html(__objects.productblock(__objects.dataEdit().cartinformation))
                    }
                    const agentSection = $(gen.createEl("div"));
                    if(__objects.dataEdit()!== null && __objects.dataEdit()!== undefined){
                        agentSection.html(__objects.agentblock(__objects.dataEdit().cartinformation));
                    }
                    __methodOptions.productsection = productSection;
                    __methodOptions.agentsection = agentSection;
                    children[children.length] = me.block({
                        icon:"fa fa-shopping-cart",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["product-search"][lang],
                        rightcontent:__objects.addProductToCartAnchor(__methodOptions),
                        content:productSection
                    }); 
                    //product search block ends
                    //agent search block starts
                    children[children.length] = me.block({
                        icon:"icon-people",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["agent-search"][lang],
                        content:agentSection
                    }); 
                    //agent search block ends
                    //save block starts
                    children[children.length] = me.block({
                        icon:"fa fa-database",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["data-saving"][lang],
                        content:__objects.dataSaving(__methodOptions)
                    }); 
                    //save block ends
                    return $(gen.createEl("div"))
                    .css({
                        backgroundColor:"#fff",
                        float:"left",
                        width:"100%",
                        display:"flex"
                    }).html(gen.objectInterfaceMaker([{element:"div",css:{margin:"5px"},children:children}]).init());
                }
            };
            return __objects;
        }
        this.bookingform = __methodOptions =>{
            allVariables.bookingforminvocing = {};
            const __objects = {
                availabilityForm:(__functionOptions) =>{
                    const uiSection = __functionOptions.uisection;
                    const uiInvoicing = __functionOptions.uiinvoicing;
                    const roomData = me.dataCaller({
                        blockid:__methodOptions.customizedsettings.availability.room.blockid,
                        columns:Object.values(__methodOptions.customizedsettings.availability.room.columns)
                    }).data;
                    let diffDay =  8;
                    let dateStarter = undefined;
                    if(__functionOptions.hasOwnProperty("datefrom")){
                        diffDay = parseInt(gen.url(false, gen.serverSideUrl, {
                            key: `calluserfunctionarray`,
                            class: `control`,
                            method: `diffBetweenTwoDates`,
                            parameters: [
                                __functionOptions.dateto,
                                __functionOptions.datefrom
                            ],
                        }, false, 1)) + 1;
                        dateStarter = __functionOptions.datefrom;
                    }
                    const table = $(gen.createEl("table")),
                    thead = $(gen.createEl("thead")),
                    tbody = $(gen.createEl("tbody"));
                    const thTdSetter = function(__annonymFunctionOptions){
                        let  dayMax = __annonymFunctionOptions.daymax;
                        const roomItem = __annonymFunctionOptions.roomitem!==undefined ? __annonymFunctionOptions.roomitem : undefined;
                        return {
                            th:() =>{
                                let th = [];
                                th[th.length] = {
                                    html:text["booking-form-features"]["usage"]["availability-form"]["room-types"][lang],
                                    css:{
                                        fontWeight:"bold"
                                    }
                                };
                                for(let i = 0; i< dayMax; i++){
                                    const addDate = gen.dateTime({
                                        datestarter:dateStarter
                                    }).add(i);
                                    th.push({
                                        html:`${gen.frDate(addDate.date)}<br/>${addDate.day(lang)}`
                                    });
                                }
                                return th;
                            },
                            td:() =>{
                                const roomTypeColumn = __methodOptions.customizedsettings.availability.room.columns.roomtype;
                                const roomPriceColumn = __methodOptions.customizedsettings.availability.room.columns.roomprice;
                                const roomNUmberColumn = __methodOptions.customizedsettings.availability.room.columns.roomprice;
                                const roomRangeColumn = __methodOptions.customizedsettings.availability.room.columns.roomrange;
                                let td = [];
                                td[td.length] = {
                                    html:`${roomItem[roomTypeColumn]}<br/> <small> USD ${roomItem[roomPriceColumn]} ${text["booking-form-features"]["usage"]["availability-form"]["per-night"][lang]}</small>`,
                                    css:{
                                        textTransform:"uppercase"
                                    }
                                };
                                for(let i = 0; i< dayMax; i++){
                                    const addDate = gen.dateTime({
                                        datestarter:dateStarter
                                    }).add(i);
                                    const availableRoom = roomItem[roomNUmberColumn];
                                    const maxRoom = roomItem[roomNUmberColumn];
                                    const availabilitySection = $(gen.createEl("div")).html(`${availableRoom}/${maxRoom}`).css({textAlign:"center"});
                                    const notificationSection = $(gen.createEl("div")).css({textAlign:"center"}).attr({notification:"idle"});
                                    if(allVariables.bookingforminvocing[roomItem.id] !== undefined && allVariables.bookingforminvocing[roomItem.id][addDate.date]){
                                        notificationSection.attr({
                                            notification:"booked"
                                        })
                                        .html($(gen.createEl("i")).addClass("icon-check icons").css({color:"#28a745"}));
                                    }
                                    td.push({
                                        html:() =>{
                                            return gen.objectInterfaceMaker([
                                                {
                                                    element:"div",
                                                    children:[
                                                        {
                                                            element:"div",
                                                            html:notificationSection
                                                        },
                                                        {
                                                            element:"div",
                                                            css:{
                                                                fontSize:"12px"
                                                            },
                                                            html:availabilitySection
                                                        }
                                                    ]
                                                }
                                            ]).init();
                                        },
                                        css:{
                                            cursor:"pointer"
                                        },
                                        on:{
                                            type:"click",
                                            data:{
                                                date:addDate.date,
                                                item:roomItem,
                                                maxroom:maxRoom,
                                                availableroom:availableRoom,
                                                notificationsection:notificationSection,
                                                availabilitysection:availabilitySection
                                            },
                                            callback:(e)=>{
                                                const data = e.data;
                                                if(allVariables.bookingforminvocing[data.item.id] === undefined){
                                                    allVariables.bookingforminvocing[data.item.id] = {};
                                                }
                                                allVariables.bookingforminvocing[data.item.id][data.date] = {
                                                    date:data.date,
                                                    roomid:data.item.id,
                                                    roomtype:data.item[roomTypeColumn],
                                                    roomprice:data.item[roomPriceColumn],
                                                    roomrange:data.item[roomRangeColumn]
                                                };
                                                const notificationAttr = data.notificationsection.attr("notification");
                                                if(notificationAttr === "idle"){
                                                    data.notificationsection.html($(gen.createEl("i")).addClass("icon-check icons").css({color:"#28a745"}))
                                                    .attr({
                                                        notification:"booked"
                                                    });
                                                }
                                                else{
                                                    if(allVariables.bookingforminvocing instanceof Object && allVariables.bookingforminvocing.hasOwnProperty(data.item.id)){
                                                        if(allVariables.bookingforminvocing[data.item.id].hasOwnProperty(data.date)){
                                                            gen.deletePropertyFromObject(allVariables.bookingforminvocing[data.item.id],data.date);
                                                            data.notificationsection.html("")
                                                            .attr({
                                                                notification:"idle"
                                                            });
                                                            if(Object.values(allVariables.bookingforminvocing[data.item.id]).length < 1){
                                                                delete allVariables.bookingforminvocing[data.item.id];
                                                            }
                                                        }
                                                    }
                                                }
                                                const uiInvoicing = $(__annonymFunctionOptions.uiinvoicing);
                                                const table = $(gen.createEl("table")).attr({class:"table table-bordered",border:1,width:"100%"});
                                                const tbody = $(gen.createEl("tbody"));
                                                let rows = [];
                                                rows[rows.length] = gen.tableRow([
                                                    {
                                                        html:text["booking-form-features"]["usage"]["availability-form"]["room-types"][lang],
                                                        css:{
                                                            textTransform:"uppercase",
                                                            fontSize:"12px",
                                                            fontWeight:600
                                                        }
                                                    },
                                                    {
                                                        html:text["booking-form-features"]["usage"]["availability-form"]["dates"][lang],
                                                        css:{
                                                            textTransform:"uppercase",
                                                            fontSize:"12px",
                                                            fontWeight:600
                                                        }
                                                    },
                                                    {
                                                        html:text["booking-form-features"]["usage"]["availability-form"]["amount"][lang],
                                                        css:{
                                                            textTransform:"uppercase",
                                                            fontSize:"12px",
                                                            fontWeight:600,
                                                            textAlign:"right"
                                                        }
                                                    }
                                                ],
                                                {
                                                    td:"th"
                                                });
                                                let totalAmount = 0;
                                                for(let p in allVariables.bookingforminvocing){
                                                    const obj = allVariables.bookingforminvocing[p];
                                                    if(obj instanceof Object){
                                                        rows[rows.length] = gen.tableRow([
                                                            {
                                                                html:Object.values(obj)[0].roomtype,
                                                                attr:{
                                                                    colspan:3
                                                                },
                                                                css:{
                                                                    textTransform:"uppercase",
                                                                    backgroundColor:"rgb(239, 239, 239)",
                                                                    fontWeight:600
                                                                }
                                                            }
                                                        ]);
                                                        const dateArrayObject = Object.values(obj).sort((a,b)=>(a.date > b.date)?1:-1);
                                                        for(let i = 0; i<dateArrayObject.length; i++){
                                                            const dates = dateArrayObject[i];
                                                            totalAmount+= Number(dates.roomprice);
                                                            rows.push(gen.tableRow([
                                                                {
                                                                    html:null
                                                                },
                                                                {
                                                                    html:gen.frDate(dates.date),
                                                                    css:{
                                                                        backgroundColor:"#efefef24"
                                                                    }
                                                                },
                                                                {
                                                                    html:`${dates.roomprice} USD`,
                                                                    css:{
                                                                        textAlign:"right",
                                                                        backgroundColor:"#efefef24"
                                                                    }
                                                                }
                                                            ]));
                                                        }
                                                    }
                                                }
                                                rows[rows.length] = gen.tableRow([
                                                    {
                                                        html:text["booking-form-features"]["usage"]["availability-form"]["total"][lang],
                                                        css:{
                                                            fontWeight:600,
                                                            textTransform:"uppercase",
                                                            backgroundColor:"rgb(239, 239, 239)"
                                                        }
                                                    },
                                                    {
                                                        html:`${totalAmount} USD`,
                                                        attr:{
                                                            colspan:2
                                                        },
                                                        css:{
                                                            textAlign:"right",
                                                            fontWeight:600,
                                                            textTransform:"uppercase",
                                                            backgroundColor:"rgb(239, 239, 239)"
                                                        }
                                                    }
                                                ]);
                                                tbody.html(rows);
                                                table.html(tbody);
                                                gen.removeBorderFromTable({
                                                    table:table,
                                                    type:"all"
                                                });
                                                uiInvoicing.html(table).css({
                                                    height:"900px",
                                                    overflow:"auto"
                                                });
                                                $(`#${text["booking-form-features"]["usage"]["availability-form"]["client-block"]["id"]}`).attr({
                                                    class:"col-lg-5"
                                                });
                                                
                                            }
                                        }
                                    });
                                }
                                return td;
                            }
                        }
                    }
                    /* working on heading starts */
                    let theadRows = [];
                    theadRows[theadRows.length] = gen.tableRow(thTdSetter({
                        daymax:diffDay
                    }).th(),
                    {
                        td:"th"
                    });
                    thead.html(theadRows);
                    /* working on heading ends */

                    /* working on rows starts */
                    let rows = [];
                    if(Array.isArray(roomData) && roomData.length > 0){
                        for(let i = 0; i < roomData.length; i++){
                            const item = roomData[i];
                            rows.push(gen.tableRow(thTdSetter({
                                daymax:diffDay,
                                roomitem:item,
                                uiinvoicing:uiInvoicing
                            }).td()))
                        }
                    }
                    tbody.html(rows);
                    /* working on rows ends*/
                    table.attr({
                        width:"100%",
                        class:"table table-bordered"
                    })
                    .html([
                        thead,
                        tbody
                    ]);

                    if(__functionOptions.returncontent!== null && __functionOptions.returncontent!==undefined){
                        return table;
                    }
                    return $(uiSection).html(table).attr({class:"table-responsive"});
                },
                filterAvailabilityForm:(__functionOptions) =>{
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-5"
                                    },
                                    html:()=>{
                                        return $(gen.textBox(
                                            "bf-g-a-date-from-id",
                                            "bf-g-a-date-from-name",
                                            "form-control",
                                            null,
                                            "calendar"
                                        )).removeAttr("class")
                                        .removeAttr("style")
                                        .addClass("form-control")
                                        .css({
                                            marginBottom:"5px"
                                        })
                                        .attr({
                                            placeholder:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-from"][lang]
                                        })
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-5"
                                    },
                                    html:()=>{
                                        return $(gen.textBox(
                                            "bf-g-a-date-to-id",
                                            "bf-g-a-date-to-name",
                                            "form-control",
                                            null,
                                            "calendar"
                                        )).removeAttr("class")
                                        .removeAttr("style")
                                        .addClass("form-control")
                                        .css({
                                            marginBottom:"5px"
                                        })
                                        .attr({
                                            placeholder:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-to"][lang]
                                        })
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-2"
                                    },
                                    children:[
                                        {
                                            element:"button",
                                            attr:{
                                                class:"btn"
                                            },
                                            css:{
                                                width:"100%",
                                                marginBottom:"5px"
                                            },
                                            html:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["generate"][lang],
                                            on:{
                                                type:"click",
                                                callback:e=>{
                                                    e.preventDefault();
                                                    const validation = gen.getInputValueFromValidation([
                                                        {
                                                            dom:"input",
                                                            type:"text",
                                                            name:"bf-g-a-date-from-name",
                                                            property:"datefrom",
                                                            warning:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-from-warning"][lang]
                                                        },
                                                        {
                                                            dom:"input",
                                                            type:"text",
                                                            name:"bf-g-a-date-to-name",
                                                            property:"dateto",
                                                            warning:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-to-warning"][lang]
                                                        }
                                                    ]);
                                                    if(validation === false){ return false;}
                                                    const diffDay1 = parseInt(gen.url(false, gen.serverSideUrl, {
                                                        key: `calluserfunctionarray`,
                                                        class: `control`,
                                                        method: `diffBetweenTwoDates`,
                                                        parameters: [
                                                            gen.dateTime().date,
                                                            gen.enDate(validation.datefrom)
                                                        ],
                                                    }, false, 1));
                                                    const diffDay2 = parseInt(gen.url(false, gen.serverSideUrl, {
                                                        key: `calluserfunctionarray`,
                                                        class: `control`,
                                                        method: `diffBetweenTwoDates`,
                                                        parameters: [
                                                            gen.enDate(validation.dateto),
                                                            gen.enDate(validation.datefrom)
                                                        ],
                                                    }, false, 1));
                                                    if(diffDay1 > 0){
                                                        swal(
                                                            text["alert"][lang],
                                                            (w =>{
                                                                let warning = gen.superReplacer(w,"@datefrom",validation.datefrom);
                                                                warning = gen.superReplacer(warning,"@currentdate",gen.frDate(gen.dateTime().date));
                                                                return warning;
                                                            })(text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-from-date-less-than-todaydate-warning"][lang]),
                                                            "warning"
                                                            );
                                                            $(`input[name="bf-g-a-date-from-name"]`).focus();
                                                        return false;
                                                    }
                                                    if(diffDay2 < 0){
                                                        swal(
                                                            text["alert"][lang],
                                                            (w =>{
                                                                let warning = gen.superReplacer(w,"@datefrom",validation.datefrom);
                                                                warning = gen.superReplacer(warning,"@dateto",validation.dateto);
                                                                return warning;
                                                            })(text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["date-to-date-less-than-date-from-warning"][lang]),
                                                            "warning"
                                                            );
                                                            $(`input[name="bf-g-a-date-to-name"]`).focus();
                                                        return false;
                                                    }
                                                    $(__functionOptions.uisection).html(__objects.availabilityForm({
                                                        datefrom:gen.enDate(validation.datefrom),
                                                        dateto:gen.enDate(validation.dateto),
                                                        returncontent:true,
                                                        uiinvoicing:__functionOptions.uiinvoicing
                                                    }));
                                                }
                                            }
                                        }
                                    ]
                                }
                            ]
                        }
                    ]).init();
                },
                clientInformation:(__functionOptions)=>{
                    console.log(__methodOptions.customizedsettings.availability.client);
                    const table = $(gen.createEl("table")).attr({class:"table"});
                    const tbody = $(gen.createEl("tbody"));
                    let rows = [];
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["firstname"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["firstname"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["firstname"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["lastname"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["lastname"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["lastname"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nickname"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nickname"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nickname"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return gen.dropDownFromArray({
                                    array:[
                                        {
                                            value:"masculin",
                                            title:"Masculin"
                                        },
                                        {
                                            value:"feminin",
                                            title:"Feminin"
                                        }
                                    ],
                                    id:"value",
                                    output:"title",
                                    attr:{
                                        class:"form-control",
                                        name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["sex"]["name"]
                                    },
                                    legend:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["sex"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                const countries = gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {key:"returnjson",fields:["countryid","countryname"],table:" sdappgeocountries",ref:"WHERE datastatus > 0 ORDER BY countryname ASC",getter: true}, false, 1));
                                return gen.dropDownFromArray({
                                    array:countries,
                                    id:"countryid",
                                    output:"countryname",
                                    attr:{
                                        class:"form-control single-select",
                                        name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nationality"]["name"]
                                    },
                                    legend:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nationality"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idnumber"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idnumber"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idnumber"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                const inputFile = $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idcopy"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idcopy"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idcopy"]["label"][lang],
                                    type:"file"
                                });
                                inputFile.on("change",e=>{
                                    gen.takeFile2Server(e, {
                                        display: path => {
                                            return path;
                                        },
                                        value: value => {
                                            return value;
                                        },
                                        displayphoto: true,
                                        successmessage: text["file-upload-successmessage"][allVariables.lang]
                                    });
                                });
                                return inputFile;
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofchildren"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofchildren"]["name"],
                                    "form-control",
                                    null,
                                    "numeric"
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofchildren"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofadult"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofadult"]["name"],
                                    "form-control",
                                    null,
                                    "numeric"
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofadult"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["email"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["email"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["email"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textBox(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["telephone"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["telephone"]["name"],
                                    "form-control",
                                    null,
                                    "numeric"
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["telephone"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    rows[rows.length] = gen.tableRow([
                        {
                            html:()=>{
                                return $(gen.textArea(
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["address"]["name"],
                                    text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["address"]["name"],
                                    "form-control",
                                    null
                                ))
                                .removeAttr("style")
                                .addClass("form-control")
                                .attr({
                                    placeholder:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["address"]["label"][lang]
                                });
                            }
                        }
                    ]);
                    tbody.html(rows);
                    table.html(tbody);
                    gen.removeBorderFromTable({
                        table:table,
                        type:"all"
                    })
                    return table;
                },
                init:() =>{
                    const availabilityBlockInterface = $(gen.createEl("div"));
                    const uiInvoice = $(gen.createEl("div"));
                    let children = [];
                    children[children.length] = me.block({
                        icon:"icon-calendar",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["booking-form-features"]["usage"]["availability-form"]["calendar-block"]["title"][lang],
                        content:__objects.filterAvailabilityForm({
                            uisection:availabilityBlockInterface,
                            uiinvoicing:uiInvoice
                        })
                    });
                    children[children.length] = me.block({
                        icon:"fa fa-bed",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        title:text["booking-form-features"]["usage"]["availability-form"]["room-block"][lang],
                        content:__objects.availabilityForm({
                            uisection:availabilityBlockInterface,
                            uiinvoicing:uiInvoice
                        })
                    });
                    children[children.length] = me.block({
                        icon:"fa fa-user",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        attr:{
                            class:"col-lg-12",
                            id:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["id"]
                        },
                        title:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["title"][lang],
                        content:__objects.clientInformation({})
                    });
                    children[children.length] = me.block({
                        icon:"fa fa-money",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        attr:{
                            class:"col-lg-6"
                        },
                        title:text["booking-form-features"]["usage"]["availability-form"]["invoice-block"]["title"][lang],
                        content:uiInvoice
                    });
                    children[children.length] = me.block({
                        icon:"",
                        color:"#f8f9fa",
                        textcolor:"#212529",
                        attr:{
                            class:"col-lg-12"
                        },
                        title:null,
                        content:__objects.saveInvoiceUI()
                    });
                    return $(gen.createEl("div"))
                    .css({
                        backgroundColor:"#fff",
                        float:"left",
                        width:"100%"
                    })
                    .html(gen.objectInterfaceMaker([{element:"div",css:{margin:"5px"},attr:{class:"row"},children:children}]).init());
                },
                saveInvoiceUI:(__fileBlockObject) =>{
                    const actionButton = gen.button(
                        "save-edit-booking-id",
                        "save-edit-booking-name",
                        "btn btn-primary",
                        text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["button"]["save"][lang],
                        (e)=>{
                            e.preventDefault();
                            const bFI = Object.values(allVariables.bookingforminvocing);
                            if(bFI.length < 1){
                                swal(text["alert"][lang],text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["warnings"]["empty-invoice"][lang],"warning");
                                gen.scroll(-999);
                                return false;
                            }
                            const validation = gen.getInputValueFromValidation([
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["firstname"]["name"],
                                    property:"client-firstname",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["firstname"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["lastname"]["name"],
                                    property:"client-lastname",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["lastname"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nickname"]["name"],
                                    property:"client-nickname",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nickname"]["warning"][lang]
                                },
                                {
                                    dom:"select",
                                    type:"select",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["sex"]["name"],
                                    property:"client-sex",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["sex"]["warning"][lang]
                                },
                                {
                                    dom:"select",
                                    type:"select",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nationality"]["name"],
                                    property:"client-nationality",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["nationality"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idnumber"]["name"],
                                    property:"client-id-number",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idnumber"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"file",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idcopy"]["name"],
                                    property:"client-id-copy",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["idcopy"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofchildren"]["name"],
                                    property:"number-of-children",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofchildren"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofadult"]["name"],
                                    property:"number-of-adult",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["numberofadult"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["email"]["name"],
                                    property:"client-email-address",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["email"]["warning"][lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["telephone"]["name"],
                                    property:"client-phone-number",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["telephone"]["warning"][lang]
                                },
                                {
                                    dom:"textarea",
                                    type:"textarea",
                                    name:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["address"]["name"],
                                    property:"client-phone-number",
                                    warning:text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["inputs"]["address"]["warning"][lang]
                                }
                            ]);
                            if(validation === false){return false;}
                            const action = function(){
                                const bookingInformation = {
                                    clientinformation:validation,
                                    invoiceinformation:allVariables.bookingforminvocing
                                }
                                const __customizedSettings = gen.getObjectFromJSON(__row["customizedformsettings"]);
                                const __savingRecords = __customizedSettings["customizedsettings"]["availability"]["savingrecords"];
                                let data = {};
                                const bookingExtraInfo = (ii =>{
                                    let n = 0;
                                    let checkinDate;
                                    let checkoutDate;
                                    let amounttopay =  0;
                                    if(ii instanceof Object){
                                        for(let p in ii){
                                            n++;
                                            if(ii[p] instanceof Object){
                                                let nn = 0;
                                                for(let pp in ii[p]){
                                                    nn++;
                                                    if(n ===1 && nn === 1){
                                                        checkinDate = ii[p][pp].hasOwnProperty("date") ? ii[p][pp].date : false;
                                                    }
                                                checkoutDate = ii[p][pp].hasOwnProperty("date") ? ii[p][pp].date : false;
                                                const roomPrice = ii[p][pp].hasOwnProperty("roomprice") ? ii[p][pp].roomprice : 0;
                                                amounttopay+= parseFloat(roomPrice); 
                                                }
                                                
                                            }
                                            
                                        }
                                    }
                                    return {
                                        checkindate:checkinDate,
                                        checkoutdate:checkoutDate,
                                        amouttopay:amounttopay
                                    };
                                })(bookingInformation.invoiceinformation);
                                data[__savingRecords.columns.checkindate] = bookingExtraInfo.checkindate;
                                data[__savingRecords.columns.checkoutdate] = bookingExtraInfo.checkoutdate;
                                data[__savingRecords.columns.amounttopay] = bookingExtraInfo.amouttopay;
                                data[__savingRecords.columns.clientid]=`${bookingInformation.clientinformation["client-firstname"]} ${bookingInformation.clientinformation["client-lastname"]} ${bookingInformation.clientinformation["client-nickname"]}`;
                                data[__savingRecords.columns.daynumber]="daynumber";
                                data[__savingRecords.columns.roomid]="roomid";
                                data.bookinginformation = bookingInformation;
                                data.bookingnumber = (db=>{
                                    let n;
                                    if(Array.isArray(db) && db.length > 0 ){
                                        n = db.length + 1;
                                    }
                                    else{
                                        n = 1;
                                    }
                                    return gen.customizeNumberGenerator({
                                        prefix:`CH`,
                                        n:n,
                                        length:8
                                    });
                                })(gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {key:"returnjson",fields:["sdappdataid","blockid","data"],table:"sdappdata",datatype:"json",ref: `WHERE blockid='${__row[0]}'`,getter: true}, false, 1)));
                                

                                console.log(__savingRecords);
                                console.log(bookingInformation);
                                console.log(data);
                                gen.url(false, gen.serverSideUrl, {
                                                key: "sqlwrite",
                                                table:"sdappdata",
                                                fieldandvalues: {
                                                    sdappdataid: "NULL",
                                                    themeid:themeId,
                                                    blockid:__row[0],
                                                    data:data,
                                                    createdby: allVariables.userid
                                                }
                                            },
                                            false,
                                        1);
                            };
                            gen.sweetWarningMsgBox(
                                action,
                                text["alert"][allVariables.lang],
                                text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["warnings"]["save-booking"]["warning"][lang],
                                text["booking-form-features"]["usage"]["availability-form"]["client-block"]["form"]["warnings"]["save-booking"]["success"][lang],
                                text["sdapp-no-action-done"][allVariables.lang]
                            );
                        }
                    );
                    $(actionButton).css({
                        width:"100%"
                    });
                    return actionButton;
                }
            };
            return __objects;
        }
        
    
    }
}