class nc_form_maker{
    constructor(nc){
        let allVariables = nc.allvariables;
        let gen = nc.gen;
        let me = this;
        this.init = (options)=>{
            let text = options.textjson;
            nc.replaceScriptWithUI({
                scriptid: options.scriptid,
                title: text["nc-project-maker"][allVariables.lang],
                textfooter: text["nc-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        "add-category": {
                            icon: "fa fa-circle-o",
                            title: text["nc-all-projects"][allVariables.lang],
                            callback: () => {
                                nc.nc_Access_Menu({
                                    key: "nc-all-projects"
                                });
                            }
                        }

                    }
                },
                html: () => {
                    return me.newProjectUI(options);
                }
            });
        }

        this.allprojects = (options)=>{
            let text = options.textjson;
            nc.replaceScriptWithUI({
                scriptid: options.scriptid,
                title: text["nc-all-projects"][allVariables.lang],
                textfooter: text["nc-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        "add-category": {
                            icon: "fa fa-plus",
                            title: text["nc-create-project"][allVariables.lang],
                            callback: () => {
                                nc.nc_Access_Menu({
                                    key: "nc-create-customized-app"
                                });
                            }
                        }

                    }
                },
                html: () => {
                    return me.newProjectUI(options);
                }
            });
        }

        this.newProjectUI = (objects)=>{
                let text = objects.textjson;
                let projectRow =objects.row;
                let random = [gen.random(4),gen.random(4)]; 
                let table = $(gen.createEl("table"));
                let rows = [];
                let tbody =$(gen.createEl("tbody"));
                let projectNameRowId = gen.random(5);
                let projectPluginName = (obj)=>{
                    $(obj.td).html($(gen.textBox("nc-project-name-id","nc-project-name-name","form-control",obj.value))
                    .removeAttr("style")
                    .attr({
                        class:"form-control",
                        placeholder: obj.placeholder
                    }));
                };
               
                rows[rows.length]=gen.tableRow([{
                    html: ()=>{
                        return $(gen.staticDropDown(
                            [
                                text["nc-project-type-project"][allVariables.lang],
                                text["nc-project-type-plugin"][allVariables.lang]
                            ],
                            [1,2],
                            `id${random[1]}`,
                            `nc-projec-type`,
                            "form-control",
                            (function(obj,prop){
                                if(obj instanceof Object && obj.hasOwnProperty(prop)){
                                    return obj[prop];
                                }
                            })(projectRow,"projectype"),
                            undefined,
                            text["nc-project-select-project-type"][allVariables.lang]
                          ))
                          .on("change",e=>{
                              let type =e.target.value;
                              let td=`td#${projectNameRowId}`;
                              let placeholder=[text["nc-project-name"][allVariables.lang],text["nc-plugin-name"][allVariables.lang]]
                              if(type>0){
                                projectPluginName({
                                    td:td,
                                    placeholder:placeholder[parseInt(type)-1]
                                });
                              }
                              else{
                                  $(td).html("");
                              }
                             
                          });
                    }
                }]);

                rows[rows.length]=gen.tableRow([{
                    html: ()=>{
                        return $(gen.staticDropDown(
                            [
                                text["nc-project-theme-1"][allVariables.lang]
                            ],
                            [1],
                            `id${random[1]}`,
                            `nc-project-theme`,
                            "form-control",
                            (function(obj,prop){
                                if(obj instanceof Object && obj.hasOwnProperty(prop)){
                                    return obj[prop];
                                }
                            })(projectRow,"projectype"),
                            undefined,
                            text["nc-select-project-theme"][allVariables.lang]
                          ));
                    }
                }]);

                rows[rows.length]=gen.tableRow([{
                    html: (td)=>{
                        projectPluginName({
                            td:td,
                            value:((obj,prop)=>{if(obj instanceof Object && obj.hasOwnProperty(prop)){return obj[prop];}})(projectRow,"projectname"),
                            placeholder:text["nc-project-name"][allVariables.lang]
                        });
                    },
                    attr:{id:projectNameRowId}
                }]);

                rows[rows.length]=gen.tableRow([{
                    html: ()=>{
                        return $(gen.textArea("nc-project-description-id","nc-project-description-name","form-control",null))
                        .removeAttr("style")
                        .attr({placeholder:text["nc-project-description"][allVariables.lang]});
                    },
                    attr:{id:projectNameRowId}
                }]);

                rows[rows.length]=gen.tableRow([{
                    html: ()=>{
                        return $(gen.button("nc-save-button-id","nc-save-button-name","btn btn-primary",text["nc-save-project"][allVariables.lang],e=>{
                            e.preventDefault();
                            let validations =Gen.getInputValueFromValidation([
                                {
                                    dom: "select",
                                    type: "select",
                                    name: "nc-projec-type",
                                    property: "projecttype",
                                    warning: text["nc-select-project-type"][allVariables.lang]
                                },
                                {
                                    dom:"select",
                                    type:"select",
                                    name:"nc-project-theme",
                                    property:"projecttheme",
                                    warning: text["nc-select-project-theme-warning"][allVariables.lang]
                                },
                                {
                                    dom:"input",
                                    type:"text",
                                    name:"nc-project-name-name",
                                    property:"projectname",
                                    warning: text["nc-add-project-name"][allVariables.lang]
                                },
                                {
                                    dom:"textarea",
                                    type:"textarea",
                                    name:"nc-project-description-name",
                                    property:"projectdescription",
                                    warning: text["nc-add-project-description"][allVariables.lang]
                                }
                            ]);

                            if(validations === false){ return false;}

                            let action = ()=>{

                                let sql =gen.url(false, gen.serverSideUrl, {
                                    key: "sqlwrite",
                                    table: "nc_project_maker",
                                    ajaxdatatype: "json",
                                    fieldandvalues: {
                                        projectid: "NULL",
                                        projectthemeid:validations.projecttheme.value,
                                        projectype:validations.projecttype.value,
                                        projectname:{
                                            parameters: [`@conn`, validations.projectname],
                                            method: `preventInj`
                                        },
                                        projectdescription:{
                                            parameters: [`@conn`, validations.projectdescription],
                                            method: `preventInj`
                                        },
                                        createdby: allVariables.userid
                                    }
                                }, false, 1);
                                console.log(sql);

                                nc.nc_Access_Menu({
                                    key: "nc-create-customized-app"
                                });
                             let projectPath;
                             if(parseInt(validations.projecttype.value) ===1){
                                 projectPath =`projects/${sql.lastid}/`;
                             }
                             else{
                                projectPath =`plugins/${sql.lastid}/`;
                             }
                             
                                console.log(gen.url(false, gen.serverSideUrl, {
                                    key: `calluserfunctionarray`,
                                    class: `control`,
                                    method: `moveFile`,
                                    parameters: [
                                        {
                                            nbackshashes:3,
                                            path:`projects/ressources/theme-1/assets.zip`
                                        },
                                        {
                                            nbackshashes:3,
                                            path: projectPath
                                        }
                                        
                                    ]
                                }, false, 1));
                            
                            };
                             

                          
                            
                            gen.sweetWarningMsgBox(
                                action,
                                text["alert"][allVariables.lang],
                                text["nc-form-save-project-warning"][allVariables.lang],
                                text["nc-form-save-project-success"][allVariables.lang],
                                text["nc-no-action-done"][allVariables.lang]
                            );
                        })).css({width:"100%"})
                    }
                }]);

                tbody.html(rows);
                table.html(tbody);
                table.attr({class:"table"});
                gen.removeBorderFromTable({
                    table:table,
                    type:"all"
                });
                return table;
        }
       
        this.addFormToProject = (options) =>{
            let text = options.textjson;
            let formRow =options.formrow;
            let table = $(gen.createEl("table")).attr({width:"100%",class:"table"});
            let rows = [];
            let tbody = $(gen.createEl("tbody"));
            let formSection =gen.random(4);
            rows[rows.length]= gen.tableRow([
                {
                    html:()=>{
                        return $(gen.textBox("formid","formname","form-control",null)).attr({placeholder:text["nc-form-name"][allVariables.lang]});
                    },
                    attr:{
                        colspan:2
                    }
                }
            ]);
            rows[rows.length] = gen.tableRow([
                {
                    html: ()=>{
                        return gen.button("newformid","newformname","btn btn-primary",text["nc-form-new-input"][allVariables.lang],e=>{
                            e.preventDefault();
                            me.newFormRow({
                                section:$(`td#${formSection}`),
                                text:text
                            });
                        },"fa fa-plus")
                    }
                }
            ]);

            rows[rows.length] = gen.tableRow([
                {
                    attr:{id:formSection}
                }
            ]);
            
            let tfoot = $(gen.createEl("tfoot"));
            tfoot.html(()=>{
                return gen.tableRow([
                    {
                        html:()=>{
                            let collection ={};
                            if(formRow instanceof Object){
                                collection.title =text["nc-form-edit-form"][allVariables.lang];
                                collection.icon ="icon-pencil icons";
                            }
                            else{
                                collection.title =text["nc-form-save-form"][allVariables.lang];
                                collection.icon ="fa fa-save";
                            }
                            return $(gen.button("buttonid","buttonname","btn btn-primary",collection.title,e=>{
                                e.preventDefault();
                                me.saveEditForm({
                                    row:formRow,
                                    text:text,
                                    tbody:tbody
                                });
                            },collection.icon))
                            .css({
                                width:"100%"
                            });
                        },
                        attr:{colspan:2}
                    }
                ]);
            });
            tbody.html(rows);
            table.html([tbody,tfoot]);
            gen.removeBorderFromTable({
                table:table,
                type:"all"
            });
            return  {
                add: ()=>{
                    nc.replaceScriptWithUI({
                        scriptid: options.scriptid,
                        title: `${text["nc-new-form"][allVariables.lang]} ${text["nc-project"][allVariables.lang]} : ${options.attributes.title}`,
                        textfooter: text["nc-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                        rightoptions: {
                            title: "",
                            iconColor: "#fff",
                            icon: "icon-options icons",
                            submenus: {
                                "all-forms": {
                                    icon: "fa fa-circle-o",
                                    title: text["nc-all-forms"][allVariables.lang],
                                    callback: () => {
                                        nc.nc_Access_Menu({
                                            key: "nc-project-all-forms",
                                            attributes:options.attributes
                                        });
                                    }
                                }
        
                            }
                        },
                        html: () => {
                            return table;
                        }
                    });
                },
             view: (attributes)=>{
                 console.log(`verify`);
                 console.log(attributes);
                nc.replaceScriptWithUI({
                    scriptid: options.scriptid,
                    title: `${text["nc-new-form"][allVariables.lang]} ${text["nc-project"][allVariables.lang]} : ${options.attributes.title}`,
                    textfooter: text["nc-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                    rightoptions: {
                        title: "",
                        iconColor: "#fff",
                        icon: "icon-options icons",
                        submenus: {
                            "all-forms": {
                                icon: "fa fa-circle-o",
                                title: text["nc-all-forms"][allVariables.lang],
                                callback: () => {
                                    nc.nc_Access_Menu({
                                        key: "nc-project-all-forms",
                                        attributes:options.attributes
                                    });
                                }
                            }
    
                        }
                    },
                    html: () => {
                        return gen.dynamicTable({
                            tablesectionid:allVariables.showrecordsid,
                            lang:allVariables.lang,
                            maxrecord:10,
                            selectedpage:1,
                            paginationlength:5,
                            lang:allVariables.lang,
                            thead: [
                                {
                                    title: text["nc-form-name-2"][allVariables.lang],
                                }
                            ],
                            headertype: 2,
                            table:"nc_form_maker",
                            ref: options.ref,
                            fkobjects: {},
                            cols: [
                                {
                                    parentfield: false,
                                    field:"formname",
                                    resultlevel: 0,
                                    callback: function (value) {
                                        return gen.jsonCharReplacer(value, -1);
                                    }
                                },
                            ],

                            editaction: function () { return false; },
                            actionbuttons: {
                                edit: false,
                                delete: false
                            },
                            optionsbtntype: 2,
                            extratoptions: function (row) {
                                return {
                                    'edit': {
                                        title: text["builder-create-block"]["td-options"]["edit"][allVariables.lang],
                                        icon: "icon-pencil icons",
                                        action: function () {
                                            elements.init({
                                                row: row,
                                                themeid: row['themeid']
                                            });
                                        }
                                    }
                                }
                            }

                        });
                    }
                });
             }
            };
            
        
        }
        this.newFormRow = (options)=>{
            let text = options.text;
            let section = options.section;
            let row = gen.tableRow([
                {
                    html: ()=>{
                         return $(gen.textBox(
                             "nc-form-maker-label-id",
                             "nc-form-maker-label-name",
                             "form-contro",
                             null
                         )).attr({
                             placeholder:text["nc-form-label"][allVariables.lang]
                         });
                    }
                },
                {
                    html:()=>{
                        return me.inputType({
                            text:text
                        });
                    }
                }
            ],{
                attr:{"nc-form-maker-row":"true"}
            });
            $(section).parents("tbody").append(row);
            let table = $(section).parents("table");
            gen.removeBorderFromTable({
                table:table,
                type:"all"
            });
        },
        this.inputType =(objects)=>{
            let text =objects.text;
            let _select =$(gen.createEl("select"));
            let _opts=[];
            let _options= (objects)=>{
                let el=$(gen.createEl("option"));
                if(objects instanceof Object){
                    if(objects.hasOwnProperty("attr") && objects.attr instanceof Object){
                        el.attr(objects.attr);
                    }
                    if(objects.hasOwnProperty("css") && objects.css instanceof Object){
                        el.css(objects.css);
                    }
                    if(objects.hasOwnProperty("html")){
                        el.html(objects.html);
                    }
                    if(objects.hasOwnProperty("html") && objects.html instanceof Object){
                        el.html(()=>{
                            return objects.html();
                        });
                    }
                    return el;
                }
                
            }
            
            _opts[_opts.length] =_options({
                attr:{value:""},
                html:text["nc-form-select-input"][allVariables.lang]
            });

            _opts[_opts.length] =_options({
                attr:{value:1},
                html:text["nc-form-input"][allVariables.lang]
            });

            _opts[_opts.length] =_options({
                attr:{value:2},
                html:text["nc-form-textarea"][allVariables.lang]
            });

            _opts[_opts.length] =_options({
                attr:{value:3},
                html:text["nc-form-submit-button"][allVariables.lang]
            });
            
            _select.attr({class:"form-control"}).html(_opts);
            return _select;
        }
        this.saveEditForm = objects=>{
            let text = objects.text;
            let tbody = objects.tbody;
            let formName = $(`input[name="formname"]`);
            let count =0;
            let formObject ={};
            let length =$(tbody).find(`tr[nc-form-maker-row="true"]`).length;
            if(formName.val().length<1){
                swal(
                    text["alert"][allVariables.lang],
                    text["nc-form-name-warning"][allVariables.lang],
                    "warning"
                );
                formName.focus();
                return false;
            }
            if(length<1){
                $("button#newformid").trigger("click");
                return false;
            }
             $(tbody).find(`tr[nc-form-maker-row="true"]`).each((index,el)=>{
                 let label =$(el).children("td:eq(0)").find("input");
                 let input =$(el).children("td:eq(1)").find("select");
                 
                    if(label.val().length<1){
                        swal(
                            text["alert"][allVariables.lang],
                            text["nc-form-add-label-warning"][allVariables.lang],
                            "warning"
                        );
                        label.focus();
                        return false;
                    }
                    else if(input.val().length<1){
                        swal(
                            text["alert"][allVariables.lang],
                            text["nc-form-select-input-warning"][allVariables.lang],
                            "warning"
                        );
                        input.focus();
                        return false;
                    }
                    else{
                        formObject[index]={
                            label:label.val(),
                            input:input.val()
                        };
                        count++;
                    }
                    
             });
             
             if(length === count){
                 let action = ()=>{
                    gen.url(false, gen.serverSideUrl, {
                        key: "sqlwrite",
                        table: "nc_form_maker",
                        fieldandvalues: {
                            formmakerid: "NULL",
                            formname:{
                                parameters: [`@conn`, formName.val()],
                                method: `preventInj`
                            },
                            formdata:formObject
                        }
                    }, false, 1);
                    nc.nc_Access_Menu({
                        key: "add-form-to-project-or-plugin"
                    });
                 };

                 gen.sweetWarningMsgBox(
                    action,
                    text["alert"][allVariables.lang],
                    text["nc-form-save-form-warning"][allVariables.lang],
                    text["nc-form-save-form-success"][allVariables.lang],
                    text["nc-no-action-done"][allVariables.lang]
                );
             }
             
        },
        this.applictionThemes =()=>{
            let themes={};
            themes["nc-theme-1"]={
                form: (inputRows)=>{
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{class:"row"},
                            children:[]
                        }
                    ]).init();
                }
            };
            themes["nc-theme-2"]={};
            return themes;
        }
    }
}