class sdapp_reporting_client{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const lang = allVariables.lang;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        this.row = __constructorOptions.blockrow;
        this.init = () =>{
            const reportingSettings = gen.getObjectFromJSON(me.row.reportingsettings);
            const type = parseInt(reportingSettings.type);
            let reporting = {
                title:null,
                content:null
            };
            switch(type){
                case 1: reporting = me.commissionPercentageSalaryReport({
                    settings:reportingSettings.settings
                });break;
            }
            return reporting;
        };

        this.commissionPercentageSalaryReport = (__methodeOptions) =>{
            const __objects = {
                getAmount:(__functionOptions)=>{
                    const agentId = parseInt(__functionOptions.agentid);
                    const commission = __functionOptions.commission;
                    const operations =gen.url(false, gen.serverSideUrl, {
                        key: "returnjson",
                        table: "sdappdata",
                        ref: `WHERE blockid ='${__functionOptions.blockid}'  AND datastatus > 0 AND YEAR(createdon) = '${__functionOptions.year}' AND MONTH(createdon) ='${__functionOptions.month}'`,
                        fields:["data","createdon"],
                        getter: true,
                        ajaxdatatype: "json"
                    }, false, 1);
                    let amount = 0;
                    let datails = [];
                    let rateSymbol = "$";
                    if(Array.isArray(operations) && operations.length > 0){
                        for(let i = 0; i < operations.length; i++){
                            const row = gen.getObjectFromJSON(operations[i]["data"]);
                            const cartInformation = row.cartinformation;
                            rateSymbol = cartInformation.ratesymbol;
                            const agentServiceRows = cartInformation.agentservicerows.filter(item=>{ return parseInt(item.agentid) === agentId;});
                            const serviceIds = agentServiceRows.map(item=>{return parseInt(item.serviceid);});
                            const servicesPaid = cartInformation.rows.filter(item=>{return serviceIds.includes(parseInt(item.id)) === true;});
                            const servicesPaidTotal = gen.arraySum(servicesPaid.map(item=>{return parseFloat(item.total)}));
                            amount+= servicesPaidTotal;
                            datails.push({
                                date:operations[i].createdon,
                                opnumber:cartInformation.operationnumber,
                                paymentmethod:cartInformation.paymentmethod,
                                services:servicesPaid 
                            });
                        }
                    }
                    return {
                        amount:amount,
                        commissionedamount:(ob=>{
                            return ob.amount * ob.commission / 100;
                        })({
                            amount:amount,
                            commission:commission
                        }),
                        details:datails,
                        ratesymbol:rateSymbol
                    }
                },
                content:(__functionOptions) =>{
                    const agentData =gen.url(false, gen.serverSideUrl, {
                        key: "returnjson",
                        table: "sdappdata",
                        ref: `WHERE blockid ='${__methodeOptions.settings.agent.blockid}'  AND datastatus > 0`,
                        fields:["data","sdappdataid"],
                        getter: true,
                        ajaxdatatype: "json"
                    }, false, 1);
                    const table = $(gen.createEl("table"));
                    const thead = $(gen.createEl("thead"));
                    const tbody = $(gen.createEl("tbody"));
                    const tfoot = $(gen.createEl("tfoot"));
                    thead.html(gen.tableRow([
                        {
                            html:text["reporting"]["salary-report"]["no"][lang]
                        },
                        {
                            html:text["reporting"]["salary-report"]["fullname"][lang]
                        },
                        {
                            html:text["reporting"]["salary-report"]["amount-generated"][lang],
                            css:{
                                textAlign:"right"
                            }
                        },
                        {
                            html:text["reporting"]["salary-report"]["commission"][lang],
                            css:{
                                textAlign:"right"
                            }
                        },
                        {
                            html:text["reporting"]["salary-report"]["salary"][lang],
                            css:{
                                textAlign:"right"
                            }
                        },
                        {
                            html:text["reporting"]["salary-report"]["interest"][lang],
                            css:{
                                textAlign:"right"
                            }
                        },
                        {
                            html:text["reporting"]["salary-report"]["action"][lang]
                        }
                    ],{td:"th"}));
                    let rows = [];
                    let count = 0;
                    const agentFullnameColumns = __methodeOptions.settings.agent.columns.fullname;
                    const agentServiceCommissionColumn = __methodeOptions.settings.agent.columns.servicecommission;
                    let totalAmountCommissioned = 0;
                    let totalAmountGenerated = 0;
                    let totalAmountInterest= 0;
                    let year = (d =>{return d.getFullYear();})(new Date());
                    let month = (d =>{return d.getMonth() + 1;})(new Date());
                    let filterByEmployee = "all";
                    if(__functionOptions instanceof Object && __functionOptions.year !== undefined && __functionOptions.month !== undefined){
                        year = __functionOptions.year;
                        month = __functionOptions.month;
                        filterByEmployee = __functionOptions.employee;
                    }
                    const rateSymbol = "$";
                    for(let i = 0; i < agentData.length; i++){
                        count ++;
                        if(filterByEmployee !=="all" && parseInt(agentData[i]["sdappdataid"]) !== parseInt(filterByEmployee)){continue;}
                        const row = gen.getObjectFromJSON(agentData[i].data);
                        const keys = Object.keys(row);
                        const agentServiceCommission = keys.includes(agentServiceCommissionColumn) ? parseFloat(row[agentServiceCommissionColumn]) : 0;
                        let agentFullname = null;
                        // agent full name starts
                         if(Array.isArray(agentFullnameColumns)){
                            agentFullname = [];
                            agentFullnameColumns.forEach(item=>{ if(keys.includes(item)){ agentFullname.push(row[item]);}});
                            agentFullname = agentFullname.join(" ");
                         }
                         else{
                            if(keys.includes(agentFullnameColumns)){
                                agentFullname = row[agentFullnameColumns];
                            }
                         }
                        // agent full name ends
                        const amountObject = __objects.getAmount({
                            agentid:agentData[i]["sdappdataid"],
                            blockid:__methodeOptions.settings.operation.blockid,
                            year:year,
                            month:month,
                            commission:agentServiceCommission
                        });
                        const interest = amountObject.amount - amountObject.commissionedamount;
                        totalAmountCommissioned+= amountObject.commissionedamount;
                        totalAmountGenerated+= amountObject.amount;
                        totalAmountInterest+= interest;
                        rows[rows.length] = gen.tableRow([
                            {
                                html:count
                            },
                            {
                                html:agentFullname
                            },
                            {
                                html:`${amountObject.ratesymbol} ${amountObject.amount}`,
                                css:{
                                    textAlign:"right"
                                }
                            },
                            {
                                html:`${agentServiceCommission}%`,
                                css:{
                                    textAlign:"right"
                                }
                            },
                            {
                                html:`${amountObject.ratesymbol} ${amountObject.commissionedamount}`,
                                css:{
                                    textAlign:"right"
                                }
                            },
                            {
                                html:`${amountObject.ratesymbol} ${interest}`,
                                css:{
                                    textAlign:"right"
                                }
                            },
                            {
                                html:gen.dropDownMenu({
                                    icon:"icon-options icons",
                                    submenus:{
                                        details:{
                                            title:text["reporting"]["salary-report"]["details"][lang],
                                            icon:"icon-notebook icons",
                                            callback: e=>{
                                                e.preventDefault();
                                                gen.modalBoxUI({
                                                    modalid: "sdapp-default-size-modal",
                                                    size: "modal-lg",
                                                    title:gen.superReplacer(text["reporting"]["salary-report"]["employee-work-follow-up"][lang],"@employeename",agentFullname),
                                                    content:(me)=>{
                                                        $(me).html( __objects.employeeWorkPerformance({
                                                            details:amountObject.details
                                                        }))
                                                        .css({
                                                            height:"500px",
                                                            overflow:"auto"
                                                        });
                                                    }
                                                });

                                            }
                                        }
                                    }
                                },true)
                            }
                        ]);
                    }
                    tbody.html(rows);
                    tfoot.html(gen.tableRow([
                        {
                            html:text["reporting"]["salary-report"]["total"][lang],
                            css:{
                                textTransform:"uppercase",
                                fontWeight:600
                            },
                            attr:{
                                colspan:2
                            }
                        },
                        {
                            html:`${rateSymbol}${totalAmountGenerated}`,
                            css:{
                                textAlign:"right",
                                fontWeight:600
                            }
                        },
                        {
                            html:`${rateSymbol}${totalAmountCommissioned}`,
                            css:{
                                textAlign:"right",
                                fontWeight:600
                            },
                            attr:{
                                colspan:2
                            }
                        },
                        {
                            html:`${rateSymbol}${totalAmountInterest}`,
                            css:{
                                textAlign:"right",
                                fontWeight:600
                            }
                        },
                        {
                            html:null
                        }
                    ]));
                    table.html([thead,tbody,tfoot]).attr({class:"table"});
                    if(__functionOptions instanceof Object && __functionOptions.hasOwnProperty("returncontent") && __functionOptions.returncontent === true){
                        return table;
                    }
                    const salaryReport = $(gen.createEl("div")).html(table);
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row table-responsive"
                            },
                            children:[
                               {
                                    element:"div",
                                    attr:{
                                        class:"row col-lg-12"
                                    },
                                    css:{
                                       marginBottom:"10px",
                                       marginTop:"5px",
                                       padding:"2px",
                                       marginLeft:"5px"
                                    },
                                    children:[
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-3"
                                            },
                                            children:[
                                                {
                                                    element:"input",
                                                    attr:{
                                                        type:"number",
                                                        class:"form-control",
                                                        value:new Date().getFullYear(),
                                                        name:"sbc-year"
                                                    }
                                                }
                                            ]
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-3"
                                            },
                                            html:gen.dropDownFromArray({
                                                array:[
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["1"][lang],
                                                        value:1
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["2"][lang],
                                                        value:2
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["3"][lang],
                                                        value:3
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["4"][lang],
                                                        value:4
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["5"][lang],
                                                        value:5
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["6"][lang],
                                                        value:6
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["7"][lang],
                                                        value:7
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["8"][lang],
                                                        value:8
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["9"][lang],
                                                        value:9
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["10"][lang],
                                                        value:10
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["11"][lang],
                                                        value:11
                                                    },
                                                    {
                                                        title:text["reporting"]["salary-report"]["month-of-the-year"]["12"][lang],
                                                        value:12
                                                    }
                                                ],
                                                attr:{
                                                    class:"form-control",
                                                    name:"sbc-month"
                                                },
                                                legend:text["reporting"]["salary-report"]["select-month"][lang],
                                                id:"value",
                                                output:"title",
                                                editedvalue:new Date().getMonth() + 1
                                            })
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-3"
                                            },
                                            html:gen.dropDownFromArray({
                                                array:agentData,
                                                id:"sdappdataid",
                                                output:(el,arr)=>{
                                                    el = gen.getObjectFromJSON(el.data)
                                                    let agentFullname = null;
                                                    const keys = Object.keys(el);
                                                        // agent full name starts
                                                        if(Array.isArray(agentFullnameColumns)){
                                                            agentFullname = [];
                                                            agentFullnameColumns.forEach(item=>{ if(keys.includes(item)){ agentFullname.push(el[item]);}});
                                                            agentFullname = agentFullname.join(" ");
                                                        }
                                                        else{
                                                            if(keys.includes(agentFullnameColumns)){
                                                                agentFullname = el[agentFullnameColumns];
                                                            }
                                                        }
                                                        return agentFullname;
                                                        // agent full name ends
                                                },
                                                attr:{
                                                    class:"form-control",
                                                    name:"sbc-employee"
                                                },
                                                legend:text["reporting"]["salary-report"]["select-employee"][lang],
                                                preoptions:[
                                                    {
                                                        html:text["reporting"]["salary-report"]["select-all-employees"][lang],
                                                        value:"all"
                                                    }
                                                ],
                                                editedvalue:"all"
                                            })
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-3"
                                            },
                                            children:[
                                                {
                                                    element:"button",
                                                    attr:{
                                                        class:"btn"
                                                    },
                                                    html:text["reporting"]["salary-report"]["generate"][lang],
                                                    on:{
                                                        type:"click",
                                                        callback:e =>{
                                                            e.preventDefault();
                                                            const validation = gen.getInputValueFromValidation(
                                                                [
                                                                    {
                                                                        dom:"input",
                                                                        type:"number",
                                                                        name:"sbc-year",
                                                                        property:"year",
                                                                        warning:text["reporting"]["salary-report"]["year-warning"][lang]
                                                                    },
                                                                    {
                                                                        dom:"select",
                                                                        type:"select",
                                                                        name:"sbc-month",
                                                                        property:"month",
                                                                        warning:text["reporting"]["salary-report"]["month-warning"][lang]
                                                                    },
                                                                    {
                                                                        dom:"select",
                                                                        type:"select",
                                                                        name:"sbc-employee",
                                                                        property:"employee",
                                                                        warning:text["reporting"]["salary-report"]["employee-warning"][lang]
                                                                    }
                                                                ]
                                                            );
                                                            validation.month = validation.month.value;
                                                            validation.employee = validation.employee.value;
                                                            validation.returncontent = true;
                                                            console.log(validation);
                                                            salaryReport.html(__objects.content(validation));
                                                        }
                                                    }
                                                }
                                            ]
                                        }
                                    ]

                               },
                               {
                                   element:"div",
                                   attr:{
                                       class:"col-lg-12"
                                   },
                                   html:salaryReport
                               }
                            ]
                        }
                    ]).init();
                },
                employeeWorkPerformance:(__functionOptions)=>{
                    const details = __functionOptions.details;
                    if(Array.isArray(details)){
                        const table = $(gen.createEl("table")),
                        thead = $(gen.createEl("thead")),
                        tbody = $(gen.createEl("tbody")),
                        tfoot = $(gen.createEl("tfoot"));
                        thead.html(gen.tableRow([
                            {
                                html:text["reporting"]["salary-report"]["no"][lang]
                            },
                            {
                                html:text["reporting"]["salary-report"]["date"][lang]
                            },
                            {
                                html:text["reporting"]["salary-report"]["operation-number"][lang]
                            },
                            {
                                html:text["reporting"]["salary-report"]["payment-method"][lang]
                            }
                        ],{
                            td:"th"
                        }));
                        let count = 0;
                        let rows = [];
                        let totalAmount = 0;
                        for(let i = 0; i < details.length; i++){
                            count ++;
                            const item = details[i];
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:count
                                },
                                {
                                    html:gen.frDate(item.date)
                                },
                                {
                                    html:item.opnumber
                                },
                                {
                                    html:item.paymentmethod
                                }
                            ]);
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["reporting"]["salary-report"]["details"][lang],
                                    attr:{
                                        colspan:4
                                    },
                                    css:{
                                        textTransform:"uppercase"
                                    }
                                }
                            ]);
                            rows[rows.length] = gen.tableRow([
                                {
                                    html:text["reporting"]["salary-report"]["product-service"][lang],
                                    css:{
                                        textTransform:"uppercase"
                                    }
                                },
                                {
                                    html:text["reporting"]["salary-report"]["quantity"][lang],
                                    css:{
                                        textTransform:"uppercase"
                                    }
                                },
                                {
                                    html:text["reporting"]["salary-report"]["price"][lang],
                                    css:{
                                        textTransform:"uppercase",
                                        textAlign:"right"
                                    }
                                },
                                {
                                    html:text["reporting"]["salary-report"]["total-price"][lang],
                                    css:{
                                        textTransform:"uppercase",
                                        textAlign:"right"
                                    }
                                }
                            ]);
                            if(Array.isArray(item.services) && item.services.length > 0){
                                item.services.forEach(service =>{
                                    totalAmount+= parseFloat(service.total);
                                    rows[rows.length] = gen.tableRow([
                                        {
                                            html:service.productname
                                        },
                                        {
                                            html:service.qty
                                        },
                                        {
                                            html:`$ ${service.price}`,
                                            css:{
                                                textAlign:"right"
                                            }
                                        },
                                        {
                                            html:`$ ${service.total}`,
                                            css:{
                                                textAlign:"right"
                                            }
                                        }
                                    ]);
                                })
                            }
                        }
                        tbody.html(rows);
                        tfoot.html(gen.tableRow([
                            {
                                html:text["reporting"]["salary-report"]["total"][lang],
                                css:{
                                    fontWeight:600,
                                    textTransform:"uppercase"
                                },
                                attr:{
                                    colspan:3
                                }
                            },
                            {
                                html:`$ ${totalAmount}`,
                                css:{
                                    fontWeight:600,
                                    textTransform:"uppercase",
                                    textAlign:"right"
                                },
                            }
                        ]));
                        table.html([thead,tbody,tfoot]).attr({class:"table table-bordered",width:"100%"});
                        return table;
                    }
                }
            };
            return {
                title:text["reporting"]["salary-report"]["title"][lang],
                content:__objects.content()
            }
        }
    }
}