<?php
use Box\Spout\Reader\ReaderFactory;
use Box\Spout\Common\Type;
require_once ("excel/Autoloader/autoload.php");
require_once("sdapp-marchand-class.php");
require_once("sdapp-view.php");
class static__to__dynamic__app extends marchand_sdapp{
	private $output='no option available';
	public $main;
	public $control;
	public $model;
	public $lang;
	private $sql;
	private $row;
	private $appUrl='https://www.sdapp.org';
	private $path;
	private $extraOptions;
	private $prepath='../../';
	public $dom;
	public $weboptions=array();
	private $appName='sdapp';
	private $html;
	private $baseRoot="php/sdapp/";
	public $configuration;
	public $copyright;
	private $phpVersion;
	private $var;
	private $view;
	private $keyWords=[
		"mobile-menu"=>"@sdapp-mobile-menu-builtin",
		"web-menu"=>"@sdapp-web-menu-builtin"
	];
	public function  __construct($main,$model,$control,$lang,$extraOptions=array()){
		$this->phpVersion=phpversion();
		$this->extraOptions=$extraOptions;
		$this->main=$main;
		$this->control=$control;
		$this->model=$model;
		$this->configuration=$this->sdappConfigurations();
		$this->lang=(function($activatedLanguage,$defaultLanguage,$availableLanguages){
			if(empty($activatedLanguage)){
				if(in_array($defaultLanguage,$availableLanguages)){
					return $defaultLanguage;
				}
				else{
					return "en";
				}
			}
			return $activatedLanguage;
		})(
			$this->configuration["sdapp-default-language"]["code"],
			$this->control->defaultLang(),
			$this->configuration["sdapp-availablelanguages"]
		);
		$tree=$this->main->request('tree');
		$this->view = new static__dynamic__app__view($this->main,$this->control,$this->model,$this);

		//sdapp-database configuration starts
		if($this->control->request("tree") ==="configuredatabaseconnection"){
			return $this->output=$this->configureDatabaseConnection();
		}
		//sdapp-database configuration ends
		if(is_object($this->conn())){
			$this->model->addExtraRows($this->conn());
			$this->configuration["themeid"]=$this->activatedThemeId();
			$this->configuration["theme"]=$this->activatedThemeId("fileextracted");
		}

		if($this->phpVersion < 7.0){
			die($this->configuration["sdapp-unsupported-version"][$this->lang]);
		}

		$this->copyright=(function($config,$lang){
			return str_replace("@date",date("Y"),$config["sdapp-copyright"][$lang]);
		})($this->configuration,$this->lang);

		if($tree==false){
			$tree=is_array($extraOptions) && isset($extraOptions['tree'])?$extraOptions['tree']:false;
		}
		switch($tree){
			case 'loadunmenupages': $this->output=$this->loadUnMenuPages();break;
			case 'getmenu':$this->output=$this->getMenu();break;
			case 'createsubmenu':$this->output=$this->createSubMenu();break;
			case 'getsubmenus':$this->output=$this->getSubMenus();break;
			case 'createedittheme':$this->output=$this->createEditTheme();break;
			case 'getpages':$this->output=$this->getPages();break;
			case 'savepage':$this->output=$this->savePage();break;
			case 'saveeditreferenceblock':$this->output=$this->saveEditReferenceblock();break;
			case 'saveeditdata':$this->output=$this->saveEditData();break;
			case 'deletedata':$this->output=$this->deleteData();break;
			case 'unpublishdata':$this->output = $this->unpublishData();break;
			case 'publishdata':$this->output = $this->publishdata();break;
			case 'saveeditpage':$this->output=$this->saveEditPageBuilding();break;
			case 'saveeditdatapage':$this->output=$this->saveEditDataPage();break;
			case "menulink":$this->output=$this->menuLink();break;
			case "searchforavailablepageformenu":$this->output=$this->search4AvailablePage4Menu();break;
			case "getpagecontent":$this->output=$this->getPageContent();break;
			case "saveplugin":$this->output=$this->savePlugin();break;
			case "login":$this->output=$this->login();break;
			case "configurations":$this->output=json_encode($this->configuration);break;
			case "logout":$this->output=$this->logout();break;
			case "editconfigurationjson":$this->output=$this->editConfigurationJSON();break;
			case "editcontentblock":$this->output=$this->editContentBlock();break;
			case "savecontentblock":$this->output=$this->saveContentBlock();break;
			case "deletepageblock":$this->output=$this->deletePageBlock();break;
			case "getsqlpageblocks":$this->output=$this->getSqlPageBlocks();break;
			case "copy-page":$this->output=$this->copyPage();break;
			case "pageinformation":$this->output = $this->getWebPageInformation();break;
			case "validate-builtin-plugin":$this->output = $this->validateBuiltInPlugin();break;
			case "fetch-dynamic-list-data":$this->output = $this->fetchDynamicListData();break;
			case "updatemenu":$this->output = $this->updateMenu();break;
			case "mediafilesparameters":$this->output = $this->mediaFilesParameters();break;
			case "delete-media-file":$this->output = $this->deleteMediaFile();break;
			case "set-session-for-download-file":$this->output = $this->setSessionForDownloadingFile();break;
			case "getallphotos":$this->output = $this->getAllPhotos();break;
			case "update-web-basic-info": $this->output  = $this->updateWebBasicInfo();break;
			case "load-more-contents": $this->output = $this->loadMoreContents();break;
			case "count-data-by-category":$this->output = $this->countDataByCategory();break;
			case "loaddatapage":$this->output = $this->loadDataPage();break;
			case "update-html-page":$this->output = $this->updateHtmlPage();break;
			case "read-imported-file":$this->output = $this->readImportedFile();break;
			case "save-imported-file":$this->output = $this->saveImportedFile();break;
			case "mobile-application-interface":$this->output = $this->mobileApplicationInterface();break;
			case "setqrcode":$this->output = $this->setQrCode();break;
			default: $this->output=$this->output;break;
		}
	}
	private function setQrCode(){
			$qrCodeData = $this->control->request("qrcodedata");
			$PNG_TEMP_DIR = dirname(__FILE__).DIRECTORY_SEPARATOR.'qrcodefiles'.DIRECTORY_SEPARATOR;
			//html PNG location prefix
			$PNG_WEB_DIR = 'php/sdapp/qrcodefiles/';
			include "phpqrcode/qrlib.php";
			if (!file_exists($PNG_TEMP_DIR))
			mkdir($PNG_TEMP_DIR);
			$filename = $PNG_TEMP_DIR.'test.png';
			//processing form input
			//remember to sanitize user input in real-life solution !!!
			$errorCorrectionLevel = 'L';
			if (isset($_REQUEST['level']) && in_array($_REQUEST['level'], array('L','M','Q','H')))
				$errorCorrectionLevel = $_REQUEST['level'];    

			$matrixPointSize = 4;
			if (isset($_REQUEST['size']))
				$matrixPointSize = min(max((int)$_REQUEST['size'], 1), 10);
			$_REQUEST["data"] = json_encode($qrCodeData);
			$filename = $PNG_TEMP_DIR.'test'.md5($_REQUEST['data'].'|'.$errorCorrectionLevel.'|'.$matrixPointSize).'.png';
			QRcode::png($_REQUEST['data'], $filename, $errorCorrectionLevel, $matrixPointSize, 2);
			return '<img src="'.$PNG_WEB_DIR.basename($filename).'" widh="100" height="100" />'; 
		}
	


	private function saveImportedFile(){
		$data = $this->control->request("data");
		$file = "../".$data["file"];
		$block = $data["blockreference"];
		$configuration = json_decode($block["importationproperties"]);
		$jsonColumns = json_decode($block["columnsobjects"]);
		//return json_encode($jsonColumns);
		//data construction starts
		if(file_exists($file)){
			$reader = ReaderFactory::create(Type::XLSX);
			$reader->open($file);
			$countSheet = 0;
			$countRow = 0;
			$multipleInsert = [];
			//sheet starts
			foreach($reader->getSheetIterator() as $sheet){
				$countSheet ++;
				if($countSheet === 1){
					//file starts
					foreach($sheet->getRowIterator() as $row){
						$countRow ++;
						if($countRow >= $configuration->rowstart){
							array_push($multipleInsert,[
								"null"=>"sdappdataid",
								"themeid"=>$block["themeid"],
								"blockid"=>$block[0],
								"data"=>(function($jsonColumns,$row,$config){
									$dataObject = (object)[];
									//column intervals starts
									$columnIntervals = $config->columnintervals;
									$columnNumbers = [];
									foreach($columnIntervals as $interval){
										$start = intVal($interval->start);
										$end  = intVal($interval->end);
										$refColumNumberCount = $start - 1;
										$subColumnNumbers = [];
										while($refColumNumberCount < $end){
											$refColumNumberCount ++;
											array_push($subColumnNumbers,$refColumNumberCount);
										}
										array_push($columnNumbers,implode(",",$subColumnNumbers));
									}
									$columnNumbersArray = explode(",",implode(",",$columnNumbers));
									//column intervals ends
									//working on col and data starts
									$index = -1;
									foreach($jsonColumns as $col){
										$index ++;
										$key = $col->key;
										$excelColumnNumberIndex  = key_exists($index,$columnNumbersArray)? intVal($columnNumbersArray[$index]) -1 : 0;
										$value = "";
										if(key_exists($excelColumnNumberIndex,$row)){
											$value = $row[$excelColumnNumberIndex];
										}
										if(is_string($value)){
											$value = $value;
										}
										if(is_object($value)){
											$value = json_decode(json_encode($value));
											if(property_exists($value ,"date")){
												$value = $value->date;
											}
											else{
												$value = "object";
											}
											
										}
										$dataObject->$key = $this->control->preventInj($this->conn(),$value);
									}
									//working on col and data ends
									return $dataObject;
								})($jsonColumns,$row,$configuration),
								"createdby"=>$this->main->userId()

							]);
						}
					}
					//return json_encode($configuration);
					return $this->model->multipleInsert($this->conn(),"sdappdata",$multipleInsert);
					//return json_encode($multipleInsert);
					//file ends
				}
				continue;
			}
			//sheet ends
		}
		//data construction ends
	}
	private function readImportedFile(){
		$data = $this->control->request("data");
		$file = "../".$data["path"];
		if(file_exists($file)){
				$reader = ReaderFactory::create(Type::XLSX);
				$reader->open($file);
				$countSheet = 0;
				$countColumn = 0;
				$data = array();
				foreach ($reader->getSheetIterator() as $sheet)
				{
					$countSheet ++;
					if($countSheet === 1){
						$n = 0;
						foreach ($sheet->getRowIterator() as $row)
						{
							$n++;
							if($n ===1){
								$countColumn = count($row);
							}
							$nColumn=count($row);
							array_push($data,'<tr>'.(function($row,$n){
								if(is_array($row)){
									$xlxRow = array('<td style="padding:5px;">'.$n.'</td>');
									for($i=0; $i < count($row); $i++){
										$value = false;
										if(is_string($row[$i])){
											$value = $this->control->letterArranger($row[$i],3);
										}
										if(is_object($row[$i])){
											$value = json_decode(json_encode($row[$i]));
											if(property_exists($value ,"date")){
												$value = $value ->date;
											}
											else{
												$value = "object";
											}
											
										}
										array_push($xlxRow,'<td style="padding:5px;">'.$value.'</td>');
									}
									return implode("",$xlxRow);
								}
							})($row,$n).'</tr>');
						}
					}
					else{
						continue;
					}
					
				}
				$firtRow = $this->control->excelColumn($countColumn);
				$table = '<table style="border:1px #ccc solid; border-collapse: collapse;" border="1"  width="100%">';
				$table.='<tr>'.$firtRow.'</tr>';
				$table.=implode("",$data);
				$table.="</table>";
				return $table;
		}
	}
	private function updateHtmlPage(){
		$data = $this->control->request("data");
		$file = $this->control->request("file");
		$pageid = $this->control->request("pageid");
		$pagename = $this->control->request("pagename");
		$pagetitle = $this->control->request("pagetitle");
		$this->model->updataQuery(
			"sdapppages",
			array(
				"pagename"=>$this->control->preventInj($this->conn(),$pagename),
				"pagetitle"=>$this->control->preventInj($this->conn(),$pagetitle)
			),
			$this->conn(),
			"pageid",
			$pageid
		);
		$propertyExist = function($data,$property){
			if(is_array($data)){
				foreach($data as $d){
					if($d["pagetagid"] === $property){
						return [
							"status"=>"found",
							"htmltags"=>$d["htmltags"]
						];
					}
				}
				return [
					"status"=>"not-found",
					"htmltags"=>false
				];
			}
		};
		if(file_exists($file)){
			$fileContent = json_decode(file_get_contents($file));
			$html = $fileContent->html;
			$htmlContent = [];
			foreach($html as $propertyKey=>$row){
				 $status = $propertyExist($data,$propertyKey);
				if($status["status"] === "found"){
					$fileContent->html->$propertyKey->data = $status["htmltags"];
				}
				if($fileContent->html->$propertyKey->type ==="static"){
					array_push($htmlContent,$fileContent->html->$propertyKey->data);
				}
				if($fileContent->html->$propertyKey->type ==="dynamic"){
					$dynamicContent = [];
					foreach($fileContent->html->$propertyKey->data as $dd){
						array_push($dynamicContent,$dd->data);
					}
					array_push($htmlContent,implode("",$dynamicContent));
				}
			}
			$this->control->mkFile($file,json_encode($fileContent));
			$htmlContent= implode("",$htmlContent);
			$sdappfile = str_replace(".json",".sdapp",$file);
			$this->control->mkFile($sdappfile,$htmlContent);
		}
	}
	public function iframe($object = false){
		return $this->view->iframe($object);
	}
	public function sharedApi($object = false){
		return $this->view->sharedApi($object);
	}
	private function loadDataPage(){
		$clientrow = $this->control->request("row");
		$themeId = $clientrow["themeid"];
		$themeurl = $this->prepath."themes/".$this->activatedThemeId("fileextracted")."/";
		$pageDir = $themeurl."sdapp-pure-html-pages/".$clientrow["pageid"]."/";
		if(is_dir($pageDir)){
			$targetFile = false;
			$targetFileContent = false;
			foreach(scandir($pageDir) as $file){
				$expl = explode(".",$file);
				$ext = end($expl);
				if($ext ==="json"){
					$targetFile = $pageDir.$file;
				}
				continue;
			}
			if($targetFile !== false && file_exists($targetFile)){
				$targetFileContent = json_decode(file_get_contents($targetFile));
			}
		}	
		if(is_array($clientrow["themeid"])){
			$themeId = $clientrow["themeid"][0];
		}
		$data = $this->model->selectData((object)[
			"table"=>"sdapppagehtmltags",
			"clauses"=>"WHERE themeid ='".$themeId."' AND pageid ='".$clientrow["pageid"]."' ORDER BY pagetagid ASC",
			"conn"=>$this->conn()
		]);
		$response = [];
		foreach($data as $row){
			$pagetagid = $row["pagetagid"];
			if($row["_type"] ==="2"){
				$response [] = [
					"type"=>2,
					"block-name"=>$this->model->foreignVal("WHERE blockid='".$row["blockid"]."'","sdappblockreference","blockname",$this->conn()),
					"row"=>$row
				];
			}
			else{
				$row["_tags"] = (function($jsonFile,$pagetagid,$self){
					if(is_object($jsonFile) 
					&& property_exists($jsonFile,"html")
					&& is_object($jsonFile->html)
					&& property_exists($jsonFile->html,$pagetagid)){
						return $jsonFile->html->$pagetagid->data;
					}
					return $self;
				})($targetFileContent,$pagetagid,$row["_tags"]);
					$restrictedKey = "@sdapp";
					$istextexisted = strip_tags(trim($row["_tags"]));
					if(strpos($istextexisted,$restrictedKey) > -1){continue;}
					$response [] = [
						"pagetagid"=>$pagetagid,
						"type"=>1,
						"row"=>$row,
						"istextexisted"=>$istextexisted,
						"textarray"=>(function($tags){
							$textArray = [];
							$expl = explode(">",$tags);
							foreach($expl as $index=>$htmltag){
								$text = strip_tags(trim($htmltag));
								if($text !== ""){
									array_push($textArray,[
										"text"=>$text,
										"index"=>$index
									]);
								}
							}
							return $textArray;
						})($row["_tags"])
					];
				
			}
		}
		return json_encode([
			"file"=>$targetFile,
			"content"=>$response
		]);
	}
	private function countDataByCategory(){
		$column = $this->control->request("childcolumn");
		$parentblockid = $this->control->request("parentblock");
		$childbockid = $this->control->request("childblock");
		$themeid = $this->activatedThemeId();
		$ref1 = [];
		$ref1[] = "themeid ='$themeid' AND blockid='$parentblockid' AND datastatus > 0";
		$ref1[] = "themeid ='".$this->configuration["sdapp-article-clausures"][0]."' AND blockid='$parentblockid' AND datastatus > 0";
		$ref1[] = "themeid ='".$this->configuration["sdapp-article-clausures"][1]."' AND blockid='$parentblockid' AND datastatus > 0";
		$ref1 = implode(" OR ",$ref1);
		$ref2 = [];
		$ref2[] = "themeid ='$themeid' AND blockid='$childbockid' AND datastatus > 0";
		$ref2[] = "themeid ='".$this->configuration["sdapp-article-clausures"][0]."' AND blockid='$childbockid' AND datastatus > 0";
		$ref2[] = "themeid ='".$this->configuration["sdapp-article-clausures"][1]."' AND blockid='$childbockid' AND datastatus > 0";
		$ref2 = implode(" OR ",$ref2);
		$dataCategory = $this->model->selectData((object)[
			"conn"=>$this->conn(),
			"table"=>"sdappdata",
			"clauses"=>"WHERE ".$ref1
		]);
		$dataChildren = $this->model->selectData((object)[
			"conn"=>$this->conn(),
			"table"=>"sdappdata",
			"clauses"=>"WHERE ".$ref2
		]);
		if(is_array($dataCategory) && count($dataCategory) > 0){
			$frontend = [];
			foreach($dataCategory as $row){
				$count =function($object){
					if(is_object($object)){
						$n =0;
						if(is_array($object->datachildren) && count($object->datachildren) > 0){
							foreach($object->datachildren as $row){
								$data = json_decode($row["data"]);
								$prop =  $object->column;
								if(property_exists($data,$prop)){
									if(is_object($data->$prop)){
										if(property_exists($data->$prop,"fkid")){
											if((string) $data->$prop->fkid === (string)$object->blockid){
												$n++;
											}
										}
									}
								}
							}
						}
					}
					return $n;
				};
				$frontend[$this->pageIdDecripted($row[0],true)] = [
					"count"=>$count((object)[
						"blockid"=>$row[0],
						"datachildren"=>$dataChildren,
						"column"=>$column
					])
				];
			}
			return json_encode($frontend);
		}
		return json_encode($dataChildren);
	}
	private function loadMoreContents(){
		return json_encode($this->writeLightPage([
			"ref"=>$this->control->request("ref"),
			"load-more-contents"=>true
		]));
	}
	private function updateWebBasicInfo(){
		$data = $this->control->request("data");
		$updates = [];
		if(is_array($data) && count($data) > 0){
			$updates[]=array("name"=>$data["websitename"]);
			$updates[]=array("title"=>$data["websitepagetitle"]);
			$updates[]=array("email"=>$data["websiteemail"]);
			$updates[]=array("description"=>$data["websitedescription"]);
			$updates[]=array("backend-default-lang"=>$data["backenddefaultlanguage"]["value"]);
			$updates[]=array("favicon"=>$data["websitefavicon"]);
			$basicInformation = $this->websiteBasicInformation();
			$basicInformation->info = $updates;
			$file = dirname(__FILE__)."/sdapp-website-info.json";
			if(file_exists($file)){
				$this->control->mkFile($file,json_encode($basicInformation));
				$pageArray= $this->model->foreignVal("WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey='sdapp_pageheader1'","sdapppages",[],$this->conn());
				die($this->writeNoSqlWebsiteInfo((object)[
					"themeid"=>$this->activatedThemeId(),
					"blockid"=>0,
					"pageid"=>$pageArray[0]
				]));
			}
		}
	}
	private function getAllPhotos(){
		return $this->mediaFiles((object)[
			"returnfiles"=>true
		]);
	}
	public function setSessionForDownloadingFile(){
		$_SESSION["SDAPP-DOWNLOADING-FILE"] = $this->control->request("url");
	}
	public function deleteMediaFile(){
		$url = "../".$this->control->request("url");
		if(file_exists($url)){
			return unlink($url);
		}
		
	}
	public function mediaFilesParameters(){
		return json_encode([
			"textjson"=>$this->configuration,
			"themeid"=>$this->activatedThemeId(),
			"fileextracted"=>$this->activatedThemeId("fileextracted"),
			"files"=>$this->mediaFiles(),
			"filesorigine"=>$this->mediaFiles()
		]);
	}
	public function fetchDynamicListData(){
		$blockid = (int)$this->pageIdDecripted($this->control->request("blockid"));
		$themeid = (int)$this->pageIdDecripted($this->control->request("themeid"));
		$columns = (array)$this->control->request("columns");
		$query = (array)$this->conn()->query("SELECT data AS data , sdappdataid AS id FROM  sdappdata WHERE themeid = '".$themeid."' AND blockid = '".$blockid."' AND datastatus > 0")->fetchAll();
		if(is_array($query) && is_iterable($query)){
			$feedback = [];
			for($i = 0; $i<count($query); $i++){
				$output = [];
				$data = json_decode($query[$i]["data"]);
				foreach($columns as $col){
					array_push($output,$data->$col);
				}
				array_push($feedback,[
					"id"=>$query[$i]["id"],
					"output"=>$output
				]);
			}
			sort($feedback);
			return json_encode($feedback,JSON_PRETTY_PRINT);
		}
	}
	public function validateBuiltInPlugin(){
		(string)$pluginid = $this->pageIdDecripted($this->control->request("pluginid"));
		(object) $plugindata = $this->model->foreignVal("WHERE builtinpluginid='".$pluginid."'","sdapp_built_in_plugins",[],$this->conn());
		return json_encode($plugindata);
	}
	public function getWebPageInformation(){
		$urlparts = $this->control->request("urlparts");
		$chosenUrlString = $urlparts[2];
		$homePageArr =["","index.php"];
		$themeId = $this->activatedThemeId();
		$homePageId = $this->model->foreignVal("WHERE themeid='".$themeId."' AND staticpagekey='sdapp_homepage3' ","sdapppages","pageid",$this->conn());
		$urlpartFromExplode= explode("/",$chosenUrlString);
		$pageid = 0;
		$__end = end($urlpartFromExplode);
		if(in_array($__end,$homePageArr)){
			$pageid = $homePageId;
		}
		else{
			$pageid = $this->pageIdDecripted($this->control->getValFromExplode("-",$__end,1));
		}
		if(strpos($__end,"sdapp-read-more-page") > -1){
			$dataid = $this->pageIdDecripted($this->control->getValFromExplode("-",$__end,6));
			$data = $this->model->foreignVal("WHERE sdappdataid='".$dataid."'","sdappdata",[],$this->conn());
			$block = $this->model->foreignVal("WHERE blockid='".$data["blockid"]."'","sdappblockreference",[],$this->conn());
			$blockColumns = json_decode($block["columnsobjects"]);
			$titleKey = false;
			$dataObject = json_decode($data["data"]);
			if(is_array($blockColumns) && count($blockColumns) > 0){
				foreach($blockColumns as $column){
					if(property_exists($column,"readmorereference") && $column->readmorereference ==="title"){
						$titleKey = $column->key;
					}
				}
			}
			if(property_exists($dataObject,$titleKey)){
				return json_encode([
					"pagetitle"=>$this->control->textCleaner($dataObject->$titleKey)
				]);
			}
			
		}
		else{
			$pageInformation  = $this->model->foreignVal("WHERE pageid='".$pageid."' AND datastatus > 0 ","sdapppages",[],$this->conn());
			return json_encode($pageInformation);
		}
		
	}
	public function base_url($obj=array()){
		if(is_array($obj) && key_exists("type",$obj) && key_exists("filename",$obj)){
			$currentUrl= $this->control->currentUrl(true);
			$script =$currentUrl["script"];
			$host =$currentUrl["host"];
			$fileName =$obj["filename"];
			$redirect ="sdapp-redirect-to-host";
			$ncUrl=(function($r,$k){ if(key_exists($k,$r)){return $r[$k];}return false;})($_REQUEST,"sdapp-url");
			$slash=substr($ncUrl,-1);
			$redirectionUrl =$currentUrl["protocol"]."://".$currentUrl["host"];
			$base_url = $redirect;
			$uri =$_SERVER['REQUEST_URI'];
			//die($script);
			switch($obj["type"]){
				case "dbconnection":
				    	$base_url =dirname(__FILE__)."/".$fileName;
				break;
				case "dbconfiguration":
					$base_url=$this->control->replacer2(array(
						array("code"=>"\\","value"=>"/"),
						array("code"=>$_SERVER["DOCUMENT_ROOT"],"value"=>false),
						array("code"=>"php/sdapp/class.php","value"=>false),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),__FILE__).$fileName;
				break;
			}
	
			if($base_url ===$redirect){
				$this->control->redirection($redirectionUrl);
				die();
			}
			else{
				return $base_url;
			}
			
		}
	}
	public function conn(){
				$dbConnFile=$this->base_url(["type"=>"dbconnection","filename"=>"sdapp-db-conn.json"]);
				$dbConnJSON=json_decode(file_get_contents($dbConnFile),true);
				$arrCreditials=$dbConnJSON["db-creditials"];
				$conn =false;
				try {
					$conn= new PDO(
					"mysql:host=".$arrCreditials['hostname'].";dbname=".$arrCreditials['databasename'].";",
					$arrCreditials['databaseusername'],
					$arrCreditials['databasepassword'],
					array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8")
					);
				}
				catch(PDOException $e)
				{  
					die($this->view->setDatabaseCreditials());	
				}
				return $conn;
	}
	
	private function copyPage(){
		$data=$this->control->request("data");
		$type =(int) $this->control->request("type");
		$row=$this->control->request("row");
		if($type ===1){
			$pagename=$data["pagename"];
			$pagetitle=$data["pagetitle"];
			$row["pagename"]=$pagename;
			$row["pagetitle"]=$pagetitle;
		}
		
		$this->var=$row;
		$copy=$this->model->copyData([
			"conn"=>$this->conn(),
			"form-data"=>$data,
			"sourcetableobject"=>[
				"query"=>"SELECT * FROM sdapppagehtmltags WHERE pageid='".$row[0]."' ORDER BY pagetagid ASC",
				"callback"=>function($qObject,$arrayOptions){
					$newHtmlTags=[];
					$type =(int) $this->control->request("type");
					if ($type ===1){
						$writePage=$this->model->insertQuery(
							"sdapppages",
							[
								"pageid"=>"NULL",
								"themeid"=>$this->var["themeid"][0],
								"pagename"=>$this->var["pagename"],
								"pagetitle"=>$this->var["pagetitle"],
								"activateasmenu"=>0,
								"activateassubmenu"=>0,
								"activatepageasstatic"=>0,
								"staticpagekey"=>"none",
								"menufeatures"=>(function($sqlResult){
									if(is_array($sqlResult) && count($sqlResult)>0){
										return $sqlResult;
									}
									return ["NULL"];
								})(json_decode($this->var["menufeatures"],true)),
								"pagefeatures"=>(function($sqlResult){
									return ["NULL"];
								})(json_decode($this->var["pagefeatures"],true)),
								"createdby"=>$this->var["createdby"]
							],
							$this->conn()
						);
						$pageid=$writePage["lastid"];
					}
					else{
						$pageid=$arrayOptions["form-data"]["receivedpage"];
					}
					foreach($qObject as $row){
						$row["pageid"]=$pageid;
						$row["pagetagid"]="NULL";
						$row["_functions"]=json_decode($row["_functions"],true);
						if((int)$row["_type"] ===2){
							//copy block  starts
							$blockId=$row["blockid"];
							$block=$this->model->foreignVal("WHERE blockid='".$blockId."' ","sdappblockreference",array(),$this->conn());
							$fields_Values=[];
							foreach($block as $key=>$value){
								if(is_string($key)){
									$fields_Values[$key]=$value;
								}
							}
							$fields_Values["blockid"]="NULL";
							$fields_Values["blockname"]=$fields_Values["blockname"]."-sdapp-copy";
							$fields_Values["columnsobjects"]=json_decode($fields_Values["columnsobjects"],true);
							$writeBlock=$this->model->insertQuery(
								"sdappblockreference",
								$fields_Values,
								$this->conn()
							);
							$newBlockId=$writeBlock["lastid"];
							$row["blockid"]=$newBlockId;
							  //copy data starts
							  $newData=[];
							  $dataquery=$this->conn()->query("SELECT * FROM  sdappdata WHERE blockid='".$blockId."'")->fetchAll(PDO::FETCH_ASSOC);
							  foreach($dataquery as $k=>$d){
								$d["sdappdataid"]="NULL";
								$d["blockid"]=$newBlockId;
								$d["data"]=json_decode($d["data"],true);
									$newData[$k]=$d;
							  }
							   $this->model->multipleInsert($this->conn(),"sdappdata",$newData);
							  //copy data ends
							//copy block ends
						}
						$newHtmlTags[]=$row;
					}
					return json_encode($this->model->multipleInsert($this->conn(),"sdapppagehtmltags",$newHtmlTags));
				}
			]
		]);
		return $copy;
	}
	private function getSqlPageBlocks(){
		$table=$this->control->request("table");
		$ref=$this->control->request("ref");
		$q=$this->conn()->query("SELECT * FROM ".$table." ".$ref." ");
		if(is_object($q)){
			$q=$q->fetchAll();
			$data=[];
			foreach($q as $row){
				$tagField="_tags";
				if(key_exists($tagField,$row) && trim($row[$tagField]) ==="JSON"){
					$data[]=(function($row,$field){
						$jsonFile=str_replace(".sdapp",".json",$this->pageUrl());
						$row[$field]=json_decode(file_get_contents($jsonFile),true)[$row[0]][$field];
						return $row;
					})($row,$tagField);
				}else{
					$data[]=$row;
				}
				
			}
			return json_encode($data);
		}
	} 
	private function deletePageBlock(){
		$file=$this->pageUrl();
		if(file_exists($file)){
			$fileContent=trim(file_get_contents($file));
			$blocktype = (int)$this->control->request("blocktype");
			$blockrow = $this->control->request("blockrow");
			$newContent=false;
			if($blocktype ===1){
				$webMenu=$this->ncMenuGenerator($blockrow["themeid"],$blockrow["pagetagid"],$blockrow["pageid"]);
				$tag=$blockrow["_tags"];
				$tag=$this->control->replacer2(
					array(
						array("code"=>$this->keyWords["web-menu"],"value"=>$webMenu),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),
					$tag
				);
				$reference=$this->control->str_replace_first(
					$this->tagsReplacer($tag),
					">",
					$this->staticKeyWordReplace($blockrow["pagetagid"],$blockrow["pageid"],$tag)
				);
				$newContent=str_replace($reference,false,$fileContent);
			}
			else if($blocktype===2){
				$reference=$this->dynamicContentBlock($blockrow["pagetagid"],$blockrow["pageid"],$blockrow["blockid"],$this->dynamicContent($blockrow));
				$newContent=str_replace($reference,false,$fileContent);
			}
			$this->control->mkFile($file,$newContent);
			$this->model->simpleDeletion(
				$this->conn(),
				"WHERE pagetagid='".$blockrow["pagetagid"]."'",
				'sdapppagehtmltags'
			);
		//return $fileContent;
		}
		
	}
	private function configureDatabaseConnection(){
		$localServer = ["127.0.0.1","::1"];
		$sRemote =$_SERVER['REMOTE_ADDR'];
		$inputs=$this->control->request("inputs");
		$online=(string)$this->control->request("online");
		$feedback=[];
		if($inputs["hostname"] ==="" || empty($inputs["hostname"]) ){
			$feedback["status"]="host-name-missing";
			$feedback["alert"]=$this->configuration["alert"][$this->lang];
			$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-1"][$this->lang];
		}
		else if($inputs["databasename"] ==="" || empty($inputs["databasename"]) ){
			$feedback["status"]="database-name-missing";
			$feedback["alert"]=$this->configuration["alert"][$this->lang];
			$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-2"][$this->lang];
		}
		else if($inputs["dbusername"] ==="" || empty($inputs["dbusername"]) ){
			$feedback["status"]="database-user-name-missing";
			$feedback["alert"]=$this->configuration["alert"][$this->lang];
			$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-3"][$this->lang];
		}
		else if($inputs["dbpassword"] ==="" && $online ==="true" && in_array($sRemote,$localServer) ===false
		|| empty($inputs["dbpassword"]) && $online ==="true" && in_array($sRemote,$localServer) ===false){
			$feedback["status"]="database-password-missing";
			$feedback["alert"]=$this->configuration["alert"][$this->lang];
			$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-4"][$this->lang].$_SERVER['REMOTE_ADDR'];
		}
		else{
			try {
					new PDO(
					"mysql:host=".$inputs["hostname"].";dbname=".$inputs["databasename"].";",
					$inputs["dbusername"],
					$inputs["dbpassword"]
				 	);
					 if($this->control->updateJSON(
						 ["db-creditials"=>[]],
						 "db-creditials",
						 [
							 "hostname"=>$inputs["hostname"],
							 "databasename"=>$inputs["databasename"],
							 "databaseusername"=>$inputs["dbusername"],
							 "databasepassword"=>$inputs["dbpassword"]
						 ],
						 false,
						 [
							 "file"=>(function($file){
								$posibilitiesRoot=[
									"",
									"../",
									"sdapp/",
									"sdapp-manager/sdapp/",
								];
								foreach($posibilitiesRoot as $prefix){
									if(file_exists($prefix.$file)){
										return $prefix.$file;
									}
								}
							 })("sdapp-db-conn.json")
						 ]

						)>0){
							$feedback["status"]="success";
							$feedback["alert"]=$this->configuration["alert"][$this->lang];
							$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-6"][$this->lang];
						};
				}
				catch(PDOException $e)
				{
					$feedback["status"]="wrong-database-creditials";
					$feedback["alert"]=$this->configuration["alert"][$this->lang];
					$feedback["message"]=$this->configuration["set-db-connection-ui"]["warning-5"][$this->lang]."\n".$e->getMessage();
				}
		}
		
		
		return json_encode($feedback);
	}
	private function staticKeyWordReplace($tagid,$pageid,$tag=""){
		return ">";
	}
	private function dynamicContentBlock($tagid,$pageid,$blockid,$content){
		return $content;
		//return '<sdapp-dynamic-content sdapp-block-reference="'.$blockid.'" sdapp-tag-id="'.$tagid.'" sdapp-page-id="'.$pageid.'">'.$content.'</sdapp-dynamic-content>';
	}

	private function menuGetAttributes ($menuFeatures,$keyProperty){
		$j=json_decode($menuFeatures);
		if(is_object($j) && property_exists($j,$keyProperty)){
			$obj =get_object_vars($j);
			if(is_object($obj[$keyProperty])){
				if($keyProperty==="sdapp-attributes"){
					$attributes =[];
					foreach($obj["sdapp-attributes"] as $key=>$attr){
						$attributes[]=$key.'="'.$attr.'"';
					}
					return implode("",$attributes);
				}	
			}
			else{
				if($keyProperty ==="menu_html_code_name"){
					return $this->control->shortReplacer($obj[$keyProperty]);
				}
				else{
					return $obj[$keyProperty];
				}
				
			}
		}else{
			return false;
		}
	}
	private function skipQuote($str){
		return str_replace("\\",false,$str);
	}
	private function ncMenuGenerator($themeid,$tageid,$pageid,$menuType="web-menu"){
			$activatedMenu=$this->model->foreignVal("WHERE setasactive>0 AND themeid='".$themeid."'","sdapp_menus","menujson",$this->conn());
			$decoder=$this->control->decodeJSONTogetArray($activatedMenu,array());
			$tags=$this->model->foreignVal("WHERE themeid='".$themeid."' AND menutype='".$menuType."'","sdappmenuconfiguration",array(),$this->conn());
			$tg=(function($arr,$key){
				if(key_exists($key,$arr)){
					return $this->skipQuote($arr[$key]);
				}
				return false;
			})($tags,"parenttagopen");
			$html=[
				$this->control->str_replace_first(
					$this->control->specialCharReplacer($tg),
					">",
					$this->staticKeyWordReplace($tageid,$pageid,$tg)
				)
			];
			
			$this->var=["pages"=>$this->conn()->query("SELECT * FROM sdapppages WHERE themeid='".$themeid."' AND datastatus >0 ")->fetchAll()];
			$updatedPage= function($pageid,$returnedField){
				foreach($this->var["pages"] as $page){
					if((int)$pageid === (int) $page[0]){
						if(is_array($returnedField)){
							return $this->skipQuote($page);
						}
						else{
							if(key_exists($returnedField,$page)){
								return $this->skipQuote($page[$returnedField]);
							}
						}
						
					}
				}
			};
			
			$this->var["updatedpage"]=$updatedPage;
			if(is_array($decoder)){
				foreach($decoder as $menu){

					$html[]=(function($tags,$li,$row){
						if(
							key_exists("parenttagdynamic",$tags) 
							&& key_exists("childrentagopen",$tags)
							&& property_exists($row,"submenu")){
							$menu[]=$tags["parenttagdynamic"];
							$dropDown=[$tags["childrentagopen"]];
							if(is_array($row->submenu)){
								foreach($row->submenu as $submenu){
									$dropDown[]=$this->control->replacer2([
										array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
										["code"=>"@title","value"=>$this->control->quoteReplacer($this->var["updatedpage"]($submenu->pageid,"pagename"))],
										["code"=>"@url","value"=>(function($submenu){
											return strtolower(implode("",[
												"page",
												"-",
												$this->control->replacer2($this->pageIdCriptedArray(),$submenu->pageid),
												"-",
												str_replace(" ","-",$this->control->quoteReplacer($this->var["updatedpage"]($submenu->pageid,"pagename")))
											]));
										})($submenu)],
										["code"=>"@attributes","value"=>$this->menuGetAttributes($this->var["updatedpage"]($submenu->pageid,"menufeatures"),"sdapp-attributes")],
										["code"=>"@menuactive","value"=>$this->menuGetAttributes($this->var["updatedpage"]($submenu->pageid,"menufeatures"),"menu_active_css_class_name")],
										["code"=>"@menuhtmlcode","value"=>$this->menuGetAttributes($this->var["updatedpage"]($submenu->pageid,"menufeatures"),"menu_html_code_name")],
										["code"=>"@menuicon","value"=>$this->menuGetAttributes($this->var["updatedpage"]($submenu->pageid,"menufeatures"),"menu_active_css_class_name")]
									],$tags["childrentagdynamic"]);
								}
							}
							$dropDown[]=$tags["childrentagclose"];
							return $this->control->replacer2([
								array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
								["code"=>"@dropdown","value"=>implode("",$dropDown)],
								["code"=>"@title","value"=>$this->control->quoteReplacer($this->var["updatedpage"]($row->pageid,"pagename"))],
								["code"=>"@url","value"=>(function($row){
									return "#";
								})($row)],
								["code"=>"@attributes","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"sdapp-attributes")],
								["code"=>"@menuactive","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_active_css_class_name")],
								["code"=>"@menuhtmlcode","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_html_code_name")],
								["code"=>"@menuicon","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_active_css_class_name")]
							],implode("",$menu));
						}
						return $this->control->replacer2([
							array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
							["code"=>"@title","value"=>$this->control->quoteReplacer($this->var["updatedpage"]($row->pageid,"pagename"))],
							["code"=>"@url","value"=>(function($row){
								return strtolower(implode("",[
									"page",
									"-",
									$this->control->replacer2($this->pageIdCriptedArray(),$row->pageid),
									"-",
									str_replace(" ","-",$this->control->quoteReplacer($this->var["updatedpage"]($row->pageid,"pagename")))
								]));
							})($row)],
							["code"=>"@dropdown","value"=>false],
							["code"=>"@attributes","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"sdapp-attributes")],
							["code"=>"@menuactive","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_active_css_class_name")],
							["code"=>"@menuhtmlcode","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_html_code_name")],
							["code"=>"@menuicon","value"=>$this->menuGetAttributes($this->var["updatedpage"]($row->pageid,"menufeatures"),"menu_active_css_class_name")]
						],$li);
					})($tags,$this->control->specialCharReplacer((function($arr,$key){
						if(key_exists($key,$arr)){
							return $arr[$key];
						}
						return false;
					})($tags,"parenttagdynamic")),$menu);
	
				  }
			}


		$html[]=$this->control->specialCharReplacer((function($arr,$key){
			if(key_exists($key,$arr)){
				return $arr[$key];
			}
			return false;
		})($tags,"parenttagclose"));
		return implode("",$html);
	}
	private function addBlockByPosition($objArr){
		$pageid=$objArr["pageid"];
		$themeid=$objArr["themeid"];
		$writeFile=$objArr["writefile"];
		$htmlcode=$objArr["htmlcode"];
		$comment=$objArr["comment"];
		$file=$objArr["file"];
		$appendType=(string)$objArr["appendtype"];
		$blockType=(int)$objArr["blocktype"];
		$blockId=(int)$objArr["blockid"];
		$ordering=(string)$objArr["ordering"];
		$limit=(int)$objArr["limit"];
		$functions=(array)$objArr["functions"];
		$currentDataFromDb=$this->conn()->query("SELECT * FROM sdapppagehtmltags WHERE pageid='".$pageid."' AND themeid='".$themeid."' ORDER BY pagetagid ASC")->fetchAll();
		$block=$writeFile["block"];
		$newData=array(
			"pagetagid"=>"NULL",
			"themeid"=>$themeid,
			"pageid"=>$pageid,
			"blockid"=>$blockId,
			"_ordering"=>$ordering,
			"_limit"=>$limit,
			"_type"=>$blockType,
			"_tags"=>$this->control->sdappReplacer(trim($htmlcode)),
			"_comments"=>$comment,
			"_functions"=>$functions,
			"createdby"=>$this->main->userId()
		);
		$newQueryArr=[];
		$newId=$this->model->foreignVal(
			"ORDER BY pagetagid DESC LIMIT 1",
			"sdapppagehtmltags",
			array(),
			$this->conn()
			);
		
			$newId=(int)$newId[0];
			$newDataTagId=0;
			$referenceBlockNewTagId=0;
			$fileContent=false;
			if(file_exists($file)){
				$fileContent=file_get_contents($file);
			}
			foreach($currentDataFromDb as $data){
				$newId++;
				$currentData=array(
				"pagetagid"=>"NULL",
				"themeid"=>(int)$data["themeid"],
				"pageid"=>(int)$data["pageid"],
				"blockid"=>(int)$data["blockid"],
				"_ordering"=>$data["_ordering"],
				"_limit"=>(int)$data["_limit"],
				"_type"=>$data["_type"],
				"_tags"=>$this->control->sdappReplacer(trim($data["_tags"])),
				"_comments"=>$data["_comments"],
				"_functions"=>json_decode($data["_functions"],true),
				"createdby"=>$data["createdby"]
				);
				if((int)$data["pagetagid"] ===(int)$block["pagetagid"]){
					if($appendType ==="append-before"){
						$newData["pagetagid"]=$newId;
						$newQueryArr[$newId]=$newData;
						$newDataTagId=$newId;
						$newId++;
						$referenceBlockNewTagId=$newId;
						$currentData["pagetagid"]=$newId;
						$newQueryArr[$newId]=$currentData;
						$fileContent=$this->control->replacer2([
							["code"=>'sdapp-tag-id="'.$data[0].'"',"value"=>'sdapp-tag-id="'.$newId.'"'],
							array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
						],$fileContent);
					}
					else if($appendType ==="append-after"){
						$fileContent=$this->control->replacer2([
							["code"=>'sdapp-tag-id="'.$data[0].'"',"value"=>'sdapp-tag-id="'.$newId.'"'],
							array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
						],$fileContent);
	
						$currentData["pagetagid"]=$newId;
						$newQueryArr[$newId]=$currentData;
						$referenceBlockNewTagId=$newId;
						$newId++;
						$newData["pagetagid"]=$newId;
						$newQueryArr[$newId]=$newData;
						$newDataTagId=$newId;
					}
					
				}
				else{
					$currentData["pagetagid"]=$newId;
					$newQueryArr[$newId]=$currentData;
					$fileContent=$this->control->replacer2([
						["code"=>'sdapp-tag-id="'.$data[0].'"',"value"=>'sdapp-tag-id="'.$newId.'"'],
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					],$fileContent);
				}
				
			}
			$tag=$this->control->specialCharReplacer(trim($block["_tags"]));
			if($blockType ===1){
				$referencedBlockforAppendingTo=$this->control->str_replace_first(
					$this->tagsReplacer($tag),
					">",
					$this->staticKeyWordReplace($referenceBlockNewTagId,$block["pageid"],$tag)
				);
				$newBlock=$this->control->str_replace_first(
					$this->tagsReplacer($htmlcode),
					">",
					$this->staticKeyWordReplace($newDataTagId,$block["pageid"],$htmlcode)
				);
				$webMenu=$this->ncMenuGenerator($themeid,$referenceBlockNewTagId,$block["pageid"]);
				$newBlock=$this->control->replacer2(
					array(
						array("code"=>$this->keyWords["web-menu"],"value"=>$webMenu),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),
					$newBlock
				);
				
			}
	
			if($blockType ===2){
				$newrow=[];
				$newrow["themeid"]=$themeid;
				$newrow["blockid"]=$blockId;
				$newrow["_tags"]=$this->control->specialCharReplacer(trim($htmlcode));
				$newrow["_ordering"]=$ordering;
				$newrow["_limit"]=$limit;
				$newrow["_functions"]=json_encode($functions);
				if((int)$block["_type"]===2){
					$referencedBlockforAppendingTo=$this->dynamicContentBlock($referenceBlockNewTagId,$block["pageid"],$block["blockid"],$this->dynamicContent($block));
				}
				else if((int)$block["_type"]===1){
					$referencedBlockforAppendingTo=$this->control->str_replace_first(
						$this->tagsReplacer($tag),
						">",
						$this->staticKeyWordReplace($referenceBlockNewTagId,$block["pageid"],$tag)
					);
				}
				$newBlock=$this->dynamicContentBlock($newDataTagId,$block["pageid"],$blockId,$this->dynamicContent($newrow));
			}
	
			if($appendType ==="append-before"){
				$htmlCodeForReplacement=$newBlock.$referencedBlockforAppendingTo;
			}
			else if($appendType ==="append-after"){
				$htmlCodeForReplacement=$referencedBlockforAppendingTo.$newBlock;
			}
			
			if(file_exists($file)){
				$fileContent=str_replace($referencedBlockforAppendingTo,$htmlCodeForReplacement,trim($fileContent));
				//die($fileContent);
				$this->model->simpleDeletion(
					$this->conn(),
					"WHERE themeid='".$themeid."' AND pageid='".$pageid."'",
					'sdapppagehtmltags'
				);
				
			$sqlArr=$this->model->multipleInsert(
					$this->conn(),
					"sdapppagehtmltags",
					$newQueryArr,
				);
		
			$this->control->mkFile($file,$fileContent);
			}
		
			return json_encode(["status"=>"success","action"=>$appendType,"blocktype"=>$blockType,"queries"=>$newQueryArr]);
	
			
	}
	private function saveEditIntoJSONFile($options){
		if(is_array($options)
		&& key_exists("table",$options)
		&& key_exists("file",$options)
		&& key_exists("colsvalues",$options)
		&& key_exists("primarykey",$options)
		&& key_exists("targetfield",$options)
		&& key_exists("content",$options)
		){
			$file=(function($ncFile){$exp=explode(".sdapp",$ncFile);return $exp[0].".json";})($options["file"]);
			$table=$options["table"];
			$colsvalues=$options["colsvalues"];
			$primaryKey=$options["primarykey"];
			$targetField=$options["targetfield"];
			$content=$options["content"];
			$colsvalues[$targetField]="JSON";
			$lastId=(function($colsValues,$table){
				$insert=$this->model->insertQuery(
					$table,
					$colsValues,
					$this->conn()
				);
				return $insert["lastid"];
			})($colsvalues,$table);
			$colsvalues[$primaryKey]=$lastId;
			$colsvalues[$targetField]=trim($content);
			$jsonFileContent=(function($jsonFile,$colsvalues,$lastId){
				if(file_exists($jsonFile)){
					$currentJSON=json_decode(file_get_contents($jsonFile),true);
					$currentJSON[$lastId]=$colsvalues;
					return json_encode($currentJSON);
				}
				else{
					return json_encode([
						$lastId=>$colsvalues
					]);
				}
			})($file,$colsvalues,$lastId);
			$this->control->mkFile($file,$jsonFileContent);
		}
	}
	private function saveContentBlock(){
		$type=(int)$this->control->request("type");
		$writeFile=(array)$this->control->request("writefile");
		$writeFileType=(function($arr,$key){
			if(is_array($arr) && key_exists($key,$arr)){return (string)$arr[$key];}return (string)"append";
		})($writeFile,"type");
		if($type ===1){
			//static content starts
			$htmlcode=$this->ncTextTag($this->control->request("htmlcode"));
			$comment=$this->control->request("comment");
			$tagid=(int)$this->control->request("tagid");
			$pageid=(int)$this->control->request("pageid");
			$themeid=(int)$this->control->request("themeid");
			$file=$this->pageUrl();
	        if($writeFileType ==="append"){
				$colsValues=array(
					"pagetagid"=>"NULL",
					"themeid"=>$themeid,
					"pageid"=>$pageid,
					"blockid"=>0,
					"_ordering"=>"none",
					"_limit"=>0,
					"_type"=>1,
					"_tags"=>$this->control->sdappReplacer(trim($htmlcode)),
					"_comments"=>$comment,
					"_functions"=>[
						"functionname"=>"void"
					],
					"createdby"=>$this->main->userId()
				);
				$insertQuery=$this->model->insertQuery(
					"sdapppagehtmltags",
					$colsValues,
					$this->conn()
				);
				if((int)$insertQuery["result"]<1){
						$this->saveEditIntoJSONFile([
							"file"=>$file,
							"colsvalues"=>$colsValues,
							"table"=>"sdapppagehtmltags",
							"primarykey"=>"pagetagid",
							"targetfield"=>"_tags",
							"content"=>$htmlcode
						]);
					};
					$row=$this->model->foreignVal(
						"WHERE _type=1 AND pageid='".$pageid."' ORDER BY pagetagid DESC LIMIT 1",
						"sdapppagehtmltags",
						array(),
						$this->conn()
						);
					$referencedBlock=$this->control->str_replace_first(
							$this->tagsReplacer($htmlcode),
							">",
							$this->staticKeyWordReplace($row[0],$pageid,$htmlcode)
						);
					if(!file_exists($file)){
						$this->control->mkFile($file,$referencedBlock);
					}else{
						$this->control->mkFile($file,$referencedBlock,1,"append");
					}
			}
			else{
				return $this->addBlockByPosition([
					"pageid"=>$pageid,
					"themeid"=>$themeid,
					"writefile"=>$writeFile,
					"htmlcode"=>$htmlcode,
					"comment"=>$comment,
					"file"=>$file,
					"appendtype"=>$writeFileType,
					"blocktype"=>$type,
					"blockid"=>0,
					"ordering"=>"none",
					"limit"=>0,
					"functions"=>[
						"functionname"=>"void"
					]
				]);
			}
			//static content ends
		}
		else{
			//dynamic content starts
			$referenceblock=$this->control->request("referenceblock");
			$sqlorder=$this->control->request("sqlorder");
			$sqllimit=$this->control->request("sqllimit");
			$htmlcode=$this->control->request("htmlcode");
			$comment=$this->control->request("comment");
			$functions=$this->control->request("functions");
			$tagid=(int)$this->control->request("tagid");
			$pageid=(int)$this->control->request("pageid");
			$themeid=(int)$this->control->request("themeid");
			$file=$this->pageUrl();
			if($writeFileType ==="append"){
				$this->model->insertQuery(
					"sdapppagehtmltags",
					array(
						"pagetagid"=>"NULL",
						"themeid"=>$themeid,
						"pageid"=>$pageid,
						"blockid"=>$referenceblock,
						"_ordering"=>$sqlorder,
						"_limit"=>$sqllimit,
						"_type"=>2,
						"_tags"=>$this->control->sdappReplacer(trim($htmlcode)),
						"_comments"=>$comment,
						"_functions"=>$functions,
						"createdby"=>$this->main->userId()
					),
					$this->conn()
				);
	
				$row=$this->model->foreignVal(
					"WHERE _type=2 AND pageid='".$pageid."' ORDER BY pagetagid DESC LIMIT 1",
					"sdapppagehtmltags",
					array(),
					$this->conn()
					);
				$referencedBlock=$this->dynamicContentBlock($row[0],$row["pageid"],$row["blockid"],$this->dynamicContent($row));
				if(!file_exists($file)){
					$this->control->mkFile($file,$referencedBlock);
				}else{
					$this->control->mkFile($file,$referencedBlock,1,"append");
				}
			}
			else{
				return $this->addBlockByPosition([
					"pageid"=>$pageid,
					"themeid"=>$themeid,
					"writefile"=>$writeFile,
					"htmlcode"=>$htmlcode,
					"comment"=>$comment,
					"file"=>$file,
					"appendtype"=>$writeFileType,
					"blocktype"=>$type,
					"blockid"=>$referenceblock,
					"ordering"=>$sqlorder,
					"limit"=>$sqllimit,
					"functions"=>$functions
				]);
			}
			
			//dynamic content ends
		}
			$pageRow=$this->model->foreignVal(
				"WHERE pageid='".$pageid."'",
				"sdapppages",
				array(),
				$this->conn()
				);
			$themeRow=$this->model->foreignVal(
					"WHERE themeid='".$themeid."'",
					"sdappthemes",
					array(),
					$this->conn()
					);
			return json_encode([
				"random"=>$this->control->pin(8),
				"rowtheme"=>$themeRow,
				"pageid"=>$pageid,
				"sqldata"=>(function($file,$row,$field){
					if(trim($row[$field])==="JSON"){
						$row[$field]=json_decode(file_get_contents(str_replace(".sdapp",".json",$file)),true)[$row[0]][$field];
					}
					return $row;
				})($file,$row,"_tags"),
				"pagerow"=>$pageRow
			]);
	}
	private function ncTextTag($htmlCode){
		$firstChar=(string)substr(trim($htmlCode),0,1);
		$lastChar=(string)substr(trim($htmlCode),-1);
		if($firstChar ==="<" && $lastChar ===">"){
			$code=$htmlCode;
		}
		else{
			if($htmlCode ===$this->keyWords["web-menu"]){
				$code=$htmlCode;
			}
			else if($htmlCode ===$this->keyWords["mobile-menu"]){
				$code=$htmlCode;
			}
			else{
				$code="<sdapp-text>".$htmlCode."</sdapp-text>";
			}
			
		}
		return $code;
	}
	private function editContentBlock(){
		$type=(int)$this->control->request("type");
		if($type ===1){
			//static content starts
			$htmlcode=$this->ncTextTag($this->control->request("htmlcode"));
			$comment=$this->control->request("comment");
			$tagid=(int)$this->control->request("tagid");
			$pageid=(int)$this->control->request("pageid");
			$themeid=(int)$this->control->request("themeid");
			$file=$this->pageUrl();
			if(file_exists($file)){
				$tagFromDb=$this->model->foreignVal(
					"WHERE pagetagid='".$tagid."'",
					"sdapppagehtmltags",
					array(),
					$this->conn()
					);
				$tag=$this->control->specialCharReplacer(trim($tagFromDb["_tags"]));
				$webMenu=$this->ncMenuGenerator($themeid,$tagid,$pageid);
				/*
				$tag=$this->control->replacer2(
					array(
						array("code"=>$this->keyWords["web-menu"],"value"=>$webMenu)
					),
					$tag
				);
				*/
				$keyWordReplace=$this->staticKeyWordReplace($tagid,$pageid,$tag);

				if(strpos($tag,"<") === false && strpos($tag,">") === false){
						$tagReference=$tag;
				}
				else{
					$tagReference=$this->control->str_replace_first($tag,">",$keyWordReplace);
				}
				
				if(strpos($htmlcode,"sdapp-tag-id") ===false && strpos($htmlcode,"sdapp-page-id")===false){
					$updatedHtmlCode=$this->control->str_replace_first($htmlcode,">",$keyWordReplace);
				}
				else{
					$updatedHtmlCode=$htmlcode;
				}

				$tagReference=$this->control->replacer2(
					array(
						array("code"=>$this->keyWords["web-menu"],"value"=>$webMenu),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),
					$tagReference
				);
				$updatedHtmlCode=$this->control->replacer2(
					array(
						array("code"=>$this->keyWords["web-menu"],"value"=>$webMenu),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),
					$updatedHtmlCode
				);
				$sourceCodes=file_get_contents($file);
				$returnSourceCodes=str_replace($tagReference,$updatedHtmlCode,$sourceCodes);
				//die($returnSourceCodes);
				$this->model->updataQuery(
					"sdapppagehtmltags",
					array(
						"_tags"=>$this->control->sdappReplacer(trim($htmlcode)),
						"_comments"=>$comment,
						"modifiedby"=>$this->main->userId()
					),
					$this->conn(),
					"pagetagid",
					$tagid
				);
			}
			//static content end
		}else{
			//dynamic content starts
			$referenceblock=$this->control->request("referenceblock");
			$sqlorder=$this->control->request("sqlorder");
			$sqllimit=$this->control->request("sqllimit");
			$htmlcode=$this->control->request("htmlcode");
			$comment=$this->control->request("comment");
			$functions=$this->control->request("functions");
			$tagid=(int)$this->control->request("tagid");
			$pageid=(int)$this->control->request("pageid");
			$themeid=(int)$this->control->request("themeid");
			$row=$this->model->foreignVal(
				"WHERE pagetagid='".$tagid."'",
				"sdapppagehtmltags",
				array(),
				$this->conn()
				);
			$newrow=$row;
			$newrow["_tags"]=$this->control->specialCharReplacer(trim($htmlcode));
			$newrow["_ordering"]=$sqlorder;
			$newrow["_limit"]=$sqllimit;
			$newrow["_functions"]=json_encode($functions);
			$content=$this->dynamicContent($row);
			$file=$this->pageUrl();
			if(file_exists($file)){
				$updatedHtmlCode=$this->dynamicContentBlock($row[0],$pageid,$row["blockid"],$this->dynamicContent($newrow));
				$tagReference=$this->dynamicContentBlock($row[0],$pageid,$row["blockid"],$this->dynamicContent($row));
				$sourceCodes=file_get_contents($file);
				$returnSourceCodes=str_replace($tagReference,$updatedHtmlCode,$sourceCodes);
				$this->model->updataQuery(
					"sdapppagehtmltags",
					array(
						"_ordering"=>$sqlorder,
						"_limit"=>$sqllimit,
						"_tags"=>$this->control->sdappReplacer(trim($htmlcode)),
						"_functions"=>$functions,
						"_comments"=>$comment,
						"modifiedby"=>$this->main->userId()
					),
					$this->conn(),
					"pagetagid",
					$tagid
				);
				
			}
			//dynamic content ends
		}
		
		$this->control->mkFile($file,$returnSourceCodes);
	}
	private function editConfigurationJSON(){
		$data =$this->control->request("data");
		$languages=(function($arr,$key){
			if(isset($arr[$key])){
				return $arr[$key];
			}
			return false;
		})($data,"lang");
		$properties=(function($arr,$key){
			if(isset($arr[$key])){
				return $arr[$key];
			}
			return false;
		})($data,"properties");
		$propertiesseparatedbycomma=(function($arr,$key){
			if(isset($arr[$key])){
				return $arr[$key];
			}
			return false;
		})($data,"propertiesseparatedbycomma");
		$exp=explode(",",$propertiesseparatedbycomma);
	    $newConfig=json_encode($this->control->updateJSON($this->configuration,$propertiesseparatedbycomma,$languages,function($val){
			$result=[];
			if(is_array($val)){
				foreach($val as $lang){
					$result[$lang["lang"]]=$lang["value"];
				}
				return $result;
			}
			return $val;
		}));
		$this->control->mkFile(
			"sdapp/sdapp-configurations.json",
			$newConfig
		);
	}
	public function activatedThemeId($sqlField=false){
		return $this->model->foreignVal(
			"WHERE themeactivation>0",
			"sdappthemes",
			(function($sqlfield){
				if($sqlfield){
					return $sqlfield;
				}else{
					return "themeid";
				}
			})($sqlField),
			$this->conn()
			);
	}
	private function logout(){
		return $this->main->logout();
	}
    private function login(){
		//unset all the session available starts
		foreach($_SESSION as $session){
			$session=false;
			unset($session);
		}
		//unset all the session available ends
		$data=$this->control->request('data');
		$feeback=[];
		if($data[0]["value"] ===""){
			$feeback["status"]="empty-username";
			$feeback["alert"]=$this->configuration["alert"][$this->lang];
			$feeback["message"]=$this->configuration["sdapp-login-page"]["empty-username"][$this->lang];
			return json_encode($feeback);
		}
		else if($data[1]["value"] ===""){
			$feeback["status"]="empty-password";
			$feeback["alert"]=$this->configuration["alert"][$this->lang];
			$feeback["message"]=$this->configuration["sdapp-login-page"]["empty-password"][$this->lang];
			return json_encode($feeback);
		}
		$username=$this->control->preventInj($this->conn(),$data[0]['value']);
		$password=md5($this->control->preventInj($this->conn(),$data[1]['value']));
		$userData=$this->model->foreignVal(
					'WHERE username="'.trim($username).'"  AND password="'.$password.'" AND datastatus > 0',
					'sdapp_users',
					array(),
					$this->conn()
					);
		if(count($userData)>0){
					$_SESSION['sdapp-USERID']=$userData["userid"];
					$_SESSION['USERID']=$userData["userid"];
					$_SESSION["SDAPP-USER-SESSION-OPENED"] = $_SESSION['USERID'];
					foreach($userData as $key=>$val){
						 if(!is_numeric($key)){
							$_SESSION[$key]=$val;
						 }
							
					}
					//user designation
					$feeback["status"]="success";
					$feeback["alert"]=$this->configuration["alert"][$this->lang];
					$feeback["message"]=$this->configuration["sdapp-login-page"]["login-successfully"][$this->lang];
					//update sdapp configuration information starts
					$logoutUrl = $this->control->request("url");
					$frontendUrl = substr($this->control->request("url"),0,-14);
					$this->setPropertyToMainConfiguration((object)[
						"property"=>"frontent-url",
						"value"=>$frontendUrl
					]);
					$this->setPropertyToMainConfiguration((object)[
						"property"=>"backend-url",
						"value"=>$logoutUrl
					]);
					//update sdapp configuration information ends
					return json_encode($feeback);
		}
		else{
					//login failed
					$feeback["status"]="access-denied";
					$feeback["alert"]=$this->configuration["alert"][$this->lang];
					$feeback["message"]=$this->configuration["sdapp-login-page"]["login-failed"][$this->lang];
					return json_encode($feeback);

	   }
	   
	}
	private function setPropertyToMainConfiguration($object){
		if(is_object($object) && property_exists($object,"property") && property_exists($object,"value")){
			$configurationFile = "sdapp/sdapp-configurations.json";
			if(file_exists($configurationFile)){
				$fileContent = file_get_contents($configurationFile);
				$fileContentAsObject = json_decode($fileContent);
				$newProperty = $object->property;
				$newValue = $object->value;
				$fileContentAsObject->$newProperty = $newValue;
				$this->control->mkFile("sdapp/sdapp-configurations.json",json_encode($fileContentAsObject));
			}
			
		}

	}
	private function search4AvailablePage4Menu(){
		$keyword=$this->control->request("keyword");
		return json_encode($this->conn()->query("SELECT * FROM sdapppages WHERE pagename LIKE '%".$keyword."%' AND activateasmenu<1 AND activateassubmenu<1 AND themeid='".$this->activatedThemeId()."' ORDER BY pagename")->fetchAll(),true);
	}
	public function userRoles(){
		if(key_exists("roles",$_SESSION)){
			return $_SESSION["roles"];
		}
		return json_encode([]);
	}
	public function invoqJS($extraJs=array()){
		return implode("",array_merge([
			"var Gen = new Sowebgra2_0('".$this->lang."');",
			"var sdapp= new static__dynamic__app({sessions:".json_encode($_SESSION).",themeid:".$this->activatedThemeId().",userid:'".$this->main->userId()."',roles:".$this->userRoles().",lang:'".$this->lang."',gen:Gen,textjson:".json_encode($this->configuration)."}); sdapp.activateLinks();",
		],$extraJs));
	}

	public function menuLink($defaultKey=false){
	    //return false;
		$key=!empty($this->control->request("attributekey"))?$this->control->request("attributekey"):$defaultKey;
		$attributes=($defaultKey === false)?$this->control->request("attributes"):(function($sessionName){
			if(isset($_SESSION[$sessionName])){
				return $_SESSION[$sessionName];
			}
			return [];
		})("RUN-PLUGIN-ATTRIBUTES");
		if(is_array($attributes) && array_key_exists("pluginid",$attributes)){$_SESSION["RUN-PLUGIN-ATTRIBUTES"]=$attributes;}
		$page=false;
		switch ($key) {
			case "page-not-found":
				$page="page not found";
				break;
			case "sdapp-home":
				$scriptId=$this->control->pin(6);
				$page = $this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$attributes){
					$js="sdapp.backendHome();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId,$attributes)]);
				$page =$this->sdapp_login_dashboard((object)[
					"homepagecontent"=>true
				]);
				break;
			case "add-form-to-project-or-plugin":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$attributes){
					$js="sdapp.addFormToProject({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration).",
						attributes:".json_encode($attributes)."
					}).add();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId,$attributes)]);
				break;
			case "sdapp-project-all-forms":
					$scriptId=$this->control->pin(6);
					$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$attributes){
						$js="sdapp.addFormToProject({
							scriptid:`".$scriptId."`,
							themeid:`".$this->activatedThemeId()."`,
							textjson:".json_encode($this->configuration).",
							attributes:".json_encode($attributes)."
						}).view(".json_encode($attributes).");";
						if($default){
							return $this->invoqJS([$js]);
						}
						return $js;
					})($defaultKey,$scriptId,$attributes)]);
			break;
			case "sdapp-create-customized-app":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.createApplitionOrPlugin({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).add();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
				break;
			case "sdapp-all-projects":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.createApplitionOrPlugin({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).view();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "runplugin":
				$page=$this->control->domCreateElement("script",["content"=>(function($default,$attributes){
					if($default){
						return $this->invoqJS(["sdapp.runPlugin(".$attributes["pluginid"].");"]);	
					}
					return "sdapp.runPlugin(".$attributes["pluginid"].");";
				})($defaultKey,$attributes)]);
				//return $attributes["pluginid"];
			break;
			case "sdapp-medias":
				$scriptId = $this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration["media-files"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"fa fa-plus","title"=>$this->configuration["add-new-media-file"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-media","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-media-files"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-medias","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$scriptId],
									"content"=>(function($default,$scriptId){
										$defaultJsMethod="sdapp.__media({scriptid:`".$scriptId."`,textjson:".json_encode($this->configuration).",themeid:`".$this->activatedThemeId()."`,fileextracted:`".$this->activatedThemeId("fileextracted")."`,files:".$this->mediaFiles().",filesorigine:".$this->mediaFiles()."}).mediaGallery();";
											if($default){
												return $this->invoqJS([$defaultJsMethod]);
											}
											return $defaultJsMethod;
									})($defaultKey,$scriptId)
								])
							]
						]
					])
				]]);
			break;
			case "download":
				if(key_exists("SDAPP-DOWNLOADING-FILE",$_SESSION)){
					$this->control->output_file($_SESSION["SDAPP-DOWNLOADING-FILE"],$_SESSION["SDAPP-DOWNLOADING-FILE"]);
				}
				$scriptId = $this->control->pin(6);
				$page = $this->control->domCreateElement("script",[
					"attributes"=>["id"=>$scriptId],
					"content"=>(function($default,$scriptId){
						$defaultJsMethod="sdapp.pageclose();";
							if($default){
								return $this->invoqJS([$defaultJsMethod]);
							}
							return $defaultJsMethod;
					})($defaultKey,$scriptId)
				]);
				unset($_SESSION["SDAPP-DOWNLOADING-FILE"]);
			break;
			case "sdapp-add-media":
				$scriptId = $this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration[$key]["pagetitle"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"fa fa-plus","title"=>$this->configuration["add-new-media-file"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-media","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-media-files"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-medias","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$scriptId],
									"content"=>(function($default,$scriptId){
										$defaultJsMethod="sdapp.__media({scriptid:`".$scriptId."`,textjson:".json_encode($this->configuration).",themeid:`".$this->activatedThemeId()."`,fileextracted:`".$this->activatedThemeId("fileextracted")."`}).addfile();";
											if($default){
												return $this->invoqJS([$defaultJsMethod]);
											}
											return $defaultJsMethod;
									})($defaultKey,$scriptId)
								])
							]
						]
					])
				]]);
			break;
			case "sdapp-add-page":
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->ncPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration[$key]["pagetitle"][$this->lang],
								"rightactions"=>false,
								"content"=>"content"
							]
						]
					])
				]]);
			break;
			case "sdapp-all-menus":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration[$key]["pagetitle"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"icon-plus icons","title"=>$this->configuration["sdapp-all-menus"]["right-options"]["add-menu"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-menu","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"icon-wrench icons","title"=>$this->configuration["sdapp-all-menus"]["right-options"]["configuration"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-builder-menu-configuration","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"icon-trash icons","title"=>$this->configuration["sdapp-trash"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-builder-menu-configuration","sdapp-js-method"=>"sdapp-all-menus-trash","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$scriptId],
									"content"=>(function($default,$scriptId){
										$defaultJsMethod="sdapp.clientConfigMenu({scriptid:`".$scriptId."`,textjson:".json_encode($this->configuration)."}).showmenus({
											themeid:`".$this->activatedThemeId()."`
										});";
										if($default){
											return $this->invoqJS([$defaultJsMethod]);
										}
										return $defaultJsMethod;
									})($defaultKey,$scriptId)
								])
							]
						]
					])
				]]);
			break;
			case "sdapp-add-user":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration["user-management"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-users"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-users","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-plus","title"=>$this->configuration["add-user"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-user","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
								$defaultJsMethod="sdapp.usermanagement({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`
								}).addUsers();";
									if($default){
										return $this->invoqJS([$defaultJsMethod]);
									}
									return $defaultJsMethod;
								})($defaultKey,$scriptId)])
							]
						]
					])
				]]);
			break;
			case "sdapp-all-users":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration["user-management"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"fa fa-plus","title"=>$this->configuration["add-user"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-user","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-users"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-users","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
								$defaultJsMethod="sdapp.usermanagement({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`
								}).users({});";
									if($default){
										return $this->invoqJS([$defaultJsMethod]);
									}
									return $defaultJsMethod;
								})($defaultKey,$scriptId)])
							]
						]
					])
				]]);
			break;
			case "sdapp-add-menu":
				$scriptId=$this->control->pin(6);
				$pages=json_encode($this->conn()->query("SELECT * FROM sdapppages WHERE activateasmenu<1 AND activateassubmenu<1  AND themeid='".$this->activatedThemeId()."' ORDER BY pagename ASC")->fetchAll());
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration[$key]["pagetitle"][$this->lang],
								"rightactions"=>$this->view->sdapp_rightActions([
									"children"=>[
										["icon"=>"icon-wrench icons","title"=>$this->configuration["sdapp-all-menus"]["right-options"]["configuration"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-builder-menu-configuration","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-plus","title"=>$this->configuration["sdapp-all-menus"]["right-options"]["add-menu"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-menu","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
										["icon"=>"fa fa-circle-o","title"=>$this->configuration["sdapp-all-menus"]["right-options"]["all-menus"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-menus","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
									]
								]),
								"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$pages){
								$defaultJsMethod="sdapp.clientConfigMenu({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									pages:".$pages.",
									themeid:`".$this->activatedThemeId()."`
								}).init();";
									if($default){
										return $this->invoqJS([$defaultJsMethod]);
									}
									return $defaultJsMethod;
								})($defaultKey,$scriptId,$pages)])
							]
						]
					])
				]]);
			break;
			case "sdapp-add-website-basic-info":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->sdappPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration["website-basic-info"][$this->lang],
								"rightactions"=>false,
								"content"=>$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$scriptId],
									"content"=>(function($default,$scriptId){
										$defaultJsMethod="sdapp.websitebasicinfo({
											scriptid:`".$scriptId."`,
											textjson:".json_encode($this->configuration).",
											basicinformation:".json_encode($this->websiteBasicInformation()).",
											themeid:`".$this->activatedThemeId()."`
										}).form();";
											if($default){
												return $this->invoqJS([$defaultJsMethod]);
											}
											return $defaultJsMethod;
									})($defaultKey,$scriptId)
								])
							]
						]
					])
				]]);
			break;
			case "sdapp-all-plugins":
				$page=$this->control->domCreateElement("div",[
					"children"=>[
					"type"=>"array",
					"nodes"=>$this->view->ncPageBlocks([
						"block0"=>[
							[
								"blockclass"=>"col-lg-12",
								"title"=>$this->configuration[$key]["pagetitle"][$this->lang],
								"rightactions"=>false,
								"content"=>$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$key],
									"content"=>(function($default,$key){
										if($default){
											return $this->invoqJS(["sdapp.importPlugin().showPlugins('".$key."');"]);
										}
										return "sdapp.importPlugin().showPlugins('".$key."');";
									})($defaultKey,$key)
								])
							]
						]
					])
				]]);
			break;
			case "sdapp-add-plugin":
				$page=$this->control->domCreateElement("script",["content"=>(function($default){
					$js="sdapp.importPlugin().init();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey)]);
			break;
			//builder cases starts
			case "sdapp-add-theme":
				$scriptId=$this->control->pin(6);
				$page="add theme starts";
			break;
			case "sdapp-all-themes":
				$page=$this->view->builderAllThemes()["ui"];
			break;
			case "sdapp-builder-menu-configuration":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderMenuConfiguration({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).init();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-builder-menu-configuration-web-menu":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderMenuConfiguration({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).webMenu();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-builder-menu-configuration-mobile-menu":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderMenuConfiguration({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).mobileMenu();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-create-page":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderCreateDataPageUI({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration).",
						webinfo:".json_encode($this->websiteBasicInformation())."
					}).init();";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-pages":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$key){
					$js="sdapp.builderCreatePageUI({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration).",
						menu:{
							add:`sdapp-create-page`,
							view:`sdapp-all-pages`
						},
						webinfo:".json_encode($this->websiteBasicInformation())."
					}).showpages({
						callbackurl:`".$key."`,
						disablemenus:{
							build:true,
							duplicatepage:true
						}
					});";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId,$key)]);
			break;
			case "sdapp-builder-add-data-block":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderCreateBlock({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration)."
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-add-article-category":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderData({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
						disableleftblock:true,
						disableformheader:true,
                        refdefaultdata:`WHERE themeid='".$this->configuration["sdapp-article-clausures"][0]."' AND pageid='".$this->configuration["sdapp-article-clausures"][0]."' AND datastatus > 0`,
						type:`article-category`
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-article-categories":
			$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderData({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
						disableleftblock:true,
						disableformheader:true,
                        refdefaultdata:`WHERE themeid='".$this->configuration["sdapp-article-clausures"][0]."' AND pageid='".$this->configuration["sdapp-article-clausures"][0]."' AND datastatus > 0`,
						type:`all-article-categories`
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-add-article":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderData({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
						disableleftblock:true,
						disableformheader:true,
                        refdefaultdata:`WHERE themeid='".$this->configuration["sdapp-article-clausures"][1]."' AND pageid='".$this->configuration["sdapp-article-clausures"][1]."' AND datastatus > 0`,
						type:`add-article`,
						richtextalloptions:true
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-articles":
				$scriptId=$this->control->pin(6);
					$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
						$js="sdapp.builderData({
							scriptid:`".$scriptId."`,
							textjson:".json_encode($this->configuration).",
							themeid:`".$this->activatedThemeId()."`,
							disableleftblock:true,
							disableformheader:true,
							refdefaultdata:`WHERE themeid='".$this->configuration["sdapp-article-clausures"][1]."' AND pageid='".$this->configuration["sdapp-article-clausures"][1]."' AND datastatus > 0`,
							type:`all-articles`
						}).init()";
						if($default){
							return $this->invoqJS([$js]);
						}
						return $js;
					})($defaultKey,$scriptId)]);
				break;
				case "sdapp-all-articles-trash":
					$scriptId=$this->control->pin(6);
						$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
							$js="sdapp.builderData({
								scriptid:`".$scriptId."`,
								textjson:".json_encode($this->configuration).",
								themeid:`".$this->activatedThemeId()."`,
								disableleftblock:true,
								disableformheader:true,
								refdefaultdata:`WHERE themeid='".$this->configuration["sdapp-article-clausures"][1]."' AND pageid='".$this->configuration["sdapp-article-clausures"][1]."' AND datastatus > 0`,
								type:`all-articles-trash`
							}).init()";
							if($default){
								return $this->invoqJS([$js]);
							}
							return $js;
						})($defaultKey,$scriptId)]);
					break;
			case "sdapp-builder-all-data-blocks":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderCreateBlock({
						scriptid:`".$scriptId."`,
						themeid:`".$this->activatedThemeId()."`,
						textjson:".json_encode($this->configuration).",
						ref:`WHERE themeid='".$this->activatedThemeId()."'`
					}).showBlocks()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-settings":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderSettings({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration)."
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-add-theme-category":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderThemeCategory({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration)."
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-themes-categories":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderThemeCategory({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration)."
					}).showCategories()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-add-theme-rate":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderThemeRate({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration)."
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-add-data":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$key){
					$js="sdapp.builderData({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
					}).init()";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId,$key)]);
			break;
			case "sdapp-all-data":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.builderData({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
					}).showRecords({})";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-create-built-in-plugin":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.__plugins({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
					}).init({
						title:`".$this->configuration["create-plugin"][$this->lang]."`,
						contentmethodname:`form`
					})";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-built-in-plugins":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.__plugins({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
					}).init({
						title:`".$this->configuration["built-in-plugins"][$this->lang]."`,
						contentmethodname:`showplugins`
					})";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			case "sdapp-all-blocks-for-plugins":
				$scriptId=$this->control->pin(6);
				$page=$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId){
					$js="sdapp.__plugins({
						scriptid:`".$scriptId."`,
						textjson:".json_encode($this->configuration).",
						themeid:`".$this->activatedThemeId()."`,
					}).init({
						title:`".$this->configuration["blocks-for-plugins"][$this->lang]."`,
						contentmethodname:`showblocksforplugins`
					})";
					if($default){
						return $this->invoqJS([$js]);
					}
					return $js;
				})($defaultKey,$scriptId)]);
			break;
			default:
					//execptions starts
					$scriptId=$this->control->pin(6);
					$exceptions=[
						"sdapp-build-page"=>[
							"sdapp-js-method"=>"sdapp.builderCreatePageUI({
								themeid:`".$this->activatedThemeId()."`,
								textjson:".json_encode($this->configuration)."
							}).buildPage({
								row:".json_encode((function($key){
									$pageid=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,3));
									return $this->model->foreignVal("WHERE pageid='".$pageid."'","sdapppages",array(),$this->conn());
								})($key)).",
								rowtheme:".json_encode((function($themeid){
									return $this->model->foreignVal("WHERE themeid='".$themeid."'","sdappthemes",array(),$this->conn());
								})($this->activatedThemeId()))."
							})"
						],
						"sdapp-create-page-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$pageId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$pageRow=$this->model->foreignVal("WHERE pageid='".$pageId."'","sdapppages",array(),$this->conn());
								$themeId= isset($pageRow["themeid"])?$pageRow["themeid"]:false;
								if(!key_exists("pagecontent",$pageRow) ||  key_exists("pagecontent",$pageRow) && $pageRow["pagecontent"] === null){
									return "sdapp.builderCreatePageUI({
										scriptid:`".$scriptId."`,
										themeid:`".$themeId."`,
										textjson:".json_encode($this->configuration).",
										webinfo:".json_encode($this->websiteBasicInformation())."
									}).init({
										row:".json_encode($pageRow)."
									})";
								}
								else{
									return "sdapp.builderCreateDataPageUI({
										scriptid:`".$scriptId."`,
										themeid:`".$themeId."`,
										textjson:".json_encode($this->configuration).",
										webinfo:".json_encode($this->websiteBasicInformation())."
									}).init({
										row:".json_encode($pageRow)."
									})";
								}
							
							})($key,$scriptId)
						],
						"sdapp-builder-add-data-block-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$blockid=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,6));
								$blockArr=$this->model->foreignVal("WHERE blockid='".$blockid."'","sdappblockreference",array(),$this->conn());
								$themeId= isset($blockArr["themeid"])?$blockArr["themeid"]:false;
								return "sdapp.builderCreateBlock({
									scriptid:`".$scriptId."`,
									themeid:`".$themeId."`,
									textjson:".json_encode($this->configuration)."
								}).init({
									themeid:".$themeId.",
									row:".json_encode($blockArr)."
								})";
							})($key,$scriptId)

						],
						"sdapp-add-theme-category-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$categoryId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$blockArr=$this->model->foreignVal("WHERE sdapp_theme_categoryid='".$categoryId."'","sdapp_theme_categories",array(),$this->conn());
								return "sdapp.builderThemeCategory({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration)."
								}).init({
									row:".json_encode($blockArr)."
								})";
							})($key,$scriptId)
						],
						"sdapp-builder-add-theme-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$themeidId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$blockArr=$this->model->foreignVal("WHERE themeid='".$themeidId."'","sdappthemes",array(),$this->conn());
								return "sdapp.newPage().createTheme({
									row:".json_encode($blockArr).",
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration)."
								});";
							})($key,$scriptId)
						],
						"sdapp-builder-all-articles-block"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$blockId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$pageId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,7));
								$blockArr=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								return "sdapp.builderData({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`,
								}).showRecords({
									themeid:`".$this->activatedThemeId()."`,
									pageid:`".$pageId."`,
									blockid:`".$blockId."`,
									rowblock:".json_encode($blockArr)."
								});";
							})($key,$scriptId)
						],
						"sdapp-add-menu-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$menuId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$menuArr=$this->model->foreignVal("WHERE menuid='".$menuId."'","sdapp_menus",array(),$this->conn());
								$pages=json_encode($this->conn()->query("SELECT * FROM sdapppages WHERE activateasmenu<1 AND activateassubmenu<1  AND themeid='".$this->activatedThemeId()."' ORDER BY pagename ASC")->fetchAll());
								return "sdapp.clientConfigMenu({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									pages:".$pages."
								}).init({
									row:".json_encode($menuArr)."
								});";
							})($key,$scriptId)
						],
						"sdapp-add-user-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$userId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$userArr=$this->model->foreignVal("WHERE userid='".$userId."'","sdapp_users",array(),$this->conn());
								$page=$this->control->domCreateElement("div",[
									"children"=>[
									"type"=>"array",
									"nodes"=>$this->view->sdappPageBlocks([
										"block0"=>[
											[
												"blockclass"=>"col-lg-12",
												"title"=>$this->configuration["user-management"][$this->lang],
												"rightactions"=>$this->view->sdapp_rightActions([
													"children"=>[
														["icon"=>"fa fa-plus","title"=>$this->configuration["add-user"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-user","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
														["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-users"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-users","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
													]
												]),
												"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$userArr){
												$defaultJsMethod="sdapp.usermanagement({
													scriptid:`".$scriptId."`,
													textjson:".json_encode($this->configuration).",
													themeid:`".$this->activatedThemeId()."`
												}).addUsers({
													row:".json_encode($userArr)."
												});";
													if($default){
														return $this->invoqJS([$defaultJsMethod]);
													}
													return $defaultJsMethod;
												})($key,$scriptId,$userArr)])
											]
										]
									])
								]]);
								return (object)[
									"page"=>$page
								];
							})($key,$scriptId)
						],
						"sdapp-set-user-roles-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$userId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$userArr=$this->model->foreignVal("WHERE userid='".$userId."'","sdapp_users",array(),$this->conn());
								$page=$this->control->domCreateElement("div",[
									"children"=>[
									"type"=>"array",
									"nodes"=>$this->view->sdappPageBlocks([
										"block0"=>[
											[
												"blockclass"=>"col-lg-12",
												"title"=>$this->configuration["user-management"][$this->lang],
												"rightactions"=>$this->view->sdapp_rightActions([
													"children"=>[
														["icon"=>"fa fa-plus","title"=>$this->configuration["add-user"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-user","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
														["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-users"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-users","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
													]
												]),
												"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$userArr){
												$defaultJsMethod="sdapp.usermanagement({
													scriptid:`".$scriptId."`,
													textjson:".json_encode($this->configuration).",
													themeid:`".$this->activatedThemeId()."`
												}).setUserRoles({
													row:".json_encode($userArr)."
												});";
													if($default){
														return $this->invoqJS([$defaultJsMethod]);
													}
													return $defaultJsMethod;
												})($key,$scriptId,$userArr)])
											]
										]
									])
								]]);
								return (object)[
									"page"=>$page
								];
							})($key,$scriptId)
						],
						"sdapp-set-block-control-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$userId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$userArr=$this->model->foreignVal("WHERE userid='".$userId."'","sdapp_users",array(),$this->conn());
								$page=$this->control->domCreateElement("div",[
									"children"=>[
									"type"=>"array",
									"nodes"=>$this->view->sdappPageBlocks([
										"block0"=>[
											[
												"blockclass"=>"col-lg-12",
												"title"=>$this->configuration["user-management"][$this->lang],
												"rightactions"=>$this->view->sdapp_rightActions([
													"children"=>[
														["icon"=>"fa fa-plus","title"=>$this->configuration["add-user"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-add-user","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]],
														["icon"=>"fa fa-circle-o","title"=>$this->configuration["all-users"][$this->lang],"attr"=>["call-even-dom-has-loaded"=>"true","url"=>"sdapp-all-users","sdapp-js-method"=>"sdapp-go-to-url-from-attr","do-not-vanish"=>"true"]]
													]
												]),
												"content"=>$this->control->domCreateElement("script",["attributes"=>["id"=>$scriptId],"content"=>(function($default,$scriptId,$userArr){
												$defaultJsMethod="sdapp.usermanagement({
													scriptid:`".$scriptId."`,
													textjson:".json_encode($this->configuration).",
													themeid:`".$this->activatedThemeId()."`
												}).setBlockControl({
													row:".json_encode($userArr).",
													text:".json_encode($this->configuration).",
													lang:".json_encode($this->lang)."
												});";
													if($default){
														return $this->invoqJS([$defaultJsMethod]);
													}
													return $defaultJsMethod;
												})($key,$scriptId,$userArr)])
											]
										]
									])
								]]);
								return (object)[
									"page"=>$page
								];
							})($key,$scriptId)
						],
						"view-record-form-token"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$letterId = $this->control->getValFromExplode("-",$key,4);
								$blockId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$data=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								return "sdapp.builtInApplication({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`,
								}).init({
									block:".json_encode($data).",
									callbackonedit:()=>{
										sdapp.sdapp_Access_Menu({
											key:`view-record-form-token-".$letterId."`
										});
									}
								});";
							})($key,$scriptId)
						],
						"view-report-form-token"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$letterId = $this->control->getValFromExplode("-",$key,4);
								$blockId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$data=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								return "sdapp.builtInApplication({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`,
								}).reporting({
									block:".json_encode($data)."
								});";
							})($key,$scriptId)
						],
						"add-record-form-token"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$letterId = $this->control->getValFromExplode("-",$key,4);
								$blockId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$data=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								return "sdapp.addRecordForm({
									scriptid:`".$scriptId."`,
									text:".json_encode($this->configuration).",
									blockrow:".json_encode($data)."
								});";
							})($key,$scriptId)
						],
						"view-builtin-application-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$letterId = $this->control->getValFromExplode("-",$key,4);
								$blockId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$data=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								return "sdapp.builtInApplication({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`,
								}).init({
									block:".json_encode($data).",
									callbackonedit:()=>{
										sdapp.sdapp_Access_Menu({
											key:`view-builtin-application-id-".$letterId."`
										});
									}
								});";
							})($key,$scriptId)
						],
						"view-plugin-record-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$letterId = $this->control->getValFromExplode("-",$key,4);
								$pluginId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$data=$this->model->foreignVal("WHERE builtinpluginid='".$pluginId."'","sdapp_built_in_plugins",array(),$this->conn());
								$pluginname = is_array($data) && key_exists("pluginname",$data)?$data["pluginname"]:false;
								$themeid = is_array($data) && key_exists("themeid",$data)?$data["themeid"]:false;
								$query = $this->conn()->query("SELECT * FROM  sdapp_built_in_plugins WHERE themeid='".$themeid."' AND builtinpluginid ='".$pluginId."' AND datastatus > 0 ORDER BY pluginname ")->fetchAll();
								$menudata = [];
								if(is_iterable($query)){
									foreach($query as $row){
										$countData =$this->model->countRowsV2($this->conn(),"sdappdata","WHERE blockid='".$row["blockid"]."' AND themeid='".$row["themeid"]."' AND datastatus > 0");
										array_push($menudata,[
											"row"=>$row,
											"max-record"=>$countData
										]);
									}
								}
								return "sdapp.__plugins({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`,
								}).init({
									title:`".$pluginname."`,
									contentmethodname:`plugindata`,
									row:".json_encode($data).",
									callbackonedit:()=>{
										sdapp.sdapp_Access_Menu({
											key:`view-plugin-record-id=".$letterId."`
										});
									},
									usesection:`true`,
									menudata:".json_encode($menudata)."
								});";
							})($key,$scriptId)
						],
						"sdapp-menu-arrangement-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$menuId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,4));
								$menuArr=$this->model->foreignVal("WHERE menuid='".$menuId."'","sdapp_menus",array(),$this->conn());
								return "sdapp.clientConfigMenu({
									scriptid:`".$scriptId."`
								}).menuArrangement({
									row:".json_encode($menuArr).",
									text:".json_encode($this->configuration)."
								});";
							})($key,$scriptId)
						],
						"sdapp-builder-add-data-id"=>[
							"sdapp-js-method"=>(function($key,$scriptId){
								$dataId=$this->pageIdDecripted($this->control->getValFromExplode("-",$key,5));
								$dataArr=$this->model->foreignVal("WHERE sdappdataid='".$dataId."'","sdappdata",array(),$this->conn());
								$blockId = key_exists("blockid",$dataArr)?$dataArr["blockid"]:0;
								$dataBlock=$this->model->foreignVal("WHERE blockid='".$blockId."'","sdappblockreference",array(),$this->conn());
								$themeid = key_exists("themeid",$dataArr)?$dataArr["themeid"]:0;
								$columns = key_exists("columnsobjects",$dataBlock)?$dataBlock["columnsobjects"]:[];
								return "sdapp.builderData({
									scriptid:`".$scriptId."`,
									textjson:".json_encode($this->configuration).",
									themeid:`".$this->activatedThemeId()."`
								}).init({
									callbackonedit:undefined,
									columns: ".json_encode($columns).",
									row: ".json_encode($dataArr).",
									themeid: `".$themeid."`,
									rowblock:".json_encode($dataBlock)."
								});";
							})($key,$scriptId)
						]
					];

					foreach ($exceptions as $myKey=>$arr){
						if((function($ref,$string){
							$ref=str_replace("-","",$ref);
							$exp=explode("-",$string);
							$text=[];
							foreach($exp as $value){
								$text[]=$value;
								if(implode("",$text) === $ref){return 1;}
							}
						})($myKey,$key)>0){
							$jsMethod = $arr["sdapp-js-method"];
							if(is_object($jsMethod) && property_exists($jsMethod,"page")){
								$page = $jsMethod->page;
							}
							else{
								$page=$this->control->domCreateElement("script",[
									"attributes"=>["id"=>$scriptId],
									"content"=>(function($default,$arr){
										$js=$arr["sdapp-js-method"];
										if($default){
											return $this->invoqJS([$js]);
										}
										return $js;
									})($defaultKey,$arr)
								]);
							}
							
						}
					}
					//exceptions ends
					//$page="oops!!".$key;
			break;
			//builder cases ends
		}
		//die(htmlentities($page));
		return $page;
		
	}
	public function applicationBasicInformation(){
		$file = dirname(__FILE__)."/sdapp-application-info.json";
		 if(file_exists($file)){
			return json_decode(file_get_contents($file));
		 }
		 return ["not found"];
	}
	public function websiteBasicInformation(){
		$file = dirname(__FILE__)."/sdapp-website-info.json";
		 if(file_exists($file)){
			return json_decode(file_get_contents($file));
		 }
		 return ["not found"];
	}
	private function mediaFiles($object = false){
		$medias = [];
		$themes = $this->model->selectData((object)[
			"conn"=>$this->conn(),
			"table"=>"sdappthemes",
			"clauses"=>"WHERE datastatus > 0"
		]);
		$readDIr =key_exists("key",$_REQUEST)?"../uploads/":"uploads/";
		$dir = "uploads/";
		$dirFiles = [];
		if(is_dir($readDIr) && file_exists($readDIr)){
			$dirFiles[0]=[
				"prepathbackend"=>$dir,
				"prepathfrontend"=>"sdapp-manager/".$dir,
				"files"=>scandir($readDIr)
			];
		}
		if(is_array($themes)){
			for($i=0;$i<count($themes);$i++){
				$readDIr = key_exists("key",$_REQUEST)? "../../themes/".$themes[$i]["fileextracted"]."/sdapp-uploads/":"../themes/".$themes[$i]["fileextracted"]."/sdapp-uploads/";
				$prepathBackend = "../themes/".$themes[$i]["fileextracted"]."/sdapp-uploads/";
				$prepathFrontend = "themes/".$themes[$i]["fileextracted"]."/sdapp-uploads/";
				if(is_dir($readDIr)){
					$dirFiles[$themes[$i][0]]=[
						"prepathbackend"=>$prepathBackend,
						"prepathfrontend"=>$prepathFrontend,
						"files"=>scandir($readDIr)
					];
				}
				
			}
		}
		ksort($dirFiles);
		if(is_object($object) && property_exists($object,"returnfiles") && $object->returnfiles === true){
			if(is_array($dirFiles) && count($dirFiles) > 0){
				$files = [];
				foreach($dirFiles as $ressources){
					foreach($ressources["files"] as $file){
						if(!in_array($file,[".",".."])){
							$expExt = explode(".",$file);
							$ext = strtolower(end($expExt));
							if(in_array($ext,["jpg","jpeg","png","gif","svg"])){
								array_push($files,$ressources["prepathbackend"].$file);
							}
						}
					}
				}
			}
			return json_encode($files);
		}
		return json_encode([
			"defaultdirectories"=>$dirFiles,
			"directories"=>$dirFiles,
			"themes"=>$themes
		]);
	}
	public function savePlugin(){
		$json=array();
		$data=$this->control->request('data');
		$dir='../js/projects/sdapp/plugins/';
		$foundDirs=$this->control->zipListDir('../'.$data['root']);
		$len=count($foundDirs);
		if($len ==1){
			$this->control->extract('../'.$data['root'],$dir);
			$dirToScan=$foundDirs[0];
			$countOurFiles=0;
				foreach(scandir($dir.$dirToScan) as $key=>$file){
					 if(is_file($dir.$dirToScan.'/'.$file)){
						 $ourFiles=array('index.php','class.js','sdapp.json');
						if(in_array($file,$ourFiles)){
							$countOurFiles++;
						}
						
					 }
				}
       
			if($countOurFiles ==3){
				//saving starts
				$pluginJson=file_get_contents($dir.$dirToScan.'/sdapp.json');
                $decoder=$this->control->decodeJSONTogetArray($pluginJson,array());
				$existingPlugin=$this->model->foreignVal("WHERE plugincode='".$decoder['plugincode']."'","sdappplugins","plugincode",$this->conn());
				if($existingPlugin!=$decoder['plugincode']){
					$this->model->insertQuery(
						'sdappplugins',
						array(
							"pluginid"=>"NULL",
							"pluginname"=>$decoder['pluginname'],
							"plugincode"=>$decoder['plugincode'],
							"pluginicon"=>$decoder["pluginicon"],
							"pluginroot"=>$dir.$dirToScan,
							"pluginactivation"=>0,
							"createdby"=>$this->main->userId()
						),
						$this->conn()
					);
					$json=array(
						'status'=>'plugin verified',
						'error'=>'Plugin installé avec succès',
						'code'=>1
					);
				}
				else{
					$json=array(
						'status'=>'plugin verified',
						'error'=>'Désolé ce plugin existe dèja sur la liste des plugins',
						'code'=>0
					);
				}
				
				//saving
			}
			else{
				$json=array(
					'status'=>'unknow plugin',
					'error'=>"L'installation du plugin a échoué!",
					'code'=>0
				);
			}
			
		}
		else{
			$json=array(
				'status'=>'unknow plugin length exceeded',
				'error'=>"L'installation du plugin a échoué!",
				'code'=>0
			);
		}

		if(is_file('../'.$data['root'])){
			unlink('../'.$data['root']);
		}
		
		return json_encode($json);
		//authentification ends
	}
	public function saveEditDataPage(){
		$data = $this->control->request("data");
		$action = $data["action"];
		if($action ==="insert"){
			$sqlResult = $this->model->insertQuery(
				' sdapppages',
				array(
					"pageid"=>"NULL",
					"themeid"=>$data["themeid"],
					"pagename"=>$data["pagename"],
					"pagetitle"=>$data["pagetitle"],
					"pagecontent"=>$this->ncTextTag($this->control->sdappReplacer(trim($data["pagecontent"]))),
					"activateasmenu"=>$data["activateasmenu"],
					"activateassubmenu"=>$data["activateassubmenu"],
					"activatepageasstatic"=>$data["activatepageasstatic"],
					"staticpagekey"=>$data["staticpagekey"],
					"createdby"=>$this->main->userId()
				),
				$this->conn()
			);
		}
		else{
			 $this->model->updataQuery(
				"sdapppages",
				array(
					"pagename"=>$data["pagename"],
					"pagetitle"=>$data["pagetitle"],
					"pagecontent"=>$this->ncTextTag($this->control->sdappReplacer(trim($data["pagecontent"]))),
					"activateasmenu"=>$data["activateasmenu"],
					"activateassubmenu"=>$data["activateassubmenu"],
					"activatepageasstatic"=>$data["activatepageasstatic"],
					"staticpagekey"=>$data["staticpagekey"],
					"modifiedby"=>$this->main->userId()
				),
				$this->conn(),
				$data["referencefield"],
				$data["referenceid"]
			);
			$sqlResult=[
				"lastid"=> $data["referenceid"]
			];
		}
			$_REQUEST["data"] = [
				"pageid"=>$sqlResult["lastid"],
				"pagekey"=>"none",
				"pagename"=>$data["pagename"],
				"pagetitle"=>$data["pagetitle"],
				"themeid"=>$data["themeid"],
				"rows"=>[
					[
						"blockid"=>0,
						"ordering"=>"none",
						"limit"=>0,
						"type"=>1,
						"htmltag"=>$data["pagecontent"],
						"comment"=>"automate data page content",
						"functions"=>[
							"functionname"=>"void"
						],
						"sdappblockgroupsid"=>0
					]
				]
			];

			$this->saveEditPageBuilding();
			//return json_encode($result);
		
		
	}
	public function saveEditPageBuilding($defaultData=false){
		if(is_array($defaultData)){
			$data =	$defaultData;
		}
		else{
			$data=$this->control->request('data');
		}
		$themeid =(function($themeid){
			if(is_array($themeid)){
				return $themeid[0];
			}
			return $themeid;
		})($data['themeid']);

		$pageid=(function($pageid){
			if(is_array($pageid)){
				return $pageid[0];
			}
			return $pageid;
		})($data['pageid']);
		
	$n=0;
		$this->model->simpleDeletion(
			$this->conn(),
			"WHERE themeid='".$themeid."' AND pageid='".$pageid."'",
			'sdapppagehtmltags'
		);
		$webInfoKeywords = $this->configuration["website-basic-information-keywords"];
		foreach($data['rows'] as $row){
			$sdappblockgroupsArray=$this->model->foreignVal("WHERE sdappblockgroupsid='".$row["sdappblockgroupsid"]."'","sdappblockgroups",[],$this->conn());
			$pagetagidjson =[];
			if(key_exists("pagetagidjson",$sdappblockgroupsArray)){
				$pagetagidjson = json_decode($sdappblockgroupsArray["pagetagidjson"]);
				$callbackfunction = function($value,$key){
					$idExist=$this->model->foreignVal("WHERE pagetagid='".$value."'","sdapppagehtmltags",[],$this->conn());
					if(key_exists("pagetagid",$idExist)){
						return $value;
					}
				};
				$pagetagidjson =array_filter($pagetagidjson, $callbackfunction, ARRAY_FILTER_USE_BOTH);
			}
			$webbasicinfoexists = function($obj){
				$count =0;
				if(is_object($obj)){
					foreach($obj->webinfokeywords as $keyword){
						if(strpos($obj->htmltag,$keyword) > -1){
							$count ++;
						}
					}
				}
				if($count > 0){
					return "true";
				}
				return "false";
			};
			$__sql = $this->model->insertQuery(
				'sdapppagehtmltags',
				array(
					"pagetagid"=>"NULL",
					"themeid"=>$themeid,
					"sdappblockgroupsid"=>$row["sdappblockgroupsid"],
					"pageid"=>$pageid,
					"blockid"=>$row['blockid'],
					"_ordering"=>$row['ordering'],
					"_limit"=>$row['limit'],
					"_type"=>$row['type'],
					"_tags"=>$this->ncTextTag($this->control->sdappReplacer(trim($row['htmltag']))),
					"webbasicinfoexists"=>$webbasicinfoexists((object)[
						"htmltag"=>$row["htmltag"],
						"webinfokeywords"=>$webInfoKeywords
					]),
					"_comments"=>$row['comment'],
					"_functions"=>$row['functions'],
					"createdby"=>$this->main->userId()
				),
				$this->conn()
			);
			if(is_array($pagetagidjson)){
				array_push($pagetagidjson,$__sql["lastid"]);
				array_unique($pagetagidjson);
				ksort($pagetagidjson,SORT_NUMERIC);
				$this->model->updataQuery(
					'sdappblockgroups',
					array(
						"pagetagidjson"=>json_encode($pagetagidjson),
						"modifiedby"=>$this->main->userId()
					),
					$this->conn(),
					'sdappblockgroupsid',
					$row["sdappblockgroupsid"]
				);
			}
		}
	
		return $this->writeLightPage($data);	
		
	
	}
	private  function writeWebMenu($tags,$themeid,$tagid,$pageid){
		if(strpos($tags,"@sdapp-web-menu-builtin") > -1 || strpos($tags,"@sdapp-mobile-menu-builtin") > -1){
			$menuType = false;
			if(strpos($tags,"@sdapp-web-menu-builtin") > -1){ $menuType = "web-menu";}
			if(strpos($tags,"@sdapp-mobile-menu-builtin") > -1){ $menuType = "mobile-menu";}
			$menu =$this->control->replacer2(array(
				array("code"=>"@sdapp-web-menu-builtin","value"=>$this->ncMenuGenerator($themeid,$tagid,$pageid,"web-menu")),
				array("code"=>"@sdapp-mobile-menu-builtin","value"=>$this->ncMenuGenerator($themeid,$tagid,$pageid,"mobile-menu")),
				array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
			),$tags);
			return ["tags"=>$this->control->sdappReplacer($menu),"menuexists"=>"true","menutype"=>$menuType];

		}
		return ["tags"=>$tags,"menuexists"=>"false","menuexists"=>"false","menutype"=>0];
	} 
    private  function writeLightPage($data){
		
		$themeid = null;
		$pageid = null;
		if(!key_exists("load-more-contents",$data)){
			$themeid =(function($themeid){
				if(is_array($themeid)){
					return $themeid[0];
				}
				return $themeid;
			})($data['themeid']);
		
			$pageid=(function($pageid){
				if(is_array($pageid)){
					return $pageid[0];
				}
				return $pageid;
			})($data['pageid']);
			$ref = "WHERE themeid='".$themeid."' AND pageid='".$pageid."' ORDER BY pagetagid ASC";
		}
		if(key_exists("ref",$data)){
			$ref = $data["ref"];
		}
				//creating file starts
				$pageContent=false;
				$arrayData = [];
				$jsonData =[];
				$jsonData["themeid"]=$themeid;
				$jsonData["pageid"]=$pageid;
				$jsonData["html"]=[];
				$webInfo = $this->websiteBasicInformation();
				$themePrepath = "themes/".$this->activatedThemeId("fileextracted")."/";
				$q=$this->conn()->query("SELECT * FROM sdapppagehtmltags $ref ");
				if(is_object($q)){
					$q=$q->fetchAll();
					foreach($q as $row){
						if($row['_type']==1){
							$newTag=$this->writeWebMenu($this->tagsReplacer(trim($row["_tags"])),$row["themeid"],$row[0],$row["pageid"]);
							$newTag["tags"] = $this->bindWebBasicInfo((object)[
								"tags"=>$newTag["tags"],
								"webinfo"=>$webInfo,
								"prepath"=>$themePrepath,
								"htmltagid"=>$row[0]
							]);
							if($newTag["menuexists"] ==="true"){
								$this->model->updataQuery(
									'sdapppagehtmltags',
									array("menuexists"=>"true","menutype"=>$newTag["menutype"]),
									$this->conn(),
									'pagetagid',
									$row[0]
								);
							}
							$jsonData["html"][$row[0]]=[
								"type"=>"static",
								"sdappblockgroupsid"=>$row["sdappblockgroupsid"],
								"pagetagid"=>$row[0],
								"menuexists"=>$newTag["menuexists"],
								"webbasicinfoexists"=>$row["webbasicinfoexists"],
								"menutype"=>$newTag["menutype"],
								"sqltags"=>$row["_tags"],
								"data"=>$newTag["tags"],
							];
							$pageContent.=$this->control->str_replace_first(
								$newTag["tags"],
								">",
								$this->staticKeyWordReplace($row[0],$row["pageid"],$newTag["tags"])
							);
						}
						else{
							if(key_exists("load-more-contents",$data)){
								$row["load-more-contents"] = true;
							}
							$dynamicContentAsArray =$this->dynamicContent($row,(object)[]);
							$jsonData["html"][$row[0]]=[
								"type"=>"dynamic",
								"sdappblockgroupsid"=>$row["sdappblockgroupsid"],
								"pagetagid"=>$row[0],
								"blockid"=>$row["blockid"],
								"functions"=>$row["_functions"],
								"sqlordering"=>(function($ordering){ 
									(int)$o=intval($ordering);
									if($o ===1){return "ASC";}
									if($o ===2){return "DESC";}
									return "ASC";
								})($row["_ordering"]),
								"sqllimit"=>$row["_limit"],
								"keys"=>(function($kz){
									$keys = [];
									foreach(json_decode($kz) as $value){
										//$d = $this->control->decodeJSONTogetArray($keyz,'key',[])
										array_push($keys,$value->key);
									}
                               return $keys;
								})($this->model->foreignVal("WHERE blockid='".$row["blockid"]."'","sdappblockreference","columnsobjects",$this->conn())),
								"tags"=>$row["_tags"],
								"data"=>$dynamicContentAsArray["jsoncontent"]	
							];
							$pageContent.= $this->bindWebBasicInfo((object)[
								"tags"=>$this->dynamicContentBlock($row[0],$row["pageid"],$row["blockid"],$dynamicContentAsArray["htmlcontent"]),
								"webinfo"=>$webInfo,
								"prepath"=>$themePrepath,
								"htmltagid"=>$row[0]
							]);
							$arrayData[] = $pageContent;
							
						}
					}
				}
				if(key_exists("load-more-contents",$data)){
					if(isset($row) && is_array($row)){
						return [
						"data"=> (function($records,$limit){
							if(count($records) > $limit){
								$n =0;
								$newRecords = [];
								foreach($records as $r){
									$n++;
									if($n > $limit){
										$newRecords[] = $r;
									}

								}
								return $newRecords;
							}
						})($dynamicContentAsArray["array"],$row["_limit"]),
						"limit"=>$row["_limit"],
						"pagetagid"=>$row[0],
						"pagetagidaplhabet"=>$this->pageIdDecripted($row[0],true),
						"row"=> $row
					];
					}
					
				}
				$jsonFile = str_replace(".sdapp",".json",$this->pageUrl());
				$this->control->mkFile($jsonFile,json_encode($jsonData));
				$this->control->mkFile($this->pageUrl(),$pageContent);
				
				
		}

	private function dynamicContent($row,$jsonContent=false){
		$blockid=$row['blockid'];
		$ordering=(function($order){
				if($order ==1){
					return "ASC";
				}
				else if($order ==2){
					return "DESC";
				}
				else{
					return $order;
				}
			
		})($row['_ordering']);
		$limit=$row['_limit'];
		$__LIMIT ="LIMIT $limit ";
		if(key_exists("load-more-contents",$row)){
			$__LIMIT = false;
		}
		$tags=$this->tagsReplacer(trim($row['_tags']));
		$dynamicData=false;
		$getKeys=$this->model->foreignVal("WHERE blockid='".$blockid."'","sdappblockreference","columnsobjects",$this->conn());
		$sqlclauses ="WHERE themeid='".$row['themeid']."' AND blockid='".$row['blockid']."' AND datastatus > 0  AND  publishdata > 0 ";
		$sqlclauses.=" OR themeid='".$this->configuration["sdapp-article-clausures"][1]."' AND blockid='".$row['blockid']."' AND datastatus > 0  AND  publishdata > 0 ";
		$sqlclauses.=" OR themeid='".$this->configuration["sdapp-article-clausures"][0]."' AND blockid='".$row['blockid']."' AND datastatus > 0  AND  publishdata > 0 ";
		$sqlclauses.=" ORDER BY sdappdataid $ordering $__LIMIT ";
		$sqlQuery="SELECT * FROM sdappdata ".$sqlclauses." ";
		$htmlArray = [];
		$q=$this->conn()->query($sqlQuery);
		if(is_object($q)){
			$q=$q->fetchAll();
			
			$jsonKeys=$this->control->decodeJSONTogetArray($getKeys,'key');
			foreach($q as $r){
				$data=$this->control->decodeJSONTogetArray($r['data'],array());
				$convertedContent=$this->dynamicContentReplacer($jsonKeys,$data,$tags,$row,$r);
				$dynamicData.=$convertedContent;
				$htmlArray[] = $convertedContent;
				if(is_object($jsonContent)){
					$dataid="dataid_".$r[0];
					$jsonContent->$dataid=[
						"sdappdataid"=>$r[0],
						"publishdata"=>$r["publishdata"],
						"sdappblockgroupsid"=>$row["sdappblockgroupsid"],
						"blockid"=>$r["blockid"],
						"data"=>$convertedContent,
					];
				}
			}
			//die($dynamicData);
			if(is_object($jsonContent)){
				return [
					"htmlcontent"=>$dynamicData,
					"jsoncontent"=>$jsonContent,
					"array"=>$htmlArray
				];
			}
			return $dynamicData;
		}
		
		

	}
	private function tagsReplacer($tags){
		return $this->control->replacer2(
			array(
				array('code'=>'@dblquote','value'=>'"'),
				array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
			),$tags
		);
	}
	private function getKeyValue($itemData){
				$newItemData=array();
				$index=-1;
				foreach($itemData as $key=>$value){
					$index++;
					$newItemData[$key]=$value;
				}
				return $newItemData;
			
	
			
	}
	private function giveValue($gottenValue,$key,$_functions){
		
		$arr=$this->control->decodeJSONTogetArray($_functions,array());
				if($arr['functionname']=='contentlimit'){
						if(is_array($arr['keys'])){
							$keys=false;
							$n=0;		
							  foreach($arr['keys'] as $json){
								  $n++;
								  $array=$this->getKeyValue($json);
								  $_key=$array['key'];
								  $_charLimit=$array['charlimit'];
								  if($_key ==$key){
									return substr($gottenValue,0,$_charLimit)."...";
								  }
							  }
							  return $gottenValue;
						}
						else{
							return 'not array';
						}
				}
				else{
					return $gottenValue;
				}
	}
	private function readObjectFK(object $object){
		if(is_object($object)){
			 if(
			 property_exists($object,"fkid")
			 && property_exists($object,"blockid")
			 && property_exists($object,"columns")
			 && property_exists($object,"themeid")
			 ){
				$row = $this->model->foreignVal("WHERE sdappdataid='".$object->fkid."' ","sdappdata",[],$this->conn());
				$data = json_decode($row["data"]);
				$result = [];
				if(is_array($object->columns) && is_object($data) && is_array($row) && count($row) > 0){
					for($i=0; $i< count($object->columns); $i++){
						$property = $object->columns[$i];
						if(property_exists($data,$property)){
							array_push($result,$data->$property);
						}
						
					}
				}
				return implode(" ",$result);
			 }
			
		}
		return false;
	}
    private function dynamicContentReplacer($keys,$arrayData,$htmlTag,$rowHtmlTag,$rowData){
		//return $rowData['_functions'];
		if(is_array($keys)){
			$arr=array();
			$arr2=array();
			$arr3=array();
			foreach($keys as $key){
				$code="@".$this->appName.'_'.$key;
				$value=isset($arrayData[$key])?$arrayData[$key]:false;
				$value=is_string($value)?$this->control->textCleaner($value):$this->readObjectFK($value);
				$arr[]=array(
					"code"=>$code,"value"=>$this->giveValue($value,$key,$rowHtmlTag['_functions'])
				);
			}
			$htmlTag = $this->control->replacer2([["code"=>$this->configuration["count-data-by-category-keywords"]["dynamic-data-id-attribute-value"],"value"=>$this->pageIdDecripted($rowData[0],true)]],$htmlTag);
			$a=$this->control->replacer2($arr,$htmlTag);
			$dataEncriptedId=$this->control->replacer2($this->pageIdCriptedArray(),$rowData[0]);
			$pageid=(int)$rowHtmlTag["pageid"];
			$defaultReadMorePageId= $this->defaultReadMorePageId();
			$associatedReadMorePageId=(function($pageid){
				$q=$this->conn()->query("SELECT * FROM sdapppages WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey ='sdapp_readingpage4'");
				if(is_object($q)){
					$q=$q->fetchAll();
					$readMorePage=0;
					foreach($q as $row){
						$readJSON=json_decode($row["pagefeatures"]);
						if(is_object($readJSON) && property_exists($readJSON,"associatedpage")
						&& (int)$readJSON->associatedpage->value === $pageid
						){
							$readMorePage= $row[0];
						}
					}
					return $readMorePage;
				}
				
			})($pageid);
			$readMorePageIdChecked=$this->control->replacer2($this->pageIdCriptedArray(),(function($defaultId,$associatedId){
				if($associatedId>0){
					return $associatedId;
				}
				return $defaultId;
			})($defaultReadMorePageId,$associatedReadMorePageId));
			$alpha=$this->control->replacer2(array(
				array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
				array('code'=>'@contentlimit(','value'=>false),
				array('code'=>');end','value'=>false),
				array('code'=>'@slash','value'=>'/'),
				array('code'=>'@squote','value'=>"'"),
				array("code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["readmore"],"value"=>"sdapp-read-more-page-".$readMorePageIdChecked."-data-".$dataEncriptedId),
				array("code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["themeprepath"],"value"=>"themes/".$this->activatedThemeId("fileextracted")."/")
			),$a);
			return $alpha;
	 }
	}
	private function rewriteNoSqlFile(object $obj){
		if(is_object($obj) && property_exists($obj,"json") && is_object($obj->json) && property_exists($obj->json,"html")){
			$htmlContent = [];
			$html = $obj->json->html;
			$n=0; foreach($html as $row){
				$n++;
				if($row->type ==="static"){
					array_push($htmlContent,$row->data);
				}
				elseif($row->type ==="dynamic" && $obj->mode ==="static"){
					array_push($htmlContent,(function($data,$row,$obj){
						$dynamicData = [];
						$n = 0;
						if ($row->sqlordering ==="ASC"){
							foreach($data as $d){
								if(is_object($d) && property_exists($d,"data")){
									$n++;
									if($n <= $row->sqllimit){
										array_push($dynamicData,$d->data);
									}
								}	
							}
						}
						//else
						else{
							$dataInversed = [];
							$maxIndex = count(get_object_vars($data));
							$maxIndexDefault =$maxIndex ;
							foreach($data as $d){
								$maxIndex--;
								$dataInversed[$maxIndex]= $d->data;
							}
							ksort($dataInversed,SORT_NUMERIC);
							$newArr =[];
							$n = 0;
							foreach($dataInversed as $nd){
								$n++;
								if($n <= $row->sqllimit){
									array_push($dynamicData,$nd);
								}
							}
						}
						return implode("",$dynamicData);
					})($row->data,$row,$obj));
				}
				else if($row->type ==="dynamic" && $obj->mode ==="dynamic"){
					array_push($htmlContent,(function($data,$row,$obj){
						$dynamicData = [];
						$n = 0;
						if ($row->sqlordering ==="ASC"){
							foreach($data as $d){
								if(is_object($d) && property_exists($d,"data")){
									$n++;
									if($n <= $row->sqllimit){
										array_push($dynamicData,$d->data);
									}
									
								}	
							}
						}
						else{
							
							$dataInversed = [];
							$maxIndex = count(get_object_vars($data));
							$maxIndexDefault =$maxIndex ;
							foreach($data as $d){
								$maxIndex--;
								$dataInversed[$maxIndex]= $d->data;
							}
							ksort($dataInversed,SORT_NUMERIC);
							$newArr =[];
							$n = 0;
							foreach($dataInversed as $nd){
								$n++;
								if($n <= $row->sqllimit){
									array_push($dynamicData,$nd);
								}
							}
						}
						return implode("",$dynamicData);
					})($row->data,$row,$obj));
				}
			}
			
			$htmlContent= implode("",$htmlContent);
			$this->control->mkFile($obj->sdappfile,$this->control->textCleaner($htmlContent));
			$this->control->mkFile($obj->jsonfile,json_encode($obj->json));
		}
		//die("error");
		
	}
	private function bindWebBasicInfo($object){
		$webInfo = $object->webinfo;//$this->websiteBasicInformation();
		$prepath = $object->prepath;//"themes/".$this->activatedThemeId("fileextracted")."/")
		$config = $this->configuration;
		$urlArray = $this->control->currentUrl(true); 
		$htmltagid = false;
		if(property_exists($object,"htmltagid")){
			$htmltagid = $config["dynamic-block-reference-attribute"].'="'.$this->pageIdDecripted($object->htmltagid,true).'"';
		}
		return $this->control->replacer2(
			array(
				array("code"=>$config["website-basic-information-keywords"]["name"],"value"=>$webInfo->info[0]->name),
				array("code"=>$config["website-basic-information-keywords"]["pagetitle"],"value"=>$webInfo->info[1]->title),
				array("code"=>$config["website-basic-information-keywords"]["favicon"],"value"=>$webInfo->info[5]->favicon),
				array("code"=>$config["website-basic-information-keywords"]["description"],"value"=>$webInfo->info[3]->description),
				array("code"=>$config["website-basic-information-keywords"]["email"],"value"=>$webInfo->info[2]->email),
				array("code"=>"@url/","value"=>$prepath),
				array("code"=>$config["extra-static-block-keywords"]["default-index"],"value"=>"./"),
				array("code"=>$config["sdapp-default-dynamic-intellissences"]["block-alphabet-html-tag-id-reference"],"value"=>$htmltagid)
				),$object->tags
			);
	}
	private function defaultReadMorePageId(){
		$q=$this->conn()->query("SELECT * FROM sdapppages WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey ='sdapp_readingpage4'");
		if(is_object($q)){
			$q=$q->fetchAll();
			foreach($q as $row){
				$readJSON=json_decode($row["pagefeatures"]);
				if(is_object($readJSON) && property_exists($readJSON,"default") && $readJSON->default ==="true"){
					return $row[0];
				}
			}
		}
	}
	private function updateNoSqlFile(object $obj){
		$defaultReadMorePageId = $this->pageIdDecripted($this->defaultReadMorePageId(),true);
		$catUpdate = $obj->category;
		$catUpdateBlockId = $obj->blockid;
		$catUpadateReferenceId = property_exists($obj,"datareferenceid")?$obj->datareferenceid:0;
		$catUpdateData =$this->model->foreignVal("WHERE sdappdataid='".$catUpadateReferenceId."' ","sdappdata","data",$this->conn());
		$themeid = $this->activatedThemeId();
		$themeurl =$this->prepath."themes/".$this->activatedThemeId("fileextracted")."/";
		if(file_exists($themeurl)){
			if(is_dir($themeurl)){
				foreach(scandir($themeurl) as $dir){
				//getting page starts
				if(property_exists($obj,"ref")){
					$ref = $obj->ref;
				}
				else{
					if(in_array($obj->themeid,$this->configuration["sdapp-article-clausures"])){
						$obj->themeid = $themeid;
					}
					$ref = "WHERE themeid ='".$obj->themeid."' AND blockid='".$obj->blockid."' AND datastatus > 0";
				}
				$q="SELECT * FROM sdapppagehtmltags ".$ref."";
				$qPage = $this->conn()->query($q)->fetchAll();
					if(is_array($qPage) && is_iterable($qPage) && count($qPage)>0){
						foreach($qPage as $page){
							$pageid = $page["pageid"];
							$sqlOrdering = (function($o){ $o = intval($o); if($o ===1){return "ASC";} return "DESC";})($page["_ordering"]);
							$sqlLimit = $page["_limit"];
							$sqlFunction = $page["_functions"];
							$sqlTags = $page["_tags"];
							$pageDir = $themeurl."sdapp-pure-html-pages/".$pageid."/";				
							if(file_exists($pageDir) && is_dir($pageDir)){
								$sdappFile =$pageDir."?.sdapp";
								$jsonFile =$pageDir."?.json";
								$diFeedback =[];
								foreach(scandir($pageDir) as $file){
									$extArr = explode(".",$file);
									$ext=end($extArr);
									if($ext ==="sdapp"){
										$sdappFile =$pageDir.$file;
										$diFeedback["sdapp"] =$sdappFile;
									}
									if($ext ==="json"){
										$jsonFile =$pageDir.$file;
										$diFeedback["json"] =$jsonFile;
									}
								}
								if(file_exists($sdappFile) && file_exists($jsonFile)){
									//start updating
									$jsonObject = json_decode(file_get_contents($jsonFile));
									if(is_object($jsonObject) && property_exists($jsonObject,"html")){
										foreach($jsonObject->html as $filerow){
											$pagetagid = $filerow->pagetagid;
											$jsonObject->html->$pagetagid = $filerow;
											if($filerow->type === "dynamic" && $filerow->blockid === $catUpdateBlockId){
												$pagetagid = $filerow->pagetagid;
												$keys = $jsonObject->html->$pagetagid->keys;
												$tags = $jsonObject->html->$pagetagid->tags;
												$functions =  $jsonObject->html->$pagetagid->functions;
												foreach($keys as $key){
													$code = "@".$this->appName."_".$key;
													$value = (function($data,$key,$functions){
														$decodeData =$this->control->decodeJSONTogetArray($data,array());
														$result=isset($decodeData[$key])?$decodeData[$key]:false;
														$result=is_string($result)?$this->control->textCleaner($result):$this->readObjectFK($result);
														$result=$this->giveValue($result,$key,$functions);
														return $result;
													})($catUpdateData,$key,$functions);
													$tags = str_replace($code,$value,$tags);
													$tags = $this->control->replacer2([
														[
															"code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["block-alphabet-html-tag-id-reference"],
															"value"=>$this->configuration["dynamic-block-reference-attribute"].'="'.$this->pageIdDecripted($pagetagid,true).'"'
														]
													],$tags);
												}
												switch($catUpdate){
													case "update":
														$newKey="dataid_".$catUpadateReferenceId;
														if(property_exists($jsonObject->html->$pagetagid->data,$newKey)){
															foreach($jsonObject->html->$pagetagid->data as $prop=>$data){
																if($data->sdappdataid === $catUpadateReferenceId){
																	$jsonObject->html->$pagetagid->data->$prop = (object)[
																		"sdappdataid"=>$catUpadateReferenceId,
																		"blockid"=>$catUpdateBlockId,
																		"data"=>$this->noSqlReplacer((object)[
																			"tags"=>$tags,
																			"dataid"=>$catUpadateReferenceId,
																			"alphabeticreadmorepageid"=>$defaultReadMorePageId
																		]),
																		"publishdata"=>1
																	];
																}
																else{continue;}
															}
														}
														else{
															
															$jsonObject->html->$pagetagid->data->$newKey = (object)[
																"sdappdataid"=>$catUpadateReferenceId,
																"blockid"=>$catUpdateBlockId,
																"data"=>$tags,
																"publishdata"=>1
															];
														}
														
													break;
													case "create":
													$newKey ="dataid_".$catUpadateReferenceId;
													$tags = $this->control->replacer2([
														[
															"code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["block-alphabet-html-tag-id-reference"],
															"value"=>$this->configuration["dynamic-block-reference-attribute"].'="'.$this->pageIdDecripted($pagetagid,true).'"'
														]
													],$tags);
													$jsonObject->html->$pagetagid->data->$newKey= (object)[
														"sdappdataid"=>$catUpadateReferenceId,
														"blockid"=>$catUpdateBlockId,
														"data"=>$this->noSqlReplacer((object)[
															"tags"=>$tags,
															"dataid"=>$catUpadateReferenceId,
															"alphabeticreadmorepageid"=>$defaultReadMorePageId
														]),
														"publishdata"=>1
													];
													break;
													case "delete":
														$blockId = $jsonObject->html->$pagetagid->blockid;
														$sqllimit = $jsonObject->html->$pagetagid->sqllimit;
														$targetItemN = $sqllimit + 1;
														$ordering = $jsonObject->html->$pagetagid->sqlordering;
														$data = $this->model->selectData((object)[
															"conn"=>$this->conn(),
															"table"=>"sdappdata",
															"clauses"=>"WHERE blockid='$blockId' AND datastatus > 0 ORDER BY sdappdataid $ordering  LIMIT $targetItemN , 1"
														]);
														$targetItem  = false;
														$tags = $jsonObject->html->$pagetagid->tags;
														if(is_array($data) && count($data) > 0 ){
															$i = 0;
															$newKey = "dataid_".$data[$i][0];
															$targetItem = $data[$i];
															//setting data starts
															foreach($keys as $key){
																$code = "@".$this->appName."_".$key;
																$value = (function($data,$key,$functions){
																	$decodeData =$this->control->decodeJSONTogetArray($data,array());
																	$result=isset($decodeData[$key])?$decodeData[$key]:false;
																	if(is_string($result)){
																		$result = $this->control->textCleaner($result);
																	}
																	if(is_object($result)){
																		$result = $this->readObjectFK($result);
																	}
																	//$result=is_string($result)?$this->control->textCleaner($result):is_object($result)?$this->readObjectFK($result):false;
																	$result=$this->giveValue($result,$key,$functions);
																	return $result;
																})($targetItem["data"] ,$key,$functions);
																 $tags = str_replace($code,$value,$tags);
																 
															}
															$tags = $this->control->replacer2([
																[
																	"code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["block-alphabet-html-tag-id-reference"],
																	"value"=>$this->configuration["dynamic-block-reference-attribute"].'="'.$this->pageIdDecripted($pagetagid,true).'"'
																]
															],$tags);
															$jsonObject->html->$pagetagid->data->$newKey = (object)[
																"sdappdataid"=>$data[$i][0],
																"blockid"=>$data[$i]["blockid"],
																"data"=>$this->noSqlReplacer((object)[
																	"tags"=>$tags,
																	"dataid"=>$data[$i][0],
																	"alphabeticreadmorepageid"=>$defaultReadMorePageId
																]),
																"publishdata"=>1
															];
															//setting data ends
														}
													
														foreach($jsonObject->html->$pagetagid->data as $prop=>$data){
															if($data->sdappdataid === $catUpadateReferenceId){
																unset($jsonObject->html->$pagetagid->data->$prop);
															}
															//else{continue;}
														}
													break;
													case "unpublish":
														foreach($jsonObject->html->$pagetagid->data as $prop=>$data){
															if($data->sdappdataid === $catUpadateReferenceId){
																$jsonObject->html->$pagetagid->data->$prop->publishdata = 0;
															}
															else{continue;}
														}
													break;
													case "publish":
														$newKey ="dataid_".$catUpadateReferenceId;
														$jsonObject->html->$pagetagid->data->$newKey= (object)[
														"sdappdataid"=>$catUpadateReferenceId,
														"blockid"=>$catUpdateBlockId,
														"data"=>$tags,
														"publishdata"=>1
														];
													break;
												}
												
	
												$dataArr = [];
												foreach($jsonObject->html->$pagetagid->data as $data){
													$dataArr[$data->sdappdataid]=$data;
												}
												ksort($dataArr,SORT_NUMERIC);
												$newObjectData = (object)[];
												foreach($dataArr as $key=>$objData){
													$newkey ="dataid_".$key;
													if(property_exists($objData,"publishdata") && intval($objData->publishdata) > 0 ){
														$newObjectData->{$newkey} = (object)[
															"blockid"=>$objData->blockid,
															"data"=>$objData->data,
															"sdappdataid"=>$objData->sdappdataid,
															"publishdata"=>$objData->publishdata
														];
													}
													
												}
												$jsonObject->html->$pagetagid->data = $newObjectData;
												//die(json_encode($jsonObject->html));
												//die(is_object($jsonObject) && property_exists($jsonObject,"html")?"yes everything is okay":"no");
												$this->rewriteNoSqlFile((object)[
													"json"=>$jsonObject,
													"jsonfile"=>$jsonFile,
													"sdappfile"=>$sdappFile,
													//"sqlordering"=>$sqlOrdering,
													//"sqllimit"=>$sqlLimit,
													"mode"=>"dynamic"
												]);
												
											}
											else if($filerow->type === "static"){
												$htmlContent = null;
												$pagetagid = $filerow->pagetagid;
												//static section  starts
												if($catUpdate ==="upatewebbasicinfo"){
													if(property_exists($filerow,"webbasicinfoexists") && $filerow->webbasicinfoexists ==="true"){
														$jsonObject->html->$pagetagid->data = $this->bindWebBasicInfo((object)[
															"tags"=>$jsonObject->html->$pagetagid->sqltags,
															"webinfo"=>$obj->webinfo,
															"prepath"=>$obj->themeprepath
														]);
													}
													
												}
												if($catUpdate ==="deactivatemenu"){
														if(property_exists($filerow,"menuexists") && $filerow->menuexists ==="true"){
															$jsonObject->html->$pagetagid = (object)[
																"type"=>"static",
																"sdappblockgroupsid"=>$filerow->sdappblockgroupsid,
																"pagetagid"=>$filerow->pagetagid,
																"menuexists"=>$filerow->menuexists,
																"menutype"=>$filerow->menutype,
																"sqltags"=>$filerow->sqltags,
																"data"=>""
															];
														}
												}
												else if(in_array($catUpdate,["activatemenu","menuordering","updatemenu"])){
													if(property_exists($filerow,"menuexists") && $filerow->menuexists ==="true"){
														$data = (function($type,$tags,$pageid,$tagid,$themeid,$obj){
															if(in_array($type,["web-menu","mobile-menu"])){
																$menu = $this->control->replacer2(array(
																	array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
																	array("code"=>"@sdapp-web-menu-builtin","value"=>$obj->webmobilemenus["web-menu"]),
																	array("code"=>"@sdapp-mobile-menu-builtin","value"=>$obj->webmobilemenus["mobile-menu"])
																),$tags);
																return $this->control->sdappReplacer($menu);
																
															}	
														})($filerow->menutype,$filerow->sqltags,$pageid,$filerow->pagetagid,$themeid,$obj);
														$jsonObject->html->$pagetagid = (object)[
															"type"=>"static",
															"sdappblockgroupsid"=>$filerow->sdappblockgroupsid,
															"pagetagid"=>$filerow->pagetagid,
															"menuexists"=>$filerow->menuexists,
															"menutype"=>$filerow->menutype,
															"sqltags"=>$filerow->sqltags,
															"data"=>$data
														];
													}
												}
												//static section ends
												
											}
										}
									}
									//end updating
									$this->rewriteNoSqlFile((object)[
										"json"=>$jsonObject,
										"jsonfile"=>$jsonFile,
										"sdappfile"=>$sdappFile,
										//"sqlordering"=>$sqlOrdering,
										//"sqllimit"=>$sqlLimit,
										"mode"=>"static"
									]);
								}
							}
						}
					}
				//getting page ends
				}
			}
		}
	}
	public function noSqlReplacer($object){
		return $this->control->replacer2([
					[
						"code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["readmore"],
						"value"=>"sdapp-read-more-page-".$object->alphabeticreadmorepageid."-data-".$this->pageIdDecripted($object->dataid,true)
					],
					[
						"code"=>$this->configuration["sdapp-default-dynamic-intellissences"]["themeprepath"],
						"value"=>"themes/".$this->activatedThemeId("fileextracted")."/"
					]
		],$object->tags);
	}
	public function deleteData(){
		$obj =(object)[];
		$data=$this->control->request('data');
		$obj->themeid = $data['themeid'];
		$obj->blockid = $data['blockid'];
		$obj->data = $data['data'];
		
		$this->model->updataQuery(
			'sdappdata',
			array(
				"themeid"=>$data['themeid'],
				"blockid"=>$data['blockid'],
				"data"=>$data['data'],
				"datastatus"=>$data['datastatus'],
				"modifiedby"=>$this->main->userId()
			),
			$this->conn(),
			'sdappdataid',
			$data['id']
		);
		$obj->category ="delete";
		$obj->datareferenceid  = $data['id'];
		$this->updateNoSqlFile($obj);
	}
	public function writeNoSqlWebsiteInfo($object){
		$obj =(object)[];
		$obj->themeid = $object->themeid;
		$obj->blockid = $object->blockid;
		$obj->pageid = $object->pageid;
		$obj->category ="upatewebbasicinfo";
		$ref ="WHERE themeid='".$obj->themeid."' AND webbasicinfoexists ='true' AND  pageid='".$obj->pageid."' AND blockid='".$object->blockid."' ORDER BY pagetagid ASC";
		$obj->ref = $ref ;
		$obj->webinfo = $this->websiteBasicInformation();
		$obj->themeprepath = "themes/".$this->activatedThemeId("fileextracted")."/";
		$this->updateNoSqlFile($obj);
	}
	public function unpublishData(){
		$obj =(object)[];
		$data=$this->control->request('data');
		$obj->themeid = $data['themeid'];
		$obj->blockid = $data['blockid'];
		$obj->data = $data['data'];
		
		$this->model->updataQuery(
			'sdappdata',
			array(
				"themeid"=>$data['themeid'],
				"blockid"=>$data['blockid'],
				"data"=>$data['data'],
				"publishdata"=>$data['publishdata'],
				"modifiedby"=>$this->main->userId()
			),
			$this->conn(),
			'sdappdataid',
			$data['id']
		);
		$obj->category ="unpublish";
		$obj->datareferenceid  = $data['id'];
		$this->updateNoSqlFile($obj);
	}

	public function publishData(){
		$obj =(object)[];
		$data=$this->control->request('data');
		$obj->themeid = $data['themeid'];
		$obj->blockid = $data['blockid'];
		$obj->data = $data['data'];
		
		$this->model->updataQuery(
			'sdappdata',
			array(
				"themeid"=>$data['themeid'],
				"blockid"=>$data['blockid'],
				"data"=>$data['data'],
				"publishdata"=>$data['publishdata'],
				"modifiedby"=>$this->main->userId()
			),
			$this->conn(),
			'sdappdataid',
			$data['id']
		);
		$obj->category ="publish";
		$obj->datareferenceid  = $data['id'];
		$this->updateNoSqlFile($obj);
	}
	public function updateMenu(){
		$obj =(object)[];
		$row=$this->control->request('row');
		$obj->themeid = $row['themeid'];
		$obj->category =$this->control->request("category");
		$q=$this->conn()->query("SELECT * FROM sdapppagehtmltags WHERE themeid='".$obj->themeid."' AND menuexists='true'")->fetchAll();
		$ref = [];
		;
		$menus =[];
		if(is_iterable($q) && is_array($q)){
			for($i=0; $i<count($q); $i++){
				array_push($ref,"themeid='".$obj->themeid."' AND  pagetagid='".$q[$i][0]."' AND blockid='".$q[$i]["blockid"]."'");
				if($q[$i]["menutype"] ==="mobile-menu"){
					$menus[$q[$i]["menutype"]]=$this->ncMenuGenerator($obj->themeid,$q[$i][0],$q[$i]["pageid"],$q[$i]["menutype"]);
				}
				if($q[$i]["menutype"] ==="web-menu"){
					$menus[$q[$i]["menutype"]]=$this->ncMenuGenerator($obj->themeid,$q[$i][0],$q[$i]["pageid"],$q[$i]["menutype"]);
				}
			}
		}
		$ref = "WHERE ".implode(" OR ",$ref);
		$obj->ref= $ref;
		$obj->blockid = 0;
		$obj->webmobilemenus = $menus;
		$this->updateNoSqlFile($obj);
	}
	private function dataDuplicationAttempt($objects){
		if(
			is_object($objects)
			&& property_exists($objects,"columnsobjects")
			&& property_exists($objects,"dataformobject")
			&& property_exists($objects,"editid")
			){
			$avoidDuplicationOntheseColumns = [];
			$columnArrayObject = json_decode($objects->columnsobjects);
			foreach($columnArrayObject as $column){
				if(property_exists($column,"events")){
					$avoidDuplicationOntheseColumns[] = $column;
				}
			}
			$obj = $objects->dataformobject;
			$editID = $objects->editid;
			//function filter starts
			$functionFilter = function($eventType,$avoidDuplicationOntheseColumns,$obj){
				$selectedColumns= [];
				foreach($avoidDuplicationOntheseColumns as $column){
					$targetEvent = (object)[];
					for($i = 0; $i < count($column->events); $i++){
						$event = $column->events[$i];
						if(intval($event->eventtype) === $eventType){
							$key = $column->key;
							$targetEvent->functionname = $event->eventfunctionname;
							$targetEvent->defaultwarning = $event->eventdefautwarning;
							$targetEvent->columnkey = $key;
							$targetEvent->value = $obj[$key];
						}
					}
					if(property_exists($targetEvent,"functionname")){
						$selectedColumns [] = $targetEvent;
					}
				}
				return $selectedColumns;
			};
			//function filter ends
	
			//loading data starts
			$loadingData = function($blockId,$columns,$editId){
				$functions = [];
				$functions["inputUnikValue"] = function($object){
					if(
						is_object($object)
						&& property_exists($object,"column")
						&& property_exists($object,"value")
						&& property_exists($object,"key")
						&& property_exists($object,"id")
						&& property_exists($object,"editid")
						){
						if(
							$object->column->columnkey === $object->key 
							&& strtolower($object->column->value) === strtolower($object->value)
							&& intval($object->id) !== intval($object->editid)
							){
							return $object->column;
						}
					}
				};
				if(is_array($columns) && count($columns) > 0){
					$data = $this->model->selectData((object)[
						"table"=>"sdappdata",
						"clauses"=>"WHERE blockid ='".$blockId."' AND datastatus > 0",
						"conn"=>$this->conn()
					]);
					$feeback = [];
					foreach($data as $row){
						$d = json_decode($row["data"]);
						foreach($d as $key => $value){
							for($i = 0; $i < count($columns); $i++){
								$col = $columns[$i];
								if(key_exists($col->functionname,$functions)){
									$result = $functions[$col->functionname]((object)[
										"column"=>$col,
										"value"=>$value,
										"key"=>$key,
										"id"=>$row[0],
										"editid"=>$editId
									]);
									if($result !== null){
										$feeback [] = $result;
									}
									 
								}
							}
						}
					}
					return $feeback;
				} 
				
			};
			//loading data ends
	
			//on submit event starst
			$columns = $functionFilter(8,$avoidDuplicationOntheseColumns,$obj->data);
			//return $columns;
			return $loadingData($obj->blockid,$columns,$editID);
			
		}	
	}
	public function saveEditData(){
		$obj =(object)[];
		$data=$this->control->request('data');
		$confirmSave = intval($this->control->request("confirmsave"));
		$obj->themeid = $data['themeid'];
		$obj->blockid = $data['blockid'];
		$obj->data = $data['data'];
		$obj->rowblock = $data["rowblock"];
		if($confirmSave === 0){
			$duplicationAttempts = $this->dataDuplicationAttempt((object)[
				"columnsobjects"=>$obj->rowblock["columnsobjects"],
				"dataformobject"=>$obj,
				"editid"=>$data['id']
			]);
			if(is_array($duplicationAttempts) && count($duplicationAttempts) > 0){
				return json_encode([
					"status"=>"dataduplicationattempt",
					"status-code"=>403,
					"duplication-attempts"=>$duplicationAttempts
				],JSON_PRETTY_PRINT);
			}
			//on submit event ends
		}
		if($confirmSave === 1){
			if(intval($data["id"]) < 1){
				$obj->category ="create";
				$sql=$this->model->insertQuery(
					'sdappdata',
					array(
						"sdappdataid"=>"NULL",
						"themeid"=>$data['themeid'],
						"blockid"=>$data['blockid'],
						"data"=>$data['data'],
						"datastatus"=>$data['datastatus'],
						"createdby"=>$this->main->userId()
					),
					$this->conn()
				);
				$obj->datareferenceid =$sql["lastid"];
				$this->updateNoSqlFile($obj);
			}
			else{
				$this->model->updataQuery(
					'sdappdata',
					array(
						"themeid"=>$data['themeid'],
						"blockid"=>$data['blockid'],
						"data"=>$data['data'],
						"datastatus"=>$data['datastatus'],
						"modifiedby"=>$this->main->userId()
					),
					$this->conn(),
					'sdappdataid',
					$data['id']
				);
				$obj->datareferenceid = $data['id'];
				$obj->category ="update";
				$this->updateNoSqlFile($obj);
			}
			return json_encode([
				"status"=>"success",
				"status-code"=>200,
				"data"=>$data
			],JSON_PRETTY_PRINT);
		}
		if($confirmSave === 0){
			return json_encode([
				"status"=>"success",
				"status-code"=>199,
				"data"=>$data
			],JSON_PRETTY_PRINT);
		}
	}
	public function saveEditReferenceblock(){
		$data=$this->control->request('data');
		if(($data['id']*1)<1){
			//return json_encode($data);
			return json_encode($this->model->insertQuery(
				'sdappblockreference',
				array(
					"blockid"=>"NULL",
					"themeid"=>$data['themeid'],
					"blockname"=>$this->main->preventInj($data['block']),
					"pageid"=>$data['pageid'],
					"blocktype"=>$data["blocktype"],
					"columnsobjects"=>$data['columns'],
					"createdby"=>$this->main->userId()
				),
				$this->conn()
			));
		}
		else{
			$this->model->updataQuery(
				'sdappblockreference',
				array(
					"themeid"=>$data['themeid'],
					"blockname"=>$this->main->preventInj($data['block']),
					"pageid"=>$data['pageid'],
					"columnsobjects"=>$data['columns'],
					"modifiedby"=>$this->main->userId()
				),
				$this->conn(),
				'blockid',
				$data['id']
			);
		}
		
	}
	public function getPageContent(){
			$url=$this->pageUrl(2,false);
			if(file_exists($url)){
				return file_get_contents($url);
			}
			
	}
	public function pageUrl($nbackDir=2,$createDir=true,$customizedRequest=false){
		$dirIndexesArr=[2,3];
		if(isset($_REQUEST['data'])){
			$data=$this->control->request("data");
			$pageid=(function($pageid){
				if(is_array($pageid)){
					return $pageid[0];
				}
				return $pageid;
			})($data["pageid"]);
			$pagekey=$data["pagekey"];
			$themeid=(function($themeid){
				if(is_array($themeid)){
					return $themeid[0];
				}
				return $themeid;
			})($data["themeid"]);
			$pagename=$data["pagename"];
		}
		else if($customizedRequest!==false
		&& is_array($customizedRequest)
		&& key_exists("pageid",$customizedRequest)
		&& key_exists("pagekey",$customizedRequest)
		&& key_exists("themeid",$customizedRequest)
		&& key_exists("pagename",$customizedRequest)
		){
			$pageid=$customizedRequest["pageid"];
			$pagekey=$customizedRequest["pagekey"];
			$themeid=$customizedRequest["themeid"];
			$pagename=$customizedRequest["pagename"];
		}
		else{
			$pageid=$this->control->request('pageid');
			$pagekey=$this->control->request('pagekey');
			$themeid=$themeid=(function($themeid){
				if(is_array($themeid)){
					return $themeid[0];
				}
				return $themeid;
			})($this->control->request('themeid'));
			$pagename=$this->control->request('pagename');
		}
		$theme=$this->model->foreignVal("WHERE themeid='".$themeid."'","sdappthemes","fileextracted",$this->conn());
		if($pagekey ==="none"){
			$pageurl=$this->control->smartPath(["themes",$theme,"sdapp-pure-html-pages",$pageid,(function($pageid,$pagename){
				return "page-".(function($id){
				
				return $this->control->replacer2($this->pageIdCriptedArray(),$id);
				})($pageid)."-".strtolower(str_replace(" ","-",$pagename));
			})($pageid,$pagename).".sdapp"],$nbackDir,$createDir,$dirIndexesArr);
		}
		else{
			
			$pageurl=$this->control->smartPath(["themes",$theme,"sdapp-pure-html-pages",$pageid,$pagekey.".sdapp"],$nbackDir,$createDir,$dirIndexesArr);
			//die($theme);
		}
		
		return $pageurl;
	}
	private function pageIdCriptedArray(){
	$encriptionObject=$this->configuration["url-encription-page-id"];
	 $obj=[];
		if(is_array($encriptionObject)){
			foreach($encriptionObject as $encri){
				if(array_key_exists("code",$encri) && array_key_exists("value",$encri)){
					array_push($obj,[
						"code"=>$encri["code"],
						"value"=>$encri["value"]
					]);
				}
				
			}
		}
		return $obj;
	}
	public function pageIdDecripted($stringId,$inverse=false){
		$encriptionObject=$this->configuration["url-encription-page-id"];
		 $obj=[];
			if(is_array($encriptionObject)){
				foreach($encriptionObject as $encri){
					$array = [
						"code"=>$encri["value"],
						"value"=>$encri["code"]
					 ];
					 
					 $inverseArray = [
						"value"=>$encri["value"],
						"code"=>$encri["code"]
					 ];
					 if($inverse && $inverse === true){
						$array = $inverseArray;
					 }
					if(array_key_exists("code",$encri) && array_key_exists("value",$encri)){
						array_push($obj,$array);
					}
					
				}
			}
			return $this->control->replacer2($obj,$stringId);
		}
	public function savePage(){
		$pageurl=$this->pageUrl();
		if(is_file($pageurl)){
			unlink($pageurl);
		}
		$pageid=$this->control->request("pageid");
		$themeid=$this->control->request("themeid");
		$content=$this->control->request("content");
		$this->model->insertQuery(
			"sdapppagehtmltags",
			array(
				"pagetagid"=>"NULL",
				"themeid"=>$themeid,
				"pageid"=>$pageid,
				"blockid"=>0,
				"_ordering"=>"none",
				"_limit"=>0,
				"_type"=>1,
				"_tags"=>$this->control->sdappReplacer(trim($content)),
				"_comments"=>"none",
				"_functions"=>[
					"functionname"=>"void"
				],
				"createdby"=>$this->main->userId()
			),
			$this->conn()
		);
		$tag=$this->model->foreignVal(
			"ORDER BY pagetagid DESC LIMIT 1",
			"sdapppagehtmltags",
			array(),
			$this->conn()
			);
		
		$indexedContent=$this->control->str_replace_first(
			$content,
			">",
			$this->staticKeyWordReplace($tag[0],$pageid,$content)
		);
		$this->control->mkFile($pageurl,$indexedContent);
	}
	public function getPages(){
		$url=$this->control->request('url');
		$extension=$this->control->request('extensions');
		$checker=function($dir,$rootPage,$arrayExtensions,$key){
			$file=$dir.'/'.$rootPage;
			$expl=explode(".",$file);
			$fileExt=end($expl);
			if(is_file($file)){
				 if(in_array($fileExt,$arrayExtensions)){
					 return array(
						 'filename'=>$rootPage,
						 'key'=>$key,
						 'ext'=>$fileExt,
						 'content'=>file_get_contents($file),
						 'pageurl'=>$file
						);
				 }
			}
			
		};
		if(is_dir($url)){
			$pages=array();
			foreach(scandir($url) as $key=>$page){
				$file=$checker($url,$page,$extension,$key);
				if($file){
					$pages[]=$file;
				}
				
			}
			return json_encode($pages);
		}
		//return $file;
	}
	public function createEditTheme(){
		$category=$this->control->request("category");
		$usedprice=$this->control->request("usedprice");
		$localprice=$this->control->request("localprice");
		$localpricesign=$this->control->request("localpricesign");
		$description=$this->control->request("description");
		$theme=$this->control->request('theme');
		$photofilename=$this->control->request("photofilename");
		$filename=$this->control->request("filename");
		$fileextracted=$this->control->request("fileextracted");
		$themeid=$this->control->request("id");
		if($themeid>0){
			$currentValues=$this->model->foreignVal("WHERE themeid='".$themeid."'","sdappthemes",array(),$this->conn());
			$dir=$this->prepath.'themes/'.$currentValues["fileextracted"].'/';
			if($currentValues["fileextracted"]!==$fileextracted){
				$this->control->removeDir($dir);
			}
			if($currentValues["themephoto"]!==$photofilename){
				if(file_exists("../".$currentValues["themephoto"])){
					unlink("../".$currentValues["themephoto"]);
				}
			}
			
			$this->model->updataQuery(
				"sdappthemes",
				array(
					"sdapp_theme_categoryid"=>$category,
					"theme"=>$this->main->preventInj($theme),
					"themeusdprice"=>$this->main->preventInj($usedprice),
					"themelocalprice"=>$this->main->preventInj($localprice),
					"localmoneysign"=>$this->main->preventInj($localpricesign),
					"themedecription"=>$this->main->preventInj($description),
					"themephoto"=>$this->main->preventInj($photofilename),
					"filename"=>$this->main->preventInj($filename),
					"fileextracted"=>$this->main->preventInj($fileextracted),
					"modifiedby"=>$this->main->userId()
				),
				$this->conn(),
				"themeid",
				$themeid
			);
		}
		else{
			$this->model->insertQuery(
				'sdappthemes',
				array(
					"themeid"=>"NULL",
					"sdapp_theme_categoryid"=>$category,
					"theme"=>$this->main->preventInj($theme),
					"themeusdprice"=>$this->main->preventInj($usedprice),
					"themelocalprice"=>$this->main->preventInj($localprice),
					"localmoneysign"=>$this->main->preventInj($localpricesign),
					"themedecription"=>$this->main->preventInj($description),
					"themephoto"=>$this->main->preventInj($photofilename),
					"filename"=>$this->main->preventInj($filename),
					"fileextracted"=>$this->main->preventInj($fileextracted),
					"createdby"=>$this->main->userId()
				),
				$this->conn()
			);
		}
		
		$dir=$this->prepath.'themes/';
		$this->path=$this->prepath.$filename;
		$this->control->extract($this->path,$dir);
		if(is_file($this->path)){unlink($this->path);}
		$themeDir=$dir.$fileextracted;
		//renaming starts
		foreach (scandir($themeDir) as $scanedDir) {
			$oldDir=$themeDir.'/'.$scanedDir;
			 if(is_dir($oldDir) && strpos($scanedDir,"wp")>-1){
				rename($oldDir,$this->control->replacer2(
					array(
						array("code"=>"wp","value"=>$this->appName),
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")
					),
					$oldDir
				));
			 }
			 //echo $scanedDir."<br/>";
		}
		foreach(scandir($dir)as $file){
			$ext=$this->control->getValFromExplode(".",$file,1);
			if($ext ==="zip"){
				$zipFile=$dir."/".$file;
				if(file_exists($zipFile)){
					unlink($zipFile);
				}
				
			}
		}
		//renaming ends


	}
	public function getSubMenus(){
		$menuid=$this->control->request("menuid");
		$q=$this->conn()->query("SELECT * FROM tblsubmenu WHERE menuparentid ='".$menuid."'");
		if(is_object($q)){
			$q=$q->fetchAll();
			$data=array();
			foreach($q as $row){
				$data[]=array(
					'row'=>$row,
					'menu'=>$this->model->foreignVal("WHERE menuid='".$row['menuid']."'"," tblmenu","menu",$this->conn())
				);
			}
			return json_encode($data);
		}
		
	}
	public function loadUnMenuPages(){
		$q=$this->conn()->query("SELECT * FROM tblpages  ORDER BY page");
		if(is_object($q)){
			$q=$q->fetchAll();
			$data=array();
			foreach($q as $value){
				$existingMenuId=$this->model->foreignVal("WHERE pageid='".$value[0]."'"," tblmenu","pageid",$this->conn());
				if($existingMenuId<1){
					$data[]=$value;
				}
				
			}
		  return json_encode($data);
		}
		
	}

	public function createSubMenu(){
         $menuid=$this->control->request('menuid');

	}

	public function getMenu(){

		$subMenuFunc=function($subMenuJSON){
                  $submenu='<ul class="sub-menu elementor-nav-menu--dropdown">';
				  $submenu.='<li class="menu-item menu-item-type-post_type menu-item-object-page">
				  <a href="index.html" aria-current="page" class="elementor-sub-item  elementor-item-active">Home1</a>
			  </li>';
				  $submenu.='</ul>';
				  return $submenu;
		};
		$menuQuery=$this->conn()->query("SELECT * FROM tblmenu ORDER BY menu");
		if(is_object($menuQuery)){
			$menuQuery=$menuQuery->fetchAll();
			$menu='<ul id="menu-main-menu" class="elementor-nav-menu">';
			foreach($menuQuery as $value){
			  //start creating menu
				$menu.='<li
				class="menu-item menu-item-type-post_type menu-item-object-page menu-item-6524">
				<a href="page.php?id='.$value[0].'"
					class="elementor-sub-item">'.$value['menu'].'</a>
					'.$subMenuFunc(true).'
			</li>';
			  //ends creating menu
			}
			$menu.='</ul>';
			return $menu;
		}
		
	}

	public function sdappRuns(){
		$this->weboptions=$this->configuration;
		$this->dom.=$this->wbHeader();
		$this->dom.=$this->wbContent();
		$this->dom.=$this->wbFooter();
		echo $this->dom;
	}
	private function pageCleaner($page,$defaultContent='My Son!!',$keywordStarter="</header",$keywordEnder="<footer"){
		$file='theme/'.$this->weboptions['ui'].'/'.$page;
        if(is_file($file)){
			$content=false;
			$n=0;
			$references=array();
			foreach (new SplFileObject($file) as $line){
				$n++;
                if(strpos(strtolower($line),$keywordStarter)>-1){
					$references[]=$n;
				}
				if(strpos(strtolower($line),$keywordEnder)>-1){
					$references[]=$n;
				}
			}
			 if(count($references)<2){
				 return $defaultContent;
			 }
			 else{
				 $content=false;
				 $count=0;
				foreach (new SplFileObject($file) as $line){
					$count++;
					 if($count>$references[0] && $count< $references[1]){
						$content.=$line; 
					 }
				}
				unlink($file);
				if(isset($this->weboptions['fileremover']) && is_array($this->weboptions['fileremover']) && count($this->weboptions['fileremover'])>0){
					$arr=array();
					foreach($this->weboptions['fileremover'] as $single){
						$arr[]=array('code'=>'src="'.$single.'"','value'=>false);
					}
					$arr[]=array('code'=>'type="text/javascript"','value'=>false);
					$arr[]=array('code'=>"type='text/javascript'",'value'=>false);
					$arr[]=array('code'=>'<script  ></script>','value'=>false);
					
				}
				$this->control->mkFile($file,$this->control->replacer2($arr,$content));
				return 'Page has been cleaned successfully';
			 }
			
		}
		else{
			return 'file missing';
		}
	}
	private function wbMenu(){
		$checkTag=function($tagProperty){
			if(isset($this->weboptions['menu']['tags']) && isset($this->weboptions['menu']['tags'][$tagProperty])){
				return $this->weboptions['menu']['tags'][$tagProperty];
			}
		};
		$readDynamicList=function($data,$parentData,$type=1,$dropDownContent=false){
			return $this->control->replacer2(
				array(
					array('code'=>'@class','value'=>$this->control->variableExists($data['attrs'],'class')),
					array('code'=>'@url','value'=>'?page='.$data['file']),
					array('code'=>'@title','value'=>$data['title']),
					array('code'=>'@dropDown','value'=>$type==1?false:$dropDownContent),
					array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./")

				),$parentData
			);
		};
		$dropDownMenu=function($data,$checkTag,$readDynamicList){
			    $html=$checkTag('childopen');
				if(is_array($data['submenu'])){
					foreach($data['submenu'] as $sub_data){
						$html.=$readDynamicList($sub_data,$checkTag('childdynamic'));
					}
				}
				$html.=$checkTag('childclose');
				return $html;	
		};


		if(isset($this->weboptions['menu'])){
			$html=$checkTag('parentopen');
					if(isset($this->weboptions['menu']['data'])){
						foreach($this->weboptions['menu']['data'] as $data){
							if($data['type'] ===1){
								$html.=$readDynamicList($data,$checkTag('parentdynamic'));
							}
							else{
									$html.=$readDynamicList(
										$data,
										$checkTag('parentdynamic'),
										2,
										$dropDownMenu($data,$checkTag,$readDynamicList)
									);
							}
							
						}
					}
			$html.=$checkTag('parentclose');
			return $html;
		}
	}

	public function menuParameters($type=1,$title=false,$file=false,$attrs=array(),$subMenuArray=array()){
			return array('type'=>$type,'title'=>$title,'file'=>$file,'attrs'=>$attrs,'submenu'=>$subMenuArray);
	}

	private function wbHeader(){

		$page=$this->model->foreignVal(
			"WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey='sdapp_pageheader1'",
			"sdapppages",
			array(),
			$this->conn()
		);
		
        if(is_array($page) && count($page)>0){
				$file=$this->pageUrl(0,false,[
			"pageid"=>$page[0],
			"pagekey"=>$page["staticpagekey"],
			"themeid"=>$this->activatedThemeId(),
			"pagename"=>$page["pagename"]
		]);
		//return $file;
	    return $this->wbFileLoader(array(
			'file'=>$file,
			'error_message'=>'Website header file is missing'
		));
		}     
		
	}
	private function wbContent(){
		$file=false;
		$page=$this->model->foreignVal(
			"WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey='sdapp_homepage3'",
			"sdapppages",
			array(),
			$this->conn()
		);
		if(is_array($page) && count($page)>0){
			$file=$this->pageUrl(0,false,[
			"pageid"=>$page[0],
			"pagekey"=>$page["staticpagekey"],
			"themeid"=>$this->activatedThemeId(),
			"pagename"=>$page["pagename"]
		]);	
		}
		
		return $this->wbFileLoader(array(
			'file'=>$file,
			'error_message'=>'Website home  file is missing',
			'func'=>function($homeContent){
				 if(count($_GET)<1){
					 return $homeContent;
				 }
				 else{
					 if(isset($_GET['sdapp-url'])){

						 $pageid=$this->pageIdDecripted($this->control->getValFromExplode("-",$_GET['sdapp-url'],1));
						 $page=$this->model->foreignVal(
							"WHERE pageid='".$pageid."'",
							"sdapppages",
							array(),
							$this->conn()
						);
						if(is_array($page) && count($page)>0){
							$file=$this->pageUrl(0,false,[
							"pageid"=>$page[0],
							"pagekey"=>$page["staticpagekey"],
							"themeid"=>$this->activatedThemeId(),
							"pagename"=>$page["pagename"]
						]);
						}
						if(isset($file)){
							if(is_array($page) && count($page) && key_exists("pagecontent",$page) && $page["pagecontent"]!==null){
								//default page starts
								$defaultPage=$this->model->foreignVal(
									"WHERE staticpagekey='sdapp_defaultpage5' AND themeid='".$this->activatedThemeId()."'",
									"sdapppages",
									array(),
									$this->conn(),
									false,
									true
								);
								if(is_array($page) && count($page)>0){
									$file=$this->pageUrl(0,false,[
									"pageid"=>$defaultPage[0],
									"pagekey"=>$defaultPage["staticpagekey"],
									"themeid"=>$this->activatedThemeId(),
									"pagename"=>$defaultPage["pagename"]
								]);
								}
								return $this->wbFileLoader(array(
									'file'=>$file,
									"pageinformation"=>$page,
									"default-page"=>true,
									'error_message'=>'!!Oops page not created yet'
								));
								//default page ends
							}
							else{
								return $this->wbFileLoader(array(
									'file'=>$file,
									'error_message'=>'!!Oops page not created yet'
								));
							}
							
						}
						else{
							if(strpos($_GET['sdapp-url'],"sdapp-read-more-page")>-1){
								return $this->wbFileLoader(array(
									'content'=>$this->ncReadMorePage(),
									'error_message'=>'!!Oops page not created yet'
								));
							}
							else{
								die("Error!");
							}
						}
						
					 }
					 /*
					 else if(isset($_GET['clean'])){
						return $this->pageCleaner($_GET['clean'].'.swb');
					 }*/
					 else{
						 //return json_encode($this->control->currentUrl([]));
						 $url = $this->control->currentUrl([]);
						 $url=[$url["protocol"],"://",$url["host"],str_replace("index.php",false,$url["script"])];
						 $url=implode("",$url);
						 $this->control->redirection($url);
						 //return 'Undefined Request';
					 }
                     
				 } 
			}
		));
	}
	private function ncReadMorePage()
	{
		$url =$_REQUEST["sdapp-url"];
		$pageid=$this->pageIdDecripted($this->control->getValFromExplode("-",$url,4));
		$dataId=$this->pageIdDecripted($this->control->getValFromExplode("-",$url,6));
		$page=$this->model->foreignVal(
			"WHERE pageid='".$pageid."'",
			"sdapppages",
			array(),
			$this->conn()
		);
		$data=$this->model->foreignVal(
			"WHERE sdappdataid='".$dataId."'",
			"sdappdata",
			array(),
			$this->conn()
		);
		$block=$this->model->foreignVal(
			"WHERE blockid='".$data["blockid"]."'",
			"sdappblockreference",
			array(),
			$this->conn()
		);
				if(is_array($page) && count($page)>0){
					$file=$this->pageUrl(0,false,[
					"pageid"=>$page[0],
					"pagekey"=>$page["staticpagekey"],
					"themeid"=>$this->activatedThemeId(),
					"pagename"=>$page["pagename"]
				]);
				return $this->wbFileLoader(array(
					"file"=>$file,
					"data"=>[
						"content"=>$data["data"],
						"block-read-more-keys"=>(function($block){
							$newArr=[];
							foreach(json_decode($block,true) as $key=>$value){
								$newArr[]=[
									"key"=>(function($value,$key){if(key_exists($key,$value)){return $value[$key];}return false;})($value,"key"),
									"keyword"=>(function($value,$key,$readMoreReferenceTypes,$keywords){
										if(key_exists($key,$value)){
											foreach($readMoreReferenceTypes as $v){
												if(key_exists("code",$v) && $v["code"] === $value[$key]){
													if(key_exists($v["code"],$keywords)){
														return $keywords[$v["code"]];
													}
												}
											}
										}
											return false;
										})($value,"readmorereference",$this->configuration["sdapp-read-more-reference-types"],$this->configuration["sdapp-read-more-keywords"])
								];
							}
							return $newArr;
						})($block["columnsobjects"])
					],
					"callback"=>function($file,$data){
						$sqlData=$data["content"];
						$blockreadmorekeys=$data["block-read-more-keys"];
						$dArr=[];
						foreach($blockreadmorekeys as $value){
							$dArr[]=[
								"key"=>$value["key"],
								"keyword"=>$value["keyword"],
								"data"=> (function($value,$data){
									if(key_exists($value["key"],$data)){
										return  $this->control->textCleaner($data[$value["key"]]);
									}
									return false;
								})($value,json_decode($sqlData,true))
							];
						}
						$replacerArr=[];
						foreach ($dArr as $lValue) {
							if($lValue["data"]!==false){
									$replacerArr[]=[
									"code"=>$lValue["keyword"],
									"value"=>(function($data){
										return $this->control->replacer2(array(
										array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
										array("code"=>"@dblquote","value"=>'"'),
										array("code"=>"@squote","value"=>"'"),
										array("code"=>"@slash","value"=>"/"),
										array("code"=>"@terminate","value"=>";"),
										array("code"=>"@newlinetab","value"=>"\n\t"),
										array("code"=>"@tab","value"=>"\t\t"),
										array("code"=>"@singleline","value"=>"\n"),
										array("code"=>"@doubleline","value"=>"\n\n"),
										array("code"=>"@tab","value"=>"\t"),
										array("code"=>"@starall","value"=>"\\*"),
										array("code"=>"@beta","value"=>"\b"),
										array("code"=>"@formfeed","value"=>"\f"),
										array("code"=>"@return","value"=>"\r"),
										array("code"=>"@backshash","code"=>"\\"),
										array("code"=>"@double2","value"=>"\"")),$data);
									})($lValue["data"])
								];
							}
						}
						$editedFile =$this->control->replacer2($replacerArr,$file);
						$missArr=[];
						foreach($this->configuration["sdapp-read-more-keywords"] as $key=>$keyword){
							$missArr[]=[
								"code"=>$keyword,
								"value"=>false
							];
						}
						$editedFile =$this->control->replacer2($missArr,$editedFile);
						return $editedFile;
					},
					"error_message"=>"Read more page missing"
				));
			}
	
	}
	private function wbFooter(){
		    $file=false;
			$page=$this->model->foreignVal(
			"WHERE themeid='".$this->activatedThemeId()."' AND staticpagekey='sdapp_pagefooter2'",
			"sdapppages",
			array(),
			$this->conn()
		);
		if(is_array($page) && count($page)>0){
			$file=$this->pageUrl(0,false,[
			"pageid"=>$page[0],
			"pagekey"=>$page["staticpagekey"],
			"themeid"=>$this->activatedThemeId(),
			"pagename"=>$page["pagename"]
		]);
		}
		return $this->wbFileLoader(array(
			'file'=>$file,
			'error_message'=>'Website footer file is missing'
		));
	}

	private function wbFileLoader($array_arguments=array()){
		if(is_array($array_arguments) && isset($array_arguments['file']) && isset($array_arguments['error_message'])){
			$file=$array_arguments['file'];
			$theme=$this->model->foreignVal(
				"WHERE themeid='".$this->activatedThemeId()."'",
				" sdappthemes",
				array(),
				$this->conn()
			);
			if(file_exists($file)
			){
				$html=false;
				if(isset($array_arguments['func'])){
					$html= $array_arguments['func'](file_get_contents($file));
				}
				else{
					 if(key_exists("default-page",$array_arguments) && $array_arguments["default-page"] === true){
						$html = $this->control->replacer2([
							array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
							["code"=>$this->configuration["default-page-keywords"]["pagetitle"],"value"=>$array_arguments["pageinformation"]["pagename"]],
							["code"=>$this->configuration["default-page-keywords"]["pagecontent"],"value"=>$array_arguments["pageinformation"]["pagecontent"]]
						],file_get_contents($file));
					 }
					 else{
						$html=file_get_contents($file);
					 }
					
				}
				return $this->control->replacer2(
					array(
						array("code"=>$this->configuration["extra-static-block-keywords"]["default-index"],"value"=>"./"),
						array("code"=>"@url","value"=>"themes/".$theme["fileextracted"]."/"),
					)
				,(function($arr,$html){
					if(key_exists("callback",$arr) && is_callable($arr["callback"])){
						if(key_exists("data",$arr)){
							return $arr["callback"]($html,$arr["data"]);
						}
						return $arr["callback"]($html);
					}
					return $html;
				})($array_arguments,$html));
				
			}
			else{
				return $array_arguments['error_message'];
			}
		}
		else{
			if(is_array($array_arguments) && isset($array_arguments['content'])){
				 return $array_arguments['content'];
			}else{
				return 'function miss configuration';
			}
			
		}
		
	}
	private function checkAllSessionAreActivated(){$sessions = $this->model->showColumns($this->conn(),"sdapp_users");
		if(is_null($this->conn())){
			die($this->main->setDatabaseCreditials($possibilityToFindFile =[
				"sdapp-admin/php/sdapp/",
				"php/sdapp/",
				"sdapp/"
			]));
		}
		if(is_array($sessions)){
			$count=count($sessions);$n=0;
			foreach($sessions as $session){if(isset($_SESSION[$session])){$n++;}}if($n === $count){return 1;}}
			return $n;
		}
		
	public function sdapp_login_dashboard($object = false){
		if($this->checkAllSessionAreActivated()>0 
		&& key_exists("SDAPP-USER-SESSION-OPENED",$_SESSION) 
		&& key_exists("USERID",$_SESSION) 
		&& $_SESSION["SDAPP-USER-SESSION-OPENED"] === $_SESSION["USERID"]){
			return $this->view->dashboard($object);
		}
		else{
			return $this->view->loginForm();
		}
	}

	public function indexUrl(){
		return str_replace("index.php",false,$this->control->getValFromExplode("?",$this->control->currentUrl(),0));
	}

	private function sdappConfigurations(){
		return json_decode(file_get_contents((function($baseRoot){
			$posibilitiesRoot=[
				"login"=>"sdapp/sdapp-configurations.json",
				"backend"=>$baseRoot."sdapp-configurations.json",
				"publicindex"=>"sdapp-manager/".$baseRoot."sdapp-configurations.json"
			];
			 $foundRoot=array_filter($posibilitiesRoot,function($value){ return is_file($value);},ARRAY_FILTER_USE_BOTH);
			 if(count($foundRoot)>0){
				return $foundRoot[array_keys($foundRoot)[0]];
			 };

		})($this->baseRoot)),true);
	}

	public function getter(){
		return $this->output;
	}
}
?>