﻿class hotelPlugin{
    constructor(options){
        var gen=options.gen;
        var me=this;
        var lang=options.lang;
        var constructorOptions=options;
        var allVariables={
            lang:lang,
            jsonfile:'nullcms.json',
            mainServerSideClass:'nc-admin/php/?',
            serversideFile:'index.php',
            serverRoot:options.serverroot,
            pluginCode:options.plugincode,
            userid:function(){
                return  gen.url(false,gen.serverSideUrl,{
                    key:`calluserfunctionarray`,
                    class:`control`,
                    method:`userSessionId`,
                    parameters:['']
                },false,1);
            },
            pluginjson:function(url){
                return  gen.url(false,url,{ajaxdatatype:'json'},false,1);
            },
            copyright:`Copyright NULL CMS All Rights Reserved`,
        }
        this.bookingsBlock=function(){
            return gen.block({
                title:'Mes reservations',
                content:me.myBookings().records('all'),
                rightoptions:{
                    title:'Actions',
                    icon:'icon-options icons',
                    submenus:{
                        'availability':{
                            title:'Disponibilités chambres',
                            icon:'fa fa-calendar',
                            callback:function(e,titleSection,contentSection){
                                titleSection.html('Disponibilités chambres');
                                contentSection.html(me.myBookings().availabilityform())
                            }
                        },
                        'newbooking':{
                            title:'Nouvelle reservation',
                            icon:'fa fa-plus',
                            callback:function(e,titleSection,contentSection){
                                titleSection.html('Formulaire reservation');
                                contentSection.html(me.myBookings().form());
                            }
                        },
                        'roombooking':{
                            title:'Reservation chambres',
                            icon:'fa fa-bed',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation chambres');
                                contentSection.html(me.myBookings().records('rooms'));
                            }
                        },
                        'mealbooking':{
                            title:'Reservation repas',
                            icon:'fa fa-spoon',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation repas');
                                contentSection.html(me.myBookings().records('restaurant'));
                            }
                        },
                        'barbooking':{
                            title:'Reservation bar',
                            icon:'fa fa-glass',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation bar');
                                contentSection.html(me.myBookings().records('bar'));
                            }
                        },
                        'propertiesbooking':{
                            title:'Reservation propriétés',
                            icon:'fa fa-universal-access',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation propriétés');
                                contentSection.html(me.myBookings().records('properties'));
                            }
                        }
                    }
                }
            });
        }
        this.myBookings=function(){
            return {
                form:function(){
                    return 'formulaire booking'
                },
                records:function(type){
                    return 'Données booking '+type;
                },
                availabilityform:function(){
                    return 'availability form';
                }
            };
        }

        this.slides=function(options){
            return {
                form:function(){
                    var pluginJson=allVariables.pluginjson(options.rootjson);
                    var text=pluginJson.plugintext.slideform;
                    var lang=allVariables.lang;
                    var tablesObject=me.sqlTables(pluginJson.plugincode);
                    return gen.formTable({
                        fields:[
                            {
                               label:text.label1[lang],
                               input:gen.textBox('slidetitle1','slidetitle1','form-control'),
                               validationwarning:text.warning1[lang],
                               required:true,
                               sqlfield:tablesObject.tables[0].fields[1].field,
                               preventinjection:true
                            },
                            {
                               label:text.label2[lang],
                               input:gen.textBox('slidetitle2','slidetitle2','form-control'),
                               validationwarning:text.warning2[lang],
                               required:true,
                               sqlfield:tablesObject.tables[0].fields[2].field,
                               preventinjection:true
                            },
                            {
                                label:text.label3[lang],
                                input:function(){
                                    var input=gen.textBox('slidephotoid','slidephotoname','form-control')
                                    .attr({type:'file'});
                                    input.on('change',function(e){
                                        gen.takeFile2Server(e,{
                                            dir:`${options.pluginroot}/uploads/`,
                                            value:function(url){
                                                var file=url.split("/").pop();
                                                return `uploads/${file}`
                                            },
                                            display:function(url){
                                                return `soweb/${url}`;
                                            },
                                            extensions:['jpg','jpeg','png','gif'],
                                            requireextension:1,
                                            warningextension:function(message){
                                                swal('alerte',message,'warning');
                                                return false;
                                            }
                                        });
                                    });
                                    return input;
                                },
                                validationwarning:text.warning3[lang],
                                required:true,
                                sqlfield:tablesObject.tables[0].fields[3].field
                             }

                        ],
                        action:'save',
                        sqlfieldid:tablesObject.tables[0].fields[0].field,
                        sqltable:tablesObject.tables[0].tablename,
                        checkschemaandcolumns:false 
                    });
                    
                },
                records:function(){
                    return 'Données slides';
                }
            };
        },
        this.extraServices=function(options){
            return {
              form:function(){
                var pluginJson=allVariables.pluginjson(options.rootjson);
                var tablesObject=me.sqlTables(pluginJson.plugincode);
                var text=pluginJson.plugintext.extraservices;
                var lang=allVariables.lang;
                return gen.formTable({
                    fields:[
                        {
                           label:text.label1[lang],
                           input:gen.textBox('serviceid','servicename','form-control'),
                           validationwarning:text.warning1[lang],
                           required:true,
                           sqlfield:tablesObject.tables[1].fields[1].field,
                           preventinjection:true
                        }

                    ],
                    action:'save',
                    sqlfieldid:tablesObject.tables[1].fields[0].field,
                    sqltable:tablesObject.tables[1].tablename,
                    checkschemaandcolumns:false
                });
                
              },
              records:function(){
                  return 'donnéés type chambre'
              }  
            };
        }
        this.rooms=function(options){
                return {
                form:function(){
                var pluginJson=allVariables.pluginjson(options.rootjson);
                var tablesObject=me.sqlTables(pluginJson.plugincode);
                var text=pluginJson.plugintext.rooms;
                var lang=allVariables.lang;
                return gen.formTable({
                    fields:[
                        {
                           label:text.label1[lang],
                           input:gen.textBox('roomnameid','roomnamename','form-control'),
                           validationwarning:text.warning1[lang],
                           required:true,
                           sqlfield:tablesObject.tables[2].fields[1].field,
                           preventinjection:true
                        },
                        {
                            label:text.label2[lang],
                            input:gen.textArea('roomdescriptionid','roomdescriptionname','none'),
                            validationwarning:text.warning2[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[2].field,
                            preventinjection:true
                         },
                         {
                            label:text.label3[lang],
                            input:function(){
                                return gen.dynamicCheckBoxesSrcJson(
                                    (function(gen){
                                        var data=gen.getObjectFromJSON(gen.url(false,gen.serverSideUrl,{
                                            key:'returnjson',
                                            table:tablesObject.tables[1].tablename,
                                            ref:`WHERE datastatus > 0 ORDER BY ${tablesObject.tables[1].fields[1].field} ASC`,
                                        },false,1));
                                        var json={};
                                        var n=0;
                                        if(data.length>0)
                                        for(var el of data){
                                            n++;
                                            json[n]={
                                                title:el[tablesObject.tables[1].fields[1].field],
                                                value:el[0]
                                            };
                                        }
                                        return json;

                                    })(gen),
                                    'roomserviceid',
                                    'roomservicesname',
                                    'none',
                                    undefined,
                                    null
                                    );
                            },
                            inputtype:'checkbox',
                            validationwarning:text.warning3[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[3].field,
                            preventinjection:true
                         },
                         {
                            label:text.label4[lang],
                            input:gen.textBox('roompriceid','roompricename','none',null,'numeric'),
                            validationwarning:text.warning4[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[4].field,
                            preventinjection:true
                         },
                         {
                            label:text.label5[lang],
                            input:gen.textBox('roomrateid','roomratename','none',null),
                            validationwarning:text.warning5[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[5].field,
                            preventinjection:true
                         },
                         {
                            label:text.label6[lang],
                            input:gen.textBox('roomquantityid','roomquantityname','none',null),
                            validationwarning:text.warning6[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[6].field,
                            preventinjection:true
                         },
                         {
                            label:text.label7[lang],
                            input:gen.textBox('roomrangenumberid','roomrangenumbername','none',null),
                            validationwarning:text.warning7[lang],
                            sqlfield:tablesObject.tables[2].fields[7].field,
                            preventinjection:true
                         },
                         {
                             label:text.label8[lang],
                             input:gen.multipleInputFile({
                                buttontitle:text.labeladdpicture[lang],
                                buttonicon:"fa fa-plus",
                                editvalue:null,
                                sowebname:"multipleroomphoto",
                                label:undefined,
                                title:undefined,
                                labelnamebysowebattr:undefined,
                                editvallabel:undefined,
                                takefile2serverobject:{
                                    dir:`${options.pluginroot}/uploads/`,
                                    value:function(url){
                                        var file=url.split("/").pop();
                                        return `uploads/${file}`
                                    },
                                    display:function(url){
                                        return `${url}`;
                                    },
                                    extensions:['jpg','jpeg','png','gif'],
                                    requireextension:1,
                                    warningextension:function(message){
                                        swal('alerte',message,'warning');
                                        return false;
                                    }
                                }
                             }),
                             inputtype:'multiplefile',
                             validationwarning:text.warning8[lang],
                             required:true,
                             sqlfield:tablesObject.tables[2].fields[8].field,
                             preventinjection:true
                         }

                    ],
                    action:'save',
                    sqlfieldid:tablesObject.tables[2].fields[0].field,
                    sqltable:tablesObject.tables[2].tablename,
                    checkschemaandcolumns:false
                });
                    },
                    records:function(){
                        return 'Data goes here'
                    }
                }
        }
        this.restaurant=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.bar=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.properties=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                },
                manage:function(){
                    return 'xxl';
                }
            };
        }
        this.photogallery=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.testimonials=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.aboutus=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.configurations=function(options){
            var pluginJson=allVariables.pluginjson(options.rootjson);
            var tablesObject=me.sqlTables(pluginJson.plugincode);
            var text=pluginJson.plugintext.configform;
            var lang=allVariables.lang;
            return {
                form:function(){
                    var data=gen.getObjectFromJSON(gen.url(false,gen.serverSideUrl,{
                        key:'returnjson',
                        table:tablesObject.tables[3].tablename,
                        ref:``
                    },false,1));
                    var action;
                    if(data.length<1){
                        data={};
                        action='save';

                    }
                    else{
                        data=data[0];
                        action='edit';
                    }
                    return gen.formTable({
                        fields:[
                            {
                                label:text.label1[lang],
                                input:gen.textBox(
                                    `${tablesObject.tables[3].fields[1].field}id`,
                                    `${tablesObject.tables[3].fields[1].field}name`,
                                    'form-control',
                                    data[tablesObject.tables[3].fields[1].field]
                                    ),
                                validationwarning:text.warning1[lang],
                                required:true,
                                sqlfield:tablesObject.tables[3].fields[1].field,
                                preventinjection:true 
                            },
                            {
                                label:text.label2[lang],
                                input:gen.textBox(
                                    `${tablesObject.tables[3].fields[2].field}id`,
                                    `${tablesObject.tables[3].fields[2].field}name`,
                                    'form-control',
                                    data[tablesObject.tables[3].fields[2].field],
                                    'numeric'
                                    ),
                                validationwarning:text.warning2[lang],
                                required:true,
                                sqlfield:tablesObject.tables[3].fields[2].field,
                                preventinjection:true 
                            },
                            {
                                label:text.label3[lang],
                                input:gen.textBox(
                                    `${tablesObject.tables[3].fields[3].field}id`,
                                    `${tablesObject.tables[3].fields[3].field}name`,
                                    'form-control',
                                    data[tablesObject.tables[3].fields[3].field],
                                    'numeric'
                                    ),
                                validationwarning:text.warning3[lang],
                                required:true,
                                sqlfield:tablesObject.tables[3].fields[3].field,
                                preventinjection:true 
                            },
                            {
                                label:text.label4[lang],
                                input:gen.textBox(
                                    `${tablesObject.tables[3].fields[4].field}id`,
                                    `${tablesObject.tables[3].fields[4].field}name`,
                                    'form-control',
                                    data[tablesObject.tables[3].fields[4].field],
                                    'numeric'
                                    ),
                                validationwarning:text.warning4[lang],
                                required:true,
                                sqlfield:tablesObject.tables[3].fields[4].field,
                                preventinjection:true 
                            }
                        ],
                        action:action,
                        sqlfieldid:tablesObject.tables[3].fields[0].field,
                        idval:data[0],
                        sqltable:tablesObject.tables[3].tablename,
                        checkschemaandcolumns:false,
                        callback:function(){
                            options.menucallback();
                            console.log('kweli kweli kabisa!!!');
                        }
                    });
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.pluginBackEndMenu=function(options){
            var pluginJson=allVariables.pluginjson(options.rootjson);
            var text=pluginJson.plugintext.appmenu;
            var lang=allVariables.lang;
            var menus=[
                {
                    title:text.configuration[lang],
                    callback:function(){
                        options.menucallback=menus[0].callback;
                        options.pluginappsection.html(gen.block({
                            title:text.configform[lang],
                            content:me.configurations(options).form()
                        }));
                    }
                },
                {
                    title:text.slide[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire slide',
                            content:me.slides(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newslide':{
                                        title:'Nouveau slide',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire slide');
                                            contentSection.html(me.slides(options).form());
                                            
                                        }
                                    },
                                    'slides':{
                                        title:'Données slides',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            titleSection.html('Données slides');
                                            contentSection.html(me.slides().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.extraservices[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire service extras',
                            content:me.extraServices(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newtype':{
                                        title:'Nouveau service',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire services extras');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                   'extraServices':{
                                       title:'Données services extras',
                                       icon:'fa fa-database',
                                       callback:function(e,titleSection,contentSection){
                                        e.preventDefault();
                                        titleSection.html('Données services extras');
                                        contentSection.html(me.extraServices(options).records())
                                       }
                                   }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.rooms[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire chambre',
                            content:me.rooms(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newroom':{
                                        title:'Nouvelle chambre',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire chambre');
                                            contentSection.html(me.rooms(options).form())
                                        }
                                    },
                                    'rooms':{
                                        title:'Données chambres',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données chambres');
                                            contentSection.html(me.rooms(options).records())
                                        }
                                    }

                                }
                            }
                        }));
                    }
                },
                {
                    title:text.hallequipement[lang],
                    callback:()=>{
                        options.pluginappsection.html({

                        });
                    }
                },
                {
                    title:text.hall[lang],
                    callback:()=>{
                        options.pluginappsection.html({

                        });
                    }
                },
                {
                    title:text.restaurant[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire restaurant',
                            content:me.restaurant().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newmeal':{
                                        title:'Nouveau repas',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire restaurant');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                    'meals':{
                                        title:'Données restaurant',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données restaurant'),
                                            contentSection.html(me.restaurant().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.bar[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire bar',
                            content:me.bar().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newbevarage':{
                                        title:'Nouvelle produit',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialSection){
                                            e.preventDefault();
                                            titleSection.html('Formulaire bar')
                                            contentSection.html(initialSection)
                                        }
                                    },
                                    'databar':{
                                        title:'Données produits',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données produits'),
                                            contentSection.html(me.bar().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.properties[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire propriétés',
                            content:me.properties().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newproperty':{
                                        title:'Nouvelle propriétés',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialcontent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire propriétés');
                                            contentSection.html(initialcontent)
                                        }
                                    },
                                    'manageproperty':{
                                        title:'Gérer propriétes',
                                        icon:'fa fa-gear',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Gestion propriétés');
                                            contentSection.html(me.properties().manage())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.booking[lang],
                    callback:function(){
                        options.pluginappsection.html(me.bookingsBlock());
                    }
                },
                {
                    title:text.photogalery[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire photo gallerie',
                            content:me.photogallery().form(),
                            rightoptions:{
                                 title:'Actions',
                                 icon:'icon-options icons',
                                 submenus:{
                                     'new':{
                                         title:'Nouvelle photo',
                                         icon:'fa fa-plus',
                                         callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire photo gallerie');
                                            contentSection.html(initialContent);
                                         }
                                     },
                                     'photos':{
                                         title:'Photos',
                                         icon:'fa fa-photo',
                                         callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Photo Gallerie');
                                            contentSection.html(me.photogallery().records())
                                         }
                                     }
                                 }
                            }
                        }));
                    }
                },
                {
                    title:text.testimonials[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire temoignages',
                            content:me.testimonials().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newtestimonial':{
                                        title:'Nouveau temoignage',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire temoignage');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                    'testimonialdata':{
                                        title:'Données temoignages',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données temoignages');
                                            contentSection.html(me.testimonials().records());
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:text.aboutus[lang],
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire apropos de nous',
                            content:me.aboutus().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icon',
                                submenus:{
                                    'newdata':{
                                        title:'Nouvelle donnée',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire apropos de nous'),
                                            contentSection.html(initialContent);

                                        }
                                    },
                                    'aboutusdata':{
                                        title:'Données',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données a propos de nous');
                                            contentSection.html(me.aboutus().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                }
            ];
             options.menusection.html(function(){
                 var blocks=[];
                 menus.forEach(menu => {
                    blocks.push($(gen.createEl('div'))
                    .addClass('hotelbackendmenu')
                    .html(menu.title)
                    .on('click',e=>{
                        menu.callback();
                    }));
                 });
                 return blocks;
             });
        }
        this.init=function(options){
            //create schemas starts
            me.sqlTables(allVariables.pluginjson(options.rootjson).plugincode).createschema();
            //create schemas ends
            var pluginAppSection=$(gen.createEl('div'));
            $(`.${constructorOptions.backendsectionclass}`)
            .html($(gen.createEl("div"))
            .css({float:"left",width:"100%",backgroundColor:"#fff"})
            .html([
                me.style(),
                gen.appWindow({
                showdata:{
                    icon:'fa fa-users',
                    title:'Reservations',
                    id:allVariables.showpluginsbuttonid,
                    callback:function(content){
                        pluginAppSection.html(me.bookingsBlock());
                    }
                },
                title:`Gestionnaire d'hotel`,
                content:gen.floatBlockColumns(gen,{},[
                    {
                        html:function(root,div){
                            me.pluginBackEndMenu({
                                pluginappsection:pluginAppSection,
                                menusection:div,
                                rootjson:options.rootjson,
                                pluginroot:options.pluginroot
                            })
                        },
                        css:{width:'20%'}
                    },
                    {
                        html:pluginAppSection,
                        css:{width:'80%'}
                    }
                ]),
                footer:allVariables.copyright
            })]))
            .css({ 'box-shadow': 'none', 'float': 'left','width':'100%'});
        }

        this.publicPluginUserInterface=function(options){
              console.log(gen.url(false,allVariables.mainServerSideClass,{
                key:`calluserfunctionarray`,
                class:`control`,
                method:`sessionMakerFromObject`,
                parameters:[
                        {
                        option:"page",
                        serverroot:options.serverroot,
                        plugincode:options.plugincode,
                        pluginid:options.pluginid
                    }
                ]
              },false,1));
               var iframe=$(gen.createEl('iframe'));
               iframe.css({
                   width:'100%',
                   border:'none',
                   height:'950px'
               })
               .attr({
                   src:`${options.pluginroot}`
               })
               var div =$(gen.createEl('div'));
                   div
                   .html(iframe)
                   .css({
                    backgroundColor:'#fff',
                    color:'#000',
                    border:'1px #ccc solid',
                    margin:'5px',
                    padding:'5px'
                   });
                   //console.log('counting----index');
                   //console.log(options.pluginindex);
                $(`script[pluginindex="${options.pluginindex}"]`).replaceWith(div);
                
        }
        this.publicPlugins=function(){
                return {
                    booking:{
                        title:'Reservation chambres',
                        key:'roombooking0001'
                    },
                    restaurant:{
                        title:'Restaurant',
                        key:'restaurant0002'
                    },
                    bar:{
                        title:'Bar',
                        key:'bar0003'
                    },
                    halls:{
                        title:"Salles d'événements",
                        key:'properties0004'
                    },
                    properties:{
                        title:'Propriétés',
                        key:'properties005'
                    },
                    properties:{
                        title:'Créer compte',
                        key:'useraccounthotelms0006'
                    },
                    slides:{
                        title:'Slide',
                        key:'slide0007'
                    }  
                };
        }

        this.sqlTables=function(pluginCode){
            let tables=[
                {
                    tablename:`plugin_${pluginCode}_slides`,
                    fields:[
                        {
                            field:'slideid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true
                        },
                        {
                            field:'title1',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'title2',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'photo',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_extraservices`,
                    fields:[
                        {
                            field:'extraserviceid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'extraservice',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_rooms`,
                    fields:[
                        {
                            field:'roomid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'roomname',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomdescription',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomextraservices',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomprice',
                            datatype:'float',
                            null:'NOT NULL'

                        },
                        {
                            field:'roompricerate',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomnqty',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomrangenumber',
                            datatype:'TEXT',
                            null:'NULL'

                        },
                        {
                            field:'roomphotos',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_configurations`,
                    fields:[
                        {
                            field:'configurationid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'hotelname',
                            datatype:'TEXT',
                            null:'NULL'
                        },
                        {
                            field:'hotelnumberofstarts',
                            datatype:'TEXT',
                            null:'NULL'
                        },
                        {
                            field:'hoteladultmaximumnumber',
                            datatype:'TEXT',
                            null:'NULL'
                        },
                        {
                            field:'hotelchildrenmaximumnumber',
                            datatype:'TEXT',
                            null:'NULL'
                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_clientusers`,
                    fields:[
                        {
                            field:'userid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'email',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'password',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'fullname',
                            datatype:'TEXT',
                            null:'NULL'
                        },
                    ],
                    data:[]   
                },
                {
                    tablename:`plugin_${pluginCode}_roombooking`,
                    fields:[
                        {
                            field:'roombookingid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'email',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'roomid',
                            datatype:'INT',
                            null:'NOT NULL'
                        },
                        {
                            field:'checkindate',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'checkoutdate',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'numberofguests',
                            datatype:'INT',
                            null:'NOT NULL'
                        },
                        {
                            field:'numberofadults',
                            datatype:'INT',
                            null:'NOT NULL'
                        },
                        {
                            field:'numberofchildren',
                            datatype:'INT',
                            null:'NOT NULL'
                        }

                    ]
                }
               
            ];
            return {
                tables:tables,
                createschema:function(){
                    gen.url(false,gen.serverSideUrl,{
                        key:`createschemas`,
                        schemas:tables
                    },false,1);
                },
                droptables:function(){
                    var feedBacks=Array();
                    tables.forEach(item=>{
                        feedBacks[feedBacks.length]=gen.url(false,gen.serverSideUrl,{
                            key:`calluserfunctionarray`,
                            class:`model`,
                            method:`dropTable`,
                            parameters:['@conn',item.tablename]
                        },false,1);
                            
                    });
                    //console.log(feedBacks);
                }
            }
            
        }

        this.style=function(){
            return $(gen.createEl('style'))
            .attr({type:'text/css'})
            .html(`
            .hotelbackendmenu{
                padding:5px;
                background-color:#cde4fd;
                margin:3px 0px 3px 0px;
                text-shadow:rgb(255 255 255) 1px 1px;
                cursor:pointer;
                text-transform:capitalize;
                border-left:5px #007bff solid;
            }
            .hotelbackendmenu:hover{
                background-color:#007bff;
                color:#fff;
                text-shadow:none;
                border-left:5px #cde4fd solid;
            }`);
        },
        this._events=function(){
           $(function(){
                $(`button[hmsplugin="bookingnowbtn1"]`).on('click',e=>{
                    e.preventDefault();
                    me.bookNow({
                        type:1,
                        rootjson:allVariables.jsonfile
                    });
                });
           });
        },
        this.bookNow = function(options){
            var pluginJson=allVariables.pluginjson(options.rootjson);
            var text=pluginJson.plugintext.bookingonlineform1;
            var lang=allVariables.lang;
                switch(options.type){
                    case 1:
                    var validation =gen.getInputValueFromValidation([
                        {
                            dom:'input',
                            type:'text',
                            name:'bookingemailname',
                            property:'email',
                            warning:function(){
                                if($('input[name="bookingemailname"]').val().length<1){
                                    $('#message').html(me.warningBlock({
                                        message:text.warning1[lang],
                                        type:'warning'
                                    }));
                                    $('input[name="bookingemailname"]').focus();
                                    return false;
                                }
                                else if(!gen.emailValidation($('input[name="bookingemailname"]').val())){
                                    $('#message').html(me.warningBlock({
                                        message:text.warning3[lang],
                                        type:'warning'
                                    }));
                                    $('input[name="bookingemailname"]').focus();
                                    return false;
                                }
                                else{
                                    return true;
                                }
                            },
                    
                        },
                        {
                            dom:'select',
                            type:'select',
                            name:'bookingroomname',
                            property:'room',
                            warning:function(){
                                $('#message').html(me.warningBlock({
                                    message:text.warning2[lang],
                                    type:'warning'
                                }));
                                $('select[name="bookingroomname"]').focus();
                            }
                        },
                        {
                            dom:'input',
                            type:'text',
                            name:'checkin',
                            property:'checkin',
                            warning:function(){
                                $('#message').html(me.warningBlock({
                                    message:text.warning4[lang],
                                    type:'warning'
                                }));
                                $('select[name="checkin"]').focus();
                            }
                        },
                        {
                            dom:'input',
                            type:'text',
                            name:'checkout',
                            property:'checkout',
                            warning:function(){
                                $('#message').html(me.warningBlock({
                                    message:text.warning5[lang],
                                    type:'warning'
                                }));
                                $('select[name="checkout"]').focus();
                            }
                        }
                    ]);
                    if(validation ==false){return false;}
                    validation.adultmaxnumber=$('select[name="adults"]').val()*1;
                    validation.childrenmaxnumber=$('select[name="children"]').val()*1;
                    validation.guestmaxnumber=(function(divTest,validation){
                        if(validation.adultmaxnumber<1){validation.adultmaxnumber=1;}
                        if(parseInt(divTest)>1){
                            return divTest;
                        }
                        else{
                            var _sum=parseInt(validation.adultmaxnumber) + parseInt(validation.childrenmaxnumber)*1
                            if(_sum<1){
                                return 1;
                            }else{
                                return _sum;
                            }
                        }
                    })($('div#test').html(),validation);
                    var serverResult=gen.url(false,allVariables.serversideFile,{
                        option:'quickbooking',
                        data:validation,
                        ajaxdatatype:'json',
                        serverroot:allVariables.serverRoot,
                        plugincode:allVariables.pluginCode
                    },false,1);
                    console.log(serverResult);
                    if(serverResult.status ==1){
                        $('#message').html(me.warningBlock({
                            message:serverResult.message,
                            type:'success'
                        }));
                        ['bookingemailname','bookingroomname','checkin','checkout','adults','children'].forEach(name=>{
                            $(`input[name="${name}"]`).val("");
                            $(`select[name="${name}"]`).val("");
                        });
                    }
                    else{

                        $('#message').html(me.warningBlock({
                            message:serverResult.message,
                            type:'warning'
                        }));

                    }
                    
                    break;
                }
        },

        this.warningBlock=function(options){
                /*<div class="alert alert-success alert-dismissable">
          <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
          Success, something went well!</div>*/
          var _class="alert alert-success alert-dismissable";
          var type=options.hasOwnProperty('type')?options.type:'none';
          switch(type){
            case 'warning':_class="alert alert-warning alert-dismissable";break;
            case 'error':_class="alert alert-danger alert-dismissable";break;
            case 'success':_class="alert alert-success alert-dismissable";break;
            case 'info':_class="alert alert-info alert-dismissable";break;
          }

          return gen.objectInterfaceMaker([
              {
                  element:'div',
                  attr:{"class":_class},
                  children:[
                     {
                        element:'button',
                        attr:{"type":"button","class":"close","data-dismiss":"alert","aria-hidden":"true"},
                        html:"x"
                     },
                     {
                        html:options.message,
                        element:'warning'
                     }
                      
                  ]
              }
          ]).init();
        }
    }
}
/*
bookingemailname
bookingroomname
bookingmaximumnumberofadultname
*/