<?php
class model2{
	private $sql;
	public function __construct(){
		
	}
	public function selectData($object){
			if(is_object($object) && property_exists($object,"table") && property_exists($object,"conn") && property_exists($object,"clauses")){
				$q = "SELECT * FROM $object->table   $object->clauses  ";
				$query = $object->conn->query($q);
				if(!is_bool($query)){
					return $query->fetchAll();
				}
				else{
					return null;
				}
			}
	}
	public function copyData($options){
		if(is_array($options)
		&& key_exists("conn",$options)
		&& is_object($options["conn"])
		&& key_exists("sourcetableobject",$options)
		&& is_array($options["sourcetableobject"])
		&& key_exists("query",$options["sourcetableobject"])
		&& key_exists("callback",$options["sourcetableobject"])
		&& is_callable($options["sourcetableobject"]["callback"])){
			$conn=$options["conn"];
			$sourcetableobject=$options["sourcetableobject"];
			$query=$sourcetableobject["query"];
			$getData=$conn->query($query)->fetchAll(PDO::FETCH_ASSOC);
			if(is_array($getData) && is_iterable($getData)){
				return $sourcetableobject["callback"]($getData,$options);
			}	
		}
	
	}
	public function multipleInsert($conn,$table,$arrQuery=array()){
		$feedback=[];
		if(is_array($arrQuery) && count($arrQuery)>0){
			$feedback["sql"]=[];
			foreach($arrQuery as $key=>$query){
				$sql=$this->insertQuery($table,$query,$conn);
				if((int)$sql["result"]===1){
					$feedback["sql"][]=[
						"status"=>"success",
						"message"=>"query went successfully",
						"query-index"=>$key
					];
				}
				else{
					$feedback["sql"][]=[
						"status"=>"error",
						"message"=>"an sql error has been encountered",
						"query-index"=>$key,
						"query-sql"=>$query,
						"sql-result"=>$sql["sql"]                   
					];
				}
				
			}
		}
		else{
			$feedback["status"]="Error";
			$feedback["message"]="the variable arrQuery isn't an array! or is definitely empty";
		}
		return json_encode($feedback,JSON_PRETTY_PRINT);
		
	}
	public function formInputs($control,$arrayOptions){
		$input=false;
		$case=isset($arrayOptions['type'])?$arrayOptions['type']:'none';
		switch($case){
			case "textbox":
				$input=$control->domCreateElement('input',[
					"attributes"=>(function($options){if(isset($options["attributes"])&& is_array($options["attributes"])){return $options["attributes"];}else{return [];}})($arrayOptions)
				]);
			break;
			case "dropdown":
				$sqlTable=isset($arrayOptions['sqltable'])?$arrayOptions['sqltable']:false;
				$sqlConn=isset($arrayOptions['sqlconn'])?$arrayOptions['sqlconn']:false;
				$sqlRef=isset($arrayOptions['sqlref'])?$arrayOptions['sqlref']:false;
				$sqlIdField=isset($arrayOptions['sqlidfield'])?$arrayOptions['sqlidfield']:false;
				$sqlOutput=isset($arrayOptions['sqloutputfield'])?$arrayOptions['sqloutputfield']:false;
				$legend=isset($arrayOptions['legend'])?$arrayOptions['legend']:false;
				$options=[$control->domCreateElement('option',["attributes"=>["value"=>""],"content"=>$legend])];
				$q=$sqlConn->query("SELECT * FROM ".$sqlTable." ")->fetchAll();
				if(is_array($q)){
					foreach($q as $value){
						array_push($options,$control->domCreateElement('option',["attributes"=>["value"=>(function($row,$idField){
								if(isset($row[$idField])){
									return $row[$idField];
								}else{
									return $row[0];
								}
						})($value,$sqlIdField)],"content"=>(function($row,$output){
							if(is_array($output)){
									$result=[];
									foreach($output as $field){
										array_push($result,(function($row,$field){
											if(isset($row[$field])){
												return $row[$field];
											}
										})($row,$field));
									}
									return implode(" | ",$result);
							}
							else{
								if(isset($row[$output])){
									return $row[$output];
								}
							}
						})($value,$sqlOutput)]));
					}
				}
				$input=$control->domCreateElement('select',[
					"attributes"=>(function($options){
						if(isset($options['attributes']) && is_array($options['attributes']) ){
							return $options['attributes'];
						}
						else{
							return [];
						}
					})($arrayOptions),
					"content"=>$options
				]);
			break;
			case "staticdropdown":
				$control=array_key_exists("control",$arrayOptions)?$arrayOptions["control"]:false;
				$input=$control->domCreateElement('select',["attributes"=>(function($options){
						if(isset($options['attributes']) && is_array($options['attributes'])){
							return $options['attributes'];
						}
				})($arrayOptions),"content"=>(function($options,$control){
											$content=[];
											if(array_key_exists('options',$options) && is_array($options['options'])){
													foreach($options['options'] as $value){
														array_push($content,$control->domCreateElement('option',[
															"attributes"=>array_key_exists('attributes',$value)?$value['attributes']:[],
															"content"=>array_key_exists('value',$value)?$value["value"]:false
														]));
													}
													return implode("",$content);
											}
				})($arrayOptions,$control)]);
				break;
		}
		return $input;
	}
	public function showColumns($conn=false,$table=false,$getJson=false){
		if(is_null($conn)){return false;}
		$q=$conn->prepare("SHOW COLUMNS FROM ".$table."");
		$q->execute();
		$colums=array();
		while($row=$q->fetch()){
			$colums[]=$row[0];
		}
		if($getJson){
			return json_encode($colums);
		}
		return $colums;
	}
	public function showTables($conn,$getJson=false){
		$q=$conn->prepare("SHOW TABLES");
		$q->execute();
		$tables=array();
		while($row=$q->fetch()){
			$tables[]=$row[0];
			
		}
		if($getJson){
			return json_encode($tables);
		}
		return $tables;
		
		
	}
	public function dropTable($conn=false,$table=false){
		$feedback=array('status'=>'failure codes did not execute','errorcode'=>'-1');
		if($conn && is_string($table)){
			$sqlCodes="DROP TABLE ".$table."";
			$prepare=$conn->query($sqlCodes);
			if(in_array($table,$this->showTables($conn))){
				if(!is_bool($prepare)  && $prepare->execute()){
					$feedback['status']='success';
					$feedback['errorcode']=1;
				}
				else{
					$feedback['status']='failure';
					$feedback['errorcode']=0;
					$feedback['sql']=$sqlCodes;
				}
			}
			else{
					$feedback['status']='Info';
					$feedback['errorcode']=2;
					$feedback['sql']='Table '.$table.' is no longer existed!';
			}
			
			
		}
		return json_encode($feedback);
	}
	public function createSchema($arrParameters=array()){
	 if(!isset($arrParameters['schema']) && !isset($arrParameters['conn']) && !isset($arrParameters['fields'])){return array(
		 'status'=>'Error',
		 'sql'=>'Some parameters are missing',
		 'code'=>'-1'
	 );}
	 $table=$arrParameters['schema'];
	 $conn=$arrParameters['conn'];
	 $fields=$arrParameters['fields'];
	 $getPrimaryKey=function($subQ){
		  if(is_array($subQ)){
			  foreach($subQ as $q){
				 if(isset($q['primarykey'])){
					 return ',PRIMARY KEY (`'.$q['field'].'`)';
				 }
			  }
		  }
	 };

	 $setFieldsAsQueries=function($subQ){
		    $fieldQ=array();
			if(is_array($subQ))
			foreach($subQ as $q){
				$dataType=function($q){
					 if(isset($q['datatype'])){
						    $q['datatype']=strtoupper($q['datatype']);
							switch(strtolower($q['datatype'])){
								case 'int':
									$dType=$q['datatype'].'(11)';
									if(isset($q['length'])){
										$dType=$q['datatype'].'('.$q['length'].')';
									}
									if(isset($q['default'])){
										$dType.=" DEFAULT '".$q['default']."' ";
									}
									if(isset($q['autoincrement'])){
										$dType.=" AUTO_INCREMENT ";
									}
									break;
								case 'text':
									$dType=$q['datatype'];
									break;
								case 'blob':
										$dType=$q['datatype'];
									break;
								case 'varchar':
									$dType=$q['datatype'].'(255)';
									if(isset($q['length'])){
										$dType=$q['datatype'].'('.$q['length'].')';
									}
									if(isset($q['default'])){
										$dType.=" DEFAULT '".$q['default']."' ";
									}
									break;
								default:
										$dType=$q['datatype'];
										if(isset($q['default'])){
											$dType.=" DEFAULT '".$q['default']."' ";
										}
								break;
							}

							
							if(isset($q['null'])){
								$dType.=' '.$q['null'];		
							}
							else{
								$dType.=' NOT NULL';
							}
							return $dType;
					 }
				};

				$fieldQ[]="`".$q['field']."` ".$dataType($q);
			}
			return implode(',',$fieldQ);//join(del,arr);
	 };
	 $sqlCodes="CREATE TABLE IF NOT EXISTS `".$table."` (".$setFieldsAsQueries($fields)." ".$getPrimaryKey($fields).") ENGINE = MyISAM";
	 $query=$conn->prepare($sqlCodes);
	 if($query->execute()){
		 return array('status'=>'success','errorcode'=>1);
	 }
	 else{
		 return array('status'=>'Failure','sql'=>$sqlCodes,'errorcode'=>0);
	 }
	}

	public function user($userid,$conn){
		return $this->foreignVal(
			'WHERE userid="'.$userid.'"',
			'tblusers',
			'fullname',
			$conn
			);
	}
	public function addExtraRows($conn,$tableRestricted=array()){
		if(is_null($conn)){return false;}
		$q=$conn->query("SHOW TABLES")->fetchAll();
		foreach($q as $key=>$value){
			if(count($tableRestricted)>0 && !in_array($value[0],$tableRestricted)){
				$this->addExtraRowExecute($value[0],$conn);
			}
			else{
				$this->addExtraRowExecute($value[0],$conn);
			}
		}

	}
	private function addExtraRowExecute($table,$conn){
		$q2=$conn->query("SHOW COLUMNS FROM ".$table." ")->fetchAll();
		$lastcol=end($q2);
		$cols=array(
			array(
				'Field'=>'createdby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'modifiedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'deletedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'createdon',
				'Datatype'=>'DATETIME',
				'Default'=>'CURRENT_TIMESTAMP'
				),
			array(
				'Field'=>'datastatus',
				'Datatype'=>'INT',
				'Default'=>1
				),
			array(
				'Field'=>'synchronizationtoken',
				'Datatype'=>'VARCHAR(255)',
				'Default'=>"'none'"
				),
			array(
				'Field'=>'offlinesite',
				'Datatype'=>'VARCHAR (255)',
				'Default'=>"'defaultsite'"
				),
			array(
				'Field'=>'offlinecreatedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'offlinemodifiedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'offlinedeletedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'offlinecreatedon',
				'Datatype'=>'DATETIME',
				'Default'=>'CURRENT_TIMESTAMP'
				),
				
			array(
				'Field'=>'datacategorization',
				'Datatype'=>'VARCHAR (255)',
				'Default'=>"'offline'"
				)
			);
			
			///ALTER TABLE `tblcategories` ADD `xx` INT NOT NULL DEFAULT '0' AFTER `categorie`;
			$addDefault=false;
			
			foreach($cols as $fieldObject){

				if(!in_array($fieldObject['Field'],$q2)){
					$addDefault=isset($fieldObject['Default'])
					?"DEFAULT ".$fieldObject['Default']." "
					:false;
					$conn->prepare("ALTER TABLE $table ADD ".$fieldObject['Field']." ".$fieldObject['Datatype']." NOT NULL ".$addDefault." AFTER `".$lastcol['Field']."`")->execute();
					$lastcol=array('Field'=>$fieldObject['Field']);
				}
			}
			
	}
	/*
	private function addExtraRowExecute($table,$conn){
		$q2=$conn->query("SHOW COLUMNS FROM ".$table." ")->fetchAll();
		$lastcol=end($q2);
		$cols=array(
			array(
				'Field'=>'createdby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'modifiedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'deletedby',
				'Datatype'=>'INT',
				'Default'=>0
				),
			array(
				'Field'=>'createdon',
				'Datatype'=>'DATETIME',
				'Default'=>'CURRENT_TIMESTAMP'
				),
			array(
				'Field'=>'datastatus',
				'Datatype'=>'INT',
				'Default'=>1
				)
			);
			
			///ALTER TABLE `tblcategories` ADD `xx` INT NOT NULL DEFAULT '0' AFTER `categorie`;
			foreach($cols as $fieldObject){
				if(!in_array($fieldObject['Field'],$q2)){
					$conn->prepare("ALTER TABLE $table ADD ".$fieldObject['Field']." ".$fieldObject['Datatype']." NOT NULL DEFAULT ".$fieldObject['Default']." AFTER `".$lastcol['Field']."`")->execute();
					$lastcol=array('Field'=>$fieldObject['Field']);
				}
			}
			
	}
	*/
	public function sumRows($conn,$tbl,$ref,$fieldToSum)
	{
		$q=$conn->prepare("SELECT SUM(".$fieldToSum.") AS newFielSumed FROM ".$tbl." ".$ref."");
		$q->execute();
		$row=$q->fetch();
		return isset($row['newFielSumed']) && $row['newFielSumed']>0?$row['newFielSumed']:0;
	}
		private function filterDuplication($conn,$table,$arr,$filterduplicationsqlfiedreference,$dataKeys){
		
			$singleData = [];
			$temporarySelfDB = [];
			foreach($arr as $k=>$d){
				if($filterduplicationsqlfiedreference !== false && isset($d[$filterduplicationsqlfiedreference])){
					//keys searching starts
					$keys = (function($d,$filterduplicationsqlfiedreference,$dataKeys,$temporarySelfDB){
						$keys = [];
						$tempData = [];
						$duplicationFound = 0;
						foreach(json_decode($d[$filterduplicationsqlfiedreference]) as $key=>$value){
							array_push($keys,$key);
							if(in_array($key,$dataKeys)){
								$tempData[] = trim(strtolower($value));
							}

						};
						if(is_array($temporarySelfDB) && count($temporarySelfDB) > 0){
							$countExceptationMatch = count($tempData);
							for($i = 0; $i < count($temporarySelfDB); $i++){
								$countDuplication = 0;
								$existingData = $temporarySelfDB[$i];
								for($j = 0; $j < count($temporarySelfDB[$i]); $j++){
									if(in_array(trim(strtolower($temporarySelfDB[$i][$j])),$tempData)){
										$countDuplication ++;
									}
								}
								if($countDuplication === $countExceptationMatch){
									$duplicationFound ++;
								}
								else{
									continue;
								}
								
							}
						}
						return [
							"keys"=>$keys,
							"tempdata"=>$tempData,
							"duplication"=>$duplicationFound
						];
					})($d,$filterduplicationsqlfiedreference,$dataKeys,$temporarySelfDB);
					$temporarySelfDB[]= $keys["tempdata"];
					if($keys["duplication"] < 1){
						$singleData[] = $d;
						$this->updataQuery(
							$table,
							array(
								"datastatus"=>1
							),
							$conn,
							$_REQUEST["primarykey"],
							$d[0]
						);
					}
					
				}
			}
			return [
				"data"=>$singleData,
				"count"=>count($singleData)
			];
		
	}
	public function returnJSON($table,$ref,$conn,$json=true,$fields='*'){
		$filterbycolumnversionii = isset($_REQUEST["filterbycolumnversionii"])?$_REQUEST["filterbycolumnversionii"]:false;
		$filterduplication = isset($_REQUEST["filterduplication"])?$_REQUEST["filterduplication"]:false;
		$filterduplicationsqlfiedreference = isset($_REQUEST["filterduplicationsqlfiedreference"])?$_REQUEST["filterduplicationsqlfiedreference"]:false;
		$dataKeys = isset($_REQUEST["datakeys"])?$_REQUEST["datakeys"]:false;
		if(is_array($fields)){
			$selectField=false;
			foreach($fields as $key=>$value){
				$selectField.=$value.',';
			}
			$selectField=substr($selectField,0,-1);
		}
		else{
			$selectField=$fields;
		}
		$datapaginated = false;
		if(key_exists("datapaginated",$_REQUEST)){$datapaginated = $_REQUEST["datapaginated"];}
		$countMaxRecord=$this->countRowsV2($conn,$table,$ref);
		$maxRecord=key_exists("maxrecord",$_REQUEST)?$_REQUEST["maxrecord"]:1000;
		$pageVal=key_exists("selectedpage",$_REQUEST)?(int)$_REQUEST["selectedpage"]:1;
		$paginationLength = key_exists("paginationlength",$_REQUEST)?$_REQUEST["paginationlength"]:5;
		(int) $startPagination=0; (int) $endPagination=$paginationLength;
		if($pageVal>$paginationLength){(int) $startPagination=$paginationLength; (int) $endPagination=$pageVal +$paginationLength;}
		$sql=$conn->prepare("SELECT COUNT(*)  FROM ".$table." ".$ref."");
		$bigQuery = $conn->query("SELECT * FROM ".$table." ".$ref."")->fetchAll();
		$sql->execute();
		$dataCount=$sql->rowCount();
		list($total) =$sql->fetch(PDO::FETCH_NUM);
		$totalPage = ceil($total / $maxRecord);
		$page = intval(@$pageVal);
		if (0 === $page){
			$page = 1;
		}
		$start=$maxRecord * ($page - 1);
		$query = "SELECT ".$selectField." FROM ".$table." ".$ref." LIMIT ".$start.", ".$maxRecord."";
		$arr=$conn->query($query)->fetchAll();

		if(key_exists("searchjsondata",$_REQUEST)){
			$searchParameters = $_REQUEST["searchjsondata"];
			$keys = $searchParameters["columnkeys"];
			$keyword = strtolower($searchParameters["keyword"]);
			$sqlfield = $searchParameters["sqlfield"];
			$newArr = [];
			$sqlStrings =[];
			$foundProbalities = [];
			$found=0;
			foreach($arr as $row){
				if(key_exists($sqlfield,$row)){
					$jsonData = json_decode($row[$sqlfield]);
					foreach($keys as $key){
						if(is_object($jsonData)){
							if(property_exists($jsonData,$key)){
								$sqlString = strtolower($jsonData->$key);
								if(strpos($sqlString,$keyword)>-1){
									$found = 1;
								}
							}
						}
						
					}

					if($found > 0){$newArr[]=$row;}
					$found = 0;
				}
			} 
			$arr = $newArr;
		}

		if($json === true){
			$defaultArray = $arr;
			if($filterduplicationsqlfiedreference !== false){
				$result = json_encode($this->filterDuplication($conn,$table,$arr,$filterduplicationsqlfiedreference,$dataKeys)["data"]);
			}
			else{
				$result= json_encode($arr);
			}
			
		}
		else{
			$result=$arr;
		}
		if($filterbycolumnversionii!== false){
			if(is_array($filterbycolumnversionii)){
				$result = $arr;
				switch($filterbycolumnversionii["type"]){
					case "dropdown":
						$dropdownArrayData = [];
						$column = $filterbycolumnversionii["column"];
						$value = $filterbycolumnversionii["value"];
						$valueText = strtolower($filterbycolumnversionii["valuetext"]);
						foreach($result as $row){
						   $dj = json_decode($row["data"]);
							if(property_exists($dj,$column) && is_string($dj->$column) && strpos(strtolower($dj->$column),$valueText) > -1 ){
								$dropdownArrayData[] = $row;
							}
							if(property_exists($dj,$column) && is_object($dj->$column) && strtolower($dj->$column->fkid) === $value){
								$dropdownArrayData[] = $row;
							}
						}
						$result = json_encode($dropdownArrayData);
						$arr = $dropdownArrayData;
					break;
					case "fileexisting":
						$column = $filterbycolumnversionii["column"];
						$value = $filterbycolumnversionii["value"];
						$fileExisting = [];
						$fileExists = function($file){
							$file = "../".$file;
							if(file_exists($file)){
								return true;
							}
							return false;
						};
						foreach($defaultArray as $row){
							$dj = json_decode($row["data"]);
							if($value === "missingfile"){
								if(property_exists($dj,$column) && $fileExists($dj->$column) === false){
									$fileExisting[] = $row;
								}
							}
							else{
								if(property_exists($dj,$column) && $fileExists($dj->$column) === true){
									$fileExisting[] = $row;
								}
							}
						}
						$result = json_encode($fileExisting);
						$arr = $fileExisting;
					break;
				}
			}
		}
		//$result=[];
		if($datapaginated === false ||  $datapaginated === "false"){return $result;}
		return json_encode([
			"datapaginated"=>$datapaginated,
			"data"=>$result,
			"npages"=>$totalPage,
			"ref"=>$ref,
			"table"=>$table,
			"query"=>$query,
			"count-max-record"=>$countMaxRecord,
			"max-record-per-page"=>count($arr),
			"selected-page"=>$pageVal,
			"pagination-length"=>$paginationLength,
			"start-pagination"=>$startPagination,
			"end-pagination"=>$endPagination,
			"version2"=>$filterbycolumnversionii
		   ]);
	}
	/*
	public function returnJSON($table,$ref,$conn,$json=true,$fields='*'){
		if(is_array($fields)){
			$selectField=false;
			foreach($fields as $key=>$value){
				$selectField.=$value.',';
			}
			$selectField=substr($selectField,0,-1);
		}
		else{
			$selectField=$fields;
		}
		$datapaginated = false;
		if(key_exists("datapaginated",$_REQUEST)){$datapaginated = $_REQUEST["datapaginated"];}
		$countMaxRecord=$this->countRowsV2($conn,$table,$ref);
		$maxRecord=key_exists("maxrecord",$_REQUEST)?$_REQUEST["maxrecord"]:1000;
		$pageVal=key_exists("selectedpage",$_REQUEST)?(int)$_REQUEST["selectedpage"]:1;
		$paginationLength = key_exists("paginationlength",$_REQUEST)?$_REQUEST["paginationlength"]:5;
		(int) $startPagination=0; (int) $endPagination=$paginationLength;
		if($pageVal>$paginationLength){(int) $startPagination=$paginationLength; (int) $endPagination=$pageVal +$paginationLength;}
		$sql=$conn->prepare("SELECT COUNT(*)  FROM ".$table." ".$ref."");
		$sql->execute();
		$dataCount=$sql->rowCount();
		list($total) =$sql->fetch(PDO::FETCH_NUM);
		$totalPage = ceil($total / $maxRecord);
		$page = intval(@$pageVal);
		if (0 === $page){
			$page = 1;
		}
		$start=$maxRecord * ($page - 1);
		$query = "SELECT ".$selectField." FROM ".$table." ".$ref." LIMIT ".$start.", ".$maxRecord."";
		$arr=$conn->query($query)->fetchAll();

		if(key_exists("searchjsondata",$_REQUEST)){
			$searchParameters = $_REQUEST["searchjsondata"];
			$keys = $searchParameters["columnkeys"];
			$keyword = strtolower($searchParameters["keyword"]);
			$sqlfield = $searchParameters["sqlfield"];
			$newArr = [];
			$sqlStrings =[];
			$foundProbalities = [];
			$found=0;
			foreach($arr as $row){
				if(key_exists($sqlfield,$row)){
					$jsonData = json_decode($row[$sqlfield]);
					foreach($keys as $key){
						if(is_object($jsonData)){
							if(property_exists($jsonData,$key)){
								$sqlString = strtolower($jsonData->$key);
								if(strpos($sqlString,$keyword)>-1){
									$found = 1;
								}
							}
						}
						
					}

					if($found > 0){$newArr[]=$row;}
					$found = 0;
				}
			} 
			$arr = $newArr;
		}

		if($json==true){
			$result= json_encode($arr);
		}
		else{
			$result=$arr;
		}
		if($datapaginated === false ||  $datapaginated === "false"){return $result;}
		return json_encode([
			"datapaginated"=>$datapaginated,
			"data"=>$result,
			"npages"=>$totalPage,
			"ref"=>$ref,
			"table"=>$table,
			"query"=>$query,
			"count-max-record"=>$countMaxRecord,
			"max-record-per-page"=>count($arr),
			"selected-page"=>$pageVal,
			"pagination-length"=>$paginationLength,
			"start-pagination"=>$startPagination,
			"end-pagination"=>$endPagination
		   ]);
	}
	*/
	public function insertQuery($tableName,$objectColsAndData,$conn,$writeSql=false,$control=false){
		if(is_array($objectColsAndData)){
			$n=0;
			$primaryKey=false;
			$query="INSERT INTO ".$tableName." SET ";
			$fieldsAndValues =[];
			foreach($objectColsAndData as $name=>$value){
			$n++;if($n===1){$primaryKey=$name;}else{array_push($fieldsAndValues,$name."=:".$name);}
			}
			$query.=implode(",",$fieldsAndValues);
			try{
			$q=$conn->prepare($query);
			$n = 0;
			foreach($objectColsAndData as $name=>$value){
				if(is_object($value)){
					$value = json_encode($value);
				}
				$n++;
				if($n > 1){
					$q->bindValue(":".$name, (function($v){
						if(is_array($v)){
							return json_encode($v);
						}
						return $v;
					})($value), PDO::PARAM_STR);
				}
				
			}
			 $exec = $q->execute() or die(print_r($q->errorInfo(), true));
			if($exec===true){
				if($writeSql==true && $control==true){
						$subdir="create";
					    $filename="offlinedata/".$subdir."/".$tableName.".sql";
					    $control->mkFile($filename,$query,1,"a");
				}
				
				$lastRecordId=$this->foreignVal(
					"ORDER BY ".$primaryKey." DESC LIMIT 1",
					$tableName,
					array(),
					$conn
				);
				return array(
					"result"=>1,
					"lastid"=>$lastRecordId[0],
					"sql"=>$query
				);
			}
			else{
				return array("result"=>0,"sql"=>$query,"error"=>$exec);
			}	
			}catch(PDOException $e){
				return $e->getMessage();
			}
		}
	}
	
	public function updataQuery($tableName,$objectColsAndData,$conn,$idField,$idVal){
		if(is_array($objectColsAndData)){
			$n=0;
			$chain=false;
			$query='UPDATE '.$tableName.' SET ';
			$fieldsAndValues =[];
			foreach($objectColsAndData as $field=>$value){
				array_push($fieldsAndValues,$field."=:".$field);
			}

			if(isset($_REQUEST["ref"])){
				$ref=$_REQUEST["ref"];
			}else{
				$ref=' WHERE '.$idField.'='.$idVal;
			}
			$query.= implode(",",$fieldsAndValues)." ".$ref;
			try{
			$q=$conn->prepare($query);
			foreach($objectColsAndData as $name=>$value){
					$q->bindValue(":".$name, (function($v){
						if(is_array($v)){
							return json_encode($v);
						}
						return $v;
					})($value), PDO::PARAM_STR);
			}
			$exec = $q->execute() or die(print_r(json_encode($q->errorInfo()).json_encode($query), true));
			if($exec === true){
				return 1;
			}
			else{
				return $query;
			}	
			}catch(PDOException $e){
				return $e->getMessage();
			}
		}
	}
	
	public function simpleDeletion($conn,$ref,$table){
		$q=$conn->prepare("DELETE FROM ".$table." ".$ref."");
		$q->execute();
		
	}
	public function readRowFromArray($array,$row){
		if(is_array($array)){
			$result=false;
			foreach($array as $field){
				$result.=isset($row[$field])?$row[$field].' ':false;
			}
			return $result;
		}
	}
	public function countRowsV2($conn,$tbl,$ref)
	{
		$newQ =$conn->prepare("SELECT COUNT(*) FROM ".$tbl." ".$ref."");
		$newQ->execute();
	    $read=$newQ->fetch(PDO::FETCH_NUM);
		return $read[0];
	}
	
	public function sqlOr($conn,$table,$ref,$orField,$mixer=false){
		$this->sql=$conn->prepare("SELECT * FROM ".$table." ".$ref."");
		$this->sql->execute();
		$query=false;
		while($row=$this->sql->fetch()){
				if($mixer===false){
				$query.=isset($row[$orField])?"$orField=".$row[$orField]." OR ":false;
				}
				else{
				$query.=isset($row[$orField])?"$orField=".$row[$orField]." AND ".$mixer." OR ":false;	
				}
		}
		return $query==true?'WHERE '.substr($query,0,-3):false;
		
		
		
	}
	public function getTableFields($conn,$table,$getFieldAsArray=false){
		try{
			$fields=array();
			$this->sql=$conn->prepare("SHOW COLUMNS FROM ".$table."");
			$this->sql->execute();
			$sqlFields=false;
			$pk=false;
			$j=0;
			$fieldAsArray=array();
			while($row=$this->sql->fetch()){
			$j++; if($j==1)$pk=$row['Field'];
			$sqlFields.=$row['Field'].',';	
			$fieldAsArray[]=$row['Field'];
			}
			$fields['fields']=is_array($getFieldAsArray)?$fieldAsArray:substr($sqlFields,0,-1);
			$fields['primarykey']=$pk;
			$fields['length']=$j;
			return $fields;
				
		}
		catch(PDOException $e){
			return $e->getMessage();
			
		}
	}
	public function foreignVal($ref,$table,$result,$conn=false,$base64decode=false,$getRow=false){
		//return json_encode($result);
		set_time_limit(0);
		if(is_object($conn) && $conn==true){
		$this->sql=$conn->prepare("SELECT * FROM ".$table." ".$ref."");
		$this->sql->execute();
		$row=$this->sql->fetch();
		if($getRow === true){
			return $row;
		}
		$returnedVal=false;
		if(is_array($result)){
			$data=$this->getTableFields($conn,$table,array());
			$result=$data['fields'];
		}
		if(is_array($result)){
			$returnedVal=array();
			$c=0;
			$index=-1;
			foreach($result as $single){
				$c++;
				$index++;
				if(isset($row[$single])){
					if($base64decode==true){
						$returnedVal[$single]=$c>1?base64_decode($row[$single]):$row[$single];
						$returnedVal[$index]=$c>1?base64_decode($row[$single]):$row[$single];
					}
					else{
						$returnedVal[$single]=$row[$single];
						$returnedVal[$index]=$row[$single];
					}
				}
			}
		}
		else{
		$returnedVal= isset($row[$result])?$row[$result]:false;
		}
		return is_array($returnedVal)?$returnedVal:stripslashes($returnedVal);
		}
	}
	public  function foreignValFromStringSeparatedByComma($conn,$table,$sqlField,$string,$result){
		$data=false;
		$exp=explode(',',$string);
		foreach($exp as $single){
			$data.=$this->foreignVal('WHERE '.$sqlField.'="'.$single.'"',$table,$result,$conn).',';
		}
		return ($data==true)?substr($data,0,-1):$data;
	}
}
?>