class sdapp_application_maker{
    constructor(sdapp){
        let allVariables = sdapp.allvariables;
        let gen = sdapp.gen;
        let me = this;
        this.init = (options)=>{
            let text = options.textjson;
            sdapp.replaceScriptWithUI({
                scriptid: options.scriptid,
                title: text["application-maker-title"][allVariables.lang],
                textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        applicationlist: {
                            icon: "fa fa-circle-o",
                            title: text["all-applications"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-application-lists"
                                });
                            }
                        },
                        addapplication: {
                            icon: "fa fa-plus",
                            title: text["create-application"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-create-customized-app"
                                });
                            }
                        }

                    }
                },
                html: () => {
                    return me.newApplicationMakerUI(options);
                }
            });
            $('[data-toggle="tooltip"]').tooltip();
        }

        this.applicationLists = (options)=>{
            const text = options.textjson;
            const themeId = options.themeid;
            const __objects = {
                applications: (__functionOptions) =>{
                    return gen.dynamicTable({
                        tablesectionid:__functionOptions.showrecordsid,
                        lang:allVariables.lang,
                        maxrecord:10,
                        emptyrows:4,
                        searchsqlfields:["applicationname","organization"],
                        searchreference: (keyword)=>{
                            return `WHERE themeid='${themeId}' AND applicationname LIKE '%${keyword}%' AND  datastatus>0 ORDER BY applicationname ASC`;
                        },
                        userid:allVariables.userid,
                        primarykey:`blockid`,
                        restorerecords:(o=>{if(o instanceof Object && o.hasOwnProperty("restore")){return true;}return false;})({}),
                        selectedpage:1,
                        paginationlength:5,
                        lang:allVariables.lang,
                        thead: [
                            {
                                title: text["application"]["table-th"]["th-1"][allVariables.lang],
                            },
                            {
                                title: text["application"]["table-th"]["th-2"][allVariables.lang],
                            }
                        ],
                        headertype: 2,
                        table:"sdapp_application_maker",
                        ref: `WHERE  themeid = "${themeId}" AND datastatus > 0 ORDER BY applicationname`,
                        fkobjects: {},
                        cols: [
                            {
                                parentfield: false,
                                field: "applicationname",
                                resultlevel: 0,
                                callback: function (value) {
                                    return gen.jsonCharReplacer(value, -1);
                                }
                            },
                            {
                                parentfield: false,
                                field: "organization",
                                resultlevel: 0,
                                callback: function (value) {
                                    return gen.jsonCharReplacer(value, -1);
                                }
                            }
                        ],

                        editaction: function () { return false; },
                        actionbuttons: {
                            edit: false,
                            delete: false
                        },
                        optionsbtntype: 2,
                        extratoptions: function (row) {
                            return {
                                export:{
                                    title:text["application"]["td-options"]["export"][allVariables.lang],
                                    icon:"icon-cloud-download",
                                    callback: (e) =>{
                                        e.preventDefault();
                                        me.applicationExporting({
                                            row:row,
                                            text:text
                                        });
                                    }
                                },
                                view:{
                                    title:text["application"]["td-options"]["view"][allVariables.lang],
                                    icon:"icon-eye icons",
                                    callback:()=>{
                                        me.applicationView({
                                            row:row,
                                            text:text
                                        });
                                    }
                                },
                                setmenu:{
                                    title:text["application-menu-setting"][allVariables.lang],
                                    icon:"icon-menu icons",
                                    callback: e =>{
                                        e.preventDefault();
                                        sdapp.editSmartUrl({
                                            encription: text["url-encription-page-id"],
                                            id: row[0],
                                            name: row["applicationname"],
                                            urlkey: "sdapp-set-menu-application-id"
                                        }).url();
                                        me.menuSetting({
                                            row:row,
                                            text:text,
                                            scriptid:options.scriptid
                                        });
                                    }
                                },
                                edit: {
                                    title: text["application"]["td-options"]["edit"][allVariables.lang],
                                    icon: "icon-pencil icons",
                                    action: function () {
                                        sdapp.editSmartUrl({
                                            encription: text["url-encription-page-id"],
                                            id: row[0],
                                            name: row["applicationname"],
                                            urlkey: "sdapp-create-customized-app-id"
                                        }).url();
                                        me.init({
                                            row: row,
                                            themeid: themeId ,
                                            textjson:text,
                                            scriptid:options.scriptid
                                        });
                                    }
                                },
                                delete:{
                                    title:text["application"]["td-options"]["delete"][allVariables.lang],
                                    icon:"icon-trash icons",
                                    callback: function(e){
                                        const action = function(){
                                            me.deleteApplication({
                                                row:row
                                            });
                                            $(e.target).parents("tr").remove();
                                        };
                                        gen.sweetWarningMsgBox(
                                            action,
                                            text["alert"][allVariables.lang],
                                            text["delete-application-warning"].warning,
                                            text["delete-application-success"].success,
                                            text["sdapp-no-action-done"][allVariables.lang]
                                        );
                                    }
                                }
                            }
                        }

                    });
                }
            };
            sdapp.replaceScriptWithUI({
                scriptid: options.scriptid,
                title: text["sdapp-application-lists"][allVariables.lang],
                textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        addapplication: {
                            icon: "fa fa-plus",
                            title: text["create-application"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-create-customized-app"
                                });
                            }
                        },
                        applicationlist: {
                            icon: "fa fa-circle-o",
                            title: text["all-applications"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-application-lists"
                                });
                            }
                        }

                    }
                },
                html: (sel) => {
                    const selId =`show-application-random${gen.random(8)}`;
                    $(sel).attr("id",selId);
                    options.showrecordsid = selId;
                    return __objects.applications(options);
                }
            });
        }
        this.deleteApplication = (__methodOptions)=>{
            const row = __methodOptions.row;
            gen.url(false, gen.serverSideUrl, {
                key: "sqledit",
                table: "sdapp_application_maker",
                fieldandvalues: {
                    datastatus: 0
                },
                referencefield:"applicationid",
                referenceid: row[0]
            }, false, 1);
        }
        this.viewPhoto = (__methodOptions) =>{
            const text = __methodOptions.text;
            const Image = $(gen.createEl("img"));
            Image.attr({
                src:__methodOptions.url,
                class:"img-responsive"
            })
            .css({
                width:"100%",
                cursor:"pointer"
            })
            .on("click",e=>{
                e.preventDefault();
                gen.closeModal();
            });
            const footer = text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate());
            gen.modalBoxUI({
                modalid: "sdapp-default-size-modal",
                title:__methodOptions.themename,
                content:Image,
                footer:footer
            });
        }
        this.newApplicationMakerUI = (__methodOptions)=>{
                const themeId = __methodOptions.themeid;
                const text = __methodOptions.textjson;
                const applicationRow = __methodOptions.row;
                const table = $(gen.createEl("table"));
                let rows = [];
                rows[rows.length] = gen.tableRow([
                    {
                        html: () =>{
                            const frontEndThemes = gen.getObjectFromJSON(gen.url(
                                false, gen.serverSideUrl, {
                                key: "returnjson",
                                table: "sdappthemes",
                                ref: `WHERE datastatus > 0`,
                                getter: true
                            }, false, 1));
                            const editedvalue =  typeof(applicationRow) ==="object" && applicationRow.frontendthemeid !== undefined ? applicationRow.frontendthemeid : themeId;
                            return gen.dropDownFromArray({
                                legend:text["select-fron-end-theme"][allVariables.lang],
                                attr:{
                                    class:"form-control",
                                    name:"application-front-end-theme"
                                },
                                css:{
                                    width:"100%"
                                },
                                array:frontEndThemes,
                                id:"themeid",
                                output:"theme",
                                editedvalue:editedvalue,
                                onchange:e=>{
                                    const frontEndTheme = frontEndThemes.filter(item=>{ return parseInt(item[0]) === parseInt(e.target.value);});
                                    let  url = frontEndTheme[0].themephoto;
                                    if(url.indexOf("themes/") > -1){
                                        url = `../${url}`;
                                    }
                                    const themename = frontEndTheme[0].theme;
                                    me.viewPhoto({
                                        url:url,
                                        themename:themename,
                                        text:text
                                    });
                                }
                            });
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            const editedvalue =  typeof(applicationRow) ==="object" && applicationRow.backendthemeid !== undefined ? applicationRow.backendthemeid : 1;
                            return  gen.dropDownFromArray({
                                legend:text["select-back-end-theme"][allVariables.lang],
                                attr:{
                                    class:"form-control",
                                    name:"application-back-end-theme"
                                },
                                css:{
                                    width:"100%"
                                },
                                array:text["backend-themes"],
                                id:"themekey",
                                output:"themename",
                                editedvalue:parseInt(editedvalue),
                                onchange:e=>{
                                    const backEndTheme = text["backend-themes"].filter(item=>{ return parseInt(item["themekey"]) === parseInt(e.target.value);});
                                    let  url = backEndTheme[0].themephoto;
                                    if(url.indexOf("themes/") > -1){
                                        url = `../${url}`;
                                    }
                                    const themename = backEndTheme[0].themename;
                                    me.viewPhoto({
                                        url:url,
                                        themename:themename,
                                        text:text
                                    });
                                }
                            });
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-organization-id",
                                "application-organization-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.organization !== undefined ? applicationRow.organization : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-organization-name"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-organization-website-id",
                                "application-organization-website-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.organizationwebsite !== undefined ? applicationRow.organizationwebsite : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-organization-website"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-name-id",
                                "application-name-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationname !== undefined ? applicationRow.applicationname : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-name"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-website-id",
                                "application-website-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationwebsite !== undefined ? applicationRow.applicationwebsite : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-website"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-login-page-title-id",
                                "application-login-page-title-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationloginpagetitle !== undefined ? applicationRow.applicationloginpagetitle : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-login-page-title"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);

                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textBox(
                                "application-dashboard-page-title-id",
                                "application-dashboard-page-title-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationdashboardpagetitle !== undefined ? applicationRow.applicationdashboardpagetitle : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-dashboard-page-title"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);

                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textArea(
                                "application-description-1-id",
                                "application-description-1-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationdescription_1 !== undefined ? applicationRow.applicationdescription_1 : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-description-1"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return $(gen.textArea(
                                "application-description-2-id",
                                "application-description-2-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.applicationdescription_2 !== undefined ? applicationRow.applicationdescription_2 : null
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-description-2"][allVariables.lang]
                                })
                                .addClass("form-control");
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return sdapp.getMediaFilesButton({
                                dir:"../uploads",
                                key:"application-favicon",
                                textjson:text,
                                title:text["application-favicon"][allVariables.lang],
                                value: ((row, field) => {
                                    if (row instanceof Object && row.hasOwnProperty(field)) {
                                        return row[field];
                                    }
                                    return null;
                                })(applicationRow, "applicationfavicon")
                            }).html
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return sdapp.getMediaFilesButton({
                                dir:"../uploads",
                                key:"application-login-logo",
                                textjson:text,
                                title:text["application-login-logo"][allVariables.lang],
                                value: ((row, field) => {
                                    if (row instanceof Object && row.hasOwnProperty(field)) {
                                        return row[field];
                                    }
                                    return null;
                                })(applicationRow, "applicationloginlogo")
                            }).html
                        }
                    },
                    {
                        html:()=>{
                            return $(gen.textBox(
                                "application-login-logo-width-id",
                                "application-login-logo-width-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.loginlogowidth !== undefined ? applicationRow.loginlogowidth : 150,
                                "numeric"
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-login-logo-width"][allVariables.lang],
                                    title:text["application-maker-enter-application-login-logo-width"][allVariables.lang],
                                    "data-toggle":"tooltip",
                                    "data-placement":"top"
                                })
                                .addClass("form-control");
                        }
                    },
                    {
                        html:()=>{
                            return $(gen.textBox(
                                "application-login-logo-height-id",
                                "application-login-logo-height-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.loginlogoheight !== undefined ? applicationRow.loginlogoheight : 133,
                                "numeric"
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-login-logo-height"][allVariables.lang],
                                    title:text["application-maker-enter-application-login-logo-height"][allVariables.lang],
                                    "data-toggle":"tooltip",
                                    "data-placement":"top"
                                })
                                .addClass("form-control");
                        }
                    }
                ]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            return sdapp.getMediaFilesButton({
                                dir:"../uploads",
                                key:"application-dashboard-logo",
                                textjson:text,
                                title:text["application-dashboard-logo"][allVariables.lang],
                                value: ((row, field) => {
                                    if (row instanceof Object && row.hasOwnProperty(field)) {
                                        return row[field];
                                    }
                                    return null;
                                })(applicationRow, "applicationdashboardlogo")
                            }).html
                        }
                    },
                    {
                        html:()=>{
                            return $(gen.textBox(
                                "application-dashboard-logo-width-id",
                                "application-dashboardlogo-width-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.dashboardlogowidth !== undefined ? applicationRow.dashboardlogowidth : 60,
                                "numeric"
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-dashboard-logo-width"][allVariables.lang],
                                    title:text["application-maker-enter-application-dashboard-logo-width"][allVariables.lang],
                                    "data-toggle":"tooltip",
                                    "data-placement":"top"
                                })
                                .addClass("form-control");
                        }
                    },
                    {
                        html:()=>{
                            return $(gen.textBox(
                                "application-dashboard-logo-height-id",
                                "application-dashboard-logo-height-name",
                                "form-control",
                                typeof(applicationRow) ==="object" && applicationRow.dashboardlogoheight !== undefined ? applicationRow.dashboardlogoheight : 60,
                                "numeric"
                                )).removeAttr("style")
                                .attr({
                                    placeholder:text["application-maker-enter-application-dashboard-logo-height"][allVariables.lang],
                                    title:text["application-maker-enter-application-dashboard-logo-height"][allVariables.lang],
                                    "data-toggle":"tooltip",
                                    "data-placement":"top"
                                })
                                .addClass("form-control");
                        }
                    }
                ]);

                rows[rows.length] = gen.tableRow([
                    {
                        html:() =>{
                            let textIcon = {
                                text:text["save-application"][allVariables.lang],
                                icon:"fa fa-save"
                            }
                            if(typeof(applicationRow) ==="object"){
                                textIcon.text = text["edit-application"][allVariables.lang],
                                textIcon.icon ="fa fa-pencil";
                            }
                            return $(gen.button(
                                "save-edit-application-id",
                                "save-edit-application-name",
                                "btn btn-primary",
                                textIcon.text,
                                e=>{
                                    e.preventDefault();
                                    me.saveEditApplication({
                                        row:applicationRow,
                                        text:text,
                                        themeid:themeId
                                    })
                                },
                                textIcon.icon
                            )).css({
                                width:"100%"
                            });
                        },
                        attr:{
                            colspan:3
                        }
                    }
                ]);

                table.html(rows)
                .attr({
                    width:"100%",
                    class:"table"
                });
                gen.removeBorderFromTable({
                    type:"all",
                    table:table
                })
                return table;
        }
        this.saveEditApplication = (__methodOptions)=>{
            const text = __methodOptions.text;
            const themeId = __methodOptions.themeid;
            const applicationRow = __methodOptions.row;
            const validation = gen.getInputValueFromValidation([
                {
                    dom:"select",
                    type:"select",
                    name:"application-front-end-theme",
                    property:"frontendtheme",
                    warning:text["application-front-end-theme-warning"][allVariables.lang]
                },
                {
                    dom:"select",
                    type:"select",
                    name:"application-back-end-theme",
                    property:"backendtheme",
                    warning:text["application-back-end-theme-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-organization-name",
                    property:"organizationname",
                    warning:text["application-organization-name-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-organization-website-name",
                    property:"organizationwebsite",
                    warning:text["application-organization-website-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-name-name",
                    property:"applicationname",
                    warning:text["application-name-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-website-name",
                    property:"applicationwebsite",
                    warning:text["application-website-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-login-page-title-name",
                    property:"applicationloginpagetitle",
                    warning:text["application-login-page-title-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-dashboard-page-title-name",
                    property:"applicationdasboardpagetitle",
                    warning:text["application-dashboard-page-title-warning"][allVariables.lang]
                },
                {
                    dom:"textarea",
                    type:"textarea",
                    name:"application-description-1-name",
                    property:"application-description-first",
                    warning:text["application-description-first-warning"][allVariables.lang]
                },
                {
                    dom:"textarea",
                    type:"textarea",
                    name:"application-description-2-name",
                    property:"application-description-second",
                    warning:text["application-description-second-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"file",
                    name:"application-favicon",
                    property:"applicationfavicon",
                    warning:text["application-favicon-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"file",
                    name:"application-login-logo",
                    property:"applicationloginlogo",
                    warning:text["application-login-logo-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-login-logo-width-name",
                    property:"loginlogowidth",
                    warning:text["application-login-logo-width-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-login-logo-height-name",
                    property:"loginlogoheight",
                    warning:text["application-login-logo-height-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"file",
                    name:"application-dashboard-logo",
                    property:"applicationdashboardlogo",
                    warning:text["application-dashboard-logo-warning"][allVariables.lang]  
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-dashboardlogo-width-name",
                    property:"dashboardlogowidth",
                    warning:text["application-dashboard-logo-width-warning"][allVariables.lang]
                },
                {
                    dom:"input",
                    type:"text",
                    name:"application-dashboard-logo-height-name",
                    property:"dashboardlogoheight",
                    warning:text["application-dashboard-logo-height-warning"][allVariables.lang]
                }
            ]);
            if (validation === false){ return false;}
            else{
                const action = function(){
                    if(typeof(applicationRow) ==="undefined"){
                        
                        return {
                            warning:text["save-application-warning"][allVariables.lang],
                            success:text["save-application-success"][allVariables.lang],
                            callback :() =>{
                                gen.url(false, gen.serverSideUrl, {
                                    key: "sqlwrite",
                                    table: "sdapp_application_maker",
                                    fieldandvalues: {
                                        applicationid: 'NULL',
                                        themeid:themeId,
                                        frontendthemeid:validation.frontendtheme.value,
                                        backendthemeid:validation.backendtheme.value,
                                        organization: {
                                            parameters: [`@conn`,validation.organizationname],
                                            method: `preventInj`
                                        },
                                        organizationwebsite:{
                                            parameters: [`@conn`,validation.organizationwebsite],
                                            method: `preventInj`
                                        },
                                        applicationname: {
                                            parameters: [`@conn`,validation.applicationname],
                                            method: `preventInj`
                                        },
                                        applicationwebsite: {
                                            parameters: [`@conn`,validation.applicationwebsite],
                                            method: `preventInj`
                                        },
                                        applicationloginpagetitle: {
                                            parameters: [`@conn`,validation.applicationloginpagetitle],
                                            method: `preventInj`
                                        },
                                        applicationdashboardpagetitle: {
                                            parameters: [`@conn`,validation.applicationdasboardpagetitle],
                                            method: `preventInj`
                                        },
                                        applicationdescription_1:{
                                            parameters: [`@conn`,validation["application-description-first"]],
                                            method: `preventInj`
                                        },
                                        applicationdescription_2:{
                                            parameters: [`@conn`,validation["application-description-second"]],
                                            method: `preventInj`
                                        },
                                        applicationfavicon:validation.applicationfavicon,
                                        applicationloginlogo:validation.applicationloginlogo,
                                        loginlogowidth:validation.loginlogowidth,
                                        loginlogoheight:validation.loginlogoheight,
                                        dashboardlogowidth:validation.dashboardlogowidth,
                                        dashboardheight:validation.dashboardlogoheight,
                                        applicationdashboardlogo:validation.applicationdashboardlogo,
                                        createdby:allVariables.userid
                                    }
                                }, false, 1);
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-application-lists"
                                });
                            }
                        };
                        
                    }
                    if(typeof(applicationRow) ==="object"){
                        return {
                            warning:text["edit-application-warning"][allVariables.lang],
                            success:text["edit-application-success"][allVariables.lang],
                            callback:()=>{
                                gen.url(false, gen.serverSideUrl, {
                                    key: "sqledit",
                                    table: "sdapp_application_maker",
                                    fieldandvalues: {
                                        themeid:themeId,
                                        frontendthemeid:validation.frontendtheme.value,
                                        backendthemeid:validation.backendtheme.value,
                                        organization: {
                                            parameters: [`@conn`,validation.organizationname],
                                            method: `preventInj`
                                        },
                                        organizationwebsite:{
                                            parameters: [`@conn`,validation.organizationwebsite],
                                            method: `preventInj`
                                        },
                                        applicationname: {
                                            parameters: [`@conn`,validation.applicationname],
                                            method: `preventInj`
                                        },
                                        applicationwebsite: {
                                            parameters: [`@conn`,validation.applicationwebsite],
                                            method: `preventInj`
                                        },
                                        applicationloginpagetitle: {
                                            parameters: [`@conn`,validation.applicationloginpagetitle],
                                            method: `preventInj`
                                        },
                                        applicationdashboardpagetitle: {
                                            parameters: [`@conn`,validation.applicationdasboardpagetitle],
                                            method: `preventInj`
                                        },
                                        applicationdescription_1:{
                                            parameters: [`@conn`,validation["application-description-first"]],
                                            method: `preventInj`
                                        },
                                        applicationdescription_2:{
                                            parameters: [`@conn`,validation["application-description-second"]],
                                            method: `preventInj`
                                        },
                                        applicationfavicon:validation.applicationfavicon,
                                        applicationloginlogo:validation.applicationloginlogo,
                                        loginlogowidth:validation.loginlogowidth,
                                        loginlogoheight:validation.loginlogoheight,
                                        dashboardlogowidth:validation.dashboardlogowidth,
                                        dashboardheight:validation.dashboardlogoheight,
                                        applicationdashboardlogo:validation.applicationdashboardlogo,
                                        modifiedby:allVariables.userid
                                    },
                                    referencefield:"applicationid",
                                    referenceid: applicationRow[0]
        
                                }, false, 1);
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-application-lists"
                                });
                            }
                        };
                    }
                };
                gen.sweetWarningMsgBox(
                    action().callback,
                    text["alert"][allVariables.lang],
                    action().warning,
                    action().success,
                    text["sdapp-no-action-done"][allVariables.lang]
                );
            }
        }
        this.applicationExporting = (__methodOptions)=>{
            const text = __methodOptions.text;
            const action = function(){
                gen.urlModalBoxLoader(gen.serverSideUrl,{
                    key:"sdapp",
                    tree:"write-sdapp-application-data",
                    row:__methodOptions.row,
                    type:"export",
                    getter:true,
                    ajaxdatatype:"json"
                 },
                 text["application-exporting-loading"][allVariables.lang],
                 text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                 function(response,section){
                     if(response.status === 200){
                        section.html([
                            $(gen.createEl("i")).attr({class:"icon-check icons"}).css({color:"#28a745"}),
                            $(gen.createEl("span")).html(gen.superReplacer(text["application-generation-success"][allVariables.lang],"@appname",response.appname.bold())).css({
                                marginLeft:"5px"
                            })
                        ]);
                        setTimeout(function(){
                            gen.closeModal();
                            const downloadAnchor = $(gen.createEl("a")).attr({href:"download",target:"_blank"});
                            downloadAnchor[0].click();
                        },1000);
                       
                     }
                 }
                 );
            };
            gen.sweetWarningMsgBox(
                action,
                text["alert"][allVariables.lang],
                text["exporting-app-warning"][allVariables.lang],
                text["exporting-app-start-process"][allVariables.lang],
                text["sdapp-no-action-done"][allVariables.lang]
            );
        }

        this.applicationView = (__methodOptions)=>{
           const text = __methodOptions.text;
            gen.urlModalBoxLoader(gen.serverSideUrl,{
                key:"sdapp",
                tree:"write-sdapp-application-data",
                row:__methodOptions.row,
                type:"view",
                getter:true,
                ajaxdatatype:"json"
             },
             text["application-visualization-loading"][allVariables.lang],
             text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
             function(response,section){
                 if(response.status === 200){
                    section.html([
                        $(gen.createEl("i")).attr({class:"icon-check icons"}).css({color:"#28a745"}),
                        $(gen.createEl("span")).html(gen.superReplacer(text["application-visualization-success"][allVariables.lang],"@appname",response.appname.bold())).css({
                            marginLeft:"5px"
                        })
                    ]);
                    setTimeout(function(){
                        gen.closeModal();
                        const anchor = $(gen.createEl("a")).attr({href:"applicationmaker/",target:"_blank"});
                        anchor[0].click();
                    },1000);
                   
                 }
             }
             );
            
        }
        this.menuSetting = (__methodOptions)=>{
            const text = __methodOptions.text;
            const applicationRow = __methodOptions.row;
            const blockForms = gen.getObjectFromJSON(gen.url(
                false, gen.serverSideUrl, {
                key: 'returnjson',
                table: 'sdappblockreference',
                ref: `WHERE themeid='${applicationRow.themeid}'`,
                getter: true
            }, false, 1));
            const scriptid = __methodOptions.scriptid;
            const __objects = {
                init:(__functionOptions)=>{
                    const row = __functionOptions.row;
                    $(__functionOptions.section).append(__objects.newParentMenuButton({
                        row:__functionOptions.row,
                        section:__functionOptions.section
                    }));
                    //display existing parent menu starts
                    if(typeof(row) ==="object" && row.hasOwnProperty("menusettings") && row.menusettings!== null && typeof(gen.getObjectFromJSON(row.menusettings)) ==="object"){
                        const menuSettings = gen.getObjectFromJSON(row.menusettings);
                        if(Array.isArray(menuSettings) && menuSettings.length > 0){
                            for(let i = 0; i < menuSettings.length; i++){
                                const parentmenu = menuSettings[i];
                                $(__functionOptions.section).append(__objects.newParentMenu({
                                    row:__functionOptions.row,
                                    section:__functionOptions.section,
                                    parentmenu:parentmenu
                                }));
                            }
                        }
                        return false;
                    }
                    //display existing parent menu ends
                    $(__functionOptions.section).append(__objects.newParentMenu({
                        row:__functionOptions.row,
                        section:__functionOptions.section
                    }));
                },
                newParentMenuButton:(__functionOptions)=>{
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            css:{
                                margin:"10px",
                                padding:"5px"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-6"
                                    },
                                    html:gen.anchor({
                                        title:text["application-new-parent-menu"][allVariables.lang],
                                        icon:"fa fa-plus",
                                        css:{
                                            cursor:"pointer"
                                        },
                                        callback:e=>{
                                            e.preventDefault();
                                            $(__functionOptions.section).append(__objects.newParentMenu({
                                                row:__functionOptions.row,
                                                section:__functionOptions.section
                                            }));
                                        }
                                    })
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-5"
                                    },
                                    html:gen.anchor({
                                        title:text["sdapp-application-save-menu-configuration"][allVariables.lang],
                                        icon:"fa fa-save",
                                        css:{
                                            cursor:"pointer"
                                        },
                                        callback:e=>{
                                            e.preventDefault();
                                            __objects.saveAppMenuConfiguration({
                                                row:applicationRow
                                            });
                                        }
                                    })
                                }
                            ]
                        }
                    ]).init();
                },
                newParentMenu:(__functionOptions)=>{
                    const parentMenu = __functionOptions.parentmenu;
                    const parentSection = $(gen.createEl("div")).attr({
                        sdapp:text["application-parent-menu"]
                    });
                    const subMenuSection =  $(gen.createEl("div"))
                    .attr({
                        sdapp:text["application-sub-menu-section"]
                    });
                    if(typeof(parentMenu) ==="object" && parentMenu.hasOwnProperty("submenus") && Array.isArray(parentMenu.submenus) && parentMenu.submenus.length > 0){
                        parentMenu.submenus.forEach(item=>{
                            subMenuSection.append(function(){
                                return __objects.newSubMenu({
                                    submenu:item
                                });
                            });
                        });
                    }
                    else{
                        subMenuSection.html(function(){
                            return __objects.newSubMenu({
    
                            });
                        });
                    }
                   
                    const menuSection = gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row",
                            },
                            css:{
                                margin:"10px",
                                border:"1px #ccc solid",
                                borderRadius:"5px",
                                padding:"5px"
                            },
                            children:[
                                {
                                  element:"div",
                                  attr:{
                                      class:"col-lg-6"
                                  },
                                  css:{margin:"5px 0px 10px 0px"},
                                  html:gen.anchor({
                                      title:text["new-application-submenu"][allVariables.lang],
                                      icon:"fa fa-plus",
                                      css:{
                                          cursor:"pointer"
                                      },
                                      callback:e=>{
                                          e.preventDefault();
                                          subMenuSection.append(__objects.newSubMenu({
                                          }));
                                      }
                                  }) 
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-6"
                                    },
                                    html:gen.dropDownMenu({
                                        icon:"icon-options icons",
                                        submenus:{
                                            delete:{
                                                title:text["application-delete-parent-menu"][allVariables.lang],
                                                icon:"fa fa-trash",
                                                callback:e=>{
                                                    parentSection.remove();
                                                }
                                            }
                                        }
                                        
                                    },true)
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-6"
                                    },
                                    css:{
                                        marginBottom:"5px"
                                    },
                                    children:[
                                        {
                                            element:"input",
                                            attr:{
                                                class:"form-control",
                                                name:"sdapp-application-parent-menu-name",
                                                type:"text",
                                                placeholder:text["enter-application-parent-menu-name"][allVariables.lang]
                                            },
                                            value:parentMenu!==undefined?parentMenu.parentmenuname:null
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-6"
                                    },
                                    css:{
                                        marginBottom:"5px"
                                    },
                                    children:[
                                        {
                                            element:"input",
                                            attr:{
                                                type:"text",
                                                class:"form-control",
                                                name:"sdapp-application-parent-menu-icon",
                                                placeholder:text["enter-application-parent-menu-icon"][allVariables.lang]
                                            },
                                            value:parentMenu!==undefined?parentMenu.parentmenuicon:null
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    html:subMenuSection 
                                  }
                            ]
                        }
                    ]).init();
                    return parentSection.html(menuSection);
                },
                newSubMenu:(__functionOptions)=>{
                    const submenu = __functionOptions.submenu;
                    const parentSection = $(gen.createEl("div")).attr({sdapp:text["application-sub-menu-section-child"]});
                    const __submenuTypeCustomized = function(){
                        const input = $(gen.createEl("input"));
                        input.attr({
                            type:"text",
                            class:"form-control",
                            name:"application-submenu-type",
                            placeholder:text["url-key"][allVariables.lang]
                        });
                        input.val(submenu!==undefined?submenu.submenutype:null);
                        return input;
                    };
                    const __submenuType = function(allowDropDown){
                        if(submenu!==undefined && allowDropDown === undefined &&  submenu.submenuform === "customize"){
                            return __submenuTypeCustomized();
                        }
                        return gen.dropDownFromArray({
                            array:[
                                {
                                    key:text["application-menu-setting-sub-menu-type"]["1"]["key"],
                                    title:text["application-menu-setting-sub-menu-type"]["1"][allVariables.lang]
                                },
                                {
                                    key:text["application-menu-setting-sub-menu-type"]["2"]["key"],
                                    title:text["application-menu-setting-sub-menu-type"]["2"][allVariables.lang]
                                },
                                {
                                    key:text["application-menu-setting-sub-menu-type"]["3"]["key"],
                                    title:text["application-menu-setting-sub-menu-type"]["3"][allVariables.lang]
                                },
                                {
                                    key:text["application-menu-setting-sub-menu-type"]["4"]["key"],
                                    title:text["application-menu-setting-sub-menu-type"]["4"][allVariables.lang]
                                },
                                {
                                    key:text["application-menu-setting-sub-menu-type"]["5"]["key"],
                                    title:text["application-menu-setting-sub-menu-type"]["5"][allVariables.lang]
                                }
                            ],
                            id:"key",
                            output:"title",
                            editedvalue:submenu!==undefined?submenu.submenutype:null,
                            legend:text["application-menu-setting-submenu-type-select"][allVariables.lang],
                            attr:{
                                class:"form-control",
                                name:"application-submenu-type"
                            },
                            css:{
                                marginBottom:"5px"
                            }
                        })
                    };
                    const subMenuSection = gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row",
                            },
                            css:{
                                border:"1px #ccc dotted",
                                borderRadius:"5px",
                                margin:"10px 1px 1px 1px",
                                padding:"5px"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    children:[
                                        {
                                            element:"input",
                                            attr:{
                                                type:"text",
                                                class:"form-control",
                                                name:"application-submenu-name",
                                                placeholder:text["enter-application-submenu-name"][allVariables.lang]
                                            },
                                            value:submenu!==undefined?submenu.submenuname:null,
                                            css:{
                                                marginBottom:"5px"
                                            }
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-2"
                                    },
                                    children:[
                                        {
                                            element:"input",
                                            attr:{
                                                type:"text",
                                                class:"form-control",
                                                name:"application-submenu-icon",
                                                placeholder:text["enter-application-submenu-icon"][allVariables.lang]
                                            },
                                            value:submenu!==undefined?submenu.submenuicon:null,
                                            css:{
                                                marginBottom:"5px"
                                            }
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:gen.dropDownFromArray({
                                        preoptions:[
                                            {
                                                value:"customize",
                                                html:text["customize"][allVariables.lang]
                                            }
                                        ],
                                        array:blockForms,
                                        id:"blockid",
                                        output:"blockname",
                                        legend:text["application-menu-setting-select-form"][allVariables.lang],
                                        editedvalue:submenu!==undefined?submenu.submenuform:null,
                                        attr:{
                                            class:"form-control",
                                            name:"application-submenu-form"
                                        },
                                        css:{
                                            marginBottom:"5px"
                                        },
                                        onchange:e=>{
                                            const value = e.target.value;
                                            const nextDiv = $(e.target).parent("div").next("div");
                                            if(value ==="customize"){
                                                nextDiv.find("select").replaceWith(__submenuTypeCustomized());
                                            }
                                            else{
                                                nextDiv.html(__submenuType(true)) 
                                            }
                                        }
                                    })
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:__submenuType()
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-1"
                                    },
                                    html:gen.dropDownMenu({
                                        icon:"icon-options icons",
                                        submenus:{
                                            delete:{
                                                title:text["delete-application-submenu"][allVariables.lang],
                                                icon:"fa fa-trash",
                                                callback:e=>{
                                                    e.preventDefault();
                                                    parentSection.remove();
                                                }
                                            },
                                            prepend:{
                                                title:text["prepend-application-submenu"][allVariables.lang],
                                                icon:"fa fa-arrow-circle-o-up",
                                                callback:e=>{
                                                    e.preventDefault();
                                                    parentSection.before(__objects.newSubMenu({

                                                    }));
                                                }
                                            },
                                            append:{
                                                title:text["append-application-submenu"][allVariables.lang],
                                                icon:"fa fa-arrow-circle-o-down",
                                                callback:e=>{
                                                    e.preventDefault();
                                                    parentSection.after(__objects.newSubMenu({

                                                    }));
                                                }
                                            }
                                        }
                                    },true)
                                }
                            ]
                        }
                    ]).init();
                    return parentSection.html(subMenuSection);
                },
                saveAppMenuConfiguration:(__functionOptions)=>{
                    const parentMenuFinder = document.querySelectorAll(`div[sdapp="${text["application-parent-menu"]}"]`);
                    const row = __functionOptions.row;
                    let applicationMenuSettings = [];
                    let countValidation = 0;
                    for(let x = 0; x < parentMenuFinder.length; x++){
                        const item = parentMenuFinder[x];
                        const parentMenuName = $(item).find(`input[name="sdapp-application-parent-menu-name"][type="text"]`);
                        const parentMenuIcon = $(item).find(`input[name="sdapp-application-parent-menu-icon"][type="text"]`);
                        if(parentMenuName.val().length < 1){
                            swal(
                                text["alert"][allVariables.lang],
                                text["application-parent-menu-name-warning"][allVariables.lang],
                                "warning"
                            );
                            parentMenuName.focus();
                            return false;
                        }
                        if(parentMenuIcon.val().length < 1){
                            swal(
                                text["alert"][allVariables.lang],
                                text["application-parent-menu-icon-warning"][allVariables.lang],
                                "warning"
                            );
                            parentMenuIcon.focus();
                            return false;
                        }
                        let submenus = [];
                        let countSubMenuValidation = 0;
                        const subMenuFinder =  $(item).find(`div[sdapp="${text["application-sub-menu-section"]}"]`).find(`div[sdapp="${text["application-sub-menu-section-child"]}"]`);
                        for(let i = 0; i< subMenuFinder.length; i++){
                            const element = subMenuFinder[i];
                            const subMenuName = $(element).find(`input[name="application-submenu-name"][type="text"]`);
                            const subMenuIcon = $(element).find(`input[name="application-submenu-icon"][type="text"]`);
                            const subMenuForm = $(element).find(`select[name="application-submenu-form"]`);
                            const subMenuType = $(element).find(`select[name="application-submenu-type"],input[type="text"][name="application-submenu-type"]`);
                            if(subMenuName.val().length < 1){
                                swal(
                                    text["alert"][allVariables.lang],
                                    text["application-sub-menu-name-warning"][allVariables.lang],
                                    "warning"
                                );
                                subMenuName.focus();
                                return false;
                            }
                            if(subMenuIcon.val().length < 1){
                                swal(
                                    text["alert"][allVariables.lang],
                                    text["application-sub-menu-icon-warning"][allVariables.lang],
                                    "warning"
                                );
                                subMenuIcon.focus();
                                return false;
                            }
                            if(subMenuForm.val().length < 1){
                                swal(
                                    text["alert"][allVariables.lang],
                                    text["application-sub-menu-form-warning"][allVariables.lang],
                                    "warning"
                                );
                                subMenuForm.focus();
                                return false;
                            }
                            if(subMenuType.val().length < 1){
                                swal(
                                    text["alert"][allVariables.lang],
                                    text["application-sub-menu-type-warning"][allVariables.lang],
                                    "warning"
                                );
                                subMenuType.focus();
                                return false;
                            }
                            countSubMenuValidation ++;
                            submenus[submenus.length]={
                                submenuname:subMenuName.val(),
                                submenuicon:subMenuIcon.val(),
                                submenuform:subMenuForm.val(),
                                submenutype:subMenuType.val()
                            };
                        };
                        if(countSubMenuValidation < subMenuFinder.length){return false;}
                        applicationMenuSettings.push({
                            parentmenuname:parentMenuName.val(),
                            parentmenuicon:parentMenuIcon.val(),
                            submenus:submenus
                        });
                        countValidation ++;
                    };
                    if(parentMenuFinder.length === countValidation){
                        const action = function(){
                            return {
                                callback: ()=>{
                                    gen.url(false, gen.serverSideUrl, {
                                        key: "sqledit",
                                        table: "sdapp_application_maker",
                                        fieldandvalues: {
                                            menusettings: applicationMenuSettings
                                        },
                                        referencefield:"applicationid",
                                        referenceid: row[0]
                                    }, false, 1);
                                    sdapp.sdapp_Access_Menu({
                                        key: "sdapp-application-lists"
                                    });
                                },
                                warning:text["application-menu-setting-save-warning"][allVariables.lang],
                                success:text["application-menu-setting-save-success"][allVariables.lang]
                            }
                        };

                        gen.sweetWarningMsgBox(
                            action().callback,
                            text["alert"][allVariables.lang],
                            action().warning,
                            action().success,
                            text["sdapp-no-action-done"][allVariables.lang]
                        );
                    }
                }
            };
            sdapp.replaceScriptWithUI({
                scriptid: scriptid,
                title: text["application-menu-setting"][allVariables.lang],
                textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        addapplication: {
                            icon: "fa fa-plus",
                            title: text["create-application"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-create-customized-app"
                                });
                            }
                        },
                        applicationlist: {
                            icon: "fa fa-circle-o",
                            title: text["all-applications"][allVariables.lang],
                            callback: () => {
                                sdapp.sdapp_Access_Menu({
                                    key: "sdapp-application-lists"
                                });
                            }
                        }

                    }
                },
                html: (sel) => {
                    __objects.init({
                        row:applicationRow,
                        section:sel
                    });
                }
            });
        }
       
    }
}