class sdapp_customized_form{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const lang = allVariables.lang;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        const row = __constructorOptions.row;
        const themeId = row.themeid;
        const blocks = gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {
            key: 'returnjson',
            table: 'sdappblockreference',
            datatype:"json",
            ref: `WHERE themeid ='${themeId}' AND datastatus > 0 ORDER BY blockname`,
            getter: true
        }, false, 1));
        const customizedFormSettings = row.customizedformsettings;
        const applicationSection = text["customized-form-application-section"];
        const __objects = {
            init: () =>{
                return gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row"
                        },
                        css:{
                            padding:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                html:__objects.formtypelist({
                                    settings:customizedFormSettings
                                })
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                html:__objects.saveButton()
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12",
                                    sdapp:applicationSection
                                },
                                css:{
                                    marginTop:"20px"
                                },
                                html:()=>{
                                    const settingsObject = gen.getObjectFromJSON(customizedFormSettings);
                                    if(settingsObject!==undefined && settingsObject!==null && settingsObject.customizedsettings!==undefined && settingsObject!==null && typeof(settingsObject.customizedsettings)==="object"){
                                        return __objects.formCentralizer({
                                            type:settingsObject.type,
                                            settings:settingsObject.customizedsettings
                                        });
                                    }
                                }
                            }
                        ]
                    }
                ]).init();
            },
            blocks:() =>{
                return blocks;
            },
            formType: () =>{
                return $(`select[sdapp="${text["customized-form-type"]}"]`);
            },
            saveButton:(__functionOptions) =>{
                return gen.anchor({
                    icon:"fa fa-save",
                    title:text["save-customized-form"][allVariables.lang],
                    css:{
                        cursor:"pointer",
                        margin:"5px 0px 5px 0px"
                    },
                    callback: e=>{
                        e.preventDefault();
                        __objects.saveCustomizedForm({

                        });
                    }
                });
            },
            validateFormType : (__functionOptions)=>{
                if(__objects.formType().val().length < 1){
                    swal(
                        text["alert"][allVariables.lang],
                        text["customized-form-type-warning"][allVariables.lang],
                        "warning"
                    );
                    __objects.formType().focus();
                    return false;
                }
                return true;
            },
            saveCustomizedForm: (__functionOptions) =>{
                if(__objects.validateFormType() === false){return false;}
                switch(__objects.formType().val()){
                    case "cartform":
                        __objects.cartform.save(__functionOptions);
                    break;
                    case "bookingform":
                        __objects.bookingform.save(__functionOptions);
                    break;
                    case "default":
                        __objects.defaultform.save(__functionOptions);
                    break;
                }
            },
            formtypelist: (__functionOptions) =>{
                let type = undefined;
                const settings = gen.getObjectFromJSON(__functionOptions.settings);
                if(settings !== null && settings.type !== null && settings.type !== undefined){
                    type = settings.type;
                }
                return gen.dropDownFromArray({
                    array:text["form-categories"],
                    id:"key",
                    output:(arr) =>{
                        return arr.title[allVariables.lang];
                    },
                    legend:text["select-form-type"][allVariables.lang],
                    onchange: (e)=>{
                        $(`div[sdapp="${applicationSection}"]`).html(__objects.formCentralizer({
                            type:e.target.value,
                            settings:settings
                        }));
                    },
                    attr:{
                        class:"form-control",
                        sdapp:text["customized-form-type"]
                    },
                    editedvalue:type
                });
            },
            customizedFormSettings:(__functionOptions)=>{
                return {
                    type:__objects.formType().val(),
                    customizedsettings:__functionOptions.customizedsettings
                };
            },
            formCentralizer:(__functionOptions)=>{
                const type = __functionOptions.type;
                const settings = __functionOptions.settings;
                let form = undefined;
                switch(type){
                    case "cartform":
                    form = __objects.cartform.init({
                        settings:settings
                    });
                    break;
                    case "bookingform":
                    form = __objects.bookingform.init({
                        settings:settings
                    });
                    break;
                    case "default":
                    form =  __objects.defaultform.init({
                        settings:settings
                    });
                    break;
                }
                return form;
            },
            blockList:(__functionOptions) =>{
                let array = __objects.blocks().filter(item=>{return item[0]!==row[0]});
                if(__functionOptions.hasOwnProperty("self") && __functionOptions.self === true){
                    array = [row];
                    __functionOptions.editedvalue = array[0][0];
                }
                let id = "blockid";
                let output = "blockname";
                if(__functionOptions.array !== undefined){array = __functionOptions.array;}
                if(__functionOptions.id !== undefined){id = __functionOptions.id;}
                if(__functionOptions.output !== undefined){output = __functionOptions.output;}
                return gen.dropDownFromArray({
                    array:array,
                    id:id,
                    output:output,
                    onchange:e=>{
                        __functionOptions.onchange(e);
                    },
                    attr:{
                        class:"form-control",
                        name:__functionOptions.name
                    },
                    editedvalue:__functionOptions.editedvalue,
                    legend:__functionOptions.legend
                });
            },
            blockMaker:(__functionOptions) =>{
                const idAuto = `id-auto-generator-random-${gen.random(8)}`;
                let display = "block"; if(__functionOptions.display !== undefined && __functionOptions.display === false){display = "none";}

                return  {
                    element:"div",
                    css:{
                        borderLeft:"1px #f8f9fa solid",
                        borderRight:"1px #f8f9fa solid",
                        borderBottom:"1px #f8f9fa solid",
                        display:display
                    },
                    attr:{
                        id:__functionOptions.blockmakerid !== undefined ? __functionOptions.blockmakerid : idAuto
                    },
                    children:[
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-12"
                            },
                            css:{
                                backgroundColor:"#f8f9fa",
                                padding:"7px",
                                fontWeight:"bold",
                                textTransform:"uppercase"
                            },
                           html:__functionOptions.title
                        },
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-12"
                            },
                            css:{
                                padding:"5px"
                            },
                           html:__functionOptions.content
                        },
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-12"
                            },
                            css:{
                                padding:"5px"
                            },
                            html:__functionOptions.extra
                        }
                    ]
                };
            },
            defaultform:{
                init:(__functionOptions) =>{
                    return null;
                },
                save:(__functionOptions) =>{
                    __objects.saveSettings({customizedsettings:undefined});
                }
            },
            cartform:{
                init:(__functionOptions) =>{
                    const settings = __functionOptions.settings;
                    const agentBlockId = `block-gent-random-${gen.random(8)}`;
                    const paymentMethodBlockId = `block-payment-method-random-${gen.random(8)}`;
                    const taxBlockId = `block-tax-random${gen.random(8)}`;
                    const clientColumns = function(__annonymFunctionOptions){
                        const array = __annonymFunctionOptions.array;
                            return gen.objectInterfaceMaker([
                                {
                                    element:"div",
                                    attr:{
                                        class:"row"
                                    },
                                    children:[
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-4"
                                            },
                                            html:()=>{
                                                return gen.dropDownFromArray({
                                                    array:array,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        class:"form-control",
                                                        name:text["cart-form-client-block-client-fullname-column-output"]
                                                    },
                                                    editedvalue:__annonymFunctionOptions.clientfullnamecolumnoutput,
                                                    legend:text["cart-form-client-block-select-client-fullname-column-output"][allVariables.lang]
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-4"
                                            },
                                            html:() =>{
                                                return gen.dropDownFromArray({
                                                    array:array,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        class:"form-control",
                                                        name:text["cart-form-client-block-client-fullname-column"],
                                                        multiple:"multiple"
                                                    },
                                                    editedvalue:__annonymFunctionOptions.clientfullnamecolumn,
                                                    legend:text["cart-form-client-block-select-client-fullname-column"][allVariables.lang]
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-4"
                                            },
                                            html: () =>{
                                                return gen.dropDownFromArray({
                                                    array:array,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        class:"form-control",
                                                        name:text["cart-form-client-block-client-photo-column"]
                                                    },
                                                    editedvalue:__annonymFunctionOptions.clientphotocolumn,
                                                    legend:text["cart-form-client-block-select-client-photo-column"][allVariables.lang]
                                                });
                                            }
                                        }
                                    ]
                                }
                            ]).init();
                    };
                    const productColumns = function(__annonymFunctionOptions){
                        const array = __annonymFunctionOptions.array;
                        return gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:()=>{
                                            return gen.dropDownFromArray({
                                                array:array,
                                                id:"key",
                                                output:"title",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["cart-form-product-name-column"]
                                                },
                                                editedvalue:__annonymFunctionOptions.productnamecolumn,
                                                legend:text["cart-form-client-block-select-product-column-name"][allVariables.lang]
                                            });
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:()=>{
                                            return gen.dropDownFromArray({
                                                array:array,
                                                id:"key",
                                                output:"title",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["cart-form-product-price-column"]
                                                },
                                                editedvalue:__annonymFunctionOptions.productpricecolumn,
                                                legend:text["cart-form-client-block-select-product-column-price"][allVariables.lang]
                                            });
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:()=>{
                                            return gen.dropDownFromArray({
                                                array:array,
                                                id:"key",
                                                output:"title",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["cart-form-product-photo-column"]
                                                },
                                                editedvalue:__annonymFunctionOptions.productphotocolumn,
                                                legend:text["cart-form-client-block-select-product-column-photo"][allVariables.lang]
                                            });
                                        }
                                    }
                                    
                                ]
                            }
                        ]).init();
                    };
                    const agentColumns = function(__annonymFunctionOptions){
                        const array = __annonymFunctionOptions.array;
                            return gen.objectInterfaceMaker([
                                {
                                    element:"div",
                                    attr:{
                                        class:"row"
                                    },
                                    children:[
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-6"
                                            },
                                            html:() =>{
                                                return gen.dropDownFromArray({
                                                    array:array,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        class:"form-control",
                                                        name:text["cart-form-client-block-agent-fullname-column"],
                                                        multiple:"multiple"
                                                    },
                                                    editedvalue:__annonymFunctionOptions.agentfullnamecolumn,
                                                    legend:text["cart-form-client-block-select-agent-fullname-column"][allVariables.lang]
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"col-lg-6"
                                            },
                                            html: () =>{
                                                return gen.dropDownFromArray({
                                                    array:array,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        class:"form-control",
                                                        name:text["cart-form-client-block-agent-photo-column"]
                                                    },
                                                    editedvalue:__annonymFunctionOptions.agentphotocolumn,
                                                    legend:text["cart-form-client-block-select-agent-photo-column"][allVariables.lang]
                                                });
                                            }
                                        }
                                    ]
                                }
                            ]).init();
                    };
                    const paymentMethodColumns = function(__annonymFunctionOptions){
                        const array = __annonymFunctionOptions.array;
                        return gen.dropDownFromArray({
                            array:array,
                            id:"key",
                            output:"title",
                            attr:{
                                class:"form-control",
                                name:text["cart-form-client-block-payment-method-name-column"]
                            },
                            editedvalue:__annonymFunctionOptions.paymentmethodcolumnname,
                            legend:text["cart-form-client-block-select-payment-method-name-column"][allVariables.lang]
                        });
                    };
                    const taxColumns = function(__annonymFunctionOptions){
                        const array = __annonymFunctionOptions.array;
                        return gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        html:() =>{
                                            return gen.dropDownFromArray({
                                                array:array,
                                                id:"key",
                                                output:"title",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["cart-form-client-block-tax-column-name"],
                                                },
                                                editedvalue:__annonymFunctionOptions.taxcolumnname,
                                                legend:text["cart-form-client-block-select-tax-column-name"][allVariables.lang]
                                            });
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        html: () =>{
                                            return gen.dropDownFromArray({
                                                array:array,
                                                id:"key",
                                                output:"title",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["cart-form-tax-block-comission-column"]
                                                },
                                                editedvalue:__annonymFunctionOptions.taxcomissioncolumn,
                                                legend:text["cart-form-client-block-select-tax-comission-column"][allVariables.lang]
                                            });
                                        }
                                    }
                                ]
                            }
                        ]).init();
                    }; 
                    let displayAgentBlock = false;
                    let displayPaymentMethodBlock = false;
                    let editedValueActivateAgentBlock = null;
                    let editedValueActivatePaymentMethodBlock = null;
                    let editedValueActivateTaxBlock = null;
                    if(settings!== null && settings!==undefined && settings.agent!==undefined){
                        editedValueActivateAgentBlock = settings.agent.agentblockactivation;
                        editedValueActivatePaymentMethodBlock = settings.paymentmethod.paymentmethodactivation;
                        editedValueActivateTaxBlock =  settings.tax.taxblockactivation;
                        if(settings.agent.agentblockactivation ==="yes"){
                            displayAgentBlock = undefined;
                        }
                        else{
                            displayAgentBlock = false;
                        }

                        if(settings.paymentmethod.paymentmethodactivation === "yes"){
                            displayPaymentMethodBlock = undefined;
                        }
                        else{
                            displayPaymentMethodBlock = false;
                        }
                    }
                    return gen.objectInterfaceMaker([
                        __objects.blockMaker({
                            title:text["rate-symbol"][allVariables.lang],
                            content:$(gen.textBox(
                                text["cart-form-rate-symbol-id"],
                                text["cart-form-rate-symbol-name"],
                                "form-control",
                                settings!== null && settings!==undefined && settings.rate!==undefined ? settings.rate.ratesymbol : null
                            ))
                            .removeAttr("style")
                            .addClass("form-control")
                            .attr({
                                placeholder:text["cart-form-rate-symbol-placeholder"][allVariables.lang]
                            })
                        }),
                    __objects.blockMaker({
                        title:text["cart-form-client-block"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.client!==undefined ? settings.client.blockid : null,
                            name:text["cart-form-client-block-select"],
                            legend:text["cart-form-select-client-block"][allVariables.lang],
                            onchange: e =>{
                                const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                if(Array.isArray(array) && array.length){
                                    $(e.target).parent("div").next("div").html(clientColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        clientfullnamecolumn:null,
                                        clientfullnamecolumnoutput:null,
                                        clientphotocolumn:null
                                    }));
                                }  
                            }
                        }),
                        extra:(s=>{
                                if(s !== undefined && s !== null && s.client !== undefined){
                                    const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.client.blockid);});
                                        return  clientColumns({
                                            array:gen.getObjectFromJSON(array[0].columnsobjects),
                                            clientfullnamecolumn:s.client.clientfullnamecolumn,
                                            clientfullnamecolumnoutput:s.client.clientfullnamecolumnoutput,
                                            clientphotocolumn:s.client.clientphotocolumn
                                        });
                                }
                                return null;
                               
                            })(settings)
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-product-block"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.product!==undefined ? settings.product.blockid : null,
                            name:text["cart-form-select-product-block"],
                            legend:text["cart-form-product-block-select"][allVariables.lang],
                            onchange: e =>{
                                const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                if(Array.isArray(array) && array.length){
                                    $(e.target).parent("div").next("div").html(productColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        productnamecolumn:null,
                                        productpricecolumn:null,
                                        productphotocolumn:null
                                    }));
                                }  
                            }
                        }),
                        extra:(s=>{
                            if(s !== undefined && s !== null && s.product !== undefined){
                                const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.product.blockid);});
                                    return  productColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        productnamecolumn:s.product.productnamecolumn,
                                        productpricecolumn:s.product.productpricecolumn,
                                        productphotocolumn:s.product.productphotocolumn
                                    });
                            }
                            return null;
                           
                        })(settings)
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-activate-agent-block-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:editedValueActivateAgentBlock,
                            name:text["cart-form-activate-agent-block"],
                            legend:text["cart-form-activate-agent-block-select"][allVariables.lang],
                            array:[
                                {
                                    key:"yes",
                                    title:text["yes"][allVariables.lang]
                                },
                                {
                                    key:"no",
                                    title:text["no"][allVariables.lang]
                                }
                            ],
                            id:"key",
                            output:"title",
                            onchange:e=>{
                                const value = e.target.value;
                                const block = $(`div#${agentBlockId}`);
                                if(value ==="yes"){
                                    block.css({
                                        display:"block"
                                    });
                                }
                                if(value ==="no"){
                                    block.css({
                                        display:"none"
                                    });
                                }
                            }
                        })
                    }),
                    __objects.blockMaker({
                        blockmakerid:agentBlockId,
                        display:displayAgentBlock,
                        title:text["cart-form-agent-block"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.agent!==undefined ? settings.agent.blockid : null,
                            name:text["cart-form-select-agent-block"],
                            legend:text["cart-form-agent-block-select"][allVariables.lang],
                            onchange: e =>{
                                const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                if(Array.isArray(array) && array.length){
                                    $(e.target).parent("div").next("div").html(agentColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        editedvalue:null
                                    }));
                                }  
                            }
                        }),
                        extra:(s=>{
                                if(s !== undefined && s !== null && s.agent !== undefined){
                                    const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.agent.blockid);});
                                        return  agentColumns({
                                            array:gen.getObjectFromJSON(array[0].columnsobjects),
                                            agentfullnamecolumn:settings.agent.agentfullnamecolumn,
                                            agentphotocolumn:settings.agent.agentphotocolumn
                                        });
                                }
                                return null;
                               
                            })(settings)
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-activate-payment-method-block-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:editedValueActivatePaymentMethodBlock,
                            name:text["cart-form-activate-payment-method-block"],
                            legend:text["cart-form-activate-payment-method-block-select"][allVariables.lang],
                            array:[
                                {
                                    key:"yes",
                                    title:text["yes"][allVariables.lang]
                                },
                                {
                                    key:"no",
                                    title:text["no"][allVariables.lang]
                                }
                            ],
                            id:"key",
                            output:"title",
                            onchange:e=>{
                                const value = e.target.value;
                                const block = $(`div#${paymentMethodBlockId}`);
                                if(value ==="yes"){
                                    block.css({
                                        display:"block"
                                    });
                                }
                                if(value ==="no"){
                                    block.css({
                                        display:"none"
                                    });
                                }
                            }
                        })
                    }),
                    __objects.blockMaker({
                        blockmakerid:paymentMethodBlockId,
                        display:displayPaymentMethodBlock,
                        title:text["cart-form-payment-method-block"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.paymentmethod!==undefined ? settings.paymentmethod.blockid : null,
                            name:text["cart-form-select-payment-method-block"],
                            legend:text["cart-form-payment-method-block-select"][allVariables.lang],
                            onchange: e =>{
                                const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                if(Array.isArray(array) && array.length){
                                    $(e.target).parent("div").next("div").html(paymentMethodColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        paymentmethodcolumnname:null
                                    }));
                                }  
                            }
                        }),
                        extra:(s=>{
                                if(s !== undefined && s !== null && s.agent !== undefined){
                                    const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.paymentmethod.blockid);});
                                        return  paymentMethodColumns({
                                            array:gen.getObjectFromJSON(array[0].columnsobjects),
                                            paymentmethodcolumnname:settings.paymentmethod.paymentmethodcolumname
                                        });
                                }
                                return null;
                               
                            })(settings)
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-activate-tax-block-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:editedValueActivateTaxBlock,
                            name:text["cart-form-activate-tax-block"],
                            legend:text["cart-form-activate-tax-block-select"][allVariables.lang],
                            array:[
                                {
                                    key:"yes",
                                    title:text["yes"][allVariables.lang]
                                },
                                {
                                    key:"no",
                                    title:text["no"][allVariables.lang]
                                }
                            ],
                            id:"key",
                            output:"title",
                            onchange:e=>{
                                const value = e.target.value;
                                const block = $(`div#${taxBlockId}`);
                                if(value ==="yes"){
                                    block.css({
                                        display:"block"
                                    });
                                }
                                if(value ==="no"){
                                    block.css({
                                        display:"none"
                                    });
                                }
                            }
                        })
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-tax-block-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.tax!==undefined ? settings.tax.blockid : null,
                            name:text["cart-form-tax-block"],
                            legend:text["cart-form-tax-block-select"][allVariables.lang],
                            onchange: e =>{
                                const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                if(Array.isArray(array) && array.length){
                                    $(e.target).parent("div").next("div").html(taxColumns({
                                        array:gen.getObjectFromJSON(array[0].columnsobjects),
                                        paymentmethodcolumnname:null
                                    }));
                                }  
                            }
                        }),
                        extra:(s=>{
                                if(s !== undefined && s !== null && s.agent !== undefined){
                                    const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.tax.blockid);});
                                        return  taxColumns({
                                            array:gen.getObjectFromJSON(array[0].columnsobjects),
                                            taxcolumnname:s.tax.taxcolumnname,
                                            taxcomissioncolumn:s.tax.taxcomissioncolumn
                                        });
                                }
                                return null;
                               
                            })(settings)
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-operation-number-column-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.row!==undefined ? settings.row.operationnumbercolumn: null,
                            name:text["cart-form-operation-number-column"],
                            legend:text["cart-form-operation-number-column-select"][allVariables.lang],
                            array:gen.getObjectFromJSON(row.columnsobjects),
                            id:"key",
                            output:"title"
                        })
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-client-column-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.row!==undefined ? settings.row.clientcolumn: null,
                            name:text["cart-form-client-column"],
                            legend:text["cart-form-client-column-select"][allVariables.lang],
                            array:gen.getObjectFromJSON(row.columnsobjects),
                            id:"key",
                            output:"title"
                        })
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-amount-paid-column-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.row!==undefined ? settings.row.amoutpaidcolumn: null,
                            name:text["cart-form-amount-paid-column"],
                            legend:text["cart-form-amount-paid-column-select"][allVariables.lang],
                            array:gen.getObjectFromJSON(row.columnsobjects),
                            id:"key",
                            output:"title"
                        })
                    }),
                    __objects.blockMaker({
                        title:text["cart-form-payment-method-column-title"][allVariables.lang],
                        content:__objects.blockList({
                            editedvalue:settings!== null && settings!==undefined && settings.row!==undefined ? settings.row.paymentmethodcolumn: null,
                            name:text["cart-form-payment-method-column"],
                            legend:text["cart-form-amount-payment-method-column-select"][allVariables.lang],
                            array:gen.getObjectFromJSON(row.columnsobjects),
                            id:"key",
                            output:"title"
                        })
                    })
                    ]).init();
                },
                save:(__functionOptions) =>{
                    const validation = gen.getInputValueFromValidation([
                        {
                            dom:"input",
                            type:"text",
                            name:text["cart-form-rate-symbol-name"],
                            property:"ratesymbol",
                            warning:text["cart-form-rate-symbol-name-warning"][allVariables.lang]
                        },
                        {   
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-select"],
                            property:"clientblock",
                            warning:text["cart-form-client-block-select-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-client-fullname-column"],
                            property:"clientfullnamecolumn",
                            warning:text["cart-form-client-block-client-fullname-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-client-fullname-column-output"],
                            property:"clientfullnamecolumnoutput",
                            warning:text["cart-form-client-block-client-fullname-column-output-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-client-photo-column"],
                            property:"clientphotocolumn",
                            warning:text["cart-form-client-block-client-photo-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-select-product-block"],
                            property:"productblock",
                            warning:text["cart-form-select-product-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-product-name-column"],
                            property:"productnamecolumn",
                            warning:text["cart-form-product-name-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-product-price-column"],
                            property:"productpricecolumn",
                            warning:text["cart-form-product-price-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-product-photo-column"],
                            property:"productphotocolumn",
                            warning:text["cart-form-product-photo-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-activate-agent-block"],
                            property:"agentblockactivation",
                            warning:text["cart-form-activate-agent-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-select-agent-block"],
                            property:"agentblock",
                            warning:text["cart-form-select-agent-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-agent-fullname-column"],
                            property:"agentfullnamecolumn",
                            warning:text["cart-form-client-block-agent-fullname-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-agent-photo-column"],
                            property:"agentphotocolumn",
                            warning:text["cart-form-client-block-agent-photo-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-activate-payment-method-block"],
                            property:"paymentmethodactivation",
                            warning:text["cart-form-activate-payment-method-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-select-payment-method-block"],
                            property:"paymentmethodblock",
                            warning:text["cart-form-select-payment-method-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-payment-method-name-column"],
                            property:"paymentmethodcolumname",
                            warning:text["cart-form-client-block-payment-method-name-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-activate-tax-block"],
                            property:"taxblockactivation",
                            warning:text["cart-form-activate-tax-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-tax-block"],
                            property:"taxblock",
                            warning:text["cart-form-tax-block-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-block-tax-column-name"],
                            property:"taxcolumnname",
                            warning:text["cart-form-client-block-tax-column-name-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-tax-block-comission-column"],
                            property:"taxcomissioncolumn",
                            warning:text["cart-form-tax-block-comission-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-amount-paid-column"],
                            property:"amoutpaidcolumn",
                            warning:text["cart-form-amount-paid-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-client-column"],
                            property:"clientcolumn",
                            warning:text["cart-form-client-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-operation-number-column"],
                            property:"operationnumbercolumn",
                            warning:text["cart-form-operation-number-column-warning"][allVariables.lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["cart-form-payment-method-column"],
                            property:"paymentmethodcolumn",
                            warning:text["cart-form-payment-method-column-warning"][allVariables.lang]
                        }
                    ]);

                    if(__objects.validateFormType() === false){return false;}
                    if(validation === false){return false}
                    if(validation.clientfullnamecolumn.value === null || validation.clientfullnamecolumn.value.filter(item=>{return item!==""}).length < 1){
                        swal(
                            text["alert"][allVariables.lang],
                            text["cart-form-client-block-client-columns-warning"][allVariables.lang],
                            "warning"
                        );
                        $(`select[name="${text["cart-form-client-block-client-fullname-column"]}"]`).focus();
                        return false;
                    };
                    if(validation.agentfullnamecolumn.value === null || validation.agentfullnamecolumn.value.filter(item=>{return item!==""}).length < 1){
                        swal(
                            text["alert"][allVariables.lang],
                            text["cart-form-client-block-agent-fullname-column-warning"][allVariables.lang],
                            "warning"
                        );
                        $(`select[name="${text["cart-form-client-block-agent-fullname-column"]}"]`).focus();
                        return false;
                    };
                  
                       __objects.saveSettings({
                        customizedsettings:{
                            rate:{
                                ratesymbol:validation.ratesymbol
                            },
                            client:{
                                blockid:validation.clientblock.value,
                                clientfullnamecolumn:validation.clientfullnamecolumn.value.filter(item=>{return item!==""}),
                                clientfullnamecolumnoutput:validation.clientfullnamecolumnoutput.value,
                                clientphotocolumn:validation.clientphotocolumn.value
                            },
                            product:{
                                blockid:validation.productblock.value,
                                productnamecolumn:validation.productnamecolumn.value,
                                productpricecolumn:validation.productpricecolumn.value,
                                productphotocolumn:validation.productphotocolumn.value
                            },
                            agent:{
                                agentblockactivation:validation.agentblockactivation.value,
                                blockid:validation.agentblock.value,
                                agentfullnamecolumn:validation.agentfullnamecolumn.value.filter(item=>{return item!==""}),
                                agentphotocolumn:validation.agentphotocolumn.value
                            },
                            paymentmethod:{
                                paymentmethodactivation:validation.paymentmethodactivation.value,
                                blockid:validation.paymentmethodblock.value,
                                paymentmethodcolumname:validation.paymentmethodcolumname.value
                            },
                            tax:{
                                taxblockactivation:validation.taxblockactivation.value,
                                blockid:validation.taxblock.value,
                                taxcolumnname:validation.taxcolumnname.value,
                                taxcomissioncolumn:validation.taxcomissioncolumn.value
                            },
                            row:{
                                amoutpaidcolumn:validation.amoutpaidcolumn.value,
                                clientcolumn:validation.clientcolumn.value,
                                operationnumbercolumn:validation.operationnumbercolumn.value,
                                paymentmethodcolumn:validation.paymentmethodcolumn.value
                            }
                        },
                        warning:text["save-cart-form-warning"][allVariables.lang],
                        success:text["save-cart-form-success"][allVariables.lang]
                       });
                }
            },
            bookingform:{
                init:(__functionOptions) =>{
                    const settings = __functionOptions.settings;
                    const availabilityColumnSetter = function(__annonymFunctionOptions){
                        const type = __annonymFunctionOptions.type;
                        let columnsObjects = undefined;
                        if(Array.isArray(__annonymFunctionOptions.array)
                        && __annonymFunctionOptions.array.length > 0
                        && typeof(__annonymFunctionOptions.array[0]) ==="object"
                        && __annonymFunctionOptions.array[0].hasOwnProperty("columnsobjects")
                        && __annonymFunctionOptions.array[0].columnsobjects !== null
                        ){
                           columnsObjects = gen.getObjectFromJSON(__annonymFunctionOptions.array[0].columnsobjects);
                        }
                        const columnList = function(__objects){
                            return gen.dropDownFromArray({
                                array:columnsObjects,
                                id:"key",
                                output:"title",
                                legend:__objects.legend,
                                editedvalue:__objects.editedvalue,
                                attr:{
                                    name:__objects.name,
                                    class:"form-control"
                                },
                                css:{
                                    marginBottom:"5px"
                                }
                            });
                        };
                        let children = [];
                        switch(type){
                            case "room":
                                children = [
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["room"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["room"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.roomtype!== undefined ? __annonymFunctionOptions.columns.roomtype : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["price"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["price"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.roomprice!== undefined ? __annonymFunctionOptions.columns.roomprice : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["number"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["number"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.roomnumber!== undefined ? __annonymFunctionOptions.columns.roomnumber : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["range"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["range"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.roomrange!== undefined ? __annonymFunctionOptions.columns.roomrange : null
                                        })
                                    }
                                ];
                            break;
                            case "client":
                                children = [
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["first-name"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["first-name"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientfirstname!== undefined ? __annonymFunctionOptions.columns.clientfirstname : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["last-name"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["last-name"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientlastname!== undefined ? __annonymFunctionOptions.columns.clientlastname : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nick-name"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nick-name"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientnickname!== undefined ? __annonymFunctionOptions.columns.clientnickname : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["sex"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["sex"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientsex!== undefined ? __annonymFunctionOptions.columns.clientsex : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nationality"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nationality"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientnationality!== undefined ? __annonymFunctionOptions.columns.clientnationality : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idnumber"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idnumber"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientidnumber!== undefined ? __annonymFunctionOptions.columns.clientidnumber : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idcopy"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idcopy"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientidcopy!== undefined ? __annonymFunctionOptions.columns.clientidcopy : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofchildren"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofchildren"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientnumberofchildren!== undefined ? __annonymFunctionOptions.columns.clientnumberofchildren : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofadult"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofadult"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientnumberofadult!== undefined ? __annonymFunctionOptions.columns.clientnumberofadult : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["email"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["email"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientemail!== undefined ? __annonymFunctionOptions.columns.clientemail : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["telephone"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["telephone"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clienttelephone!== undefined ? __annonymFunctionOptions.columns.clienttelephone : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["address"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["address"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientaddress!== undefined ? __annonymFunctionOptions.columns.clientaddress : null
                                        })
                                    }
                                ];
                            break;
                            case "savingrecords":
                                children = [
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["clientid"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["clientid"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.clientid!== undefined ? __annonymFunctionOptions.columns.clientid : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["roomid"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["roomid"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.roomid!== undefined ? __annonymFunctionOptions.columns.roomid : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["daynumber"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["daynumber"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.daynumber!== undefined ? __annonymFunctionOptions.columns.daynumber : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkin"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkin"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.checkindate!== undefined ? __annonymFunctionOptions.columns.checkindate : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkout"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkout"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.checkoutdate!== undefined ? __annonymFunctionOptions.columns.checkoutdate : null
                                        })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:columnList({
                                            legend:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["amounttopay"]["legend"][lang],
                                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["amounttopay"]["name"],
                                            editedvalue:__annonymFunctionOptions.columns!== null && __annonymFunctionOptions.columns !== undefined && __annonymFunctionOptions.columns.amounttopay!== undefined ? __annonymFunctionOptions.columns.amounttopay : null
                                        })
                                    }
                                ];
                            break;
                        }
                        return gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:children
                            }
                        ]).init();
                    };
                    const roomSection = $(gen.createEl("div")),
                    clientSection = $(gen.createEl("div")),
                    savingRecordSection = $(gen.createEl("div"));
                    return gen.objectInterfaceMaker([
                        __objects.blockMaker({
                            title:text["booking-form-features"]["settings"]["availability-block"]["title"][lang],
                            content:__objects.blockList({
                                editedvalue: settings!==null && typeof(settings) ==="object" && settings.hasOwnProperty("availability") ? settings.availability.room.blockid : null,
                                name:text["booking-form-features"]["settings"]["availability-block"]["block-name"],
                                legend:text["booking-form-features"]["settings"]["availability-block"]["legend"][lang],
                                onchange: e =>{
                                    const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                    if(Array.isArray(array) && array.length){
                                        roomSection.html(availabilityColumnSetter({
                                            array:array,
                                            type:"room"
                                        }));
                                    }  
                                }
                            }),
                            extra:(s=>{
                                if(settings!==null 
                                    && typeof(settings) ==="object" 
                                    && settings.hasOwnProperty("availability")
                                    && settings.availability.hasOwnProperty("client")
                                    && settings.availability.room.columns !== null
                                    && settings.availability.room.columns !== undefined
                                    && settings.availability.room.columns instanceof Object
                                    ){
                                        const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.availability.room.blockid);});
                                        return roomSection.html(availabilityColumnSetter({
                                            array:array,
                                            columns:settings.availability.room.columns,
                                            type:"room"
                                        }));
                                }
                                return roomSection;
                            })(settings)
                        }),
                        __objects.blockMaker({
                            title:text["booking-form-features"]["settings"]["client-block"]["title"][lang],
                            content:__objects.blockList({
                                editedvalue: settings!==null && typeof(settings) ==="object" && settings.hasOwnProperty("availability") ? settings.availability.client.blockid : null,
                                name:text["booking-form-features"]["settings"]["client-block"]["block-name"],
                                legend:text["booking-form-features"]["settings"]["client-block"]["legend"][lang],
                                onchange: e =>{
                                    const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                    if(Array.isArray(array) && array.length){
                                        clientSection.html(availabilityColumnSetter({
                                            array:array,
                                            type:"client"
                                        }));
                                    }  
                                }
                            }),
                            extra:(s=>{
                                if(settings!==null 
                                    && typeof(settings) ==="object" 
                                    && settings.hasOwnProperty("availability")
                                    && settings.availability.hasOwnProperty("client")
                                    && settings.availability.client.columns !== null
                                    && settings.availability.client.columns !== undefined
                                    && settings.availability.client.columns instanceof Object
                                    ){
                                        const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(s.availability.client.blockid);});
                                        return clientSection.html(availabilityColumnSetter({
                                            array:array,
                                            columns:settings.availability.client.columns,
                                            type:"client"
                                        }));
                                }
                                return clientSection;
                            })(settings)
                        }),
                        __objects.blockMaker({
                            title:text["booking-form-features"]["settings"]["saving-record-block"]["title"][lang],
                            content:__objects.blockList({
                                self:true,
                                editedvalue: settings!==null && typeof(settings) ==="object" && settings.hasOwnProperty("availability") ? settings.availability.client.blockid : null,
                                name:text["booking-form-features"]["settings"]["saving-record-block"]["block-name"],
                                legend:text["booking-form-features"]["settings"]["saving-record-block"]["legend"][lang],
                                onchange: e =>{
                                    const array = e.data.array.filter(item=>{return parseInt(item[0]) === parseInt(e.target.value);});
                                    if(Array.isArray(array) && array.length){
                                        savingRecordSection.html(availabilityColumnSetter({
                                            array:array,
                                            type:"savingrecords"
                                        }));
                                    }  
                                }
                            }),
                            extra:(s=>{
                                if(s!==null 
                                    && typeof(s) ==="object" 
                                    && s.hasOwnProperty("availability")
                                    && s.availability.hasOwnProperty("savingrecords")
                                    && s.availability.savingrecords.columns !== null
                                    && s.availability.savingrecords.columns !== undefined
                                    && s.availability.savingrecords.columns instanceof Object
                                    ){
                                        const array = blocks.filter(item=>{return parseInt(item[0]) === parseInt(row[0]);});
                                        return savingRecordSection.html(availabilityColumnSetter({
                                            array:array,
                                            columns:s.availability.savingrecords.columns,
                                            type:"savingrecords"
                                        }));
                                }
                                return savingRecordSection;
                            })(settings)
                        })
                    ]).init();
                },
                save:(__functionOptions) =>{
                    const validation = gen.getInputValueFromValidation([
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["block-name"],
                            property:"roomblock",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["room"]["name"],
                            property:"roomcolumn",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["room"]["warning"][lang] 
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["price"]["name"],
                            property:"pricecolumn",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["price"]["warning"][lang] 
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["number"]["name"],
                            property:"numbercolumn",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["number"]["warning"][lang] 
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["range"]["name"],
                            property:"rangecolumn",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["range"]["warning"][lang] 
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["client-block"]["block-name"],
                            property:"clientblock",
                            warning:text["booking-form-features"]["settings"]["client-block"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["first-name"]["name"],
                            property:"clientfirstname",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["first-name"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["last-name"]["name"],
                            property:"clientlastname",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["last-name"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nick-name"]["name"],
                            property:"clientnickname",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nick-name"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["sex"]["name"],
                            property:"clientsex",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["sex"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nationality"]["name"],
                            property:"clientnationality",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["nationality"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idnumber"]["name"],
                            property:"clientidnumber",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idnumber"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idcopy"]["name"],
                            property:"clientidcopy",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["idcopy"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofchildren"]["name"],
                            property:"clientnumberofchildren",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofchildren"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofadult"]["name"],
                            property:"clientnumberofadult",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["numberofadult"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["email"]["name"],
                            property:"clientemail",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["email"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["telephone"]["name"],
                            property:"clienttelephone",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["telephone"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["address"]["name"],
                            property:"clientaddress",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["client"]["address"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["saving-record-block"]["block-name"],
                            property:"savingrecordsblock",
                            warning:text["booking-form-features"]["settings"]["saving-record-block"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["clientid"]["name"],
                            property:"savingrecordsclientid",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["clientid"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["roomid"]["name"],
                            property:"savingrecordsroomid",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["roomid"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["daynumber"]["name"],
                            property:"savingrecordsdaynumber",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["daynumber"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkin"]["name"],
                            property:"savingrecordscheckin",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkin"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkout"]["name"],
                            property:"savingrecordscheckout",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["checkout"]["warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["amounttopay"]["name"],
                            property:"savingrecordsamounttopay",
                            warning:text["booking-form-features"]["settings"]["availability-block"]["columns"]["saving-records"]["amounttopay"]["warning"][lang]
                        }
                    ]);
                    if(validation === false){return false;}
                    __objects.saveSettings({
                        customizedsettings:{
                            availability:{
                                client:{
                                    blockid:validation.clientblock.value,
                                    columns:{
                                        clientfirstname:validation.clientfirstname.value,
                                        clientlastname:validation.clientlastname.value,
                                        clientnickname:validation.clientnickname.value,
                                        clientsex:validation.clientsex.value,
                                        clientnationality:validation.clientnationality.value,
                                        clientidnumber:validation.clientidnumber.value,
                                        clientidcopy:validation.clientidcopy.value,
                                        clientnumberofchildren:validation.clientnumberofchildren.value,
                                        clientnumberofadult:validation.clientnumberofadult.value,
                                        clientemail:validation.clientemail.value,
                                        clienttelephone:validation.clienttelephone.value,
                                        clientaddress:validation.clientaddress.value
                                    }
                                },
                                room:{
                                    blockid:validation.roomblock.value,
                                    columns:{
                                        roomtype:validation.roomcolumn.value,
                                        roomprice:validation.pricecolumn.value,
                                        roomnumber:validation.numbercolumn.value,
                                        roomrange:validation.rangecolumn.value,
                                       
                                    }
                                },
                                savingrecords:{
                                    blockid:validation.savingrecordsblock.value,
                                    columns:{
                                        clientid:validation.savingrecordsclientid.value,
                                        roomid:validation.savingrecordsroomid.value,
                                        daynumber:validation.savingrecordsdaynumber.value,
                                        checkindate:validation.savingrecordscheckin.value,
                                        checkoutdate:validation.savingrecordscheckout.value,
                                        amounttopay:validation.savingrecordsamounttopay.value
                                    }
                                }
                               
                            }
                        },
                        warning:text["booking-form-features"]["settings"]["save-warning"][lang],
                        success:text["booking-form-features"]["settings"]["save-success"][lang]
                    });
                }
            },
            saveSettings:(__functionOptions) =>{
                const action = function(){
                    const settings = __objects.customizedFormSettings({
                        customizedsettings:__functionOptions.customizedsettings
                    });
                    gen.url(false, gen.serverSideUrl, {
                        key: "sqledit",
                        table: "sdappblockreference",
                        fieldandvalues: {
                            customizedformsettings:settings
                        },
                        referencefield: "blockid",
                        referenceid: row[0]
                    }, false, 1);
                    sdapp.sdapp_Access_Menu({
                        key:"sdapp-builder-all-data-blocks"
                    });
                };
                gen.sweetWarningMsgBox(
                    action,
                    text["alert"][allVariables.lang],
                    __functionOptions.warning,
                    __functionOptions.success,
                    text["sdapp-no-action-done"][allVariables.lang]
                );
                
            }
        };
        this.objects = __objects;
        if(__constructorOptions.hasOwnProperty("importing-ressources") && __constructorOptions["importing-ressources"] === true){
            return this.objects;
        }
        else{
            $(allVariables.appsection).html(sdapp.replaceScriptWithUI({
                returncontent:true,
                title:gen.jsonCharReplacer(gen.superReplacer(text["customized-form-title"][allVariables.lang],"@blockname",row["blockname"]),-1),
                html:__objects.init(),
                textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
                rightoptions: {
                    title: "",
                    iconColor: "#fff",
                    icon: "icon-options icons",
                    submenus: {
                        newblock:{
                            title:text["new-block"][allVariables.lang],
                            icon:"fa fa-plus",
                            callback: e =>{
                                e.preventDefault();
                                sdapp.sdapp_Access_Menu({
                                    key:"sdapp-builder-add-data-block"
                                });
                            }
                        },
                        allblocks:{
                            title:text["all-blocks"][allVariables.lang],
                            icon:"fa fa-circle-o",
                            callback: e=>{
                                e.preventDefault();
                                sdapp.sdapp_Access_Menu({
                                    key:"sdapp-builder-all-data-blocks"
                                });
                            }
                        }
                    }
                }
            }));
            gen.selectDropdownChildrenMultipleSelection();
        }
       
    
    }
}