class sdapp_input_events_configurations{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        const row = __constructorOptions.row;
        const __row = row;
        const themeId = row.themeid;
        const lang = allVariables.lang;
        const importingModules = __constructorOptions.import;
        const __objects = {
            init:()=>{
                const columnsSection = $(gen.createEl("div")).css({
                    border:"1px #ccc solid",
                    marginTop:"50px",
                    borderRadius:"5px"
                });
                 columnsSection.html(__objects.tableColumns({}));
                 return columnsSection;
            },
            tableColumns:(__functionOptions) =>{
                const table = $(gen.createEl("table"));
                const tbody = $(gen.createEl("tbody")),rows = [];
                const columns = gen.getObjectFromJSON(row["columnsobjects"]);
                rows[rows.length] = gen.tableRow([
                    {
                        html:text["column"][lang],
                        css:{
                            textTransform:"uppercase",
                            fontWeight:"bolder"
                        },
                        attr:{
                            colspan:2
                        }
                    }
                ]);
                if(Array.isArray(columns) && columns.length > 0){
                    columns.filter(item=>{ return item.key !== text["event-settings"]["form"]["event-key"];}).forEach(item=>{
                        const columnName = gen.jsonCharReplacer(item.title,-1);
                        const tdEQ_1 = $(gen.createEl("div"));
                        tdEQ_1.html(columnName);
                        rows[rows.length] = gen.tableRow([
                            {
                                html:(td,tr) =>{
                                    const input = $(gen.createEl("input")).attr({type:"checkbox",name:text["filter-duplication-column"],value:item.key});
                                    if(item!== null && item!== undefined && item.hasOwnProperty("events")){
                                        input.prop("checked",true);
                                        tdEQ_1.append(__objects.setEvents({
                                            tr:tr,
                                            columnname:columnName,
                                            item:item,
                                            row:__row,
                                            columns:columns,
                                            returncontent:true
                                        }));
                                    }
                                    input.on("click",e=>{
                                        if(e.target.checked === true){
                                            __objects.setEvents({
                                                tr:tr,
                                                columnname:columnName,
                                                item:item,
                                                row:__row,
                                                columns:columns
                                            });
                                        }
                                        else{
                                            $(tr).children(`td:eq(1)`).html(columnName);
                                        }
                                    });
                                    return input;
                                }
                            },
                            {
                                html:tdEQ_1
                            }
                        ]);
                    });
                }
                //form starts
                rows[rows.length] = gen.tableRow([
                    {
                        html:text["event-settings"]["form"]["title"][lang],
                        css:{
                            textTransform:"uppercase",
                            fontWeight:"bolder"
                        },
                        attr:{
                            colspan:2
                        }
                    }
                ]);
                let formItem = {
                    key:text["event-settings"]["form"]["event-key"],
                    title:text["event-settings"]["form"]["event-name"][lang],
                    datatype:"form",
                    dynamiclistdata:"0",
                    isdeleted:"0",
                    isretrievable:"0",
                    listdata:"0",
                    readmorereference:"none"
                };
                const tdEQ_2 = $(gen.createEl("div"));
                tdEQ_2.html(formItem.title);
                rows[rows.length] = gen.tableRow([
                    {
                        html:(td,tr)=>{
                            
                            if(columns.map(item=>{return item.key;}).includes(formItem.key) === false){
                                columns[columns.length] = formItem;
                            }
                            else{
                                formItem = columns.filter(item=>{ return item.key ===formItem.key;})[0];
                            }
                            //console.log(columns);
                            me.columns = columns;
                            const input = $(gen.createEl("input")).attr({type:"checkbox",name:text["filter-duplication-column"],value:formItem.key});
                            if(formItem!== null && formItem!== undefined && formItem.hasOwnProperty("events")){
                                input.prop("checked",true);
                                tdEQ_2.append(__objects.setEvents({
                                    tr:tr,
                                    columnname:formItem.title,
                                    item:formItem,
                                    row:__row,
                                    columns:columns,
                                    returncontent:true
                                }));
                            } 
                            input.on("click",e=>{
                                if(e.target.checked === true){
                                    __objects.setEvents({
                                        tr:tr,
                                        columnname:formItem.title,
                                        item:formItem,
                                        row:__row,
                                        columns:columns
                                    });
                                }
                                else{
                                    $(tr).children(`td:eq(1)`).html(formItem.title);
                                }
                            });
                            return input;
                        }
                    },
                    {
                        html:tdEQ_2
                    }
                ]);
                //form ends
                tbody.html(rows);
                table.html(tbody);
                table.attr({class:"table table-striped",width:"100%"});
                gen.removeBorderFromTable({
                    type:"all",
                    table:table
                })
                return table;
            },
            setEvents:(__functionOptions) =>{
                const td =$(__functionOptions.tr).children(`td:eq(1)`);
                const UI = $(gen.createEl("div"));
                const childrenSection = $(gen.createEl("div"));
                const sdappRow = `input-vent-row-${__functionOptions.item.key}`;
                const addRow = `input-event-add-row-${__functionOptions.item.key}`;
                const column = __functionOptions.item;
                if(column.hasOwnProperty("events") && Array.isArray(column.events) && column.events.length > 0){
                    let rowsUI =[];
                    for(let i = 0; i < column.events.length; i++){
                        const event = column.events[i];
                        rowsUI.push(__objects.eventBlock({
                            sdapprow:sdappRow,
                            event:event,
                            columns:__functionOptions.columns,
                            column:column
                        }));
                    }
                    childrenSection.html(rowsUI);
                }
                UI.html(gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row"
                        },
                        css:{
                            border:"1px #ccc solid",
                            width:"100%",
                            marginTop:"10px",
                            borderRadius:"5px",
                            padding:"5px",
                            backgroundColor:"#fff"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    marginBottom:"10px"
                                },
                                html:() =>{
                                    return gen.anchor({
                                        title:text["input-new-event"][allVariables.lang],
                                        icon:"fa fa-plus",
                                        css:{
                                            cursor:"pointer"
                                        },
                                        attr:{
                                           sdapp:addRow
                                        },
                                        callback:e=>{
                                            e.preventDefault();
                                            childrenSection.append(__objects.eventBlock({
                                                sdapprow:sdappRow,
                                                columns:__functionOptions.columns,
                                                column:__functionOptions.item
                                            }));
                                        }
                                    })
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    textAlign:"right"
                                },
                                html:() =>{
                                    return gen.anchor({
                                        title:text["save-input-events"][allVariables.lang],
                                        icon:"fa fa-save",
                                        css:{
                                            cursor:"pointer",
                                            textAlign:"right"
                                        },
                                        callback:e=>{
                                            e.preventDefault();
                                            const rows = document.querySelectorAll(`div[sdapp="${sdappRow}"]`);
                                            let events = [];
                                            let countValidation = 0;
                                            if(rows.length < 1){
                                                $(`a[sdapp="${addRow}"]`)[0].click();
                                            }
                                            rows.forEach(item=>{
                                                const eventType = $(item).find(`select[name="input-event-type"]`);
                                                const eventFunction = $(item).find(`select[name="input-event-function"]`);
                                                const defaultWarning = $(item).find(`textarea[name="input-event-default-warning"]`);
                                                if(eventType.val().length < 1){
                                                    swal(
                                                        text["alert"][allVariables.lang],
                                                        text["input-event-type-warning"][allVariables.lang],
                                                        "warning"
                                                    );
                                                    eventType.focus();
                                                    return false;
                                                }
                                                if(eventFunction.val().length < 1){
                                                    swal(
                                                        text["alert"][allVariables.lang],
                                                        text["input-event-function-warning"][allVariables.lang],
                                                        "warning"
                                                    );
                                                    eventFunction.focus();
                                                    return false;
                                                }
                                                if(defaultWarning.val().length < 1){
                                                    swal(
                                                        text["alert"][allVariables.lang],
                                                        text["input-event-default-warning"][allVariables.lang],
                                                        "warning"
                                                    );
                                                    defaultWarning.focus();
                                                    return false;
                                                }
                                                const extraFeatures = __objects.functionExtraFeatures({
                                                    function:eventFunction.val(),
                                                    columns:__functionOptions.columns,
                                                    section:childrenSection
                                                });
                                                if(extraFeatures.status === 404){
                                                    swal(
                                                        text["alert"][allVariables.lang],
                                                        extraFeatures.warning,
                                                        "warning"
                                                    );
                                                    if(extraFeatures.input!== null && extraFeatures.input !== undefined){
                                                        extraFeatures.input.focus();
                                                    }
                                                    return false;
                                                }
                                                countValidation ++;
                                                events.push({
                                                    eventtype:eventType.val(),
                                                    event:text["input-event-types"].filter(ev=>{return parseInt(ev.key) === parseInt(eventType.val())})[0].event,
                                                    eventfunction:eventFunction.val(),
                                                    eventfunctionname:text["input-event-functions"].filter(func=>{return parseInt(eventFunction.val()) === parseInt(func.key);})[0].name,
                                                    eventdefautwarning:defaultWarning.val(),
                                                    extrafeatures:extraFeatures.data
                                                });
                                            });
                                            __functionOptions.item.events = events;
                                            const action = function(){
                                                const columnsObjects = me.columns;//gen.getObjectFromJSON(__functionOptions.row["columnsobjects"]);
                                                //console.log(me.columns);
                                                //console.log(columnsObjects);
                                                let columns = [];
                                                for(let i = 0; i < columnsObjects.length; i++){
                                                    const newItem = columnsObjects[i];
                                                    if(newItem.key === __functionOptions.item.key){
                                                        newItem.events = events;
                                                    }
                                                    columns.push(newItem);
                                                }
                                                //console.log(columns);
                                                //return false;
                                                gen.url(false, gen.serverSideUrl, {
                                                    key: "sqledit",
                                                    table: " sdappblockreference",
                                                    fieldandvalues: {
                                                        columnsobjects:columns,
                                                    },
                                                    referencefield:"blockid",
                                                    referenceid: __functionOptions.row[0]
                        
                                                }, false, 1);
                                                document.location = document.URL;
                                            };
                                            if(countValidation === rows.length){
                                                gen.sweetWarningMsgBox(
                                                    action,
                                                    text["alert"][allVariables.lang],
                                                    text["save-input-event-warning"][allVariables.lang],
                                                    text["save-input-event-success"][allVariables.lang],
                                                    text["sdapp-no-action-done"][allVariables.lang]
                                                );
                                            }
                                            
                                            
                                        }
                                    })
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                html:childrenSection

                            }
                        ]
                    }
                ]).init());
                if(__functionOptions.hasOwnProperty("returncontent") && __functionOptions.returncontent === true){
                    return UI;
                }
                td.append(UI);
            },
            functionExtraFeatures:(__functionOptions) =>{
                const __functionType = parseInt(__functionOptions.function);
                const section = __functionOptions.section;
                const columns = __functionOptions.columns;
                if(__functionType === 2){
                    return __objects.columnValueMatch({
                        section:section,
                        columns:columns
                    });
                }
                if(__functionType === 3){
                    return __objects.passwordStrength({
                        section:section,
                        columns:columns
                    });
                }
                if(__functionType === 5){
                    return __objects.redirectionCallBack({
                        section:section,
                        columns:columns
                    });
                }
                if(__functionType === 6){
                    return __objects.duplicateMyValueOnAnotherInput({
                        section:section,
                        columns:columns
                    });
                }
                if(__functionType === 7){
                    return __objects.displayInputWithIfStatement({
                        section:section,
                        columns:columns
                    });
                }
                return {
                    status:200,
                    data:null
                };

            },
            displayInputWithIfStatement:(__functionOptions)=>{
                const section = __functionOptions.section;
                const comparaisonOperator = $(section).find(`select[name="${text["comparison-operators"]["input-name"]}"]`);
                const __xValue = $(section).find(`input[type="text"][name="${text["displayinputwithifstatement"]["x"]["name"]}"]`);
                const hiddenInputs = $(section).find(`input[type="checkbox"][name="${text["displayinputwithifstatement"]["hiddeninputs"]["name"]}"]`);
                let data = {};
                if(comparaisonOperator.length > 0){
                    if(comparaisonOperator.val().length < 1){
                        return {
                            status:404,
                            data:undefined,
                            warning:text["comparison-operators"]["warning"][lang],
                            input:comparaisonOperator
                        };
                    }
                    data.comparaisonoperator = comparaisonOperator.val();
                }
                if(__xValue.length > 0){
                    if(__xValue.val().length < 1){
                        return {
                            status:404,
                            data:undefined,
                            warning:text["displayinputwithifstatement"]["x"]["warning"][lang],
                            input:__xValue
                        };
                    }
                    data.xvalue = __xValue.val();
                }
                if(hiddenInputs.length > 0){
                    let theHiddenInputs = [];
                    let n = 0;
                    for(let el of hiddenInputs){
                        if(el.checked === true){
                            theHiddenInputs.push(el.value);
                            n++;
                        }
                    }
                    if(n<1){
                        return {
                            status:404,
                            data:undefined,
                            warning:text["displayinputwithifstatement"]["hiddeninputs"]["warning"][lang],
                            input:theHiddenInputs[0]
                        };
                    }
                    data.hiddeninputs = theHiddenInputs;
                }
                return {
                    status:200,
                    data:data
                }
            },
            duplicateMyValueOnAnotherInput:(__functionOptions)=>{
                const section = __functionOptions.section;
                const duplicationColumn = $(section).find(`select[name="${text["event-settings"]["form"]["event-functions"]["duplicate-my-value-on-another-input"]["input-name"]}"]`);
                if(duplicationColumn.length > 0){
                    if(duplicationColumn.val().length < 1){
                        return {
                            status:404,
                            data:undefined,
                            warning:text["event-settings"]["form"]["event-functions"]["duplicate-my-value-on-another-input"]["warning"][lang],
                            input:duplicationColumn
                        };
                    }
                }
                return {
                    status:200,
                    data:{
                        duplicationcolumn:duplicationColumn.val()
                    }
                }

            },
            redirectionCallBack:(__functionOptions)=>{
                const section = __functionOptions.section;
                const page = $(section).find(`select[name="${text["event-settings"]["form"]["event-functions"]["redirection-callback"]["input-name"]}"]`);
                if(page.length > 0){
                    if(page.val().length < 1){
                        return {
                            status:404,
                            data:undefined,
                            warning:text["event-settings"]["form"]["event-functions"]["redirection-callback"]["warning"][lang],
                            input:page
                        };
                    }
                }
                return {
                    status:200,
                    data:{
                        redirectedpage:page.val()
                    }
                }

            },
            passwordStrength:(__functionOptions)=>{
                const section = __functionOptions.section;
                const __options = [];
                const checkboxes = $(section).find(`input[type="checkbox"][name="${text["event-settings"]["password-strength"]["name"]}"]:checked`);
                if(checkboxes.length!== undefined && checkboxes.length !== null && checkboxes.length > 0){
                    for(let i = 0; i< checkboxes.length; i++){
                        const element = $(checkboxes[i]);
                        const key = parseInt(element.val());
                        const exec = function(objects){
                            let length = $(section).find(objects.lengthinput);
                            if(length.length > 0){
                                if(length.val().length < 1){
                                    return {
                                        status:404,
                                        data:undefined,
                                        warning:objects.lengthwarning,
                                        input:length
                                    };
                                }
                                length = parseInt(length.val());
                            }
                            let warning = $(section).find(objects.warninginput);
                            if(warning.length > 0){
                                if(warning.val().length < 1){
                                    return {
                                        status:404,
                                        data:undefined,
                                        warning:objects.warningwarning,
                                        input:warning
                                    };
                                }
                                warning = warning.val();
                            }
                            return {
                                status:200,
                                length:length,
                                warning:warning
                            }
                        };
                        let executer = {};
                        let humanDefinition = null;
                        if(key === 1){
                            //number
                            executer = exec({
                                lengthinput:`input[type="text"][name="${text["event-settings"]["password-strength"]["mixture"]["number"]["name"]}"]`,
                                lengthwarning:text["event-settings"]["password-strength"]["mixture"]["number"]["length-warning"][lang],
                                warninginput:`textarea[name="${text["event-settings"]["password-strength"]["mixture"]["number"]["warning-name"]}"]`,
                                warningwarning:text["event-settings"]["password-strength"]["mixture"]["number"]["warning-warning"][lang]
                            });
                            if(executer.status === 404){
                                return executer;
                            }
                            humanDefinition = "Number";
                        }

                        if(key === 2){
                            //special characters
                                executer = exec({
                                lengthinput:`input[type="text"][name="${text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["name"]}"]`,
                                lengthwarning:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["length-warning"][lang],
                                warninginput:`textarea[name="${text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["warning-name"]}"]`,
                                warningwarning:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["warning-warning"][lang]
                            });
                            if(executer.status === 404){
                                return executer;
                            }
                            humanDefinition = "Special characters";
                        }

                        if(key === 3){
                            //capital letter
                                executer = exec({
                                lengthinput:`input[type="text"][name="${text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["name"]}"]`,
                                lengthwarning:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["length-warning"][lang],
                                warninginput:`textarea[name="${text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["warning-name"]}"]`,
                                warningwarning:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["warning-warning"][lang]
                            });
                            if(executer.status === 404){
                                return executer;
                            }
                            humanDefinition = "Capital letters";
                        }

                        if(key === 4){
                            //lower case letter
                                executer = exec({
                                lengthinput:`input[type="text"][name="${text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["name"]}"]`,
                                lengthwarning:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["length-warning"][lang],
                                warninginput:`textarea[name="${text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["warning-name"]}"]`,
                                warningwarning:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["warning-warning"][lang]
                            });
                            if(executer.status === 404){
                                return executer;
                            }
                            humanDefinition = "Lower case letters";
                        }
                        
                       __options.push({
                            key:key,
                            humandefinition:humanDefinition,
                            length:executer.length,
                            warning:executer.warning
                        }); 
                    }
                }

                if(__options.length < 1){
                    return {
                        status:404,
                        data:undefined,
                        warning:"??"
                    }
                }
                const passwordlength = $(`input[type="text"][name="${text["event-settings"]["password-strength"]["password-length"]["name"]}"]`);
                const passwordlengthWarning = $(`textarea[name="${text["event-settings"]["password-strength"]["password-length-warning"]["name"]}"]`);
                if(passwordlength.val().length < 1){
                    return {
                        status:404,
                        data:undefined,
                        warning:text["event-settings"]["password-strength"]["password-length"]["warning"][lang],
                        input:passwordlength
                    }
                }
                if(passwordlengthWarning.val().length < 1){
                    return {
                        status:404,
                        data:undefined,
                        warning:text["event-settings"]["password-strength"]["password-length-warning"]["warning"][lang],
                        input:passwordlengthWarning
                    }
                }
                return {
                    status:200,
                    data:{
                        options:__options,
                        passwordlength:passwordlength.val(),
                        passwordlengthwarning:passwordlengthWarning.val()
                    }
                }
            },
            columnValueMatch:(__functionOptions)=>{
                const section = __functionOptions.section;
                const columns = __functionOptions.columns;
                let columnsForMatching = [];
                $(section).find(`input[type="checkbox"][name="${text["event-settings"]["columnvaluesmatch"]["select-column"]["name"]}"]:checked`).each(function(index,element){
                    const value = $(element).val();
                    const foundColumn = columns.filter(item =>{return item.key === value;});
                    columnsForMatching.push({
                        key:foundColumn[0].key,
                        title:foundColumn[0].title
                    });
                });

                if(columnsForMatching.length < 1){
                    return {
                        status:404,
                        data:undefined,
                        warning:text["event-settings"]["columnvaluesmatch"]["select-column"]["warning"][lang]
                    }
                }
                return {
                    status:200,
                    data:{
                        columns:columnsForMatching
                    }
                }
            },
            eventBlock:(__functionOptions) =>{
                const blockRow = $(gen.createEl("div"));
                      blockRow.css({
                          margin:"10px 0px 5px 0px"
                      });
                const event = __functionOptions.hasOwnProperty("event") ? __functionOptions.event : undefined;
                const eventExtraFeaturesSection = $(gen.createEl("div"));
                // action edit starts --------------------------------------------------------------
                      if(typeof(event) === "object"){
                        if(event.eventfunction !== null && event.eventfunction !== undefined){
                            const eventFunction = parseInt(event.eventfunction);
                            if(eventFunction === 2){
                                  __objects.events({
                                    section:eventExtraFeaturesSection,
                                    columns:__functionOptions.columns,
                                    column:__functionOptions.column,
                                    event:event
                                }).columnValuesMatch();
                            }
                            if(eventFunction === 3){
                                  __objects.events({
                                    section:eventExtraFeaturesSection,
                                    columns:__functionOptions.columns,
                                    column:__functionOptions.column,
                                    event:event
                                }).passwordStrength();
                            }
                            if(eventFunction === 5){
                                __objects.events({
                                  section:eventExtraFeaturesSection,
                                  columns:__functionOptions.columns,
                                  column:__functionOptions.column,
                                  event:event
                              }).redirectionCallBack();
                          }
                          if(eventFunction === 6){
                            __objects.events({
                              section:eventExtraFeaturesSection,
                              columns:__functionOptions.columns,
                              column:__functionOptions.column,
                              event:event
                          }).duplicateMyValueOnAnotherInput();
                        }
                       if(eventFunction === 7){
                        __objects.events({
                          section:eventExtraFeaturesSection,
                          columns:__functionOptions.columns,
                          column:__functionOptions.column,
                          event:event
                       }).displayInputWithIfStatement();
                      }
                        }
                    }
                // action edit ends -------------------------------------------------------------------
                return blockRow.html(gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:__functionOptions.sdapprow
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-3",
                                },
                                html:() =>{
                                    return gen.dropDownFromArray({
                                        editedvalue:event!== undefined ? parseInt(event.eventtype) : null,
                                        array:text["input-event-types"],
                                        id:"key",
                                        output:"name",
                                        attr:{
                                            class:"form-control",
                                            name:"input-event-type"
                                        },
                                        css:{
                                            marginBottom:"5px"
                                        },
                                        legend:text["select-input-event-types"][allVariables.lang],
                                        onchange:e=>{
                                            const eventTypeValue = parseInt(e.target.value);
                                            let count = 0;
                                            document.querySelectorAll(`div[sdapp="${__functionOptions.sdapprow}"]`).forEach(item=>{
                                                const eventType = $(item).find(`select[name="input-event-type"]`);
                                                const value = parseInt(eventType.val());
                                                if(value === eventTypeValue){
                                                    count ++;
                                                }
                                            });
                                            /* if(count >1){
                                                const valueText = $(e.target).children(`option:selected`).html();
                                                $(e.target).val("");
                                                swal(
                                                    text["alert"][allVariables.lang],
                                                    gen.superReplacer(text["input-event-existed-warning"][allVariables.lang],"@event",valueText),
                                                    "warning"
                                                    );
                                                return false;
                                            } */
                                        }
                                    });
                                }  
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-3"
                                },
                                html:() =>{
                                    return gen.dropDownFromArray({
                                        editedvalue:event!== undefined ? parseInt(event.eventfunction) : null,
                                        array:text["input-event-functions"],
                                        id:"key",
                                        output:(ob) =>{
                                            return ob.title[allVariables.lang];
                                        },
                                        attr:{
                                            class:"form-control",
                                            name:"input-event-function"
                                        },
                                        css:{
                                            marginBottom:"5px"
                                        },
                                        legend:text["select-input-event-functions"][allVariables.lang],
                                        onchange:e=>{
                                            const value = parseInt(e.target.value);
                                            switch(value){
                                                case 2:
                                                    /* column values match starts */
                                                    __objects.events({
                                                        section:eventExtraFeaturesSection,
                                                        columns:__functionOptions.columns,
                                                        column:__functionOptions.column
                                                    }).columnValuesMatch();
                                                    /* column values match ends */
                                                break;
                                                case 3:
                                                    /* password strength starts */
                                                    __objects.events({
                                                        section:eventExtraFeaturesSection,
                                                        columns:__functionOptions.columns,
                                                        column:__functionOptions.column
                                                    }).passwordStrength();
                                                    /* -assword strength ends */
                                                break;
                                                case 5:
                                                    /* redirection callback starts */
                                                    __objects.events({
                                                        section:eventExtraFeaturesSection,
                                                        columns:__functionOptions.columns,
                                                        column:__functionOptions.column
                                                    }).redirectionCallBack();
                                                    /* redirection callback ends */
                                                break;
                                                case 6:
                                                    /* duplicate my value on another input starts */
                                                    __objects.events({
                                                        section:eventExtraFeaturesSection,
                                                        columns:__functionOptions.columns,
                                                        column:__functionOptions.column
                                                    }).duplicateMyValueOnAnotherInput();
                                                    /* duplicate my value on another input ends */
                                                break;

                                                case 7:
                                                    /* display input with if statement starts */
                                                    __objects.events({
                                                        section:eventExtraFeaturesSection,
                                                        columns:__functionOptions.columns,
                                                        column:__functionOptions.column
                                                    }).displayInputWithIfStatement();
                                                    /* display input with if statement ends */
                                                break;
                                                default:{
                                                    eventExtraFeaturesSection.html("");
                                                }
                                            }
                                        }
                                    });
                                }  
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-5"
                                },
                                children:[
                                    {
                                        element:"textarea",
                                        attr:{
                                            class:"form-control",
                                            placeholder:text["input-event-function-default-warning"][allVariables.lang],
                                            name:"input-event-default-warning"
                                        },
                                        css:{
                                            width:"100%",
                                            height:"37px",
                                            marginBottom:"5px"
                                        },
                                        value:event!== undefined ? event.eventdefautwarning : null,
                                    }
                                ]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-1"
                                },
                                html:() =>{
                                    return gen.dropDownMenu({
                                        icon:"icon-options icons",
                                        submenus:{
                                            delete:{
                                                title:text["delete"][allVariables.lang],
                                                icon:"fa fa-trash",
                                                iconColor: "#000",
                                                callback:e=>{
                                                    e.preventDefault();
                                                    blockRow.remove();
                                                }
                                            }
                                        }
                                    },true);
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                html:eventExtraFeaturesSection
                            }
                        ]
                    }
                ]).init());
            },
            events:(__functionOptions) =>{
                const section = __functionOptions.section;
                let columns = __functionOptions.columns;
                const column = __functionOptions.column;
                const event = __functionOptions.hasOwnProperty("event") ? __functionOptions.event : undefined;
                section.css({
                    border:"1px #ccc dashed",
                    marginTop:"10px",
                    marginBottom:"5px",
                    padding:"5px"
                });
                return {
                    displayInputWithIfStatement:() =>{
                        let extraFeatures = null;
                        const cl = column;
                        if(cl instanceof Object && cl.hasOwnProperty("events") && Array.isArray(cl.events) && cl.events.filter(item =>{ return parseInt(item.eventfunction) === 7}).length > 0){
                            extraFeatures = cl.events.filter(item =>{ return parseInt(item.eventfunction) === 7})[0].extrafeatures;
                        }
                        section.html(gen.objectInterfaceMaker([
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            marginTop:"10px"
                                        },
                                        html:() =>{
                                            return text["displayinputwithifstatement"]["introduce-condition"][lang];
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            marginTop:"10px"
                                        },
                                        html:()=>{
                                            return gen.dropDownFromArray({
                                                array:text["comparison-operators"]["operators"],
                                                id:"key",
                                                output:(v)=>{return v.title[lang];},
                                                attr:{
                                                    class:"form-control",
                                                    name:text["comparison-operators"]["input-name"]
                                                },
                                                legend:text["comparison-operators"]["legend"][lang],
                                                editedvalue:extraFeatures !== null && extraFeatures instanceof Object ? extraFeatures.comparaisonoperator : null
                                            });
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            marginTop:"10px"
                                        },
                                        children:[
                                            {
                                                element:"input",
                                                attr:{
                                                    class:"form-control",
                                                    name:text["displayinputwithifstatement"]["x"]["name"],
                                                    type:"text",
                                                    placeholder:text["displayinputwithifstatement"]["x"]["placeholder"][lang]
                                                },
                                                value:extraFeatures !== null && extraFeatures instanceof Object ? extraFeatures.xvalue : null
                                            }
                                        ]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6",
                                        },
                                        css:{
                                            marginTop:"10px"
                                        },
                                        html:()=>{
                                            return text["displayinputwithifstatement"]["then"][lang]
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            marginTop:"10px"
                                        },
                                        html:() =>{
                                            
                                            const hiddenInputs = columns.filter(item=>{return item.hasOwnProperty("inputrowextraoptions") && item.inputrowextraoptions instanceof Object && item.inputrowextraoptions.name ==="display" && item.inputrowextraoptions.value === "none" && item.key !== column.key});
                                            if(hiddenInputs.length > 0){
                                                return gen.dropDownFromArray({
                                                    array:hiddenInputs,
                                                    id:"key",
                                                    output:"title",
                                                    attr:{
                                                        name:text["displayinputwithifstatement"]["hiddeninputs"]["name"]
                                                    },
                                                    display:"checkboxes",
                                                    editedvalue:extraFeatures !== null && extraFeatures instanceof Object ? extraFeatures.hiddeninputs : null
                                                });
                                            }
                                            return null;
                                        }
                                    }
                                ]
                            }
                        ]).init());
                    },
                    duplicateMyValueOnAnotherInput:() =>{
                        const arrayColumns = columns.filter(item=>{return item.key !== text["event-settings"]["form"]["event-key"] && item.key !== column.key;});
                        section.html(gen.dropDownFromArray({
                            array:arrayColumns,
                            id:"key",
                            output:"title",
                            attr:{
                                class:"form-control",
                                name:text["event-settings"]["form"]["event-functions"]["duplicate-my-value-on-another-input"]["input-name"],
                            },
                            legend:text["event-settings"]["form"]["event-functions"]["duplicate-my-value-on-another-input"]["legend"][lang],
                            editedvalue:event !== undefined && event !== null && typeof(event) ==="object" ? event.extrafeatures.duplicationcolumn: null
                        }));
                    },
                    redirectionCallBack:()=>{
                        section.html(gen.dropDownFromArray({
                            array:importingModules.loginConfiguration().pages,
                            id:"pageid",
                            output:"pagename",
                            attr:{
                                class:"form-control",
                                name:text["event-settings"]["form"]["event-functions"]["redirection-callback"]["input-name"],
                            },
                            legend:text["event-settings"]["form"]["event-functions"]["redirection-callback"]["legend"][lang],
                            editedvalue:event !== undefined && event !== null && typeof(event) ==="object" ? event.extrafeatures.redirectedpage: null
                        }));
                    },
                    columnValuesMatch:() =>{
                        columns = columns.filter(item=>{return item.key !== column.key;});
                        const checkboxes = gen.dropDownFromArray({
                            array:columns,
                            id:"key",
                            output:"title",
                            attr:{
                                name:text["event-settings"]["columnvaluesmatch"]["select-column"]["name"]
                            },
                            legend:text["event-settings"]["columnvaluesmatch"]["select-column"][lang],
                            display:"checkboxes",
                            editedvalue:typeof(event) === "object" 
                            && event !== null 
                            && event !== undefined 
                            && event.hasOwnProperty("extrafeatures") 
                            && typeof(event.extrafeatures) ==="object" 
                            && event.extrafeatures.hasOwnProperty("columns") 
                            && Array.isArray(event.extrafeatures.columns) ? event.extrafeatures.columns : null
                        });
                        section.html(checkboxes)
                    },
                    passwordStrength:()=>{
                        const calculateInputLength = function(){
                            const lengths = [
                                text["event-settings"]["password-strength"]["mixture"]["number"]["name"],
                                text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["name"],
                                text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["name"],
                                text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["name"]
                            ];
                            let maxLength = 0;
                            lengths.forEach(item =>{
                                maxLength+= parseInt($(`input[name="${item}"]`).val());
                            });
                            $(`input[name="${text["event-settings"]["password-strength"]["password-length"]["name"]}`).val(maxLength);
                        };
                        const pwdStrengthSetter = function(__annonymFunctionOptions){
                            const checked = __annonymFunctionOptions.object.unchecked !== undefined && __annonymFunctionOptions.object.unchecked === true? undefined :"checked";
                            return   {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                css:{
                                    margin:"5px"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-1"
                                        },
                                        children:[
                                            {
                                                element:"input",
                                                attr:{
                                                    type:"checkbox",
                                                    name:text["event-settings"]["password-strength"]["name"],
                                                    value:__annonymFunctionOptions.value,
                                                    checked:checked
                                                }
                                            }
                                        ]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-3"
                                        },
                                        html:__annonymFunctionOptions.type
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html: $(gen.textBox(
                                            __annonymFunctionOptions.lengthname,
                                            __annonymFunctionOptions.lengthname,
                                            "form-control",
                                            ((eV,dV) =>{
                                                if(eV!== null && eV!== undefined){
                                                    return eV;
                                                }
                                                return dV;
                                            })(__annonymFunctionOptions.lengthvalue,__annonymFunctionOptions.defaultvalue),
                                            "numeric"
                                            )).attr({
                                                placeholder:__annonymFunctionOptions.lengthplaceholder
                                            })
                                            .on("input",e=>{
                                                calculateInputLength();
                                            })
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html: $(gen.textArea(
                                            __annonymFunctionOptions.warningname,
                                            __annonymFunctionOptions.warningname,
                                            "form-control",
                                            ((eV,dV) =>{
                                                if(eV!== null && eV!== undefined){
                                                    return eV;
                                                }
                                                return dV;
                                            })(__annonymFunctionOptions.warningvalue,__annonymFunctionOptions.warningdefaultvalue)
                                            )).attr({
                                                placeholder:__annonymFunctionOptions.warningplaceholder
                                            })
                                            .css({
                                                height:"37px"
                                            })
                                    }
                                ]
                            };
                        };
                        const editValues = function(ev){
                            let object =  {
                                "number":{
                                    key:1,
                                    length:2,
                                    warning:text["event-settings"]["password-strength"]["mixture"]["number"]["warning"][lang],
                                    unchecked:true
                                },
                                "specialcharacters":{
                                    key:2,
                                    length:2,
                                    warning:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["warning"][lang],
                                    unchecked:true
                                },
                                "capitalletters":{
                                    key:3,
                                    length:2,
                                    warning:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["warning"][lang],
                                    unchecked:true
                                },
                                "lowercaseletters":{
                                    key:4,
                                    length:2,
                                    warning:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["warning"][lang],
                                    unchecked:true
                                }
                            };
                            if(ev !== null && ev !== undefined && typeof(ev) === "object" && ev.hasOwnProperty("extrafeatures")){
                                const keys = ev.extrafeatures.options.map(item =>{return parseInt(item.key);});
                                if(keys.includes(1)){
                                    object["number"] = ev.extrafeatures.options.filter(item =>{return parseInt(item.key) === 1;})[0];
                                }
                                if(keys.includes(2)){
                                    object["specialcharacters"] = ev.extrafeatures.options.filter(item =>{return parseInt(item.key) === 2;})[0];
                                }
                                if(keys.includes(3)){
                                    object["capitalletters"] = ev.extrafeatures.options.filter(item =>{return parseInt(item.key) === 3;})[0];
                                }
                                if(keys.includes(4)){
                                    object["lowercaseletters"] = ev.extrafeatures.options.filter(item =>{return parseInt(item.key) === 4;})[0];
                                }
                                
                            }
                            return object;
                        };
                        const __editedValues = editValues(event);
                        section.html(gen.objectInterfaceMaker([
                            pwdStrengthSetter({
                                value:__editedValues["number"].key,
                                type:text["event-settings"]["password-strength"]["mixture"]["number"][lang],
                                lengthname:text["event-settings"]["password-strength"]["mixture"]["number"]["name"],
                                lengthplaceholder:text["event-settings"]["password-strength"]["mixture"]["number"]["placeholder"][lang],
                                warningname:text["event-settings"]["password-strength"]["mixture"]["number"]["warning-name"],
                                warningplaceholder:text["event-settings"]["password-strength"]["mixture"]["number"]["warning-placeholder"][lang],
                                warningdefaultvalue:__editedValues["number"].warning,
                                defaultvalue:__editedValues["number"].length,
                                object:__editedValues["number"]
                            }),
                            pwdStrengthSetter({
                                value:__editedValues["specialcharacters"].key,
                                type:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"][lang],
                                lengthname:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["name"],
                                lengthplaceholder:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["placeholder"][lang],
                                warningname:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["warning-name"],
                                warningplaceholder:text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["warning-placeholder"][lang],
                                warningdefaultvalue:__editedValues["specialcharacters"].warning,
                                defaultvalue:__editedValues["specialcharacters"].length,
                                object:__editedValues["specialcharacters"]
                            }),
                            pwdStrengthSetter({
                                value:__editedValues["capitalletters"].key,
                                type:text["event-settings"]["password-strength"]["mixture"]["capitalletter"][lang],
                                lengthname:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["name"],
                                lengthplaceholder:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["placeholder"][lang],
                                warningname:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["warning-name"],
                                warningplaceholder:text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["warning-placeholder"][lang],
                                warningdefaultvalue:__editedValues["capitalletters"].warning,
                                defaultvalue:__editedValues["capitalletters"].length,
                                object:__editedValues["capitalletters"]
                            }),
                            pwdStrengthSetter({
                                value:__editedValues["lowercaseletters"].key,
                                type:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"][lang],
                                lengthname:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["name"],
                                lengthplaceholder:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["placeholder"][lang],
                                warningname:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["warning-name"],
                                warningplaceholder:text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["warning-placeholder"][lang],
                                warningdefaultvalue:__editedValues["lowercaseletters"].warning,
                                defaultvalue:__editedValues["lowercaseletters"].length,
                                object:__editedValues["lowercaseletters"]
                            }),
                            {
                                element:"div",
                                attr:{
                                    class:"row"
                                },
                                css:{
                                    margin:"5px"
                                },
                                children:[
                                    {
                                       element:"div",
                                       attr:{
                                        class:"col-lg-1"
                                       },
                                       html:null
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                         class:"col-lg-3"
                                        },
                                        html:text["event-settings"]["password-strength"]["password-length"][lang] 
                                     },
                                    {
                                        element:"div",
                                        attr:{
                                         class:"col-lg-4"
                                        },
                                        html:()=>{
                                            return $(gen.textBox(
                                                text["event-settings"]["password-strength"]["password-length"]["name"],
                                                text["event-settings"]["password-strength"]["password-length"]["name"],
                                                "form-control",
                                                (pL=>{
                                                    console.log(event);
                                                    if(typeof(event) ==="object" && event !== null && event!== undefined && event.hasOwnProperty("extrafeatures")){
                                                        return event.extrafeatures.passwordlength;
                                                    }
                                                    return 8;
                                                })(),
                                                "numeric"
                                            )).on("input",e=>{
                                                const value = parseInt(e.target.value);
                                                if(value >=8){
                                                    const optionLength = Math.ceil(value/4);
                                                    const lengths = [
                                                        text["event-settings"]["password-strength"]["mixture"]["number"]["name"],
                                                        text["event-settings"]["password-strength"]["mixture"]["specialcharacters"]["name"],
                                                        text["event-settings"]["password-strength"]["mixture"]["capitalletter"]["name"],
                                                        text["event-settings"]["password-strength"]["mixture"]["lowercaseletter"]["name"]
                                                    ];
                                                    lengths.forEach(item =>{
                                                        $(`input[name="${item}"]`).val(optionLength)
                                                    })
                                                    console.log(optionLength);
                                                }
                                            })
                                        }
                                     },
                                     {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html:()=>{
                                            return $(gen.textArea(
                                                text["event-settings"]["password-strength"]["password-length-warning"]["name"],
                                                text["event-settings"]["password-strength"]["password-length-warning"]["name"],
                                                "form-control",
                                                (()=>{
                                                    if(typeof(event) ==="object" && event !== null && event!== undefined && event.hasOwnProperty("extrafeatures")){
                                                        return event.extrafeatures.passwordlengthwarning;
                                                    }
                                                    return text["event-settings"]["password-strength"]["password-length-warning"]["default-warning"][lang]
                                                })()
                                                )).attr({
                                                    placeholder:text["event-settings"]["password-strength"]["password-length-warning"]["placeholder"][lang]
                                                })
                                                .css({
                                                    height:"37px"
                                                })
                                        }
                                     }
                                ]
                            }
                        ]).init());
                    }
                };
            }
        };
        $(allVariables.appsection).html(sdapp.replaceScriptWithUI({
            returncontent:true,
            title:gen.jsonCharReplacer(gen.superReplacer(text["input-events-configuration-title"][allVariables.lang],"@blockname",row["blockname"]),-1),
            html:__objects.init(),
            textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
            rightoptions: {
                title: "",
                iconColor: "#fff",
                icon: "icon-options icons",
                submenus: {
                    newblock:{
                        title:text["new-block"][allVariables.lang],
                        icon:"fa fa-plus",
                        callback: e =>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-add-data-block"
                            });
                        }
                    },
                    allblocks:{
                        title:text["all-blocks"][allVariables.lang],
                        icon:"fa fa-circle-o",
                        callback: e=>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-all-data-blocks"
                            });
                        }
                    }
                }
            }
        }));
        gen.selectDropdownChildrenMultipleSelection();
    
    }
}