class sdapp_login_configurations{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        const row = __constructorOptions.row;
        const __row = row;
        const themeId = row.themeid;
        const lang = allVariables.lang;
        const importingModules = __constructorOptions.import;
        const pages = gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {
            key: "returnjson",
            table: "sdapppages",
            datatype:"json",
            ref: `WHERE themeid ='${themeId}' AND datastatus > 0 ORDER BY pagename`,
            getter: true
        }, false, 1));
        this.pages = pages;
        const __objects = {
            init:()=>{
                const settings = gen.getObjectFromJSON(__row.loginsettings);
                const columnsSection = $(gen.createEl("div")).css({
                    border:"1px #ececfd solid",
                    marginTop:"50px",
                    borderRadius:"5px",
                    padding:"5px"
                });
                 columnsSection.html(gen.objectInterfaceMaker([
                    importingModules.customizedform().blockMaker({
                        title:null,
                        content:__objects.saveSettings({})
                    }),
                    importingModules.customizedform().blockMaker({
                        title:text["login-settings"]["creditials-definition-block"]["title"][lang],
                        content:__objects.creditialDefinitionBlockExteriorForm({
                            settings:settings
                        })
                     }),
                     importingModules.customizedform().blockMaker({
                        title:text["login-settings"]["login-grouping-block"]["title"][lang],
                        content:__objects.groupingLoginBlock({
                            settings:settings
                        })
                     }),
                     importingModules.customizedform().blockMaker({
                        title:null,
                        content:__objects.saveSettings({})
                    })
                 ]).init());
                 return columnsSection;
            },
            groupingLoginBlock:(__functionOptions) =>{
                console.log(__functionOptions);
                const sectionGroupingLogin = $(gen.createEl("div"));
                //action on edit starts
                if(__functionOptions.hasOwnProperty("settings") && typeof(__functionOptions.settings) === "object" && __functionOptions.settings !== null && __functionOptions.settings !== undefined){
                    for(let i = 0; i < __functionOptions.settings.logingroups.length; i++){
                        const loginGroup = __functionOptions.settings.logingroups[i];
                        sectionGroupingLogin.append(__objects.newLoginGroup({returncontent:true,logingroup:loginGroup}));
                    }
                }
                //action on edit ends
                else{
                    sectionGroupingLogin.append(__objects.newLoginGroup({returncontent:true}));
                }
                return gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                html:() =>{
                                    return gen.anchor({
                                        title:text["login-settings"]["login-grouping-block"]["new-group"][lang],
                                        icon:"fa fa-plus",
                                        css:{
                                            cursor:"pointer"
                                        },
                                        callback:e=>{
                                            __objects.newLoginGroup({
                                                section:sectionGroupingLogin
                                            });
                                        }
                                    });
                                }
                            },
                            {
                                element:sectionGroupingLogin,
                                attr:{
                                    class:"col-lg-12"
                                }
                            }
                        ]
                    }
                ]).init();
            },
            newLoginGroup:(__functionOptions)=>{
                const section = __functionOptions.section;
                const loginGroupObject = __functionOptions.logingroup;
                const newGroupFeatures = $(gen.createEl("div"));
                //on edit code starts here
                if(typeof(loginGroupObject) ==="object" && loginGroupObject.hasOwnProperty("columncreditials")){
                    __objects.newGroupFeatures({
                        blockid:loginGroupObject.groupsqlblockid,
                        section:newGroupFeatures,
                        logincreditials:{
                            username:loginGroupObject.columncreditials.username,
                            password:loginGroupObject.columncreditials.password
                        },
                        events:loginGroupObject.events,
                        elements:loginGroupObject.elements
                    });
                }
                //on edit code ends here
                const newGroup = $(gen.createEl("div"));
                newGroup.css({
                    margin:"5px",
                    border:"1px #ccc dashed",
                    padding:"10px 5px"
                });
                newGroup.html(gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-5"
                                },
                                children:[
                                    {
                                        element:"input",
                                        attr:{
                                            type:"text",
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-name"],
                                            placeholder:text["login-settings"]["login-grouping-block"]["group-name"][lang]
                                        },
                                        css:{
                                            marginBottom:"5px"
                                        },
                                        value:(lgo=>{
                                            if(lgo!==null && lgo!==undefined && typeof(lgo) ==="object" && lgo.hasOwnProperty("groupname")){
                                                return lgo.groupname;
                                            }
                                            return null;
                                        })(loginGroupObject)
                                    }
                                ]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-5"
                                },
                                html:()=>{
                                    return gen.dropDownFromArray({
                                        editedvalue:loginGroupObject !== null && loginGroupObject !== undefined && typeof(loginGroupObject) === "object" && loginGroupObject.hasOwnProperty("groupsqlblockid")? loginGroupObject.groupsqlblockid :null,
                                        array:importingModules.customizedform().blocks(),
                                        id:"blockid",
                                        output:"blockname",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-sql-block"]
                                        },
                                        legend:text["login-settings"]["login-grouping-block"]["select-sql-block"][lang],
                                        onchange:e=>{
                                            e.preventDefault();
                                            const blockId = e.target.value;
                                            if(blockId !== ""){
                                                __objects.newGroupFeatures({
                                                    blockid:blockId,
                                                    section:newGroupFeatures 
                                                });
                                            }
                                            else{
                                                newGroupFeatures.html(""); 
                                            }
                                        }
                                    })
                                }
                            },
                            {
                               element:"div",
                               attr:{
                                   class:"col-lg-2"
                               },
                               css:{
                                   textAlign:"right"
                               },
                               html:()=>{
                                   return gen.anchor({
                                       icon:"fa fa-trash",
                                       title:null,
                                       attr:{
                                            title:text["login-settings"]["login-grouping-block"]["delete-group"][lang]
                                       },
                                       css:{
                                           cursor:"pointer",
                                           color:"red"
                                       },
                                       callback:e=>{
                                           e.preventDefault();
                                            gen.sweetWarningMsgBox(
                                                ()=>{
                                                    newGroup.remove()
                                                },
                                                text["alert"][lang],
                                                text["login-settings"]["login-grouping-block"]["delete-group-warning"][lang],
                                                text["login-settings"]["login-grouping-block"]["delete-group-success"][lang],
                                                text["sdapp-no-action-done"][lang]
                                            );
                                       }
                                   })
                               } 
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                html:newGroupFeatures
                            }
                        ]
                    },
                    
                ]).init());
                if(__functionOptions.returncontent !== null && __functionOptions.returncontent !== undefined){ return newGroup;}
                section.append(newGroup);
            },
            newGroupFeatures:(__functionOptions)=>{
                const section = __functionOptions.section;
                const blockId = __functionOptions.blockid;
                const loginCreditials = __functionOptions.logincreditials;
                const events = __functionOptions.events;
                const elements = __functionOptions.elements;
                const keyDefaultPhotoProfileSection = $(gen.createEl("div"));
                const keyDefaultPhotoTimelineSection = $(gen.createEl("div"));
                const __newObjects = {
                    defaultProfilePhotokey:(__annonymFunctionOptions)=>{
                        const editedValue = __annonymFunctionOptions.editedvalue;
                        const array = __annonymFunctionOptions.array;
                        return  gen.dropDownFromArray({
                            array:array,
                            id:"key",
                            output:"title",
                            attr:{
                                class:"form-control",
                                name:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["column"]["name"]
                            },
                            css:{
                                marginTop:"5px"
                            },
                            legend:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["column"]["legend"][lang],
                            editedvalue:editedValue
                        });
                    },
                    defaultTimelinePhotokey:(__annonymFunctionOptions)=>{
                        const editedValue = __annonymFunctionOptions.editedvalue;
                        const array = __annonymFunctionOptions.array;
                        return  gen.dropDownFromArray({
                            array:array,
                            id:"key",
                            output:"title",
                            attr:{
                                class:"form-control",
                                name:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["column"]["name"]
                            },
                            css:{
                                marginTop:"5px"
                            },
                            legend:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["column"]["legend"][lang],
                            editedvalue:editedValue
                        });
                    }
                };
                section.html(gen.objectInterfaceMaker([
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group-features-login-creditials"
                        },
                        css:{
                            margin:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                css:{
                                    backgroundColor:"#f8f9fa",
                                    fontWeight:"600"
                                },
                                html:text["login-settings"]["login-grouping-block"]["creditial-definition-sql-block"][lang]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                html:()=>{
                                    return __objects.dropDownFromColumns({
                                        blockid:blockId,
                                        name:text["login-settings"]["input-naming"]["group-features-login-creditials-username-column"],
                                        legend:text["login-settings"]["login-grouping-block"]["creditial-definition-sql-block-define-username"][lang],
                                        editedvalue:typeof(loginCreditials) ==="object" && loginCreditials.hasOwnProperty("username") ? loginCreditials.username : null,
                                        css:{
                                            margin:"5px 0px"
                                        }
                                    })
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                html:()=>{
                                    return __objects.dropDownFromColumns({
                                        blockid:blockId,
                                        name:text["login-settings"]["input-naming"]["group-features-login-creditials-password-column"],
                                        legend:text["login-settings"]["login-grouping-block"]["creditial-definition-sql-block-define-password"][lang],
                                        editedvalue:typeof(loginCreditials) ==="object" && loginCreditials.hasOwnProperty("password") ? loginCreditials.password : null,
                                        css:{
                                            margin:"5px 0px"
                                        }
                                    })
                                }
                            }
                        ]
                    },
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group-features-on-login-successfully-event"
                        },
                        css:{
                            margin:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                css:{
                                    backgroundColor:"#f8f9fa",
                                    fontWeight:"600",
                                    textTransform:"capitalize"
                                },
                                html:text["login-settings"]["login-grouping-block"]["on-login-successfully"][lang]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                html:()=>{
                                    return gen.dropDownFromArray({
                                        editedvalue:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onloginsuccessfully") ? events.onloginsuccessfully.redirectedpage : null,
                                        array:me.pages.filter(item=>{return item.pagecategory === "private";}),
                                        id:"pageid",
                                        output:"pagename",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-login-successfully-event-redirected-page"]
                                        },
                                        legend:text["login-settings"]["login-grouping-block"]["select-private-page"][lang]
                                    });
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                children:[
                                    {
                                        element:"textarea",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-login-successfully-event-feedback-message"],
                                            placeholder:text["login-settings"]["login-grouping-block"]["group-features-on-login-successfully-feedback-message-placeholder"][lang]
                                        },
                                        css:{
                                            height:"37px"
                                        },
                                        value:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onloginsuccessfully") ? events.onloginsuccessfully.feebackmessage : text["login-settings"]["login-grouping-block"]["group-features-on-login-successfully-feedback-message-default-value"][lang],
                                    }
                                ]
                            }
                        ]
                    },
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group-features-on-login-failed-event"
                        },
                        css:{
                            margin:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                css:{
                                    backgroundColor:"#f8f9fa",
                                    fontWeight:"600",
                                    textTransform:"capitalize"
                                },
                                html:text["login-settings"]["login-grouping-block"]["on-login-failed"][lang]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                html:()=>{
                                    return gen.dropDownFromArray({
                                        editedvalue:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onloginfailed") ? events.onloginfailed.redirectedpage : null,
                                        array:me.pages.filter(item=>{return item.pagecategory ==="public";}),
                                        id:"pageid",
                                        output:"pagename",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-login-failed-event-redirected-page"]
                                        },
                                        legend:text["login-settings"]["login-grouping-block"]["select-public-page"][lang]
                                    });
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                children:[
                                    {
                                        element:"textarea",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-login-failed-event-feedback-message"],
                                            placeholder:text["login-settings"]["login-grouping-block"]["group-features-on-login-failed-feedback-message-placeholder"][lang]
                                        },
                                        css:{
                                            height:"37px"
                                        },
                                        value:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onloginfailed") ? events.onloginfailed.feedbackmessage : text["login-settings"]["login-grouping-block"]["group-features-on-login-failed-feedback-message-default-value"][lang],
                                    }
                                ]
                            }
                        ]
                    },
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group-features-on-logout-event"
                        },
                        css:{
                            margin:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-12"
                                },
                                css:{
                                    backgroundColor:"#f8f9fa",
                                    fontWeight:"600",
                                    textTransform:"capitalize"
                                },
                                html:text["login-settings"]["login-grouping-block"]["on-logout"][lang]
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                html:()=>{
                                    return gen.dropDownFromArray({
                                        editedvalue:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onlogout") ? events.onlogout.redirectedpage : null,
                                        array:me.pages.filter(item=>{return item.pagecategory === "public";}),
                                        id:"pageid",
                                        output:"pagename",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-logout-event-redirected-page"]
                                        },
                                        legend:text["login-settings"]["login-grouping-block"]["select-public-page"][lang]
                                    });
                                }
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-6"
                                },
                                css:{
                                    padding:"5px"
                                },
                                children:[
                                    {
                                        element:"textarea",
                                        attr:{
                                            class:"form-control",
                                            name:text["login-settings"]["input-naming"]["group-features-login-on-logout-event-feedback-message"],
                                            placeholder:text["login-settings"]["login-grouping-block"]["group-features-on-login-failed-feedback-message-placeholder"][lang]
                                        },
                                        css:{
                                            height:"37px"
                                        },
                                        value:events!== null && events!== null && typeof(events) ==="object" && events.hasOwnProperty("onlogout") ? events.onlogout.feedbackmessage : text["login-settings"]["login-grouping-block"]["group-features-on-logout-feedback-message-default-value"][lang],
                                    }
                                ]
                            }
                        ]
                    },
                    {
                        element:"div",
                        attr:{
                            class:"row",
                            sdapp:"login-group-features-elements"
                        },
                        css:{
                            margin:"5px"
                        },
                        children:[
                            {
                                element:"div",
                                css:{
                                    margin:"5px",
                                    width:"100%"
                                },
                                attr:{
                                    class:"row"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-12"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            fontWeight:"600",
                                            textTransform:"uppercase",
                                            marginBottom:"10px"
                                        },
                                        html:text["login-settings"]["login-grouping-block"]["elements"]["title"][lang]
                                    }
                                ]
                            },
                            {
                                element:"div",
                                css:{
                                    margin:"5px",
                                    width:"100%"
                                },
                                attr:{
                                    class:"row",
                                    sdapp:"default-user-profile-photo"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        html:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["key"]["title"][lang]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        children:[
                                            {
                                                element:"div",
                                                html:()=>{
                                                    return gen.dropDownFromArray({
                                                        editedvalue:null,
                                                        array:importingModules.customizedform().blocks(),
                                                        id:"blockid",
                                                        output:"blockname",
                                                        attr:{
                                                            class:"form-control",
                                                            name:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["block"]["name"]
                                                        },
                                                        legend:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["block"]["legend"][lang],
                                                        onchange:e=>{
                                                            const __value = parseInt(e.target.value);
                                                            let __singleBlock = importingModules.customizedform().blocks().filter(item=>{return parseInt(item.blockid) === __value;});
                                                            if(__singleBlock.length > 0){
                                                                __singleBlock = gen.getObjectFromJSON(__singleBlock[0].columnsobjects);
                                                                keyDefaultPhotoProfileSection.html(__newObjects.defaultProfilePhotokey({
                                                                    array:__singleBlock,
                                                                    editedvalue:null
                                                                }));
                                                            }
                                                           
                                                        },
                                                        editedvalue:(el=>{
                                                            if(el instanceof Object && el.hasOwnProperty("defaultphotoprofile") && el.defaultphotoprofile instanceof Object){
                                                                return el.defaultphotoprofile.block;
                                                            }
                                                            return null;
                                                        })(elements)
                                                    });
                                                   
                                                }
                                            }
                                        ]
                                    },
                                    {
                                        element:keyDefaultPhotoProfileSection,
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html: ()=>{
                                           if(elements instanceof Object && elements.hasOwnProperty("defaultphotoprofile") && elements.defaultphotoprofile instanceof Object
                                           ){
                                            let __singleBlock = importingModules.customizedform().blocks().filter(item=>{return parseInt(item.blockid) === parseInt(elements.defaultphotoprofile.block);});
                                                    if(__singleBlock.length > 0){
                                                        __singleBlock = gen.getObjectFromJSON(__singleBlock[0].columnsobjects);
                                                        return __newObjects.defaultProfilePhotokey({
                                                            array:__singleBlock,
                                                            editedvalue:elements.defaultphotoprofile.key
                                                        });
                                                    }
                                           }
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        html:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["title"][lang]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        children:[
                                            {
                                                element:"div",
                                                html:(el)=>{
                                                    return sdapp.getMediaFilesButton({
                                                        parent:el,
                                                        dir: "../uploads",
                                                        key:text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["name"],
                                                        textjson: text,
                                                        value: ((row, field) => {
                                                            if (row instanceof Object && row.hasOwnProperty(field)) {
                                                                return row[field].value;
                                                            }
                                                            return null;
                                                        })(elements, "defaultphotoprofile")
                                                    }).html
                                                }
                                            }
                                        ]
                                    }
                                ]
                            },
                            {
                                element:"div",
                                css:{
                                    margin:"5px",
                                    width:"100%"
                                },
                                attr:{
                                    class:"row",
                                    sdapp:"default-user-timeline-photo"
                                },
                                children:[
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        html:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["key"]["title"][lang]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        children:[
                                            {
                                                element:"div",
                                                html:()=>{
                                                    return gen.dropDownFromArray({
                                                        editedvalue:null,
                                                        array:importingModules.customizedform().blocks(),
                                                        id:"blockid",
                                                        output:"blockname",
                                                        attr:{
                                                            class:"form-control",
                                                            name:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["block"]["name"]
                                                        },
                                                        legend:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["block"]["legend"][lang],
                                                        onchange:e=>{
                                                            const __value = parseInt(e.target.value);
                                                            let __singleBlock = importingModules.customizedform().blocks().filter(item=>{return parseInt(item.blockid) === __value;});
                                                            if(__singleBlock.length > 0){
                                                                __singleBlock = gen.getObjectFromJSON(__singleBlock[0].columnsobjects);
                                                                keyDefaultPhotoTimelineSection.html(__newObjects.defaultTimelinePhotokey({
                                                                    array:__singleBlock,
                                                                    editedvalue:null
                                                                }));
                                                            }
                                                           
                                                        },
                                                        editedvalue:(el=>{
                                                            if(el instanceof Object && el.hasOwnProperty("defaultphototimeline") && el.defaultphototimeline instanceof Object){
                                                                return el.defaultphototimeline.block;
                                                            }
                                                            return null;
                                                        })(elements)
                                                    });
                                                   
                                                }
                                            }
                                        ]
                                    },
                                    {
                                        element:keyDefaultPhotoTimelineSection,
                                        attr:{
                                            class:"col-lg-4"
                                        },
                                        html: ()=>{
                                           if(elements instanceof Object && elements.hasOwnProperty("defaultphototimeline") && elements.defaultphototimeline instanceof Object
                                           ){
                                            let __singleBlock = importingModules.customizedform().blocks().filter(item=>{return parseInt(item.blockid) === parseInt(elements.defaultphototimeline.block);});
                                                    if(__singleBlock.length > 0){
                                                        __singleBlock = gen.getObjectFromJSON(__singleBlock[0].columnsobjects);
                                                        return __newObjects.defaultTimelinePhotokey({
                                                            array:__singleBlock,
                                                            editedvalue:elements.defaultphototimeline.key
                                                        });
                                                    }
                                           }
                                        }
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        html:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["title"][lang]
                                    },
                                    {
                                        element:"div",
                                        attr:{
                                            class:"col-lg-6"
                                        },
                                        css:{
                                            backgroundColor:"#f8f9fa",
                                            textTransform:"capitalize",
                                            padding:"5px"
                                        },
                                        children:[
                                            {
                                                element:"div",
                                                html:(el)=>{
                                                    return sdapp.getMediaFilesButton({
                                                        parent:el,
                                                        dir: "../uploads",
                                                        key:text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["name"],
                                                        textjson: text,
                                                        value: ((row, field) => {
                                                            if (row instanceof Object && row.hasOwnProperty(field)) {
                                                                return row[field].value;
                                                            }
                                                            return null;
                                                        })(elements, "defaultphototimeline")
                                                    }).html
                                                }
                                            }
                                        ]
                                    }
                                ]
                            }
                            
                        ]
                    }
                ]).init());
            },
            saveSettings:(__functionOptions)=>{
                return gen.anchor({
                    title:text["login-settings"]["creditials-definition-block"]["save-button-title"][lang],
                    icon:"fa fa-save",
                    attr:{
                        class:"btn btn-primary"
                    },
                    css:{
                        cursor:"pointer",
                        color:"white",
                        width:"100%"
                    },
                    callback:e=>{
                        e.preventDefault();
                        const validation = gen.getInputValueFromValidation([
                            {
                                dom:"select",
                                type:"select",
                                name:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["name"],
                                property:"credition-definition-username",
                                warning:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["warning-alert"][lang]
                            },
                            {
                                dom:"textarea",
                                type:"textarea",
                                name:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["warning-textarea"]["name"],
                                property:"credition-definition-username-warning",
                                warning:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["warning-textarea"]["warning-alert"][lang]
                            },
                            {
                                dom:"select",
                                type:"select",
                                name:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["name"],
                                property:"credition-definition-password",
                                warning:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["warning-alert"][lang]
                            },
                            {
                                dom:"textarea",
                                type:"textarea",
                                name:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["warning-textarea"]["name"],
                                property:"credition-definition-password-warning",
                                warning:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["warning-textarea"]["warning-alert"][lang]
                            }
                        ]);
                        if(validation === false){return false;}
                        const settings = {};
                        //creditions definition starts
                        settings.creditiondefinitionexteriorform = {
                            username:{
                                column:validation["credition-definition-username"],
                                warning:validation["credition-definition-username-warning"]
                            },
                            password:{
                                column:validation["credition-definition-password"],
                                warning:validation["credition-definition-password-warning"]
                            }
                        };
                        //creditions definition ends
                        //login groupping starts
                        const groups = $(`div[sdapp="login-group"]`);
                        if(groups.length > 0){
                            settings.logingroups = {};
                            for(let i = 0; i<groups.length; i++){
                                const group = $(groups[i]);
                                const groupName = group.find(`input[name="${text["login-settings"]["input-naming"]["group-name"]}"]`);
                                const groupSqlBlock = group.find(`select[name="${text["login-settings"]["input-naming"]["group-sql-block"]}"]`);
                                if(groupName.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-name"][lang],
                                        "warning"
                                        );
                                    groupName.focus();
                                    return false;  
                                }
                                if(groupSqlBlock.val().length <1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-sql-block"][lang],
                                        "warning"
                                    );
                                    groupSqlBlock.focus();
                                    return false;
                                }
                                //features starts
                                const featuresLoginCreditials = group.find(`div[sdapp="login-group-features-login-creditials"]`);
                                const featuresOnLoginSuccessfully = group.find(`div[sdapp="login-group-features-on-login-successfully-event"]`);
                                const featuresOnLoginFailed = group.find(`div[sdapp="login-group-features-on-login-failed-event"]`);
                                const featuresOnLogout = group.find(`div[sdapp="login-group-features-on-logout-event"]`);
                                const creditialUsername = featuresLoginCreditials.find(`select[name="${text["login-settings"]["input-naming"]["group-features-login-creditials-username-column"]}"]`);
                                const creditialPassword = featuresLoginCreditials.find(`select[name="${text["login-settings"]["input-naming"]["group-features-login-creditials-password-column"]}"]`);
                                const onLoginSuccessfullyRedirectedPage = featuresOnLoginSuccessfully.find(`select[name="${text["login-settings"]["input-naming"]["group-features-login-on-login-successfully-event-redirected-page"]}"]`);
                                const onLoginSuccessfullyFeedbackMessage = featuresOnLoginSuccessfully.find(`textarea[name="${text["login-settings"]["input-naming"]["group-features-login-on-login-successfully-event-feedback-message"]}"]`)
                                const onLoginFailedRedirectedPage = featuresOnLoginFailed.find(`select[name="${text["login-settings"]["input-naming"]["group-features-login-on-login-failed-event-redirected-page"]}"]`);
                                const onLoginFailedMessage = featuresOnLoginFailed.find(`textarea[name="${text["login-settings"]["input-naming"]["group-features-login-on-login-failed-event-feedback-message"]}"]`);
                                const onLogoutRedirectedPage = featuresOnLogout.find(`select[name="${text["login-settings"]["input-naming"]["group-features-login-on-logout-event-redirected-page"]}"]`);
                                const onLogoutMessage = featuresOnLogout.find(`textarea[name="${text["login-settings"]["input-naming"]["group-features-login-on-logout-event-feedback-message"]}"]`);
                                if(creditialUsername !== undefined && creditialUsername !== null && creditialUsername.val() !== undefined &&creditialUsername.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-login-creditials-username-column"][lang],
                                        "warning"
                                    );
                                    creditialUsername.focus();
                                    return false;
                                }
                                if(creditialPassword !== undefined && creditialPassword !== null && creditialPassword.val() !== undefined && creditialPassword.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-login-creditials-password-column"][lang],
                                        "warning"
                                    );
                                    creditialPassword.focus();
                                    return false;
                                }
                                if(onLoginSuccessfullyRedirectedPage !== undefined && onLoginSuccessfullyRedirectedPage !== null && onLoginSuccessfullyRedirectedPage.val()!==undefined && onLoginSuccessfullyRedirectedPage.val().length <1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-login-successfully-redirected-page"][lang],
                                        "warning"
                                    );
                                    onLoginSuccessfullyRedirectedPage.focus();
                                    return false;
                                }
                                if(onLoginSuccessfullyFeedbackMessage !== undefined && onLoginSuccessfullyFeedbackMessage !== null && onLoginSuccessfullyFeedbackMessage.val()!== undefined && onLoginSuccessfullyFeedbackMessage.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-login-successfully-feedback-message"][lang],
                                        "warning"
                                    );
                                    onLoginSuccessfullyFeedbackMessage.focus();
                                    return false;
                                }
                                if(onLoginFailedRedirectedPage !== undefined && onLoginFailedRedirectedPage !== null && onLoginFailedRedirectedPage.val()!== undefined && onLoginFailedRedirectedPage.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-login-failed-redirected-page"][lang],
                                        "warning"
                                    );
                                    onLoginFailedRedirectedPage.focus();
                                    return false;
                                }
                                if(onLoginFailedMessage !== undefined && onLoginFailedMessage !== null && onLoginFailedMessage.val() !== undefined && onLoginFailedMessage.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-login-failed-feedback-message"][lang],
                                        "warning"
                                    );
                                    onLoginFailedMessage.focus();
                                    return false;
                                }
                                if(onLogoutRedirectedPage !== undefined && onLogoutRedirectedPage !== null && onLogoutRedirectedPage.val() !== undefined && onLogoutRedirectedPage.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-logout-redirected-page"][lang],
                                        "warning"
                                    );
                                    onLogoutRedirectedPage.focus();
                                    return false;
                                }
                                if(onLogoutMessage !== undefined && onLogoutMessage !== null && onLogoutMessage.val() !== undefined && onLogoutMessage.val().length <1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["warnings"]["group-features-on-logout-feedback-message"][lang],
                                        "warning"
                                    );
                                    onLogoutMessage.focus();
                                    return false;
                                }
                                //features ends

                                //elements starts
                                const elements = group.find(`div[sdapp="login-group-features-elements"]`);
                                const defaultProfilePhoto  = elements.find(`input[type="file"][name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["name"]}"]`);
                                const defaultProfileBlock = elements.find(`select[name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["block"]["name"]}"]`);
                                const defaultProfileKey = elements.find(`select[name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["column"]["name"]}"]`);
                                const defaultProfilePhotoValue = $(defaultProfilePhoto).attr("value");

                                const defaultTimelinePhoto  = elements.find(`input[type="file"][name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["name"]}"]`);
                                const defaultTimelineBlock = elements.find(`select[name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["block"]["name"]}"]`);
                                const defaultTimelineKey = elements.find(`select[name="${text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["column"]["name"]}"]`);
                                const defaultTimelinePhotoValue = $(defaultTimelinePhoto).attr("value");
                                if(defaultProfilePhotoValue === null || defaultProfilePhotoValue === undefined){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["warning"][lang],
                                        "warning"
                                    );
                                    return false;
                                }
                                if(defaultProfileBlock.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["block"]["warning"][lang],
                                        "warning"
                                    );
                                    defaultProfileBlock.focus();
                                    return false;
                                }
                                if(defaultProfileKey.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-profile-photo"]["column"]["warning"][lang],
                                        "warning"
                                    );
                                    defaultProfileKey.focus();
                                    return false;
                                }

                                if(defaultTimelinePhotoValue === null || defaultTimelinePhotoValue === undefined){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["warning"][lang],
                                        "warning"
                                    );
                                    return false;
                                }
                                if(defaultTimelineBlock.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["block"]["warning"][lang],
                                        "warning"
                                    );
                                    defaultTimelineBlock.focus();
                                    return false;
                                }
                                if(defaultTimelineKey.val().length < 1){
                                    swal(
                                        text["alert"][lang],
                                        text["login-settings"]["login-grouping-block"]["elements"]["default-user-timeline-photo"]["column"]["warning"][lang],
                                        "warning"
                                    );
                                    defaultTimelineKey.focus();
                                    return false;
                                }
                                //element ends
                                settings.logingroups[i] = {
                                        groupname:groupName.val(),
                                        groupsqlblockid:groupSqlBlock.val(),
                                        columncreditials:{
                                            username:creditialUsername.val(),
                                            password:creditialPassword.val()
                                        },
                                        events:{
                                            onloginsuccessfully:{
                                                redirectedpage:onLoginSuccessfullyRedirectedPage.val(),
                                                feebackmessage:onLoginSuccessfullyFeedbackMessage.val()
                                            },
                                            onloginfailed:{
                                                redirectedpage:onLoginFailedRedirectedPage.val(),
                                                feedbackmessage:onLoginFailedMessage.val()
                                            },
                                            onlogout:{
                                                redirectedpage:onLogoutRedirectedPage.val(),
                                                feedbackmessage:onLogoutMessage.val()
                                            }
                                        },
                                        elements:{
                                            defaultphotoprofile:{
                                                block:defaultProfileBlock.val(),
                                                key:defaultProfileKey.val(),
                                                value:defaultProfilePhotoValue
                                            },
                                            defaultphototimeline:{
                                                block:defaultTimelineBlock.val(),
                                                key:defaultTimelineKey.val(),
                                                value:defaultTimelinePhotoValue
                                            }
                        
                                        }
                                };
                            }
                        }
                        //console.log(settings);
                        //return false;
                        //login groupping ends
                        const action = () =>{
                            gen.url(false, gen.serverSideUrl, {
                                key: "sqledit",
                                table: "sdappblockreference",
                                fieldandvalues: {
                                    loginsettings:settings
                                },
                                referencefield: "blockid",
                                referenceid: __row[0]
                            }, false, 1);
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-all-data-blocks"
                            });
                        };
                        gen.sweetWarningMsgBox(
                            action,
                            text["alert"][lang],
                            text["login-settings"]["creditials-definition-block"]["save-settings-warning"][lang],
                            text["login-settings"]["creditials-definition-block"]["save-settings-success"][lang],
                            text["sdapp-no-action-done"][lang]
                        );
                    }
                });
            },
            dropDownFromColumns:(__functionOption)=>{
                const blocks = importingModules.customizedform().blocks();
                const blockid = parseInt(__functionOption.blockid);
                const legend = __functionOption.legend;
                const name = __functionOption.name;
                const editedvalue = __functionOption.editedvalue;
                const css = __functionOption.hasOwnProperty("css") ? __functionOption.css : {};
                const block = blocks.filter(item=>{return parseInt(item.blockid) === blockid;});
                if(block.length > 0){
                    const blockColumns = gen.getObjectFromJSON(block[0].columnsobjects)
                    return gen.dropDownFromArray({
                        array:blockColumns,
                        id:"key",
                        output:"title",
                        attr:{
                            class:"form-control",
                            name:name
                        },
                        css:css,
                        legend:legend,
                        editedvalue:editedvalue
                    });
                }
               
                console.log(block);
            },
            creditialDefinitionBlockExteriorForm:(__functionOption)=>{
                const settings = __functionOption.settings;
                const row = function(__annonymFunctionOptions){
                const columnName = __annonymFunctionOptions.columnname;
                const columnLegend = __annonymFunctionOptions.columnlegend;
                const columnEditedValue = __annonymFunctionOptions.columneditedvalue;
                const warningEditedValue = __annonymFunctionOptions.warningeditedvalue;
                const warningName = __annonymFunctionOptions.warningname;
                const warningPlaceholder = __annonymFunctionOptions.warningplaceholder;
                    return {
                        element:"div",
                        attr:{
                            class:"row"
                        },
                        css:{
                            marginBottom:"10px"
                        },
                        children:[
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-3"
                                },
                                html:__annonymFunctionOptions.title
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-4"
                                },
                                html:__objects.dropDownFromColumns({
                                    blockid:__row[0],
                                    name:columnName,
                                    legend:columnLegend,
                                    editedvalue:columnEditedValue,
                                    css:{
                                        marginBottom:"5px"
                                    }
                                })
                            },
                            {
                                element:"div",
                                attr:{
                                    class:"col-lg-5"
                                },
                                children:[
                                    {
                                        element:"textarea",
                                        attr:{
                                            name:warningName,
                                            class:"form-control",
                                            placeholder:warningPlaceholder
                                        },
                                        css:{
                                            height:"37px",
                                            marginBottom:"5px"
                                        },
                                        value:warningEditedValue
                                    }
                                ]
                            }
                        ]
                    };
                };
                return gen.objectInterfaceMaker([
                    row({
                        title:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["title"][lang],
                        columnname:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["name"],
                        columnlegend:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["legend"][lang],
                        columneditedvalue:settings !== null && settings !== undefined ? settings.creditiondefinitionexteriorform.username.column.value: null,
                        warningname:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["warning-textarea"]["name"],
                        warningplaceholder:text["login-settings"]["creditials-definition-block"]["rows"]["username"]["warning-textarea"]["placeholder"][lang],
                        warningeditedvalue:settings !== null && settings !== undefined ? settings.creditiondefinitionexteriorform.username.warning: null,
                    }),
                    row({
                        title:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["title"][lang],
                        columnname:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["name"],
                        columnlegend:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["legend"][lang],
                        columneditedvalue:settings !== null && settings !== undefined ? settings.creditiondefinitionexteriorform.password.column.value: null,
                        warningname:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["warning-textarea"]["name"],
                        warningplaceholder:text["login-settings"]["creditials-definition-block"]["rows"]["password"]["warning-textarea"]["placeholder"][lang],
                        warningeditedvalue:settings !== null && settings !== undefined ? settings.creditiondefinitionexteriorform.password.warning: null,
                    })
                ]).init();
            }
        };
        if(__constructorOptions.hasOwnProperty("importing-ressources") && __constructorOptions["importing-ressources"] === true){
            return this;
        }
        $(allVariables.appsection).html(sdapp.replaceScriptWithUI({
            returncontent:true,
            title:gen.jsonCharReplacer(gen.superReplacer(text["login-settings"]["form-heading-title"][lang],"@blockname",row["blockname"]),-1),
            html:__objects.init(),
            textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
            rightoptions: {
                title: "",
                iconColor: "#fff",
                icon: "icon-options icons",
                submenus: {
                    newblock:{
                        title:text["new-block"][allVariables.lang],
                        icon:"fa fa-plus",
                        callback: e =>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-add-data-block"
                            });
                        }
                    },
                    allblocks:{
                        title:text["all-blocks"][allVariables.lang],
                        icon:"fa fa-circle-o",
                        callback: e=>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-all-data-blocks"
                            });
                        }
                    }
                }
            }
        }));
        gen.selectDropdownChildrenMultipleSelection();
    
    }
}