class sdapp_reporting{
    constructor(__constructorOptions){
        const sdapp = __constructorOptions.sdapp;
        const allVariables = sdapp.allvariables;
        const gen = sdapp.gen;
        const me = this;
        const text = __constructorOptions.text;
        const row = __constructorOptions.row;
        const themeId = row.themeid;
        const lang = allVariables.lang;
        this.row = row;
        this.init = () =>{
            const outputSection = $(gen.createEl("div"));
            const reportingSettings = gen.getObjectFromJSON(me.row["reportingsettings"]);
            outputSection.html(() =>{
                if(reportingSettings instanceof Object && reportingSettings !== null && reportingSettings.hasOwnProperty("type")){
                    return me.reportTypeOutput({
                        value:parseInt(reportingSettings.type),
                        settings:reportingSettings.settings
                    });
                }
                return null;
            });
            return gen.objectInterfaceMaker([
                {
                    element:"div",
                    attr:{
                        class:"row"
                    },
                    children:[
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-6"
                            },
                            html:() =>{
                                const reportTypes = gen.dropDownFromArray({
                                    array:text["report-types"],
                                    id:"key",
                                    output:(arr)=>{return arr.title[lang];},
                                    editedvalue: typeof(reportingSettings) === "object" && reportingSettings !== null && reportingSettings.hasOwnProperty("type") ? parseInt(reportingSettings.type) : null,
                                    attr:{
                                        class:"form-control",
                                        name:"report-types"
                                    },
                                    css:{
                                        margin:"5px 0px 5px 0px"
                                    },
                                    legend:text["select-report-type"][lang],
                                    onchange:e=>{
                                        const value = parseInt(e.target.value);
                                        if(value > 0){
                                            outputSection.html(me.reportTypeOutput({
                                                value:value
                                            }));
                                            sdapp.activateSelect2();
                                        }
                                    }
                                });
                                return reportTypes;
                            }
                        },
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-6"
                            },
                            css:{
                                padding:"10px"
                            },
                            html:gen.anchor({
                                title:text["save-report-settings"][lang],
                                icon:"fa fa-save",
                                css:{
                                    cursor:"pointer",
                                    marginTop:"10px",
                                    marginLeft:"10px"
                                },
                                callback:e=>{
                                    e.preventDefault();
                                    me.saveReportSettings();
                                }
                            })
                        },
                        {
                            element:"div",
                            attr:{
                                class:"col-lg-12"
                            },
                            html:outputSection
                        }
                    ]
                }
            ]).init();
        }
        this.referenceBlockData = (__methodOptions)=>{
            return gen.getObjectFromJSON(gen.url(false, gen.serverSideUrl, {
                key: "returnjson",
                table: "sdappblockreference",
                datatype: "json",
                ref: `WHERE themeid ='${row.themeid}' AND datastatus > 0`,
                getter: true
            }, false, 1));
        }
        this.reportTypeOutput = (__methodOptions)=>{
            const value = __methodOptions.value;
            let UI = null;
            switch(value){
                case 1: UI=me.salaryBasedOnCommissionPercentage(__methodOptions).init();break;
            }
            return UI;
        }
        this.salaryBasedOnCommissionPercentage = (__methodOptions)=>{
            const settings = __methodOptions instanceof Object && __methodOptions.hasOwnProperty("settings") ? __methodOptions.settings : {};
            const __objects = {
                css:{
                    agentblocksection:{
                        padding:"10px 0px 10px 0px"
                    },
                    operatioblocksection:{
                        padding:"10px 0px 10px 0px"
                    },
                    rows:{
                        agentblock:{
                           block:{
                            margin:"50px 0px 5px 0px",
                            border:"1px #ced4da solid",
                            width:"100%",
                            padding:"5px",
                            borderRadius:"3px"
                           },
                           title:{
                               backgroundColor:"#ced4da",
                               color:"#000",
                               padding:"5px",
                               margin:"-37px 0px 5px 0px",
                               float:"left",
                               width:"auto"
                           }
                        },
                        operationblock:{
                            margin:"5px 0px 5px 0px",
                            borderRadius:"5px",
                            border:"1px #ccc solid",
                            width:"100%",
                            padding:"5px"
                        },
                        savingblock:{
                            margin:"5px 0px 5px 0px",
                            borderRadius:"5px",
                            border:"1px #ccc solid",
                            width:"100%",
                            padding:"5px"
                        }
                    }
                },
                init:() =>{
                    const agentBlockSubSection = $(gen.createEl("div")).css(__objects.css.agentblocksection).html(()=>{
                        if(settings instanceof Object && settings.hasOwnProperty("agent")){
                            const d = me.referenceBlockData().filter(item=>{return parseInt(item.blockid) === parseInt(settings.agent.blockid)})[0];
                            return __objects.agentBlockSectionFeatures({
                                data:d,
                                columns:settings.agent.columns
                            });
                        }
                        return  null;
                    });
                    const operationBlockSubSection = $(gen.createEl("div")).css(__objects.css.operatioblocksection).html(()=>{
                        if(settings instanceof Object && settings.hasOwnProperty("operation")){
                            const d = me.referenceBlockData().filter(item=>{return parseInt(item.blockid) === parseInt(settings.operation.blockid)})[0];
                            return __objects.operationBlockFeatures({
                                data:d,
                                columns:settings.operation.columns
                            });
                        }
                    });
                    const saveBlockSubSection = $(gen.createEl("div")).css(__objects.css.operatioblocksection).html(()=>{
                        if(settings instanceof Object && settings.hasOwnProperty("save")){
                            const d = me.referenceBlockData().filter(item=>{return parseInt(item.blockid) === parseInt(settings.save.blockid)})[0];
                            return __objects.saveBlockFeatures({
                                data:d,
                                columns:settings.save.columns
                            });
                        }
                        return null;
                    });
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    css:__objects.css.rows.agentblock.block,
                                    children:[
                                        {
                                            element:"div",
                                            css:__objects.css.rows.agentblock.title,
                                            html:text["agent-block"][lang]
                                        },
                                        {
                                            element:"div",
                                            html:() =>{
                                                return __objects.blockDropDown({
                                                    legend:text["select-agent-block"][lang],
                                                    name:"agent-block",
                                                    editedvalue:settings instanceof Object && settings.agent !== undefined && settings.agent.blockid !== undefined ? settings.agent.blockid : null,
                                                    onchange: e =>{
                                                        const data = e.data.array;
                                                        const value = parseInt(e.target.value);
                                                        if(Array.isArray(data)){
                                                            const single = data.filter(item=>{ return parseInt(item[0]) === value;});
                                                            agentBlockSubSection.html(__objects.agentBlockSectionFeatures({
                                                                data:single[0]
                                                            })); 
                                                        }  
                                                    }
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            html:() =>{
                                                return agentBlockSubSection;
                                            }
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    css:__objects.css.rows.agentblock.block,
                                    children:[
                                        {
                                            element:"div",
                                            css:__objects.css.rows.agentblock.title,
                                            html:text["operation-block"][lang]
                                        },
                                        {
                                            element:"div",
                                            html:() =>{
                                                return __objects.blockDropDown({
                                                    legend:text["select-operation-block"][lang],
                                                    name:"operation-block",
                                                    editedvalue:settings instanceof Object && settings.operation !== undefined && settings.operation.blockid !== undefined ? settings.operation.blockid : null,
                                                    onchange:e=>{
                                                        const data = e.data.array;
                                                        const value = parseInt(e.target.value);
                                                        if(Array.isArray(data)){
                                                            const single = data.filter(item=>{ return parseInt(item[0]) === value;});
                                                            operationBlockSubSection.html(__objects.operationBlockFeatures({
                                                                data:single[0]
                                                            })); 
                                                        } 
                                                    }
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            html:operationBlockSubSection
                                        }
                                    ]
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    css:__objects.css.rows.agentblock.block,
                                    children:[
                                        {
                                            element:"div",
                                            css:__objects.css.rows.agentblock.title,
                                            html:text["saving-block"][lang]
                                        },
                                        {
                                            element:"div",
                                            html:() =>{
                                                return __objects.blockDropDown({
                                                    legend:text["select-saving-block"][lang],
                                                    name:"saving-block",
                                                    editedvalue:settings instanceof Object && settings.save !== undefined && settings.save.blockid !== undefined ? settings.save.blockid : null,
                                                    onchange:e =>{
                                                        const data = e.data.array;
                                                        const value = parseInt(e.target.value);
                                                        if(Array.isArray(data)){
                                                            const single = data.filter(item=>{ return parseInt(item[0]) === value;});
                                                            saveBlockSubSection.html(__objects.saveBlockFeatures({
                                                                data:single[0]
                                                            })); 
                                                        } 
                                                    }
                                                });
                                            }
                                        },
                                        {
                                            element:"div",
                                            html:saveBlockSubSection
                                        }
                                    ]
                                }
                            ]
                        }
                    ]).init();
                },
                blockDropDown:(__functionOption) =>{
                    return gen.dropDownFromArray({
                        array:me.referenceBlockData(),
                        id:"blockid",
                        output:"blockname",
                        attr:{
                            class:"form-control single-select",
                            name:__functionOption.name
                        },
                        onchange:__functionOption.onchange,
                        legend:__functionOption.legend,
                        editedvalue:__functionOption.editedvalue
                    });
                },
                agentBlockSectionFeatures:(__functionOption)=>{
                    const columns = gen.getObjectFromJSON(__functionOption.data["columnsobjects"]);
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr)=>{
                                                return arr.title;
                                            },
                                            attr:{
                                                class:"form-control",
                                                multiple:"multiple",
                                                name:"agent-fullname-columns"
                                            },
                                            legend:text["select-fullname-columns"][lang],
                                            editedvalue:__functionOption instanceof Object && __functionOption.columns !== undefined && __functionOption.columns.fullname !== null && __functionOption.columns.fullname !== undefined ? __functionOption.columns.fullname : null
                                        });
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-9"
                                    },
                                    children:[
                                        {
                                            element:"div",
                                            attr:{
                                                class:"row"
                                            },
                                            children:[
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-6"
                                                    },
                                                    html:()=>{
                                                        return gen.dropDownFromArray({
                                                            array:columns,
                                                            id:"key",
                                                            output:(arr)=>{
                                                                return arr.title;
                                                            },
                                                            attr:{
                                                                class:"form-control",
                                                                name:"agent-excepted-service-day-work"
                                                            },
                                                            legend:text["select-work-days-column"][lang],
                                                            editedvalue:__functionOption instanceof Object && __functionOption.columns !== undefined && __functionOption.columns.numberforworkday !== null && __functionOption.columns.numberforworkday !== undefined ? __functionOption.columns.numberforworkday : null
                                                        });
                                                    }
                                                },
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-6"
                                                    },
                                                    html:()=>{
                                                        return   gen.dropDownFromArray({
                                                            array:columns,
                                                            id:"key",
                                                            output:(arr)=>{
                                                                return arr.title;
                                                            },
                                                            attr:{
                                                                class:"form-control",
                                                                name:"agent-default-monthly-salary"
                                                            },
                                                            legend:text["select-default-monthly-salary-column"][lang],
                                                            editedvalue:__functionOption instanceof Object && __functionOption.columns !== undefined && __functionOption.columns.monthlysalary !== null && __functionOption.columns.monthlysalary !== undefined ? __functionOption.columns.monthlysalary : null
                                                        });
                                                    }
                                                }
                                                
                                            ]
                                        },
                                        {
                                            element:"div",
                                            attr:{
                                                class:"row"
                                            },
                                            css:{
                                                marginTop:"10px"
                                            },
                                            children:[
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-6"
                                                    },
                                                    html:function(){
                                                        return  gen.dropDownFromArray({
                                                            array:columns,
                                                            id:"key",
                                                            output:(arr)=>{
                                                                return arr.title;
                                                            },
                                                            attr:{
                                                                class:"form-control",
                                                                name:"agent-commission-percentage-column"
                                                            },
                                                            legend:text["select-commission-percentage-column"][lang],
                                                            editedvalue:__functionOption instanceof Object && __functionOption.columns !== undefined && __functionOption.columns.servicecommission !== null && __functionOption.columns.servicecommission !== undefined ? __functionOption.columns.servicecommission : null
                                                        });
                                                    }
                                                },
                                                {
                                                    element:"div",
                                                    attr:{
                                                        class:"col-lg-6"
                                                    },
                                                    html:function(){
                                                        return  gen.dropDownFromArray({
                                                            array:columns,
                                                            id:"key",
                                                            output:(arr)=>{
                                                                return arr.title;
                                                            },
                                                            attr:{
                                                                class:"form-control",
                                                                name:"agent-photo-column"
                                                            },
                                                            legend:text["select-agent-photo-column"][lang],
                                                            editedvalue:__functionOption instanceof Object && __functionOption.columns !== undefined && __functionOption.columns.photo !== null && __functionOption.columns.photo !== undefined ? __functionOption.columns.photo : null
                                                        });
                                                    }
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]).init();
                },
                operationBlockFeatures:(__functionOption)=>{
                    const columns = gen.getObjectFromJSON(__functionOption.data["columnsobjects"]);
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-12"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr)=>{return arr.title;},
                                            legend:text["select-amount-column"][lang],
                                            attr:{
                                                class:"form-control",
                                                name:"operation-amount-column"
                                            },
                                            editedvalue:__functionOption instanceof Object && __functionOption.hasOwnProperty("columns") && __functionOption.columns.amount !== null && __functionOption.columns.amount !== undefined ? __functionOption.columns.amount : null
                                        });
                                    }
                                }
                            ]
                        }
                    ]).init();
                },
                saveBlockFeatures:(__functionOption)=>{
                    const columns = gen.getObjectFromJSON(__functionOption.data["columnsobjects"]);
                    return gen.objectInterfaceMaker([
                        {
                            element:"div",
                            attr:{
                                class:"row"
                            },
                            children:[
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr) =>{
                                                return arr.title;
                                            },
                                            legend:text["select-column-for-agent"][lang],
                                            attr:{
                                                class:"form-control",
                                                name:"save-block-agent-column"
                                            },
                                            editedvalue:__functionOption instanceof Object && __functionOption.hasOwnProperty("columns") &&  __functionOption.columns.agentfullname !== null && __functionOption.columns.agentfullname ? __functionOption.columns.agentfullname : null
                                        });
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr) =>{
                                                return arr.title;
                                            },
                                            legend:text["select-column-for-month"][lang],
                                            attr:{
                                                class:"form-control",
                                                name:"save-block-month-column"
                                            },
                                            editedvalue:__functionOption instanceof Object && __functionOption.hasOwnProperty("columns") &&  __functionOption.columns.month !== null && __functionOption.columns.month ? __functionOption.columns.month : null
                                        });
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr) =>{
                                                return arr.title;
                                            },
                                            legend:text["select-column-for-year"][lang],
                                            attr:{
                                                class:"form-control",
                                                name:"save-block-year-column"
                                            },
                                            editedvalue:__functionOption instanceof Object && __functionOption.hasOwnProperty("columns") &&  __functionOption.columns.year !== null && __functionOption.columns.year ? __functionOption.columns.year : null
                                        });
                                    }
                                },
                                {
                                    element:"div",
                                    attr:{
                                        class:"col-lg-3"
                                    },
                                    html:() =>{
                                        return gen.dropDownFromArray({
                                            array:columns,
                                            id:"key",
                                            output:(arr) =>{
                                                return arr.title;
                                            },
                                            legend:text["select-column-for-amount"][lang],
                                            attr:{
                                                class:"form-control",
                                                name:"save-block-amount-column"
                                            },
                                            editedvalue:__functionOption instanceof Object && __functionOption.hasOwnProperty("columns") &&  __functionOption.columns.amount !== null && __functionOption.columns.amount ? __functionOption.columns.amount : null
                                        });
                                    }
                                }
                            ]
                        }
                    ]).init();
                },
                saveSettings:(__functionOption) =>{
                    const validation = gen.getInputValueFromValidation([
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-block",
                            property:"agentblock",
                            warning:text["select-agent-block-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-fullname-columns",
                            property:"agenfullnamecolumns",
                            warning:text["agent-fullname-columns-warning"][lang],
                            callback:[
                            (fullnamecolumns) => {
                                return {
                                    validation:(columns =>{
                                        if(Array.isArray(columns)){
                                            if(columns[0].length<1){
                                                return false;
                                            }
                                            return true;
                                        }
                                        return true;
                                    })(fullnamecolumns),
                                    warning: () => {
                                        swal(
                                            text["alert"][lang],
                                            text["agent-fullname-columns-warning"][lang],
                                            "warning"
                                        );

                                    }
                                };
                            }
                           ]

                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-excepted-service-day-work",
                            property:"agentexceptedservicedaywork",
                            warning:text["agent-excepted-service-day-work-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-default-monthly-salary",
                            property:"agentdefaultmonthlysalary",
                            warning:text["agent-default-monthly-salary-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-commission-percentage-column",
                            property:"agentcommissionpercentagecolumn",
                            warning:text["agent-commission-percentage-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"agent-photo-column",
                            property:"agentphotocolumn",
                            warning:text["agent-photo-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"operation-block",
                            property:"operationblock",
                            warning:text["operation-block-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"operation-amount-column",
                            property:"operationamountcolumn",
                            warning:text["operation-amount-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"saving-block",
                            property:"savingblock",
                            warning:text["saving-block-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"save-block-agent-column",
                            property:"saveblockagentcolumn",
                            warning:text["save-block-agent-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"save-block-month-column",
                            property:"saveblockmonthcolumn",
                            warning:text["save-block-month-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"save-block-year-column",
                            property:"saveblockyearcolumn",
                            warning:text["save-block-year-column-warning"][lang]
                        },
                        {
                            dom:"select",
                            type:"select",
                            name:"save-block-amount-column",
                            property:"saveblockamountcolumn",
                            warning:text["save-block-amount-column-warning"][lang]
                        }
                    ]);
                    if(validation === false){
                        return false;
                    }
                    this.savingApplyForAll({
                        type:__functionOption.type,
                        settings:{
                            agent:{
                                blockid:validation.agentblock.value,
                                columns:{
                                    fullname:validation.agenfullnamecolumns.value,
                                    numberforworkday:validation.agentexceptedservicedaywork.value,
                                    monthlysalary:validation.agentdefaultmonthlysalary.value,
                                    servicecommission:validation.agentcommissionpercentagecolumn.value,
                                    photo:validation.agentphotocolumn.value

                                }
                            },
                            operation:{
                                blockid:validation.operationblock.value,
                                columns:{
                                    amount:validation.operationamountcolumn.value
                                }
                            },
                            save:{
                                blockid:validation.savingblock.value,
                                columns:{
                                    agentfullname:validation.saveblockagentcolumn.value,
                                    month:validation.saveblockmonthcolumn.value,
                                    year:validation.saveblockyearcolumn.value,
                                    amount:validation.saveblockamountcolumn.value

                                }
                            }
                        }
                    })
                }
            };
            return __objects;
        }
        this.savingApplyForAll = (__methodOptions) =>{
            const action = function(){
                gen.url(false, gen.serverSideUrl, {
                    key: "sqledit",
                    table: "sdappblockreference",
                    fieldandvalues: {
                        reportingsettings:{
                            type:__methodOptions.type,
                            settings:__methodOptions.settings
                        }
                    },
                    referencefield: "blockid",
                    referenceid: me.row[0]
                }, false, 1);

                sdapp.sdapp_Access_Menu({
                    key: "sdapp-builder-all-data-blocks"
                });
            };
            gen.sweetWarningMsgBox(
                action,
                text["alert"][allVariables.lang],
                text["save-reporting-settings-warning"][lang],
                text["save-reporting-settings-success"][lang],
                text["sdapp-no-action-done"][lang]
            );
        }
        this.saveReportSettings = (__methodOptions) =>{
            const reportTypes = $(`select[name="report-types"]`);
            if(reportTypes.val().length < 1){
                swal(text["alert"][lang],text["select-report-type-warning"][lang],"warning");
                reportTypes.focus();
                return false;
            }
            switch(parseInt(reportTypes.val())){
                case 1:me.salaryBasedOnCommissionPercentage().saveSettings({
                    type:reportTypes.val()
                });break;
            }
        }
        $(allVariables.appsection).html(sdapp.replaceScriptWithUI({
            returncontent:true,
            title:gen.jsonCharReplacer(gen.superReplacer(text["report-setting-title"][allVariables.lang],"@blockname",row["blockname"]),-1),
            html:me.init(),
            textfooter: text["sdapp-copyright"][allVariables.lang].replace("@date", gen.currentDate()),
            rightoptions: {
                title: "",
                iconColor: "#fff",
                icon: "icon-options icons",
                submenus: {
                    newblock:{
                        title:text["new-block"][allVariables.lang],
                        icon:"fa fa-plus",
                        callback: e =>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-add-data-block"
                            });
                        }
                    },
                    allblocks:{
                        title:text["all-blocks"][allVariables.lang],
                        icon:"fa fa-circle-o",
                        callback: e=>{
                            e.preventDefault();
                            sdapp.sdapp_Access_Menu({
                                key:"sdapp-builder-all-data-blocks"
                            });
                        }
                    }
                }
            }
        }));
    }
}