<?php
class sdapp_application_maker{
    private $main;
    private $control;
    private $model;
	private $configuration;
	private $lang;
    private $output = false;
	private $sdapp;
	private $html;
    public function __construct($main,$control,$model,$sdappClass){
        $this->main=$main;
        $this->control=$control;
        $this->model=$model;
		$this->sdapp=$sdappClass;
		$this->lang=$this->sdapp->lang;
		$this->configuration=$this->sdapp->configuration;
    }
    private function setDatabase($myObject){
        $filePath = $myObject->filepath;
        $createTableQuery = function($obj){
            $functions = [];
            $functions["getprimarykey"] = function($desc){
                if(is_array($desc)){
                    foreach($desc as $structure){
                        if(is_array($structure)){
                            if(key_exists("Key",$structure) && $structure["Key"] ==="PRI"){
                                return $structure;
                            }
                        }
                    }
                }
            };
            $table = $obj->table;
            $description = $obj->description;
            $pk = $functions["getprimarykey"]($description);
            $primaryKey = false;
            $primaryKeyStepArray = false;
            $query = ["CREATE TABLE IF NOT EXISTS `".$table."`"];
            $query[] = "(";
            if(is_array($pk) && count ($pk) > 0 && key_exists("Field",$pk) && key_exists("Type",$pk) && key_exists("Null",$pk) && key_exists("Null",$pk) && key_exists("Default",$pk) && key_exists("Extra",$pk)){
                $primaryKey =  strtolower($pk["Field"]);
                $query[] = "`".$primaryKey."`";
                $query[] = $pk["Type"];
                if(strtolower($pk["Null"]) ==="no"){
                    $query[] = "NOT NULL";
                }
                else{
                    $query[] = "NULL";
                }
                $primaryKeyStepArray = ", PRIMARY KEY  (`".$primaryKey."`)";
            }

            foreach($description as $field){
                if(key_exists("Field",$field) && strtolower($field["Field"]) === $primaryKey){
                    continue;
                }
                else{
                    $query[] =(function($field){
                        if(is_array($field) && count($field) > 0 && key_exists("Field",$field) && key_exists("Type",$field) && key_exists("Null",$field) && key_exists("Null",$field) && key_exists("Default",$field) && key_exists("Extra",$field)){
                            $fieldSetter = [", "];
                            $fieldSetter[] = $field["Field"];
                            $fieldSetter[] = strtoupper($field["Type"]);
                            if(strtolower($field["Null"]) ==="no"){
                                $fieldSetter[] = "NOT NULL";
                            }
                            else{
                                $fieldSetter[] = "NULL";
                            }

                            if(strtolower($field["Default"]) !== null && !empty($field["Default"])){
                                if($field["Default"] ==="CURRENT_TIMESTAMP"){
                                    $fieldSetter[] = "DEFAULT ".$field["Default"]." ";
                                }
                                else{
                                    $fieldSetter[] = "DEFAULT '".$field["Default"]."' ";
                                }
                                
                            }
                            return implode(" ",$fieldSetter);
                        }
                    })($field);
                }
            }

            $query[] =  $primaryKeyStepArray;
            $query[] = ") ENGINE = MyISAM";
            return implode(" ",$query);
        };
        $q = $this->sdapp->conn()->query("SHOW TABLES")->fetchAll();
        $dbStructures = [];
        foreach($q as $table){
            $qDesc =  $this->sdapp->conn()->query("DESC ".$table[0]." ")->fetchAll(PDO::FETCH_ASSOC);
            $dbStructures[] = $createTableQuery((object)[
                "table"=>$table[0],
                "description"=>$qDesc
            ]);
        }
        $this->control->mkFile($filePath,json_encode($dbStructures,JSON_PRETTY_PRINT));
    }
    private function sqlDataWrapper($myObject){
        $filePath = $myObject->filepath;
        $tableStructure = function ($table){
            return $this->sdapp->conn()->query("DESC ".$table." ")->fetchAll(PDO::FETCH_ASSOC);
        };
        $dataStructure = function($dQ,$tS){
            $dataType = function($field,$tS){
                if(is_iterable($tS) && is_array($tS)){
                    foreach($tS as $f){
                        if(key_exists("Field",$f) && $f["Field"] ===$field && key_exists("Type",$f)){
                            return [
                                "Field"=>$f["Field"],
                                "Type"=>$f["Type"]
                            ];
                        } 
                    }
                }
            };
            $fields = [];
            $__data = [];
            if(is_array($dQ)){
                if(is_iterable($dQ)){
                    foreach($dQ as $row){
                        $fields = (function($row,$dT,$tS){
                            $newFieldArr = [];
                            $keys = array_keys($row);
                            foreach($keys as $key){
                                $dataType =$dT($key,$tS);
                                if(is_array($dataType) && key_exists("Type",$dataType)){
                                    $newFieldArr[] = [
                                        "Field"=>$key,
                                        "Type"=>$dataType["Type"]
                                    ];
                                }

                            }
                            return $newFieldArr;
                        })($row,$dataType,$tS);
                        $__data [] = (function($fields,$row,$dataType){
                            $structure = [];
                            foreach($fields as $f){
                                 $field = $f["Field"];
                                 $type = $f["Type"];
                                if($type ==="json"){
                                    $structure[$field] = json_decode($row[$field]);
                                }
                                else{
                                    $structure[$field] = $row[$field];
                                }
                                
                            }
                            return $structure;
                        })($fields,$row,$dataType);
                    }
                }
            }
            return  $__data;
        };
        $q = $this->sdapp->conn()->query("SHOW TABLES")->fetchAll();
        $data = (object)[];
        foreach($q as $table){
            $sqlTable = $table[0];
            $dataQuery = $this->model->selectData((object)[
                "conn"=>$this->sdapp->conn(),
                "table"=>$sqlTable,
                "clauses"=>"WHERE datastatus > 0",
                "fetchmode"=>"assoc"
            ]);
            if(count($dataQuery) > 0){
                $data->$sqlTable = $dataStructure($dataQuery,$tableStructure($sqlTable));
            }
           
        }
        $this->control->mkFile($filePath,json_encode($data,JSON_PRETTY_PRINT));
    }
    private function applicationMakerWrapper($object){
        $appName = $object->appname;
        $source = $object->source;
        $destination = $object->destination.$appName;
        $this->emptyDir($object->destination);
        $this->control->zipFiles($source,$destination);
        return $destination;
    }
    public function writeSdappApplicationData(){
		$row = $this->control->request("row");
        $type = $this->control->request("type");
		$filePath = $this->applicationRoot()->sdapp."sdapp-application-info.json";
        $tableStructureFile = $this->applicationRoot()->sdapp."sdapp-sql-table-structures.json";
        $dataStructureFile = $this->applicationRoot()->sdapp."sdapp-sql-data-structures.json";
        if(file_exists($filePath)){
           $fileContent = file_get_contents($filePath);
           $basicInfo = [
            "id"=>$row[0],
            "theme-id"=>$row["themeid"],
            "organization"=>$row["organization"],
            "organization-website"=>$row["organizationwebsite"],
            "application-name"=>$row["applicationname"],
            "application-website"=>$row["applicationwebsite"],
            "application-login-page-title"=>$row["applicationloginpagetitle"],
            "application-dashboard-page-title"=>$row["applicationdashboardpagetitle"],
            "application-first-description"=>$row["applicationdescription_1"],
            "application-second-description"=>$row["applicationdescription_2"],
            "application-login-logo-width"=>$row["loginlogowidth"],
            "application-login-logo-height"=>$row["loginlogoheight"],
            "application-dashboard-logo-width"=>$row["dashboardlogowidth"],
            "application-dashboard-height"=>$row["dashboardheight"]
           ];
           $bi = "basic-info";
           $sdapp = "sdapp-application";
           $object = (object)[];
           $sourcePrepath ="../../";
           $destPrepath ="img/sdapp-application/";
           $base = $this->applicationRoot()->base;

           $photos = (object)[
               "favicon"=>$base.$destPrepath.$this->pathSpliter($sourcePrepath.$row["applicationfavicon"])->last,
               "loginicon"=>$base.$destPrepath.$this->pathSpliter($sourcePrepath.$row["applicationloginlogo"])->last,
               "dashboardicon"=>$base.$destPrepath.$this->pathSpliter($sourcePrepath.$row["applicationdashboardlogo"])->last,
           ];
           //default photo files uploads starts
           $appMakerUploadsDir = $base."uploads/";
           if(is_dir($appMakerUploadsDir)){
               //delete whatever file found starts
               foreach(scandir($appMakerUploadsDir) as $file){
                   if(file_exists($appMakerUploadsDir.$file) && in_array($file,[".","..","..."]) === false){
                       unlink($appMakerUploadsDir.$file);
                   }
               }
               //delete whatever file found ends
               //copy from builder to product starts
               $builderUploadsDir = "../uploads/";
               if(is_dir($builderUploadsDir)){
                   foreach(scandir($builderUploadsDir) as $file){
                    if(file_exists($builderUploadsDir.$file) && in_array($file,[".","..","..."]) === false){
                        copy($builderUploadsDir.$file,$appMakerUploadsDir.$file);
                    }
                   }
               }
               //copy from builder to product ends
           }
           //default photo files uploads ends
           
           //files starts
           $this->emptyDir($base.$destPrepath);
           copy($sourcePrepath.$row["applicationfavicon"],$photos->favicon);
           copy($sourcePrepath.$row["applicationloginlogo"],$photos->loginicon);
           copy($sourcePrepath.$row["applicationdashboardlogo"],$photos->dashboardicon);
           //files ends
           //theme starts
           $theme = $this->model->foreignVal("WHERE themeid='".$row["frontendthemeid"]."'","sdappthemes",[],$this->sdapp->conn());
           //zip starts
           $themeDir = $this->applicationRoot()->builderthemes.$theme["fileextracted"]."/";
           $themeDestination = $this->applicationRoot()->themes.$theme["fileextracted"];
           if(is_dir($themeDir)){
            //removemain theme dir starts
            @$this->control->removeDir($this->applicationRoot()->themes);
            if(!file_exists($this->applicationRoot()->themes)){
                mkdir($this->applicationRoot()->themes);
            }
            //removemain theme dir ends
            $this->control->zipFiles($themeDir,$themeDestination);
           }
           //zip ends
           //extraction starts
           if(!file_exists($this->applicationRoot()->themes.$theme["fileextracted"]."/")){
            mkdir($this->applicationRoot()->themes.$theme["fileextracted"]."/");
           }
           $this->control->extract($themeDestination.".zip",$this->applicationRoot()->themes.$theme["fileextracted"]."/");
           unlink($themeDestination.".zip");
           //extraction ends
           //theme ends
           $basicInfo["application-favicon"] = str_replace($base,false,$photos->favicon);
           $basicInfo["application-login-logo"] = str_replace($base,false,$photos->loginicon);
           $basicInfo["application-dashboard-logo"] = str_replace($base,false,$photos->dashboardicon);
           if(empty($fileContent)){
               $object = (object)[
                    $sdapp =>[
                       $bi=>$basicInfo
                   ]
               ];
           }
           else{
                $object = json_decode($fileContent);
                $object->$sdapp->$bi = $basicInfo;
           }
           $this->control->mkFile($filePath,json_encode($object));
           $this->sdapp->setPropertyToMainConfiguration((object)[
               "property"=>"sdapp-menu",
               "value"=>$this->applicationMenu((object)[
                   "settings"=>$row["menusettings"]
               ]),
               "file"=>$this->applicationRoot()->sdapp."sdapp-configurations.json"
           ]);
           
        }
        if($type ==="view"){
            return json_encode([
                "status"=>200,
                "appname"=>$row["applicationname"]
            ]);
        }
        if($type ==="export"){
            $this->setDatabase((object)[
                "filepath"=>$tableStructureFile
            ]);
            $this->sqlDataWrapper((object)[
                "filepath"=>$dataStructureFile
            ]);
            $downloadUrl = $this->applicationMakerWrapper((object)[
                "appname"=>str_replace(" ","_",strtolower($row["applicationname"]))."_".$this->control->pin(12),
                "source"=>$this->applicationRoot()->parent,
                "destination"=>$this->applicationRoot()->production
            ]);

            $downloadUrl = $downloadUrl.".zip";
            $downloadUrl = str_replace("../",false,$downloadUrl);
            $_SESSION["SDAPP-DOWNLOADING-FILE"] = $downloadUrl;
            return json_encode([
                "status"=>200,
                "appname"=>$row["applicationname"]
            ]);
        }
        
	}
    private function applicationMenu($object){
        $menu = (object)[];
        $menu->dashboard = (object)[
            "menu-key"=> "dashboard",
            "deactivate-page"=>"false",
            "name"=>[
                "fr"=> "Tableau de board",
                "en"=> "Dashboard",
            ],
            "children"=>[
                "home"=>[
                    "class"=> "fa fa-circle-o",
                    "attr"=> [
                        "key"=> "sdapp-home"
                    ],
                    "title"=> [
                        "fr"=> "Accueil",
                        "en"=> "Home"
                    ]
                ]
            ]
        ];
        $settings = json_decode($object->settings);
        $key = 0;
        if(is_iterable($settings)){
            foreach($settings as $set){
                $key++;
                $property = $set->parentmenuname."_".$key;
                $menu->$property = (object)[
                    "menu-key"=>$property,
                    "deactivate-page"=>"false",
                    "name"=>[
                        "fr"=>$set->parentmenuname,
                        "en"=>$set->parentmenuname
                    ],
                    "children"=>(function($obj){
                        $arr = [];
                        if(is_array($obj->submenus)){
                            foreach($obj->submenus as $k=>$ob){
                                $key = $this->sdapp->pageIdDecripted($ob->submenuform,true);
                                $urlKey = "view-record-form-token-".$key;
                                if($ob->submenutype === "form"){
                                    $urlKey = "add-record-form-token-".$key;
                                }
                                if($ob->submenutype === "report"){
                                    $urlKey = "view-report-form-token-".$key;
                                }
                                if($ob->submenuform === "customize"){
                                    $urlKey = $ob->submenutype;
                                }
                                $arr[$k]=[
                                    "class"=>$ob->submenuicon,
                                    "attr"=>[
                                        "key"=>$urlKey
                                    ],
                                    "title"=>[
                                        "fr"=>$ob->submenuname,
                                        "en"=>$ob->submenuname
                                    ]
                                ];
                            }
                            return $arr;
                        }
                        return null;
                    })($set),
                    "class"=>$set->parentmenuicon
                ];
            }
        }
      
        return $menu;
    }
    private function pathSpliter($path){
        $spliter = explode("/",$path);
        $end = end($spliter);
        return (object)[
            "last"=>$end,
            "array"=>$spliter
        ];

    }
    private function emptyDir($dir){
        if(is_dir($dir)){
            foreach(scandir($dir) as $file){
                $file = $dir."/".$file;
                if(is_file($file)){
                    unlink($file);
                }
            }
        }
    }
    private function applicationRoot(){
        $production = "../applicationmakerproduction/";
        $parent = "../applicationmaker/";
        $base = $parent."sdapp-manager/";
        $builderthemes = "../../themes/";
        $themes = "../applicationmaker/themes/";
        return (object)[
            "builderthemes"=>$builderthemes,
            "themes"=>$themes,
            "base"=>$base,
            "parent"=>$parent,
            "production"=>$production,
            "php"=>$base."php/",
            "sdapp"=>$base."php/sdapp/"
        ];
    }
    public function getter(){
        return $this->output;
    }

}
?>