﻿class hotelPlugin{
    constructor(options){
        var gen=options.gen;
        var me=this;
        var lang='fr';
        var constructorOptions=options;
        var allVariables={
            lang:lang,
            userid:function(){
                return  gen.url(false,gen.serverSideUrl,{
                    key:`calluserfunctionarray`,
                    class:`control`,
                    method:`userSessionId`,
                    parameters:['']
                },false,1);
            },
            pluginjson:function(url){
                return  gen.url(false,url,{ajaxdatatype:'json'},false,1);
            },
            copyright:`Copyright NULL CMS All Rights Reserved`,
        }
        this.bookingsBlock=function(){
            return gen.block({
                title:'Mes reservations',
                content:me.myBookings().records('all'),
                rightoptions:{
                    title:'Actions',
                    icon:'icon-options icons',
                    submenus:{
                        'availability':{
                            title:'Disponibilités chambres',
                            icon:'fa fa-calendar',
                            callback:function(e,titleSection,contentSection){
                                titleSection.html('Disponibilités chambres');
                                contentSection.html(me.myBookings().availabilityform())
                            }
                        },
                        'newbooking':{
                            title:'Nouvelle reservation',
                            icon:'fa fa-plus',
                            callback:function(e,titleSection,contentSection){
                                titleSection.html('Formulaire reservation');
                                contentSection.html(me.myBookings().form());
                            }
                        },
                        'roombooking':{
                            title:'Reservation chambres',
                            icon:'fa fa-bed',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation chambres');
                                contentSection.html(me.myBookings().records('rooms'));
                            }
                        },
                        'mealbooking':{
                            title:'Reservation repas',
                            icon:'fa fa-spoon',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation repas');
                                contentSection.html(me.myBookings().records('restaurant'));
                            }
                        },
                        'barbooking':{
                            title:'Reservation bar',
                            icon:'fa fa-glass',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation bar');
                                contentSection.html(me.myBookings().records('bar'));
                            }
                        },
                        'propertiesbooking':{
                            title:'Reservation propriétés',
                            icon:'fa fa-universal-access',
                            callback:function(e,titleSection,contentSection){
                                e.preventDefault();
                                titleSection.html('Reservation propriétés');
                                contentSection.html(me.myBookings().records('properties'));
                            }
                        }
                    }
                }
            });
        }
        this.myBookings=function(){
            return {
                form:function(){
                    return 'formulaire booking'
                },
                records:function(type){
                    return 'Données booking '+type;
                },
                availabilityform:function(){
                    return 'availability form';
                }
            };
        }

        this.slides=function(options){
            return {
                form:function(){
                    var pluginJson=allVariables.pluginjson(options.rootjson);
                    var text=pluginJson.plugintext.slideform;
                    var lang=allVariables.lang;
                    var tablesObject=me.sqlTables(pluginJson.plugincode);
                    return gen.formTable({
                        fields:[
                            {
                               label:text.label1[lang],
                               input:gen.textBox('slidetitle1','slidetitle1','form-control'),
                               validationwarning:text.warning1[lang],
                               required:true,
                               sqlfield:tablesObject.tables[0].fields[1].field,
                               preventinjection:true
                            },
                            {
                               label:text.label2[lang],
                               input:gen.textBox('slidetitle2','slidetitle2','form-control'),
                               validationwarning:text.warning2[lang],
                               required:true,
                               sqlfield:tablesObject.tables[0].fields[2].field,
                               preventinjection:true
                            },
                            {
                                label:text.label3[lang],
                                input:function(){
                                    var input=gen.textBox('slidephotoid','slidephotoname','form-control')
                                    .attr({type:'file'});
                                    input.on('change',function(e){
                                        gen.takeFile2Server(e,{
                                            dir:`${options.pluginroot}/uploads/`,
                                            value:function(url){
                                                var file=url.split("/").pop();
                                                return `uploads/${file}`
                                            },
                                            display:function(url){
                                                return `soweb/${url}`;
                                            },
                                            extensions:['jpg','jpeg','png','gif'],
                                            requireextension:1,
                                            warningextension:function(message){
                                                swal('alerte',message,'warning');
                                                return false;
                                            }
                                        });
                                    });
                                    return input;
                                },
                                validationwarning:text.warning3[lang],
                                required:true,
                                sqlfield:tablesObject.tables[0].fields[3].field
                             }

                        ],
                        action:'save',
                        sqlfieldid:tablesObject.tables[0].fields[0],
                        sqltable:tablesObject.tables[0].tablename,
                        checkschemaandcolumns:false 
                    });
                    
                },
                records:function(){
                    return 'Données slides';
                }
            };
        },
        this.extraServices=function(options){
            return {
              form:function(){
                var pluginJson=allVariables.pluginjson(options.rootjson);
                var tablesObject=me.sqlTables(pluginJson.plugincode);
                var text=pluginJson.plugintext.extraservices;
                var lang=allVariables.lang;
                return gen.formTable({
                    fields:[
                        {
                           label:text.label1[lang],
                           input:gen.textBox('serviceid','servicename','form-control'),
                           validationwarning:text.warning1[lang],
                           required:true,
                           sqlfield:tablesObject.tables[1].fields[1].field,
                           preventinjection:true
                        }

                    ],
                    action:'save',
                    sqlfieldid:tablesObject.tables[1].fields[0].field,
                    sqltable:tablesObject.tables[1].tablename,
                    checkschemaandcolumns:false
                });
                
              },
              records:function(){
                  return 'donnéés type chambre'
              }  
            };
        }
        this.rooms=function(options){
                return {
                form:function(){
                var pluginJson=allVariables.pluginjson(options.rootjson);
                var tablesObject=me.sqlTables(pluginJson.plugincode);
                var text=pluginJson.plugintext.rooms;
                var lang=allVariables.lang;
                return gen.formTable({
                    fields:[
                        {
                           label:text.label1[lang],
                           input:gen.textBox('roomnameid','roomnamename','form-control'),
                           validationwarning:text.warning1[lang],
                           required:true,
                           sqlfield:tablesObject.tables[2].fields[1].field,
                           preventinjection:true
                        },
                        {
                            label:text.label2[lang],
                            input:gen.textArea('roomdescriptionid','roomdescriptionname','none'),
                            validationwarning:text.warning2[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[2].field,
                            preventinjection:true
                         },
                         {
                            label:text.label3[lang],
                            input:function(){
                                return gen.dynamicCheckBoxesSrcJson(
                                    (function(gen){
                                        var data=gen.getObjectFromJSON(gen.url(false,gen.serverSideUrl,{
                                            key:'returnjson',
                                            table:tablesObject.tables[1].tablename,
                                            ref:`WHERE datastatus > 0 ORDER BY ${tablesObject.tables[1].fields[1].field} ASC`,
                                        },false,1));
                                        var json={};
                                        var n=0;
                                        if(data.length>0)
                                        for(var el of data){
                                            n++;
                                            json[n]={
                                                title:el[tablesObject.tables[1].fields[1].field],
                                                value:el[0]
                                            };
                                        }
                                        return json;

                                    })(gen),
                                    'roomserviceid',
                                    'roomservicesname',
                                    'none',
                                    undefined,
                                    null
                                    );
                            },
                            validationwarning:text.warning3[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[3].field,
                            preventinjection:true
                         },
                         {
                            label:text.label4[lang],
                            input:gen.textBox('roompriceid','roompricename','none',null,'numeric'),
                            validationwarning:text.warning4[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[4].field,
                            preventinjection:true
                         },
                         {
                            label:text.label5[lang],
                            input:gen.textBox('roomrateid','roomratename','none',null),
                            validationwarning:text.warning5[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[5].field,
                            preventinjection:true
                         },
                         {
                            label:text.label6[lang],
                            input:gen.textBox('roomquantityid','roomquantityname','none',null),
                            validationwarning:text.warning6[lang],
                            required:true,
                            sqlfield:tablesObject.tables[2].fields[6].field,
                            preventinjection:true
                         },
                         {
                            label:text.label7[lang],
                            input:gen.textBox('roomrangenumberid','roomrangenumbername','none',null),
                            validationwarning:text.warning7[lang],
                            sqlfield:tablesObject.tables[2].fields[7].field,
                            preventinjection:true
                         },
                         {
                             label:text.label8[lang],
                             input:gen.multipleInputFile(text.labeladdpicture[lang],'fa fa-plus',null,'multiplearthimeticquizphoto'),
                             validationwarning:text.warning8[lang],
                             required:true,
                             sqlfield:tablesObject.tables[2].fields[8].field,
                             preventinjection:true
                         }

                    ],
                    action:'save',
                    sqlfieldid:tablesObject.tables[2].fields[0].field,
                    sqltable:tablesObject.tables[2].tablename
                });
                    },
                    records:function(){
                        return 'Data goes here'
                    }
                }
        }
        this.restaurant=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.bar=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.properties=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                },
                manage:function(){
                    return 'xxl';
                }
            };
        }
        this.photogallery=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.testimonials=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.aboutus=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }
        this.configurations=function(){
            return {
                form:function(){
                    return 'formulaire restaure';
                },
                records:function(){
                    return 'donnees formulaires'
                }
            };
        }

        this.pluginBackEndMenu=function(options){
            var menus=[
                {
                    title:'Configurations',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire configuration',
                            content:me.configurations().form()
                        }));
                    }
                },
                {
                    title:'Slides',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire slide',
                            content:me.slides(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newslide':{
                                        title:'Nouveau slide',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire slide');
                                            contentSection.html(me.slides(options).form());
                                            
                                        }
                                    },
                                    'slides':{
                                        title:'Données slides',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            titleSection.html('Données slides');
                                            contentSection.html(me.slides().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Extras services',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire service extras',
                            content:me.extraServices(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newtype':{
                                        title:'Nouveau service',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire services extras');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                   'extraServices':{
                                       title:'Données services extras',
                                       icon:'fa fa-database',
                                       callback:function(e,titleSection,contentSection){
                                        e.preventDefault();
                                        titleSection.html('Données services extras');
                                        contentSection.html(me.extraServices(options).records())
                                       }
                                   }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Chambres',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire chambre',
                            content:me.rooms(options).form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newroom':{
                                        title:'Nouvelle chambre',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire chambre');
                                            contentSection.html(me.rooms(options).form())
                                        }
                                    },
                                    'rooms':{
                                        title:'Données chambres',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données chambres');
                                            contentSection.html(me.rooms(options).records())
                                        }
                                    }

                                }
                            }
                        }));
                    }
                },
                {
                    title:'Restaurant',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire restaurant',
                            content:me.restaurant().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newmeal':{
                                        title:'Nouveau repas',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire restaurant');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                    'meals':{
                                        title:'Données restaurant',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données restaurant'),
                                            contentSection.html(me.restaurant().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Bar',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire bar',
                            content:me.bar().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newbevarage':{
                                        title:'Nouvelle produit',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialSection){
                                            e.preventDefault();
                                            titleSection.html('Formulaire bar')
                                            contentSection.html(initialSection)
                                        }
                                    },
                                    'databar':{
                                        title:'Données produits',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données produits'),
                                            contentSection.html(me.bar().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Propriétes',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire propriétés',
                            content:me.properties().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newproperty':{
                                        title:'Nouvelle propriétés',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialcontent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire propriétés');
                                            contentSection.html(initialcontent)
                                        }
                                    },
                                    'manageproperty':{
                                        title:'Gérer propriétes',
                                        icon:'fa fa-gear',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Gestion propriétés');
                                            contentSection.html(me.properties().manage())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Reservations',
                    callback:function(){
                        options.pluginappsection.html(me.bookingsBlock());
                    }
                },
                {
                    title:'Gallerie photos',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire photo gallerie',
                            content:me.photogallery().form(),
                            rightoptions:{
                                 title:'Actions',
                                 icon:'icon-options icons',
                                 submenus:{
                                     'new':{
                                         title:'Nouvelle photo',
                                         icon:'fa fa-plus',
                                         callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire photo gallerie');
                                            contentSection.html(initialContent);
                                         }
                                     },
                                     'photos':{
                                         title:'Photos',
                                         icon:'fa fa-photo',
                                         callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Photo Gallerie');
                                            contentSection.html(me.photogallery().records())
                                         }
                                     }
                                 }
                            }
                        }));
                    }
                },
                {
                    title:'Temoignages',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire temoignages',
                            content:me.testimonials().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icons',
                                submenus:{
                                    'newtestimonial':{
                                        title:'Nouveau temoignage',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire temoignage');
                                            contentSection.html(initialContent);
                                        }
                                    },
                                    'testimonialdata':{
                                        title:'Données temoignages',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données temoignages');
                                            contentSection.html(me.testimonials().records());
                                        }
                                    }
                                }
                            }
                        }));
                    }
                },
                {
                    title:'Apropos de nous',
                    callback:function(){
                        options.pluginappsection.html(gen.block({
                            title:'Formulaire apropos de nous',
                            content:me.aboutus().form(),
                            rightoptions:{
                                title:'Actions',
                                icon:'icon-options icon',
                                submenus:{
                                    'newdata':{
                                        title:'Nouvelle donnée',
                                        icon:'fa fa-plus',
                                        callback:function(e,titleSection,contentSection,initialContent){
                                            e.preventDefault();
                                            titleSection.html('Formulaire apropos de nous'),
                                            contentSection.html(initialContent);

                                        }
                                    },
                                    'aboutusdata':{
                                        title:'Données',
                                        icon:'fa fa-database',
                                        callback:function(e,titleSection,contentSection){
                                            e.preventDefault();
                                            titleSection.html('Données a propos de nous');
                                            contentSection.html(me.aboutus().records())
                                        }
                                    }
                                }
                            }
                        }));
                    }
                }
            ];
             options.menusection.html(function(){
                 var blocks=[];
                 menus.forEach(menu => {
                    blocks.push($(gen.createEl('div'))
                    .addClass('hotelbackendmenu')
                    .html(menu.title)
                    .on('click',e=>{
                        menu.callback();
                    }));
                 });
                 return blocks;
             });
        }
        this.init=function(options){
            //create schemas starts
            me.sqlTables(allVariables.pluginjson(options.rootjson).plugincode).createschema();
            //create schemas ends
            var pluginAppSection=$(gen.createEl('div'));
            $(`#${constructorOptions.backendsectionid}`)
            .html([
                me.style(),
                gen.appWindow({
                showdata:{
                    icon:'fa fa-users',
                    title:'Reservations',
                    id:allVariables.showpluginsbuttonid,
                    callback:function(content){
                        pluginAppSection.html(me.bookingsBlock());
                    }
                },
                title:`Gestionnaire d'hotel`,
                content:gen.floatBlockColumns(gen,{},[
                    {
                        html:function(root,div){
                            me.pluginBackEndMenu({
                                pluginappsection:pluginAppSection,
                                menusection:div,
                                rootjson:options.rootjson,
                                pluginroot:options.pluginroot
                            })
                        },
                        css:{width:'20%'}
                    },
                    {
                        html:pluginAppSection,
                        css:{width:'80%'}
                    }
                ]),
                footer:allVariables.copyright
            })])
            .css({ 'box-shadow': 'none', 'float': 'left','width':'100%'});;
        }

        this.publicPluginUserInterface=function(options){
               var iframe=$(gen.createEl('iframe'));
               iframe.css({
                   width:'100%',
                   border:'none',
                   height:'950px'
               })
               .attr({
                   src:`${options.pluginroot}?pluginid=${options.pluginid}`
               })
               var div =$(gen.createEl('div'));
                   div
                   .html(iframe)
                   .css({
                    backgroundColor:'#fff',
                    color:'#000',
                    border:'1px #ccc solid',
                    margin:'5px',
                    padding:'5px'
                   });
                   //console.log('counting----index');
                   //console.log(options.pluginindex);
                $(`script[pluginindex="${options.pluginindex}"]`).replaceWith(div);
                
        }
        this.publicPlugins=function(){
                return {
                    rooms:{
                        title:'Reservation chambres',
                        key:'roombooking0001'
                    },
                    restaurant:{
                        title:'Restaurant',
                        key:'restaurant0002'
                    },
                    bar:{
                        title:'Bar',
                        key:'bar0003'
                    },
                    properties:{
                        title:'Propriétés',
                        key:'properties0004'
                    },
                    properties:{
                        title:'Créer compte',
                        key:'useraccounthotelms0005'
                    }  
                };
        }

        this.sqlTables=function(pluginCode){
            let tables=[
                {
                    tablename:`plugin_${pluginCode}_slides`,
                    fields:[
                        {
                            field:'slideid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true
                        },
                        {
                            field:'title1',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'title2',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        },
                        {
                            field:'photo',
                            datatype:'TEXT',
                            null:'NOT NULL'
                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_extraservices`,
                    fields:[
                        {
                            field:'extraserviceid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'extraservice',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        }
                    ],
                    data:[]
                },
                {
                    tablename:`plugin_${pluginCode}_rooms`,
                    fields:[
                        {
                            field:'roomid',
                            datatype:'INT',
                            length:'11',
                            primarykey:true,
                            autoincrement:true,
                        },
                        {
                            field:'roomname',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomdescription',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomextraservices',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomprice',
                            datatype:'float',
                            null:'NOT NULL'

                        },
                        {
                            field:'roompricerate',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomnqty',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        },
                        {
                            field:'roomrangenumber',
                            datatype:'TEXT',
                            null:'NULL'

                        },
                        {
                            field:'roomphotos',
                            datatype:'TEXT',
                            null:'NOT NULL'

                        }
                    ],
                    data:[]
                }
            ];
            return {
                tables:tables,
                createschema:function(){
                    gen.url(false,gen.serverSideUrl,{
                        key:`createschemas`,
                        schemas:tables
                    },false,1);
                },
                droptables:function(){
                    var feedBacks=Array();
                    tables.forEach(item=>{
                        feedBacks[feedBacks.length]=gen.url(false,gen.serverSideUrl,{
                            key:`calluserfunctionarray`,
                            class:`model`,
                            method:`dropTable`,
                            parameters:['@conn',item.tablename]
                        },false,1);
                            
                    });
                    //console.log(feedBacks);
                }
            }
            
        }

        this.style=function(){
            return $(gen.createEl('style'))
            .attr({type:'text/css'})
            .html(`
            .hotelbackendmenu{
                padding:5px;
                background-color:#cde4fd;
                margin:3px 0px 3px 0px;
                text-shadow:rgb(255 255 255) 1px 1px;
                cursor:pointer;
                text-transform:capitalize;
                border-left:5px #007bff solid;
            }
            .hotelbackendmenu:hover{
                background-color:#007bff;
                color:#fff;
                text-shadow:none;
                border-left:5px #cde4fd solid;
            }`);
        }
    }
}
